<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.php"><span>Class&nbsp;List</span></a></li>
      <li><a href="classes.php"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.php"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>CouplingMatrix Class Reference</h1><!-- doxytag: class="CouplingMatrix" --><code>#include &lt;<a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>&gt;</code>
<p>

<p>
<a href="classCouplingMatrix-members.php">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#27461cd0e280757b87b97f4051f419f6">CouplingMatrix</a> (const unsigned int n=0)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned char&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#50d7daefb61625abc6f03782ab138070">operator()</a> (const unsigned int i, const unsigned int j) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned char &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#65795b99e2b1c8b4bf1080021a680856">operator()</a> (const unsigned int i, const unsigned int j)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#873ea83161bff58bc9f4b5ff771500ea">size</a> () const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#4e4d272c9773d38902de9a9068ca6229">resize</a> (const unsigned int n)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#a0f80d14dabd7a4dba808b4b0ed3cf0a">clear</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#ed22bc105cd6bd1925ebbdc1e833848e">empty</a> () const </td></tr>

<tr><td colspan="2"><br><h2>Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; unsigned char &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">_values</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class defines a coupling matrix. A coupling matrix is simply a matrix of ones and zeros describing how different components in a system couple with each other. A coupling matrix is necessarily square but not necessarily symmetric. 
<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00041">41</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="27461cd0e280757b87b97f4051f419f6"></a><!-- doxytag: member="CouplingMatrix::CouplingMatrix" ref="27461cd0e280757b87b97f4051f419f6" args="(const unsigned int n=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CouplingMatrix::CouplingMatrix           </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&nbsp;</td>
          <td class="paramname"> <em>n</em> = <code>0</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor. 
<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00109">109</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00150">resize()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00109"></a>00109                                                     :
<a name="l00110"></a>00110   <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>(n)
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112   this-&gt;<a class="code" href="classCouplingMatrix.php#4e4d272c9773d38902de9a9068ca6229">resize</a>(n);
<a name="l00113"></a>00113 }

</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="a0f80d14dabd7a4dba808b4b0ed3cf0a"></a><!-- doxytag: member="CouplingMatrix::clear" ref="a0f80d14dabd7a4dba808b4b0ed3cf0a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CouplingMatrix::clear           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clears the matrix. 
<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00163">163</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00164"></a>00164 {
<a name="l00165"></a>00165   <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a> = 0;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <a class="code" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">_values</a>.clear();
<a name="l00168"></a>00168 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="ed22bc105cd6bd1925ebbdc1e833848e"></a><!-- doxytag: member="CouplingMatrix::empty" ref="ed22bc105cd6bd1925ebbdc1e833848e" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CouplingMatrix::empty           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if the matrix is empty. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00173">173</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8C_source.php#l01831">SparsityPattern::Build::operator()()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00174"></a>00174 {
<a name="l00175"></a>00175   <span class="keywordflow">return</span> (<a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a> == 0);
<a name="l00176"></a>00176 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="65795b99e2b1c8b4bf1080021a680856"></a><!-- doxytag: member="CouplingMatrix::operator()" ref="65795b99e2b1c8b4bf1080021a680856" args="(const unsigned int i, const unsigned int j)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char &amp; CouplingMatrix::operator()           </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&nbsp;</td>
          <td class="paramname"> <em>j</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>the (i,j) entry of the matrix as a writeable reference. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00130">130</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00132"></a>00132 {
<a name="l00133"></a>00133   libmesh_assert (i &lt; <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00134"></a>00134   libmesh_assert (j &lt; <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">_values</a>[i*<a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a> + j];
<a name="l00137"></a>00137 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="50d7daefb61625abc6f03782ab138070"></a><!-- doxytag: member="CouplingMatrix::operator()" ref="50d7daefb61625abc6f03782ab138070" args="(const unsigned int i, const unsigned int j) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char CouplingMatrix::operator()           </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&nbsp;</td>
          <td class="paramname"> <em>j</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>the (i,j) entry of the matrix. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00118">118</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00120"></a>00120 {
<a name="l00121"></a>00121   libmesh_assert (i &lt; <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00122"></a>00122   libmesh_assert (j &lt; <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">_values</a>[i*<a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a> + j];
<a name="l00125"></a>00125 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="4e4d272c9773d38902de9a9068ca6229"></a><!-- doxytag: member="CouplingMatrix::resize" ref="4e4d272c9773d38902de9a9068ca6229" args="(const unsigned int n)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CouplingMatrix::resize           </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&nbsp;</td>
          <td class="paramname"> <em>n</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Resizes the matrix and initializes all entries to be 0. 
<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00150">150</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00093">_values</a>.</p>

<p>Referenced by <a class="el" href="coupling__matrix_8h_source.php#l00109">CouplingMatrix()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00151"></a>00151 {
<a name="l00152"></a>00152   <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a> = n;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <a class="code" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">_values</a>.resize(<a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>*<a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">_values</a>.size(); i++)
<a name="l00157"></a>00157     <a class="code" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">_values</a>[i] = 0;
<a name="l00158"></a>00158 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="873ea83161bff58bc9f4b5ff771500ea"></a><!-- doxytag: member="CouplingMatrix::size" ref="873ea83161bff58bc9f4b5ff771500ea" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int CouplingMatrix::size           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>the size of the matrix, i.e. N for an NxN matrix. </dd></dl>

<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00142">142</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>References <a class="el" href="coupling__matrix_8h_source.php#l00098">_size</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8C_source.php#l01831">SparsityPattern::Build::operator()()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00143"></a>00143 {
<a name="l00144"></a>00144   <span class="keywordflow">return</span> <a class="code" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">_size</a>;
<a name="l00145"></a>00145 }
</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="e04509ff743b77bceb1ee7212223e16c"></a><!-- doxytag: member="CouplingMatrix::_size" ref="e04509ff743b77bceb1ee7212223e16c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="classCouplingMatrix.php#e04509ff743b77bceb1ee7212223e16c">CouplingMatrix::_size</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The size of the matrix. 
<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00098">98</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>Referenced by <a class="el" href="coupling__matrix_8h_source.php#l00163">clear()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00173">empty()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00118">operator()()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00150">resize()</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00142">size()</a>.</p>

</div>
</div><p>
<a class="anchor" name="76d27153a0a07a0a55052d310a86f7e6"></a><!-- doxytag: member="CouplingMatrix::_values" ref="76d27153a0a07a0a55052d310a86f7e6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;unsigned char&gt; <a class="el" href="classCouplingMatrix.php#76d27153a0a07a0a55052d310a86f7e6">CouplingMatrix::_values</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The actual matrix values. These are stored as unsigned chars because a vector of bools is not what you think. 
<p>Definition at line <a class="el" href="coupling__matrix_8h_source.php#l00093">93</a> of file <a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a>.</p>

<p>Referenced by <a class="el" href="coupling__matrix_8h_source.php#l00163">clear()</a>, <a class="el" href="coupling__matrix_8h_source.php#l00118">operator()()</a>, and <a class="el" href="coupling__matrix_8h_source.php#l00150">resize()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="coupling__matrix_8h_source.php">coupling_matrix.h</a></ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
