<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.php"><span>Class&nbsp;List</span></a></li>
      <li><a href="classes.php"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.php"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>LaplaceMeshSmoother Class Reference</h1><!-- doxytag: class="LaplaceMeshSmoother" --><!-- doxytag: inherits="MeshSmoother" --><code>#include &lt;<a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for LaplaceMeshSmoother:</div>
<div class="dynsection">
<p><center><img src="classLaplaceMeshSmoother__inherit__graph.png" border="0" usemap="#LaplaceMeshSmoother__inherit__map" alt="Inheritance graph"></center>
<map name="LaplaceMeshSmoother__inherit__map">
<area shape="rect" id="node2" href="classMeshSmoother.php" title="MeshSmoother" alt="" coords="32,6,152,37"></map>
<center><font size="2">[<a href="graph_legend.php">legend</a>]</font></center></div>

<p>
<a href="classLaplaceMeshSmoother-members.php">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#319cc639d5a11d8ef5113b7d6beea374">LaplaceMeshSmoother</a> (<a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;mesh)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#0a1720664a007ac7c622eec34efa2ea5">~LaplaceMeshSmoother</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#836c8d87c7e6ae66de9462a7a587eaaf">smooth</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#a9eb8b9ba1fbaefab44b3e950e4d4e20">smooth</a> (unsigned int n_iterations)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#b70683d8eaa560136b8423a734afeb68">init</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#8195e341cfaf73c63b07afaa1b7c903a">print_graph</a> () const </td></tr>

<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a></td></tr>

<tr><td colspan="2"><br><h2>Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#ad041b842be1c1813c57744ec8b467dc">_initialized</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; std::vector<br class="typebreak">
&lt; unsigned int &gt; &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class defines the data structures necessary for Laplace smoothing. Note that this is a simple averaging smoother, which does NOT guarantee that points will be smoothed to valid locations, e.g. locations inside the boundary! This aspect could use work.<p>
<dl class="author" compact><dt><b>Author:</b></dt><dd>John W. Peterson </dd></dl>
<dl class="date" compact><dt><b>Date:</b></dt><dd>2002-2007 </dd></dl>
<dl class="version" compact><dt><b>Version:</b></dt><dd>$Revision$ </dd></dl>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00053">53</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="319cc639d5a11d8ef5113b7d6beea374"></a><!-- doxytag: member="LaplaceMeshSmoother::LaplaceMeshSmoother" ref="319cc639d5a11d8ef5113b7d6beea374" args="(UnstructuredMesh &amp;mesh)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">LaplaceMeshSmoother::LaplaceMeshSmoother           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>mesh</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor. Sets the constant mesh reference in the protected data section of the class. 
<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00060">60</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00061"></a>00061     : <a class="code" href="classMeshSmoother.php#7e21469c23699a6f526581a080e5d7ba">MeshSmoother</a>(mesh),
<a name="l00062"></a>00062       <a class="code" href="classLaplaceMeshSmoother.php#ad041b842be1c1813c57744ec8b467dc">_initialized</a>(<span class="keyword">false</span>) {}
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="0a1720664a007ac7c622eec34efa2ea5"></a><!-- doxytag: member="LaplaceMeshSmoother::~LaplaceMeshSmoother" ref="0a1720664a007ac7c622eec34efa2ea5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual LaplaceMeshSmoother::~LaplaceMeshSmoother           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destructor. 
<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00067">67</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00067"></a>00067 {}
</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="b70683d8eaa560136b8423a734afeb68"></a><!-- doxytag: member="LaplaceMeshSmoother::init" ref="b70683d8eaa560136b8423a734afeb68" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LaplaceMeshSmoother::init           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Initialization for the Laplace smoothing routine is basically identical to building an "L-graph" which is expensive. It's provided separately from the constructor since you may or may not want to build the L-graph on construction. 
<p>Definition at line <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">124</a> of file <a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">_graph</a>, <a class="el" href="mesh__smoother__laplace_8h_source.php#l00104">_initialized</a>, <a class="el" href="mesh__smoother_8h_source.php#l00070">MeshSmoother::_mesh</a>, <a class="el" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">MeshBase::active_elements_begin()</a>, <a class="el" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">MeshBase::active_elements_end()</a>, <a class="el" href="classElem.php#554c146bcfb5537636bd77a157f21b85">Elem::build_side()</a>, <a class="el" href="dof__object_8h_source.php#l00449">DofObject::id()</a>, <a class="el" href="mesh__base_8h_source.php#l00140">MeshBase::mesh_dimension()</a>, <a class="el" href="elem_8h_source.php#l00301">Elem::n_neighbors()</a>, <a class="el" href="classMeshBase.php#8a927e499ea08fe30b7a867fa14314d6">MeshBase::n_nodes()</a>, and <a class="el" href="elem_8h_source.php#l01213">Elem::neighbor()</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00125"></a>00125 {
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordflow">switch</span> (<a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>())
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       
<a name="l00131"></a>00131       <span class="comment">// TODO:[BSK] Fix this to work for refined meshes...  I think</span>
<a name="l00132"></a>00132       <span class="comment">// the implementation was done quickly for Damien, who did not have</span>
<a name="l00133"></a>00133       <span class="comment">// refined grids.  Fix it here and in the original Mesh member.</span>
<a name="l00134"></a>00134       
<a name="l00135"></a>00135     <span class="keywordflow">case</span> 2: <span class="comment">// Stolen directly from build_L_graph in mesh_base.C</span>
<a name="l00136"></a>00136       {
<a name="l00137"></a>00137         <span class="comment">// Initialize space in the graph.  It is n_nodes</span>
<a name="l00138"></a>00138         <span class="comment">// long and each node is assumed to be connected to</span>
<a name="l00139"></a>00139         <span class="comment">// approximately 4 neighbors.</span>
<a name="l00140"></a>00140         <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.resize(<a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00141"></a>00141 <span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<a name="l00142"></a>00142 <span class="comment">//        _graph[i].reserve(4);</span>
<a name="l00143"></a>00143         
<a name="l00144"></a>00144         <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00145"></a>00145         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00146"></a>00146         
<a name="l00147"></a>00147         <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00148"></a>00148           {
<a name="l00149"></a>00149             <span class="comment">// Constant handle for the element</span>
<a name="l00150"></a>00150             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00151"></a>00151             
<a name="l00152"></a>00152             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
<a name="l00153"></a>00153               {
<a name="l00154"></a>00154                 <span class="comment">// Only operate on sides which are on the</span>
<a name="l00155"></a>00155                 <span class="comment">// boundary or for which the current element's</span>
<a name="l00156"></a>00156                 <span class="comment">// id is greater than its neighbor's.</span>
<a name="l00157"></a>00157                 <span class="comment">// Sides get only built once.</span>
<a name="l00158"></a>00158                 <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL) ||
<a name="l00159"></a>00159                     (elem-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>() &gt; elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s)-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()))
<a name="l00160"></a>00160                   {
<a name="l00161"></a>00161                     <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(elem-&gt;<a class="code" href="classElem.php#554c146bcfb5537636bd77a157f21b85">build_side</a>(s));
<a name="l00162"></a>00162                     <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(0)].push_back(side-&gt;node(1));
<a name="l00163"></a>00163                     <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(1)].push_back(side-&gt;node(0));
<a name="l00164"></a>00164                 }
<a name="l00165"></a>00165               }
<a name="l00166"></a>00166           }
<a name="l00167"></a>00167         <a class="code" href="classLaplaceMeshSmoother.php#ad041b842be1c1813c57744ec8b467dc">_initialized</a> = <span class="keyword">true</span>;
<a name="l00168"></a>00168         <span class="keywordflow">break</span>;
<a name="l00169"></a>00169       }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     <span class="keywordflow">case</span> 3: <span class="comment">// Stolen blatantly from build_L_graph in mesh_base.C</span>
<a name="l00172"></a>00172       {
<a name="l00173"></a>00173         <span class="comment">// Initialize space in the graph.  In 3D, I've assumed</span>
<a name="l00174"></a>00174         <span class="comment">// that each node was connected to approximately 3 neighbors.</span>
<a name="l00175"></a>00175         <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.resize(<a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00176"></a>00176 <span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<a name="l00177"></a>00177 <span class="comment">//        _graph[i].reserve(8);</span>
<a name="l00178"></a>00178         
<a name="l00179"></a>00179         <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00180"></a>00180         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182         <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00183"></a>00183           {
<a name="l00184"></a>00184             <span class="comment">// Shortcut notation for simplicity</span>
<a name="l00185"></a>00185             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00186"></a>00186             
<a name="l00187"></a>00187             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f=0; f&lt;elem-&gt;<a class="code" href="classElem.php#8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); f++) <span class="comment">// Loop over faces</span>
<a name="l00188"></a>00188               <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(f) == NULL) ||
<a name="l00189"></a>00189                   (elem-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>() &gt; elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(f)-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()))
<a name="l00190"></a>00190                 {
<a name="l00191"></a>00191                   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> face(elem-&gt;<a class="code" href="classElem.php#554c146bcfb5537636bd77a157f21b85">build_side</a>(f));
<a name="l00192"></a>00192                 
<a name="l00193"></a>00193                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;face-&gt;n_neighbors(); s++) <span class="comment">// Loop over face's edges</span>
<a name="l00194"></a>00194                     {
<a name="l00195"></a>00195                       <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(face-&gt;build_side(s));
<a name="l00196"></a>00196                     
<a name="l00197"></a>00197                       <span class="comment">// At this point, we just insert the node numbers</span>
<a name="l00198"></a>00198                       <span class="comment">// again.  At the end we'll call sort and unique</span>
<a name="l00199"></a>00199                       <span class="comment">// to make sure there are no duplicates</span>
<a name="l00200"></a>00200                       <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(0)].push_back(side-&gt;node(1));
<a name="l00201"></a>00201                       <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[side-&gt;node(1)].push_back(side-&gt;node(0));
<a name="l00202"></a>00202                     }
<a name="l00203"></a>00203                 }
<a name="l00204"></a>00204           }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206         <span class="comment">// Now call sort and unique to remove duplicate entries.</span>
<a name="l00207"></a>00207         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(); ++i)
<a name="l00208"></a>00208           {
<a name="l00209"></a>00209             std::sort  (<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(), <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end());
<a name="l00210"></a>00210             <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].erase(std::unique(<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(), <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end()), <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end());
<a name="l00211"></a>00211           }
<a name="l00212"></a>00212         
<a name="l00213"></a>00213         <a class="code" href="classLaplaceMeshSmoother.php#ad041b842be1c1813c57744ec8b467dc">_initialized</a> = <span class="keyword">true</span>;
<a name="l00214"></a>00214         <span class="keywordflow">break</span>;
<a name="l00215"></a>00215       }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217     <span class="keywordflow">default</span>:
<a name="l00218"></a>00218       {
<a name="l00219"></a>00219         std::cerr &lt;&lt; <span class="stringliteral">"At this time it is not possible "</span>
<a name="l00220"></a>00220                   &lt;&lt; <span class="stringliteral">"to smooth a dimension "</span>
<a name="l00221"></a>00221                   &lt;&lt; <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>()
<a name="l00222"></a>00222                   &lt;&lt; <span class="stringliteral">"mesh.  Aborting..."</span>
<a name="l00223"></a>00223                   &lt;&lt; std::endl;
<a name="l00224"></a>00224         libmesh_error();
<a name="l00225"></a>00225       }
<a name="l00226"></a>00226       
<a name="l00227"></a>00227     }
<a name="l00228"></a>00228 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="8195e341cfaf73c63b07afaa1b7c903a"></a><!-- doxytag: member="LaplaceMeshSmoother::print_graph" ref="8195e341cfaf73c63b07afaa1b7c903a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LaplaceMeshSmoother::print_graph           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Mainly for debugging, this function will print out the connectivity graph which has been created. 
<p>Definition at line <a class="el" href="mesh__smoother__laplace_8C_source.php#l00233">233</a> of file <a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">_graph</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00234"></a>00234 {
<a name="l00235"></a>00235   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>.size(); ++i)
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       std::cout &lt;&lt; i &lt;&lt; <span class="stringliteral">": "</span>;
<a name="l00238"></a>00238       std::copy(<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].begin(),
<a name="l00239"></a>00239                 <a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[i].end(),
<a name="l00240"></a>00240                 std::ostream_iterator&lt;unsigned int&gt;(std::cout, <span class="stringliteral">" "</span>));
<a name="l00241"></a>00241       std::cout &lt;&lt; std::endl;
<a name="l00242"></a>00242     }
<a name="l00243"></a>00243 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="a9eb8b9ba1fbaefab44b3e950e4d4e20"></a><!-- doxytag: member="LaplaceMeshSmoother::smooth" ref="a9eb8b9ba1fbaefab44b3e950e4d4e20" args="(unsigned int n_iterations)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LaplaceMeshSmoother::smooth           </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>n_iterations</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The actual smoothing function, gets called whenever the user specifies an actual number of smoothing iterations. 
<p>Definition at line <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">33</a> of file <a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">_graph</a>, <a class="el" href="mesh__smoother__laplace_8h_source.php#l00104">_initialized</a>, <a class="el" href="mesh__smoother_8h_source.php#l00070">MeshSmoother::_mesh</a>, <a class="el" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">MeshBase::active_elements_begin()</a>, <a class="el" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">MeshBase::active_elements_end()</a>, <a class="el" href="classTypeVector.php#5a491e5c665118253b6e2f65141c8922">TypeVector&lt; T &gt;::add()</a>, <a class="el" href="mesh__tools_8C_source.php#l00245">MeshTools::find_boundary_nodes()</a>, <a class="el" href="dof__object_8h_source.php#l00449">DofObject::id()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, <a class="el" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">Elem::n_nodes()</a>, <a class="el" href="classMeshBase.php#8a927e499ea08fe30b7a867fa14314d6">MeshBase::n_nodes()</a>, <a class="el" href="elem_8C_source.php#l01209">Elem::n_second_order_adjacent_vertices()</a>, <a class="el" href="classElem.php#6bbe1895127c069722e36ee4e2a8a6e1">Elem::n_vertices()</a>, <a class="el" href="elem_8h_source.php#l01164">Elem::node()</a>, <a class="el" href="classMeshBase.php#298477f2d67d6a85f6c7fb5a640e2b64">MeshBase::node()</a>, <a class="el" href="classMeshBase.php#2683097ac8a923892fa43a1a911a273d">MeshBase::nodes_begin()</a>, <a class="el" href="classMeshBase.php#b9b58c2b060ea4d47b50e1dad15415b0">MeshBase::nodes_end()</a>, <a class="el" href="classMeshBase.php#06af1f178519c606d0bdca7857f95ba6">MeshBase::point()</a>, and <a class="el" href="elem_8C_source.php#l01217">Elem::second_order_adjacent_vertex()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="keywordflow">if</span> (!<a class="code" href="classLaplaceMeshSmoother.php#ad041b842be1c1813c57744ec8b467dc">_initialized</a>)
<a name="l00036"></a>00036     this-&gt;<a class="code" href="classLaplaceMeshSmoother.php#b70683d8eaa560136b8423a734afeb68">init</a>();
<a name="l00037"></a>00037   
<a name="l00038"></a>00038   <span class="comment">// Don't smooth the nodes on the boundary...</span>
<a name="l00039"></a>00039   <span class="comment">// this would change the mesh geometry which</span>
<a name="l00040"></a>00040   <span class="comment">// is probably not something we want!</span>
<a name="l00041"></a>00041   std::vector&lt;bool&gt; on_boundary;
<a name="l00042"></a>00042   <a class="code" href="namespaceMeshTools.php#b24d347f09559cc4fa6ea2c1a238b2d4">MeshTools::find_boundary_nodes</a>(<a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>, on_boundary);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="comment">// We can only update the nodes after all new positions were</span>
<a name="l00045"></a>00045   <span class="comment">// determined. We store the new positions here</span>
<a name="l00046"></a>00046   std::vector&lt;Point&gt; new_positions;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_iterations; n++)
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050       new_positions.resize(<a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00051"></a>00051       
<a name="l00052"></a>00052       <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00053"></a>00053            it != <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#b9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00054"></a>00054            ++it) 
<a name="l00055"></a>00055         {
<a name="l00056"></a>00056           <a class="code" href="classNode.php">Node</a>* node = *it;
<a name="l00057"></a>00057           <span class="comment">// leave the boundary intact</span>
<a name="l00058"></a>00058           <span class="comment">// Only relocate the nodes which are vertices of an element</span>
<a name="l00059"></a>00059           <span class="comment">// All other entries of _graph (the secondary nodes) are empty</span>
<a name="l00060"></a>00060           <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()] &amp;&amp; (<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()].size() &gt; 0) )
<a name="l00061"></a>00061             {
<a name="l00062"></a>00062               <a class="code" href="classPoint.php">Point</a> avg_position(0.,0.,0.);
<a name="l00063"></a>00063               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()].size(); ++j)
<a name="l00064"></a>00064                 avg_position.add(<a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#298477f2d67d6a85f6c7fb5a640e2b64">node</a>(<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()][j]));
<a name="l00065"></a>00065               new_positions[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()] = avg_position /
<a name="l00066"></a>00066                 <span class="keyword">static_cast&lt;</span><a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a><span class="keyword">&gt;</span>(<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()].size());
<a name="l00067"></a>00067             }
<a name="l00068"></a>00068         }
<a name="l00069"></a>00069       
<a name="l00070"></a>00070       <span class="comment">// now update the node positions</span>
<a name="l00071"></a>00071       <span class="keywordflow">for</span> (<a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00072"></a>00072            it != <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#b9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00073"></a>00073            ++it)
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075           <a class="code" href="classNode.php">Node</a>* node = *it;
<a name="l00076"></a>00076           
<a name="l00077"></a>00077           <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()] &amp;&amp; (<a class="code" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">_graph</a>[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()].size() &gt; 0) )
<a name="l00078"></a>00078             {
<a name="l00079"></a>00079               <span class="comment">// Should call Point::op=</span>
<a name="l00080"></a>00080               <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#298477f2d67d6a85f6c7fb5a640e2b64">node</a>(node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()) = new_positions[node-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>()];
<a name="l00081"></a>00081             }
<a name="l00082"></a>00082         }
<a name="l00083"></a>00083     }
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="comment">// finally adjust the second order nodes (those located between vertices)</span>
<a name="l00086"></a>00086   <span class="comment">// these nodes will be located between their adjacent nodes</span>
<a name="l00087"></a>00087   <span class="comment">// do this element-wise</span>
<a name="l00088"></a>00088   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00089"></a>00089   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00090"></a>00090         
<a name="l00091"></a>00091   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093       <span class="comment">// Constant handle for the element</span>
<a name="l00094"></a>00094       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096       <span class="comment">// get the second order nodes (son)</span>
<a name="l00097"></a>00097       <span class="comment">// their element indices start at n_vertices and go to n_nodes</span>
<a name="l00098"></a>00098       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_begin = elem-&gt;<a class="code" href="classElem.php#6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>();
<a name="l00099"></a>00099       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_end   = elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00100"></a>00100       
<a name="l00101"></a>00101       <span class="comment">// loop over all second order nodes (son)</span>
<a name="l00102"></a>00102       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son=son_begin; son&lt;son_end; son++)
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104           <span class="comment">// Don't smooth second-order nodes which are on the boundary</span>
<a name="l00105"></a>00105           <span class="keywordflow">if</span> (!on_boundary[elem-&gt;<a class="code" href="classElem.php#2924d09a5bddbd9cce87838bdec6c6c1">node</a>(son)])
<a name="l00106"></a>00106             {
<a name="l00107"></a>00107               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_vertices =
<a name="l00108"></a>00108                 elem-&gt;<a class="code" href="classElem.php#9f073eee0a8cd4d87e72f0834b4b1815">n_second_order_adjacent_vertices</a>(son);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110               <span class="comment">// calculate the new position which is the average of the</span>
<a name="l00111"></a>00111               <span class="comment">// position of the adjacent vertices</span>
<a name="l00112"></a>00112               <a class="code" href="classPoint.php">Point</a> avg_position(0,0,0);
<a name="l00113"></a>00113               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_adjacent_vertices; v++)
<a name="l00114"></a>00114                 avg_position +=
<a name="l00115"></a>00115                   <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#06af1f178519c606d0bdca7857f95ba6">point</a>( elem-&gt;<a class="code" href="classElem.php#2924d09a5bddbd9cce87838bdec6c6c1">node</a>( elem-&gt;<a class="code" href="classElem.php#51e4bd9931fa1378113784f76ac13d6a">second_order_adjacent_vertex</a>(son,v) ) );
<a name="l00116"></a>00116 
<a name="l00117"></a>00117               <a class="code" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">_mesh</a>.<a class="code" href="classMeshBase.php#298477f2d67d6a85f6c7fb5a640e2b64">node</a>(elem-&gt;<a class="code" href="classElem.php#2924d09a5bddbd9cce87838bdec6c6c1">node</a>(son)) = avg_position / n_adjacent_vertices;
<a name="l00118"></a>00118             }
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120     }
<a name="l00121"></a>00121 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="836c8d87c7e6ae66de9462a7a587eaaf"></a><!-- doxytag: member="LaplaceMeshSmoother::smooth" ref="836c8d87c7e6ae66de9462a7a587eaaf" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void LaplaceMeshSmoother::smooth           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Redefinition of the smooth function from the base class. All this does is call the smooth function in this class which takes an int, using a default value of 1. 
<p>Implements <a class="el" href="classMeshSmoother.php#2f860e9c2cfbe3e14f363f223ed5baab">MeshSmoother</a>.</p>

<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00075">75</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>

<p>References <a class="el" href="mesh__smoother__laplace_8h_source.php#l00075">smooth()</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8h_source.php#l00075">smooth()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00075"></a>00075 { this-&gt;<a class="code" href="classLaplaceMeshSmoother.php#836c8d87c7e6ae66de9462a7a587eaaf">smooth</a>(1); }
</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="9b4ece7f6dd69aae5c30db7619a8d82e"></a><!-- doxytag: member="LaplaceMeshSmoother::_graph" ref="9b4ece7f6dd69aae5c30db7619a8d82e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;std::vector&lt;unsigned int&gt; &gt; <a class="el" href="classLaplaceMeshSmoother.php#9b4ece7f6dd69aae5c30db7619a8d82e">LaplaceMeshSmoother::_graph</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Data structure for holding the L-graph 
<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00109">109</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00233">print_graph()</a>, and <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>.</p>

</div>
</div><p>
<a class="anchor" name="ad041b842be1c1813c57744ec8b467dc"></a><!-- doxytag: member="LaplaceMeshSmoother::_initialized" ref="ad041b842be1c1813c57744ec8b467dc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classLaplaceMeshSmoother.php#ad041b842be1c1813c57744ec8b467dc">LaplaceMeshSmoother::_initialized</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
True if the L-graph has been created, false otherwise. 
<p>Definition at line <a class="el" href="mesh__smoother__laplace_8h_source.php#l00104">104</a> of file <a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, and <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>.</p>

</div>
</div><p>
<a class="anchor" name="7f5ff11e687f8df03f58b73499e63549"></a><!-- doxytag: member="LaplaceMeshSmoother::_mesh" ref="7f5ff11e687f8df03f58b73499e63549" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classUnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="el" href="classMeshSmoother.php#7f5ff11e687f8df03f58b73499e63549">MeshSmoother::_mesh</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="mesh__smoother_8h_source.php#l00070">70</a> of file <a class="el" href="mesh__smoother_8h_source.php">mesh_smoother.h</a>.</p>

<p>Referenced by <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00501">VariationalMeshSmoother::adjust_adapt_data()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00124">init()</a>, <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00245">VariationalMeshSmoother::readgr()</a>, <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00041">VariationalMeshSmoother::smooth()</a>, <a class="el" href="mesh__smoother__laplace_8C_source.php#l00033">smooth()</a>, and <a class="el" href="mesh__smoother__vsmoother_8C_source.php#l00148">VariationalMeshSmoother::writegr()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="mesh__smoother__laplace_8h_source.php">mesh_smoother_laplace.h</a><li><a class="el" href="mesh__smoother__laplace_8C_source.php">mesh_smoother_laplace.C</a></ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
