<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.php"><span>Class&nbsp;List</span></a></li>
      <li><a href="classes.php"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.php"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>MatlabIO Class Reference</h1><!-- doxytag: class="MatlabIO" --><!-- doxytag: inherits="MeshInput&lt; MeshBase &gt;" --><code>#include &lt;<a class="el" href="matlab__io_8h_source.php">matlab_io.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for MatlabIO:</div>
<div class="dynsection">
<p><center><img src="classMatlabIO__inherit__graph.png" border="0" usemap="#MatlabIO__inherit__map" alt="Inheritance graph"></center>
<map name="MatlabIO__inherit__map">
<area shape="rect" id="node2" href="classMeshInput.php" title="MeshInput\&lt; MeshBase \&gt;" alt="" coords="5,6,181,37"></map>
<center><font size="2">[<a href="graph_legend.php">legend</a>]</font></center></div>

<p>
<a href="classMatlabIO-members.php">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMatlabIO.php#15202601cb2b0fd0852fb6f203c9c6f2">MatlabIO</a> (<a class="el" href="classMeshBase.php">MeshBase</a> &amp;)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMatlabIO.php#3a6ccb2025cb0c6e64c6813acdada143">read</a> (const std::string &amp;name)</td></tr>

<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classMeshBase.php">MeshBase</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshInput.php#2e8be596b1583aa3348740f461562d24">mesh</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMeshInput.php#1261f0e7a0d6284c4a1e321d13c3c3ec">skip_comment_lines</a> (std::istream &amp;in, const char comment_start)</td></tr>

<tr><td colspan="2"><br><h2>Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMatlabIO.php#207f96c9be8ef76f489b8b84e491e823">read_stream</a> (std::istream &amp;in)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class implements reading meshes in the Matlab PDE toolkit in a proprietary format.<p>
A VALID INPUT FILE for this type of mesh should be generated in Matlab with the following steps: 1.) Draw the domain and triangulate it in the GUI 2.) Export the mesh to matlab using Mesh-&gt;Export <a class="el" href="classMesh.php">Mesh</a> 3.) Create a file with this script: fid = fopen('filename', 'w'); fprintf(fid, 'd d <br>
', length(p), length(t)); fprintf(fid, 'f f <br>
', p); fprintf(fid, 'd d d d <br>
', t); fclose(fid);<p>
What's going on here? There is no standard for exporting PDE toolkit meshes to files in Matlab. When you choose "export mesh" in the GUI, it returns three matrices that it likes to call p, e, and t. All meshes (as far as I can tell) that come from the PDE toolkit are 2D triangle meshes.<p>
p is the point matrix... Row 1: x coordinate Row 2: y coordinate<p>
e is the edge matrix ... Row 1: starting point number (dummy) Row 2: ending point number (dummy) Row 3: starting parameter value (?) (dummy) Row 4: ending parameter value (?) (dummy) Row 5: boundary segment number (?) (dummy) Row 6: left-hand subdomain number (dummy) Row 7: right-hand subdomain number (dummy)<p>
t is the triangle matrix ... Row 1: <a class="el" href="classNode.php">Node</a> number 1 Row 2: <a class="el" href="classNode.php">Node</a> number 2 Row 3: <a class="el" href="classNode.php">Node</a> number 3 Row 4: subdomain number (dummy)<p>
There are some important things to notice here: o The implied ordering of the p matrix is 1..N o The e matrix is entirely irrelevant in this code o All of the matrices are row based<p>
<dl class="author" compact><dt><b>Author:</b></dt><dd>John W. Peterson, 2004 </dd></dl>

<p>Definition at line <a class="el" href="matlab__io_8h_source.php#l00086">86</a> of file <a class="el" href="matlab__io_8h_source.php">matlab_io.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="15202601cb2b0fd0852fb6f203c9c6f2"></a><!-- doxytag: member="MatlabIO::MatlabIO" ref="15202601cb2b0fd0852fb6f203c9c6f2" args="(MeshBase &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">MatlabIO::MatlabIO           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classMeshBase.php">MeshBase</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>mesh</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor. Takes a non-const <a class="el" href="classMesh.php">Mesh</a> reference which it will fill up with elements. 
<p>Definition at line <a class="el" href="matlab__io_8h_source.php#l00114">114</a> of file <a class="el" href="matlab__io_8h_source.php">matlab_io.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00114"></a>00114                                   :
<a name="l00115"></a>00115   <a class="code" href="classMeshInput.php">MeshInput&lt;MeshBase&gt;</a>  (mesh)
<a name="l00116"></a>00116 {}

</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="2e8be596b1583aa3348740f461562d24"></a><!-- doxytag: member="MatlabIO::mesh" ref="2e8be596b1583aa3348740f461562d24" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classMeshBase.php">MeshBase</a> &amp; <a class="el" href="classMeshInput.php">MeshInput</a>&lt; <a class="el" href="classMeshBase.php">MeshBase</a>  &gt;::mesh           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the object as a writeable reference. 
<p>Referenced by <a class="el" href="gmv__io_8C_source.php#l02008">GMVIO::_read_materials()</a>, <a class="el" href="gmv__io_8C_source.php#l02051">GMVIO::_read_nodes()</a>, <a class="el" href="gmv__io_8C_source.php#l02086">GMVIO::_read_one_cell()</a>, <a class="el" href="gmv__io_8C_source.php#l01837">GMVIO::add_cell_centered_data()</a>, <a class="el" href="gmv__io_8C_source.php#l02226">GMVIO::copy_nodal_solution()</a>, <a class="el" href="unv__io_8C_source.php#l00642">UNVIO::element_in()</a>, <a class="el" href="tetgen__io_8C_source.php#l00175">TetGenIO::element_in()</a>, <a class="el" href="unv__io_8C_source.php#l01018">UNVIO::element_out()</a>, <a class="el" href="unv__io_8C_source.php#l00535">UNVIO::node_in()</a>, <a class="el" href="tetgen__io_8C_source.php#l00119">TetGenIO::node_in()</a>, <a class="el" href="unv__io_8C_source.php#l00952">UNVIO::node_out()</a>, <a class="el" href="xdr__io_8C_source.php#l00743">XdrIO::read()</a>, <a class="el" href="vtk__io_8C_source.php#l00449">VTKIO::read()</a>, <a class="el" href="gmv__io_8C_source.php#l01854">GMVIO::read()</a>, <a class="el" href="exodusII__io_8C_source.php#l00082">ExodusII_IO::read()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00205">LegacyXdrIO::read_ascii()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00219">LegacyXdrIO::read_binary()</a>, <a class="el" href="ucd__io_8C_source.php#l00107">UCDIO::read_implementation()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00269">LegacyXdrIO::read_mesh()</a>, <a class="el" href="gmsh__io_8C_source.php#l00319">GmshIO::read_mesh()</a>, <a class="el" href="xdr__io_8C_source.php#l01009">XdrIO::read_serialized_bcs()</a>, <a class="el" href="xdr__io_8C_source.php#l00813">XdrIO::read_serialized_connectivity()</a>, <a class="el" href="xdr__io_8C_source.php#l00935">XdrIO::read_serialized_nodes()</a>, <a class="el" href="off__io_8C_source.php#l00042">OFFIO::read_stream()</a>, <a class="el" href="matlab__io_8C_source.php#l00040">read_stream()</a>, <a class="el" href="vtk__io_8C_source.php#l00300">VTKIO::solution_to_vtk()</a>, <a class="el" href="xdr__io_8C_source.php#l00147">XdrIO::write()</a>, <a class="el" href="vtk__io_8C_source.php#l00619">VTKIO::write()</a>, <a class="el" href="tetgen__io_8C_source.php#l00252">TetGenIO::write()</a>, <a class="el" href="gmv__io_8C_source.php#l00256">GMVIO::write_ascii_new_impl()</a>, <a class="el" href="gmv__io_8C_source.php#l00530">GMVIO::write_ascii_old_impl()</a>, <a class="el" href="gmv__io_8C_source.php#l01108">GMVIO::write_binary()</a>, <a class="el" href="gmv__io_8C_source.php#l01501">GMVIO::write_discontinuous_gmv()</a>, <a class="el" href="unv__io_8C_source.php#l00308">UNVIO::write_implementation()</a>, <a class="el" href="ucd__io_8C_source.php#l00214">UCDIO::write_implementation()</a>, <a class="el" href="legacy__xdr__io_8C_source.php#l00635">LegacyXdrIO::write_mesh()</a>, <a class="el" href="gmsh__io_8C_source.php#l00620">GmshIO::write_mesh()</a>, <a class="el" href="gmsh__io_8C_source.php#l00705">GmshIO::write_post()</a>, <a class="el" href="xdr__io_8C_source.php#l00665">XdrIO::write_serialized_bcs()</a>, <a class="el" href="xdr__io_8C_source.php#l00229">XdrIO::write_serialized_connectivity()</a>, <a class="el" href="xdr__io_8C_source.php#l00527">XdrIO::write_serialized_nodes()</a>, and <a class="el" href="legacy__xdr__io_8C_source.php#l00997">LegacyXdrIO::write_soln()</a>.</p>

</div>
</div><p>
<a class="anchor" name="3a6ccb2025cb0c6e64c6813acdada143"></a><!-- doxytag: member="MatlabIO::read" ref="3a6ccb2025cb0c6e64c6813acdada143" args="(const std::string &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MatlabIO::read           </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reads in a matlab data file based on the string you pass it. 
<p>Implements <a class="el" href="classMeshInput.php#9d70b68a1cf29ba6a123c9270aac0c07">MeshInput&lt; MeshBase &gt;</a>.</p>

<p>Definition at line <a class="el" href="matlab__io_8C_source.php#l00032">32</a> of file <a class="el" href="matlab__io_8C_source.php">matlab_io.C</a>.</p>

<p>References <a class="el" href="matlab__io_8C_source.php#l00040">read_stream()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00033"></a>00033 {
<a name="l00034"></a>00034   std::ifstream in (<a class="code" href="namespaceQuality.php#47f1b8befd1bbd18dfe20c810b9ade23">name</a>.c_str());
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   this-&gt;<a class="code" href="classMatlabIO.php#207f96c9be8ef76f489b8b84e491e823">read_stream</a>(in);
<a name="l00037"></a>00037 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="207f96c9be8ef76f489b8b84e491e823"></a><!-- doxytag: member="MatlabIO::read_stream" ref="207f96c9be8ef76f489b8b84e491e823" args="(std::istream &amp;in)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MatlabIO::read_stream           </td>
          <td>(</td>
          <td class="paramtype">std::istream &amp;&nbsp;</td>
          <td class="paramname"> <em>in</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [private, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Implementation of the <a class="el" href="classMatlabIO.php#3a6ccb2025cb0c6e64c6813acdada143">read()</a> function. This function is called by the public interface function and implements reading the file. 
<p>Definition at line <a class="el" href="matlab__io_8C_source.php#l00040">40</a> of file <a class="el" href="matlab__io_8C_source.php">matlab_io.C</a>.</p>

<p>References <a class="el" href="classMeshBase.php#0f6974cf3e413cfe9caa1fcb4ce8153e">MeshBase::add_elem()</a>, <a class="el" href="classMeshBase.php#01b66468d3e9d8b5db82c6f3d9131f5e">MeshBase::add_point()</a>, <a class="el" href="mesh__base_8C_source.php#l00117">MeshBase::clear()</a>, <a class="el" href="classMeshInput.php#2e8be596b1583aa3348740f461562d24">MeshInput&lt; MeshBase &gt;::mesh()</a>, <a class="el" href="mesh__base_8h_source.php#l00140">MeshBase::mesh_dimension()</a>, <a class="el" href="classMeshBase.php#1f4e7c33b1f6fa7742e703b625e95c54">MeshBase::node_ptr()</a>, <a class="el" href="libmesh__base_8h_source.php#l00088">libMesh::processor_id()</a>, <a class="el" href="dof__object_8h_source.php#l00458">DofObject::set_id()</a>, and <a class="el" href="elem_8h_source.php#l01187">Elem::set_node()</a>.</p>

<p>Referenced by <a class="el" href="matlab__io_8C_source.php#l00032">read()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00043"></a>00043   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00044"></a>00044   <span class="comment">// broadcast later</span>
<a name="l00045"></a>00045   libmesh_assert(<a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="comment">// Get a reference to the mesh</span>
<a name="l00048"></a>00048   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">// Clear any existing mesh data</span>
<a name="l00051"></a>00051   mesh.<a class="code" href="classMeshBase.php#efd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00052"></a>00052   
<a name="l00053"></a>00053   <span class="comment">// PDE toolkit only works in 2D</span>
<a name="l00054"></a>00054   libmesh_assert(mesh.<a class="code" href="classMeshBase.php#81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 2);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">// Check the input buffer</span>
<a name="l00057"></a>00057   libmesh_assert (in.good());
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nNodes=0, nElem=0;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   in &gt;&gt; nNodes   <span class="comment">// Read the number of nodes</span>
<a name="l00062"></a>00062      &gt;&gt; nElem;   <span class="comment">// Read the number of elements</span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// Sort of check that it worked</span>
<a name="l00065"></a>00065   libmesh_assert(nNodes &gt; 0);
<a name="l00066"></a>00066   libmesh_assert(nElem &gt; 0);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// Read the nodal coordinates</span>
<a name="l00069"></a>00069   {
<a name="l00070"></a>00070     <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> x=0., y=0., z=0.;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nNodes; i++)
<a name="l00073"></a>00073       {
<a name="l00074"></a>00074         in &gt;&gt; x   <span class="comment">// x-coordinate value</span>
<a name="l00075"></a>00075            &gt;&gt; y;  <span class="comment">// y-coordinate value</span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077         mesh.<a class="code" href="classMeshBase.php#01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> ( <a class="code" href="classPoint.php">Point</a>(x,y,z), i);
<a name="l00078"></a>00078       }
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Read the elements (elements)</span>
<a name="l00082"></a>00082   {
<a name="l00083"></a>00083     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0, dummy=0;
<a name="l00084"></a>00084     
<a name="l00085"></a>00085     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nElem; i++)
<a name="l00086"></a>00086       {
<a name="l00087"></a>00087         <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>; <span class="comment">// Always build a triangle</span>
<a name="l00088"></a>00088         elem-&gt;<a class="code" href="classDofObject.php#4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(i);
<a name="l00089"></a>00089         mesh.<a class="code" href="classMeshBase.php#0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (elem);
<a name="l00090"></a>00090         
<a name="l00091"></a>00091         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;3; n++)  <span class="comment">// Always read three 3 nodes</span>
<a name="l00092"></a>00092           {
<a name="l00093"></a>00093             in &gt;&gt; node;
<a name="l00094"></a>00094             elem-&gt;<a class="code" href="classElem.php#135cbd216d30a1abaa52e43f4abe7329">set_node</a>(n) = mesh.<a class="code" href="classMeshBase.php#1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(node-1);  <span class="comment">// Assign the node number</span>
<a name="l00095"></a>00095           }
<a name="l00096"></a>00096         
<a name="l00097"></a>00097         <span class="comment">// There is an additional subdomain number here,</span>
<a name="l00098"></a>00098         <span class="comment">// so we read it and get rid of it!</span>
<a name="l00099"></a>00099         in &gt;&gt; dummy;
<a name="l00100"></a>00100       }
<a name="l00101"></a>00101   }
<a name="l00102"></a>00102   
<a name="l00103"></a>00103 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="1261f0e7a0d6284c4a1e321d13c3c3ec"></a><!-- doxytag: member="MatlabIO::skip_comment_lines" ref="1261f0e7a0d6284c4a1e321d13c3c3ec" args="(std::istream &amp;in, const char comment_start)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classMeshInput.php">MeshInput</a>&lt; <a class="el" href="classMeshBase.php">MeshBase</a>  &gt;::skip_comment_lines           </td>
          <td>(</td>
          <td class="paramtype">std::istream &amp;&nbsp;</td>
          <td class="paramname"> <em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char&nbsp;</td>
          <td class="paramname"> <em>comment_start</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reads input from <code>in</code>, skipping all the lines that start with the character <code>comment_start</code>. 
<p>Referenced by <a class="el" href="tetgen__io_8C_source.php#l00033">TetGenIO::read()</a>, and <a class="el" href="ucd__io_8C_source.php#l00107">UCDIO::read_implementation()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="matlab__io_8h_source.php">matlab_io.h</a><li><a class="el" href="matlab__io_8C_source.php">matlab_io.C</a></ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
