<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.php"><span>Class&nbsp;List</span></a></li>
      <li><a href="classes.php"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.php"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>RefinementSelector Class Reference</h1><!-- doxytag: class="RefinementSelector" --><code>#include &lt;<a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>&gt;</code>
<p>

<p>
<a href="classRefinementSelector-members.php">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#8e7a9f23515246948381ff7bc92fc5e7">RefinementSelector</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#ddddaebb143b3695f23809b93ef7acff">~RefinementSelector</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#9891700e7928634b66a4359689f76ff9">select_refinement</a> (const <a class="el" href="classSystem.php">System</a> &amp;system)</td></tr>

<tr><td colspan="2"><br><h2>Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; float &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classRefinementSelector.php#b59c0cb5e36a5788c86424be2db92be3">component_scale</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This abstract class provides an interface to methods for selecting the type of refinement to be used on each element in a given mesh. Currently we assume that a set of elements has already been flagged for h refinement, and the only concrete subclass will change some of those elements to be flagged for p refinement. Future subclasses may handle anisotropic refinement instead.<p>
<dl class="author" compact><dt><b>Author:</b></dt><dd>Roy H. Stogner, 2006. </dd></dl>

<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00046">46</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="8e7a9f23515246948381ff7bc92fc5e7"></a><!-- doxytag: member="RefinementSelector::RefinementSelector" ref="8e7a9f23515246948381ff7bc92fc5e7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">RefinementSelector::RefinementSelector           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor. Empty. 
<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00053">53</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00053"></a>00053 {}
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="ddddaebb143b3695f23809b93ef7acff"></a><!-- doxytag: member="RefinementSelector::~RefinementSelector" ref="ddddaebb143b3695f23809b93ef7acff" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual RefinementSelector::~RefinementSelector           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destructor. 
<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00058">58</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00058"></a>00058 {}
</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="9891700e7928634b66a4359689f76ff9"></a><!-- doxytag: member="RefinementSelector::select_refinement" ref="9891700e7928634b66a4359689f76ff9" args="(const System &amp;system)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void RefinementSelector::select_refinement           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classSystem.php">System</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>system</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
This pure virtual function must be redefined in derived classes to take a mesh flagged for h refinement and potentially change the desired refinement type. 
</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="b59c0cb5e36a5788c86424be2db92be3"></a><!-- doxytag: member="RefinementSelector::component_scale" ref="b59c0cb5e36a5788c86424be2db92be3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;float&gt; <a class="el" href="classRefinementSelector.php#b59c0cb5e36a5788c86424be2db92be3">RefinementSelector::component_scale</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
This vector can be used to "scale" certain variables in a system. If the mask is not empty, the consideration given to each component will be scaled by component_scale[c]. 
<p>Definition at line <a class="el" href="refinement__selector_8h_source.php#l00075">75</a> of file <a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="refinement__selector_8h_source.php">refinement_selector.h</a></ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
