<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.php"><span>Class&nbsp;List</span></a></li>
      <li><a href="classes.php"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.php"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Surface Class Reference</h1><!-- doxytag: class="Surface" --><code>#include &lt;<a class="el" href="surface_8h_source.php">surface.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Surface:</div>
<div class="dynsection">
<p><center><img src="classSurface__inherit__graph.png" border="0" usemap="#Surface__inherit__map" alt="Inheritance graph"></center>
<map name="Surface__inherit__map">
<area shape="rect" id="node3" href="classPlane.php" title="Plane" alt="" coords="5,86,64,117"><area shape="rect" id="node5" href="classSphere.php" title="Sphere" alt="" coords="88,86,155,117"></map>
<center><font size="2">[<a href="graph_legend.php">legend</a>]</font></center></div>

<p>
<a href="classSurface-members.php">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#8fc57f2a15292135c00545c9d224ec68">Surface</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#6a06e68159b7c22878599d81b3defbdc">Surface</a> (const <a class="el" href="classSurface.php">Surface</a> &amp;)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#44ff6a911acc4ada428c3d734f342a8a">~Surface</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#37cfeede124f5d1e9ada0ce5c791706a">above_surface</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#3105b56b3069916cb60dbb5afa5f6a62">below_surface</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#aa7f101ff25a02957c7a9e53e6d57532">on_surface</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#ae21735f15cf140d7c313d66226e007f">closest_point</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#8d8a8631247ff64332be872c5828be5a">unit_normal</a> (const <a class="el" href="classPoint.php">Point</a> &amp;p) const =0</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#00afc929b46acf6554a5be50c79a5769">surface_coords</a> (const <a class="el" href="classPoint.php">Point</a> &amp;world_coords) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classPoint.php">Point</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSurface.php#1e47cede5e7f87673132d27ef72633bb">world_coords</a> (const <a class="el" href="classPoint.php">Point</a> &amp;surf_coords) const </td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class defines a surface. A surface is a two-dimensional object living in three-dimensional space. Examples of surfaces are planes, hollow spheres, hollow cylinders, etc... This is a generic base class that describes the useful functionality a surface will provide. Specific derived classes actually implement the functionality, so this class has pure virtual members.<p>
<dl class="author" compact><dt><b>Author:</b></dt><dd>Benjamin S. Kirk, 2002 </dd></dl>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00044">44</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="8fc57f2a15292135c00545c9d224ec68"></a><!-- doxytag: member="Surface::Surface" ref="8fc57f2a15292135c00545c9d224ec68" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Surface::Surface           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor. Does nothing at the moment. 
<p>Definition at line <a class="el" href="surface_8h_source.php#l00051">51</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00051"></a>00051 {}
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="6a06e68159b7c22878599d81b3defbdc"></a><!-- doxytag: member="Surface::Surface" ref="6a06e68159b7c22878599d81b3defbdc" args="(const Surface &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Surface::Surface           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classSurface.php">Surface</a> &amp;&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Copy-constructor. 
<p>Definition at line <a class="el" href="surface_8h_source.php#l00056">56</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00056"></a>00056 {}
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="44ff6a911acc4ada428c3d734f342a8a"></a><!-- doxytag: member="Surface::~Surface" ref="44ff6a911acc4ada428c3d734f342a8a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Surface::~Surface           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destructor. 
<p>Definition at line <a class="el" href="surface_8h_source.php#l00061">61</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00061"></a>00061 {}
</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="37cfeede124f5d1e9ada0ce5c791706a"></a><!-- doxytag: member="Surface::above_surface" ref="37cfeede124f5d1e9ada0ce5c791706a" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Surface::above_surface           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if the point p is above the surface, false otherwise. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#4602c3eac515d90e7391b44f661eb0f9">Plane</a>, and <a class="el" href="classSphere.php#7c55ddf6e71f18aec75c7b836d75b84f">Sphere</a>.</p>

</div>
</div><p>
<a class="anchor" name="3105b56b3069916cb60dbb5afa5f6a62"></a><!-- doxytag: member="Surface::below_surface" ref="3105b56b3069916cb60dbb5afa5f6a62" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Surface::below_surface           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if the point p is below the surface, false otherwise. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#b7ab4751a24bb7211cfea1796216b1c0">Plane</a>, and <a class="el" href="classSphere.php#97a59b2ab1a320b4739b52b388387a68">Sphere</a>.</p>

</div>
</div><p>
<a class="anchor" name="ae21735f15cf140d7c313d66226e007f"></a><!-- doxytag: member="Surface::closest_point" ref="ae21735f15cf140d7c313d66226e007f" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classPoint.php">Point</a> Surface::closest_point           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>the closest point on the surface to point p. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#501daecf11d3b630e00a9d9146fc056e">Plane</a>, and <a class="el" href="classSphere.php#2d75d8d43b1e2d5549a068c7167d97e6">Sphere</a>.</p>

</div>
</div><p>
<a class="anchor" name="aa7f101ff25a02957c7a9e53e6d57532"></a><!-- doxytag: member="Surface::on_surface" ref="aa7f101ff25a02957c7a9e53e6d57532" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Surface::on_surface           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if the point p is on the surface, false otherwise. Note that the definition of on the surface really means "very close" to account for roundoff error. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#db2b4ea766a9da6df0e131825c8d1cff">Plane</a>, and <a class="el" href="classSphere.php#a76dbb36091a83101c8812ec96913193">Sphere</a>.</p>

</div>
</div><p>
<a class="anchor" name="00afc929b46acf6554a5be50c79a5769"></a><!-- doxytag: member="Surface::surface_coords" ref="00afc929b46acf6554a5be50c79a5769" args="(const Point &amp;world_coords) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPoint.php">Point</a> Surface::surface_coords           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>world_coords</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>the <code><a class="el" href="classPoint.php">Point</a></code> <code>world_coords</code> in the surface's coordinate system. <code>world_coords</code> is in the world coordinate system. This method is not purely virtual, because there may be surfaces that do not have an own coordinate system. These simply do not have to overload this method. </dd></dl>

<p>Reimplemented in <a class="el" href="classSphere.php#bf39c91886c0d9e5e8cfc6f1f8bf3a51">Sphere</a>.</p>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00120">120</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00121"></a>00121 {
<a name="l00122"></a>00122   <a class="code" href="classPoint.php">Point</a> p (world_coords);
<a name="l00123"></a>00123   <span class="keywordflow">return</span> p;
<a name="l00124"></a>00124 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="8d8a8631247ff64332be872c5828be5a"></a><!-- doxytag: member="Surface::unit_normal" ref="8d8a8631247ff64332be872c5828be5a" args="(const Point &amp;p) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classPoint.php">Point</a> Surface::unit_normal           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>a unit vector normal to the surface at point p. </dd></dl>

<p>Implemented in <a class="el" href="classPlane.php#7ea7aadc47cd4adec76933cf2d445553">Plane</a>, and <a class="el" href="classSphere.php#60b23e8ca4e87e8f0b1637546d4fb869">Sphere</a>.</p>

</div>
</div><p>
<a class="anchor" name="1e47cede5e7f87673132d27ef72633bb"></a><!-- doxytag: member="Surface::world_coords" ref="1e47cede5e7f87673132d27ef72633bb" args="(const Point &amp;surf_coords) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPoint.php">Point</a> Surface::world_coords           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classPoint.php">Point</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>surf_coords</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>the world (cartesian) coordinates for the surface coordinates <code>surf_coords</code>. This method is not purely virtual, because there may be surfaces that do not have an own coordinate system. These simply do not have to overload this method. </dd></dl>

<p>Reimplemented in <a class="el" href="classSphere.php#fa113ecc10c66fa8ba2e2c22626b32fe">Sphere</a>.</p>

<p>Definition at line <a class="el" href="surface_8h_source.php#l00129">129</a> of file <a class="el" href="surface_8h_source.php">surface.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00130"></a>00130 {
<a name="l00131"></a>00131   <a class="code" href="classPoint.php">Point</a> p (surf_coords);
<a name="l00132"></a>00132   <span class="keywordflow">return</span> p;
<a name="l00133"></a>00133 }
</pre></div>
<p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="surface_8h_source.php">surface.h</a></ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
