<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.php"><span>Class&nbsp;List</span></a></li>
      <li><a href="classes.php"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.php"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.php"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>SystemNorm Class Reference</h1><!-- doxytag: class="SystemNorm" --><code>#include &lt;<a class="el" href="system__norm_8h_source.php">system_norm.h</a>&gt;</code>
<p>

<p>
<a href="classSystemNorm-members.php">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#6cf0f181a09f25ff9b52ac4a78436738">SystemNorm</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#40956e9332c25e0b33bf8ff4609f637b">SystemNorm</a> (const FEMNormType &amp;t)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#f54096d7083e3b09bb5b217d0fa5e3ea">SystemNorm</a> (const std::vector&lt; FEMNormType &gt; &amp;norms)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#cdce1ba116c553de75c1630225b13249">SystemNorm</a> (const std::vector&lt; FEMNormType &gt; &amp;norms, std::vector&lt; <a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> &gt; &amp;weights)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#5c06a53b5a477fe53f38ab8989d5998d">SystemNorm</a> (const <a class="el" href="classSystemNorm.php">SystemNorm</a> &amp;s)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#9de80f3c79788788a192addd2c49bcc6">is_discrete</a> () const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">FEMNormType&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#486740c4dbb868404a39d1c315daa2df">type</a> (unsigned int var) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#e8b33ea25655f66a4acc368c79723fed">weight</a> (unsigned int var) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#5a1f8483b61f9a931014352ca678f684">weight_sq</a> (unsigned int var) const </td></tr>

<tr><td colspan="2"><br><h2>Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; FEMNormType &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; <a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; <a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class defines a norm/seminorm to be applied to a <a class="el" href="classNumericVector.php">NumericVector</a> which contains coefficients in a finite element space.<p>
Discrete vector norms and weighted l2 combinations of Sobolev norms and seminorms are representable.<p>
<dl class="author" compact><dt><b>Author:</b></dt><dd>Roy H. Stogner 2008 </dd></dl>

<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00046">46</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="6cf0f181a09f25ff9b52ac4a78436738"></a><!-- doxytag: member="SystemNorm::SystemNorm" ref="6cf0f181a09f25ff9b52ac4a78436738" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SystemNorm::SystemNorm           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor, defaults to DISCRETE_L2 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00119">119</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00119"></a>00119                        :
<a name="l00120"></a>00120     <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>(1, <a class="code" href="namespacelibMeshEnums.php#4448492d578e5ad9c23eddd1518a0098482797897c042873f53453795347edb6">DISCRETE_L2</a>), <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>(1, 1.0), <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>(1, 1.0)
<a name="l00121"></a>00121 { 
<a name="l00122"></a>00122 }

</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="40956e9332c25e0b33bf8ff4609f637b"></a><!-- doxytag: member="SystemNorm::SystemNorm" ref="40956e9332c25e0b33bf8ff4609f637b" args="(const FEMNormType &amp;t)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SystemNorm::SystemNorm           </td>
          <td>(</td>
          <td class="paramtype">const FEMNormType &amp;&nbsp;</td>
          <td class="paramname"> <em>t</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor, for discrete vector norms, systems with one variable, and systems for which the same norm type should be used with a weight of one on each variable. 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00126">126</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00126"></a>00126                                            :
<a name="l00127"></a>00127     <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>(1, t), <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>(1, 1.0), <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>(1, 1.0)
<a name="l00128"></a>00128 { 
<a name="l00129"></a>00129 }

</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="f54096d7083e3b09bb5b217d0fa5e3ea"></a><!-- doxytag: member="SystemNorm::SystemNorm" ref="f54096d7083e3b09bb5b217d0fa5e3ea" args="(const std::vector&lt; FEMNormType &gt; &amp;norms)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SystemNorm::SystemNorm           </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; FEMNormType &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>norms</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor, for unweighted sobolev norms on systems with multiple variables.<p>
For a system with n variables, the final norm will be the l2 norm of the n-vector of the norms in each variable. 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00133">133</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>References <a class="el" href="system__norm_8h_source.php#l00107">_norms</a>, and <a class="el" href="enum__norm__type_8h_source.php#l00049">libMeshEnums::DISCRETE_L2</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00133"></a>00133                                                           :
<a name="l00134"></a>00134     <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>(norms), <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>(1, 1.0), <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>(1, 1.0)
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136   <span class="keywordflow">if</span> (<a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.empty())
<a name="l00137"></a>00137     <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.push_back(<a class="code" href="namespacelibMeshEnums.php#4448492d578e5ad9c23eddd1518a0098482797897c042873f53453795347edb6">DISCRETE_L2</a>);
<a name="l00138"></a>00138 }

</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="cdce1ba116c553de75c1630225b13249"></a><!-- doxytag: member="SystemNorm::SystemNorm" ref="cdce1ba116c553de75c1630225b13249" args="(const std::vector&lt; FEMNormType &gt; &amp;norms, std::vector&lt; Real &gt; &amp;weights)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SystemNorm::SystemNorm           </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; FEMNormType &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>norms</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; <a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>weights</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor, for weighted sobolev norms on systems with multiple variables.<p>
For a system with n variables, the final norm will be the l2 norm of the n-vector of the norms in each variable, each multiplied by weight. 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00142">142</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>References <a class="el" href="system__norm_8h_source.php#l00107">_norms</a>, <a class="el" href="system__norm_8h_source.php#l00109">_weights</a>, <a class="el" href="system__norm_8h_source.php#l00110">_weights_sq</a>, and <a class="el" href="enum__norm__type_8h_source.php#l00049">libMeshEnums::DISCRETE_L2</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00143"></a>00143                                                  :
<a name="l00144"></a>00144     <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>(norms), <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>(weights), <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>(<a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>.size(), 0.0)
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146   <span class="keywordflow">if</span> (<a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.empty())
<a name="l00147"></a>00147     <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.push_back(<a class="code" href="namespacelibMeshEnums.php#4448492d578e5ad9c23eddd1518a0098482797897c042873f53453795347edb6">DISCRETE_L2</a>);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">if</span> (<a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>.empty())
<a name="l00150"></a>00150     {
<a name="l00151"></a>00151       <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>.push_back(1.0);
<a name="l00152"></a>00152       <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>.push_back(1.0);
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154   <span class="keywordflow">else</span>
<a name="l00155"></a>00155     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>.size(); ++i)
<a name="l00156"></a>00156       <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>[i] = <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>[i] * <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>[i];
<a name="l00157"></a>00157 }

</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="5c06a53b5a477fe53f38ab8989d5998d"></a><!-- doxytag: member="SystemNorm::SystemNorm" ref="5c06a53b5a477fe53f38ab8989d5998d" args="(const SystemNorm &amp;s)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SystemNorm::SystemNorm           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classSystemNorm.php">SystemNorm</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>s</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Copy Constructor 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00161">161</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00161"></a>00161                                           :
<a name="l00162"></a>00162     <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>(s.<a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>), <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>(s.<a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>), <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>(s.<a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>)
<a name="l00163"></a>00163 {
<a name="l00164"></a>00164 }

</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="9de80f3c79788788a192addd2c49bcc6"></a><!-- doxytag: member="SystemNorm::is_discrete" ref="9de80f3c79788788a192addd2c49bcc6" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool SystemNorm::is_discrete           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns true if this is purely a discrete norm 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00168">168</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>References <a class="el" href="system__norm_8h_source.php#l00107">_norms</a>, <a class="el" href="enum__norm__type_8h_source.php#l00048">libMeshEnums::DISCRETE_L1</a>, <a class="el" href="enum__norm__type_8h_source.php#l00049">libMeshEnums::DISCRETE_L2</a>, and <a class="el" href="enum__norm__type_8h_source.php#l00050">libMeshEnums::DISCRETE_L_INF</a>.</p>

<p>Referenced by <a class="el" href="system_8C_source.php#l00845">System::calculate_norm()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00169"></a>00169 {
<a name="l00170"></a>00170   libmesh_assert (!<a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.empty());
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="keywordflow">if</span> (<a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#4448492d578e5ad9c23eddd1518a0098d5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a> ||
<a name="l00173"></a>00173       <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#4448492d578e5ad9c23eddd1518a0098482797897c042873f53453795347edb6">DISCRETE_L2</a> ||
<a name="l00174"></a>00174       <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#4448492d578e5ad9c23eddd1518a0098e354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l00175"></a>00175     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00178"></a>00178 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="486740c4dbb868404a39d1c315daa2df"></a><!-- doxytag: member="SystemNorm::type" ref="486740c4dbb868404a39d1c315daa2df" args="(unsigned int var) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">FEMNormType SystemNorm::type           </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>var</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the type of the norm in variable <code>var</code> 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00182">182</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>References <a class="el" href="system__norm_8h_source.php#l00107">_norms</a>.</p>

<p>Referenced by <a class="el" href="system_8C_source.php#l00845">System::calculate_norm()</a>, <a class="el" href="error__estimator_8C_source.php#l00092">ErrorEstimator::estimate_errors()</a>, <a class="el" href="exact__error__estimator_8C_source.php#l00287">ExactErrorEstimator::find_squared_element_error()</a>, and <a class="el" href="patch__recovery__error__estimator_8C_source.php#l00170">PatchRecoveryErrorEstimator::EstimateError::operator()()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00183"></a>00183 {
<a name="l00184"></a>00184   libmesh_assert (!<a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.empty());
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = (var &lt; <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.size()) ? var : <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>.size() - 1;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <span class="keywordflow">return</span> <a class="code" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">_norms</a>[i];
<a name="l00189"></a>00189 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="e8b33ea25655f66a4acc368c79723fed"></a><!-- doxytag: member="SystemNorm::weight" ref="e8b33ea25655f66a4acc368c79723fed" args="(unsigned int var) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> SystemNorm::weight           </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>var</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the weight corresponding to the norm in variable <code>var</code> 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00193">193</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>References <a class="el" href="system__norm_8h_source.php#l00109">_weights</a>.</p>

<p>Referenced by <a class="el" href="kelly__error__estimator_8C_source.php#l00099">KellyErrorEstimator::boundary_side_integration()</a>, <a class="el" href="discontinuity__measure_8C_source.php#l00095">DiscontinuityMeasure::boundary_side_integration()</a>, <a class="el" href="system_8C_source.php#l00845">System::calculate_norm()</a>, <a class="el" href="jump__error__estimator_8C_source.php#l00052">JumpErrorEstimator::estimate_error()</a>, <a class="el" href="kelly__error__estimator_8C_source.php#l00058">KellyErrorEstimator::internal_side_integration()</a>, <a class="el" href="fourth__error__estimators_8C_source.php#l00056">LaplacianErrorEstimator::internal_side_integration()</a>, <a class="el" href="discontinuity__measure_8C_source.php#l00056">DiscontinuityMeasure::internal_side_integration()</a>, and <a class="el" href="patch__recovery__error__estimator_8C_source.php#l00170">PatchRecoveryErrorEstimator::EstimateError::operator()()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00194"></a>00194 {
<a name="l00195"></a>00195   libmesh_assert (!<a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>.empty());
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = (var &lt; <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>.size()) ? var : <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>.size() - 1;
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="keywordflow">return</span> <a class="code" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">_weights</a>[i];
<a name="l00200"></a>00200 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="5a1f8483b61f9a931014352ca678f684"></a><!-- doxytag: member="SystemNorm::weight_sq" ref="5a1f8483b61f9a931014352ca678f684" args="(unsigned int var) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> SystemNorm::weight_sq           </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>var</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the squared weight corresponding to the norm in variable <code>var</code>. We cache that at construction time to save a few flops. 
<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00204">204</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>References <a class="el" href="system__norm_8h_source.php#l00110">_weights_sq</a>.</p>

<p>Referenced by <a class="el" href="system_8C_source.php#l00845">System::calculate_norm()</a>, and <a class="el" href="patch__recovery__error__estimator_8C_source.php#l00170">PatchRecoveryErrorEstimator::EstimateError::operator()()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00205"></a>00205 {
<a name="l00206"></a>00206   libmesh_assert (!<a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>.empty());
<a name="l00207"></a>00207   
<a name="l00208"></a>00208   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = (var &lt; <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>.size()) ? var : <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>.size() - 1;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="keywordflow">return</span> <a class="code" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">_weights_sq</a>[i];
<a name="l00211"></a>00211 }
</pre></div>
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="0e5242446f19ad6d1576b6959d9c8cb6"></a><!-- doxytag: member="SystemNorm::_norms" ref="0e5242446f19ad6d1576b6959d9c8cb6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;FEMNormType&gt; <a class="el" href="classSystemNorm.php#0e5242446f19ad6d1576b6959d9c8cb6">SystemNorm::_norms</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00107">107</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>Referenced by <a class="el" href="system__norm_8h_source.php#l00168">is_discrete()</a>, <a class="el" href="system__norm_8h_source.php#l00133">SystemNorm()</a>, and <a class="el" href="system__norm_8h_source.php#l00182">type()</a>.</p>

</div>
</div><p>
<a class="anchor" name="44966b619151a4b7cb52ebb83798484c"></a><!-- doxytag: member="SystemNorm::_weights" ref="44966b619151a4b7cb52ebb83798484c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a>&gt; <a class="el" href="classSystemNorm.php#44966b619151a4b7cb52ebb83798484c">SystemNorm::_weights</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00109">109</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>Referenced by <a class="el" href="system__norm_8h_source.php#l00142">SystemNorm()</a>, and <a class="el" href="system__norm_8h_source.php#l00193">weight()</a>.</p>

</div>
</div><p>
<a class="anchor" name="6dd9634ecbfe6f9f6ef0297206e468c7"></a><!-- doxytag: member="SystemNorm::_weights_sq" ref="6dd9634ecbfe6f9f6ef0297206e468c7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a>&gt; <a class="el" href="classSystemNorm.php#6dd9634ecbfe6f9f6ef0297206e468c7">SystemNorm::_weights_sq</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="system__norm_8h_source.php#l00110">110</a> of file <a class="el" href="system__norm_8h_source.php">system_norm.h</a>.</p>

<p>Referenced by <a class="el" href="system__norm_8h_source.php#l00142">SystemNorm()</a>, and <a class="el" href="system__norm_8h_source.php#l00204">weight_sq()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="system__norm_8h_source.php">system_norm.h</a></ul>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
