<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_17ac460506c8e7bb91dbc4cd8f04436f.php">numerics</a>
  </div>
</div>
<div class="contents">
<h1>dense_matrix.C</h1><a href="dense__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for sqrt</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "<a class="code" href="dense__vector_8h.php">dense_vector.h</a>"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "<a class="code" href="libmesh_8h.php">libmesh.h</a>"</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Dense Matrix member functions</span>
<a name="l00033"></a>00033 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00034"></a><a class="code" href="classDenseMatrix.php#7d06b0e1e75022a5fbdcbc4171ac6b5b">00034</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7d06b0e1e75022a5fbdcbc4171ac6b5b">DenseMatrix&lt;T&gt;::left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   <span class="comment">// (*this) &lt;- M2 * M3</span>
<a name="l00037"></a>00037   <span class="comment">// Where:</span>
<a name="l00038"></a>00038   <span class="comment">// (*this) = (m x n),</span>
<a name="l00039"></a>00039   <span class="comment">// M2      = (m x p),</span>
<a name="l00040"></a>00040   <span class="comment">// M3      = (p x n)</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// M3 is a copy of *this before it gets resize()d</span>
<a name="l00043"></a>00043   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> M3(*<span class="keyword">this</span>);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="comment">// Resize *this so that the result can fit</span>
<a name="l00046"></a>00046   this-&gt;<a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a> (M2.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(), M3.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="comment">// Call the multiply function in the base class</span>
<a name="l00049"></a>00049   this-&gt;<a class="code" href="classDenseMatrixBase.php#504aa639ac3d2619555b947bb8c9bb9b">multiply</a>(*<span class="keyword">this</span>, M2, M3);
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00056"></a><a class="code" href="classDenseMatrix.php#62832696c265cff213ff133f9e73ef34">00056</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#62832696c265cff213ff133f9e73ef34">DenseMatrix&lt;T&gt;::left_multiply_transpose</a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A)
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <span class="comment">//Check to see if we are doing (A^T)*A</span>
<a name="l00059"></a>00059   <span class="keywordflow">if</span> (<span class="keyword">this</span> == &amp;A)
<a name="l00060"></a>00060     {
<a name="l00061"></a>00061       <span class="comment">//libmesh_here();</span>
<a name="l00062"></a>00062       <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> B(*<span class="keyword">this</span>);
<a name="l00063"></a>00063       
<a name="l00064"></a>00064       <span class="comment">// Simple but inefficient way</span>
<a name="l00065"></a>00065       <span class="comment">// return this-&gt;left_multiply_transpose(B);</span>
<a name="l00066"></a>00066 
<a name="l00067"></a>00067       <span class="comment">// More efficient, but more code way</span>
<a name="l00068"></a>00068       <span class="comment">// If A is mxn, the result will be a square matrix of Size n x n.</span>
<a name="l00069"></a>00069       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a> = A.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00070"></a>00070       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a> = A.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072       <span class="comment">// resize() *this and also zero out all entries.</span>
<a name="l00073"></a>00073       this-&gt;<a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a>(n,n);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075       <span class="comment">// Compute the lower-triangular part</span>
<a name="l00076"></a>00076       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00077"></a>00077         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; ++j)
<a name="l00078"></a>00078           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;m; ++k) <span class="comment">// inner products are over m</span>
<a name="l00079"></a>00079             (*<span class="keyword">this</span>)(i,j) += B(k,i)*B(k,j);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081       <span class="comment">// Copy lower-triangular part into upper-triangular part</span>
<a name="l00082"></a>00082       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00083"></a>00083         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;n; ++j)
<a name="l00084"></a>00084           (*<span class="keyword">this</span>)(i,j) = (*<span class="keyword">this</span>)(j,i);
<a name="l00085"></a>00085     }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="keywordflow">else</span>
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089       <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> B(*<span class="keyword">this</span>);
<a name="l00090"></a>00090   
<a name="l00091"></a>00091       this-&gt;<a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a> (A.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>(), B.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00092"></a>00092       
<a name="l00093"></a>00093       libmesh_assert (A.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>() == B.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00094"></a>00094       libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>() == A.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00095"></a>00095       libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>() == B.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00096"></a>00096       
<a name="l00097"></a>00097       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_s = A.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00098"></a>00098       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_s = A.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(); 
<a name="l00099"></a>00099       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_s = this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00100"></a>00100   
<a name="l00101"></a>00101       <span class="comment">// Do it this way because there is a</span>
<a name="l00102"></a>00102       <span class="comment">// decent chance (at least for constraint matrices)</span>
<a name="l00103"></a>00103       <span class="comment">// that A.transpose(i,k) = 0.</span>
<a name="l00104"></a>00104       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m_s; i++)
<a name="l00105"></a>00105         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;p_s; k++)
<a name="l00106"></a>00106           <span class="keywordflow">if</span> (A.<a class="code" href="classDenseMatrix.php#4ce520268efceb0e68897595d3b38318">transpose</a>(i,k) != 0.)
<a name="l00107"></a>00107             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_s; j++)
<a name="l00108"></a>00108               (*<span class="keyword">this</span>)(i,j) += A.<a class="code" href="classDenseMatrix.php#4ce520268efceb0e68897595d3b38318">transpose</a>(i,k)*B(k,j);
<a name="l00109"></a>00109     }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00119"></a><a class="code" href="classDenseMatrix.php#56e32ffe655816974245f3daef9f6581">00119</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#56e32ffe655816974245f3daef9f6581">DenseMatrix&lt;T&gt;::right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3)
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121   <span class="comment">// (*this) &lt;- M2 * M3</span>
<a name="l00122"></a>00122   <span class="comment">// Where:</span>
<a name="l00123"></a>00123   <span class="comment">// (*this) = (m x n),</span>
<a name="l00124"></a>00124   <span class="comment">// M2      = (m x p),</span>
<a name="l00125"></a>00125   <span class="comment">// M3      = (p x n)</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="comment">// M2 is a copy of *this before it gets resize()d</span>
<a name="l00128"></a>00128   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> M2(*<span class="keyword">this</span>);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="comment">// Resize *this so that the result can fit</span>
<a name="l00131"></a>00131   this-&gt;<a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a> (M2.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(), M3.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   this-&gt;<a class="code" href="classDenseMatrixBase.php#504aa639ac3d2619555b947bb8c9bb9b">multiply</a>(*<span class="keyword">this</span>, M2, M3);
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00140"></a><a class="code" href="classDenseMatrix.php#8a041f8b6c2f50de27565618331b16fb">00140</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#8a041f8b6c2f50de27565618331b16fb">DenseMatrix&lt;T&gt;::right_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; B)
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   <span class="comment">//Check to see if we are doing B*(B^T)</span>
<a name="l00143"></a>00143   <span class="keywordflow">if</span> (<span class="keyword">this</span> == &amp;B)
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       <span class="comment">//libmesh_here();</span>
<a name="l00146"></a>00146       <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00147"></a>00147       
<a name="l00148"></a>00148       <span class="comment">// Simple but inefficient way</span>
<a name="l00149"></a>00149       <span class="comment">// return this-&gt;right_multiply_transpose(A);</span>
<a name="l00150"></a>00150 
<a name="l00151"></a>00151       <span class="comment">// More efficient, more code</span>
<a name="l00152"></a>00152       <span class="comment">// If B is mxn, the result will be a square matrix of Size m x m.</span>
<a name="l00153"></a>00153       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a> = B.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00154"></a>00154       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a> = B.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00155"></a>00155 
<a name="l00156"></a>00156       <span class="comment">// resize() *this and also zero out all entries.</span>
<a name="l00157"></a>00157       this-&gt;<a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a>(m,m);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159       <span class="comment">// Compute the lower-triangular part</span>
<a name="l00160"></a>00160       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00161"></a>00161         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; ++j)
<a name="l00162"></a>00162           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;n; ++k) <span class="comment">// inner products are over n</span>
<a name="l00163"></a>00163             (*<span class="keyword">this</span>)(i,j) += A(i,k)*A(j,k);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165       <span class="comment">// Copy lower-triangular part into upper-triangular part</span>
<a name="l00166"></a>00166       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00167"></a>00167         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;m; ++j)
<a name="l00168"></a>00168           (*<span class="keyword">this</span>)(i,j) = (*<span class="keyword">this</span>)(j,i);
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="keywordflow">else</span>
<a name="l00172"></a>00172     {
<a name="l00173"></a>00173       <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00174"></a>00174   
<a name="l00175"></a>00175       this-&gt;<a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a> (A.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(), B.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00176"></a>00176       
<a name="l00177"></a>00177       libmesh_assert (A.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>() == B.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00178"></a>00178       libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>() == A.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00179"></a>00179       libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>() == B.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00180"></a>00180       
<a name="l00181"></a>00181       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_s = A.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00182"></a>00182       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_s = A.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>(); 
<a name="l00183"></a>00183       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_s = this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185       <span class="comment">// Do it this way because there is a</span>
<a name="l00186"></a>00186       <span class="comment">// decent chance (at least for constraint matrices)</span>
<a name="l00187"></a>00187       <span class="comment">// that B.transpose(k,j) = 0.</span>
<a name="l00188"></a>00188       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_s; j++)
<a name="l00189"></a>00189         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;p_s; k++)
<a name="l00190"></a>00190           <span class="keywordflow">if</span> (B.<a class="code" href="classDenseMatrix.php#4ce520268efceb0e68897595d3b38318">transpose</a>(k,j) != 0.)
<a name="l00191"></a>00191             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m_s; i++)
<a name="l00192"></a>00192               (*<span class="keyword">this</span>)(i,j) += A(i,k)*B.<a class="code" href="classDenseMatrix.php#4ce520268efceb0e68897595d3b38318">transpose</a>(k,j);
<a name="l00193"></a>00193     }
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00197"></a><a class="code" href="classDenseMatrix.php#0c25dd3e8d8093f7443c4b6689c73b10">00197</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#0c25dd3e8d8093f7443c4b6689c73b10">DenseMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00198"></a>00198                                   <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00199"></a>00199 <span class="keyword"></span>{
<a name="l00200"></a>00200   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00201"></a>00201   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cols = this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="comment">// Make sure the sizes are compatible</span>
<a name="l00204"></a>00204   libmesh_assert(n_cols == arg.<a class="code" href="classDenseVector.php#1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00205"></a>00205   libmesh_assert(n_rows == dest.<a class="code" href="classDenseVector.php#1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   dest.<a class="code" href="classDenseVector.php#4e0123eb5cc4054e8069155f0faf4425">zero</a>();
<a name="l00208"></a>00208   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_rows; i++)
<a name="l00211"></a>00211     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_cols; j++)
<a name="l00212"></a>00212       dest(i) += A(i,j)*arg(j);
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00216"></a><a class="code" href="classDenseMatrix.php#e1716bba5985ba4753b74fba4e9a7d90">00216</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> <a class="code" href="classDenseMatrix.php#e1716bba5985ba4753b74fba4e9a7d90">DenseMatrix&lt;T&gt;::get_transpose</a> ()<span class="keyword"> const</span>
<a name="l00217"></a>00217 <span class="keyword"></span>{
<a name="l00218"></a>00218   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> transposed_matrix(this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>(), this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;transposed_matrix.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(); i++)
<a name="l00221"></a>00221     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;transposed_matrix.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>(); j++)
<a name="l00222"></a>00222       transposed_matrix(i,j) = (*this)(j,i);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="keywordflow">return</span> transposed_matrix;
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00229"></a><a class="code" href="classDenseMatrix.php#477240f22a12d4bcf761b490414f4491">00229</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#477240f22a12d4bcf761b490414f4491">DenseMatrix&lt;T&gt;::lu_solve</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00230"></a>00230                                <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00231"></a>00231                                <span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot)
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   <span class="comment">// Check for a previous decomposition</span>
<a name="l00234"></a>00234   <span class="keywordflow">switch</span>(this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>)
<a name="l00235"></a>00235     {
<a name="l00236"></a>00236     <span class="keywordflow">case</span> <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>:
<a name="l00237"></a>00237       {
<a name="l00238"></a>00238         this-&gt;<a class="code" href="classDenseMatrix.php#d8001c2fe3b274823a2bcf237887886a">_lu_decompose</a> (partial_pivot);
<a name="l00239"></a>00239         <span class="keywordflow">break</span>;
<a name="l00240"></a>00240       }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     <span class="keywordflow">case</span> <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79b75f9cd205ebf1b98c8b6763531a9d4b">LU</a>:
<a name="l00243"></a>00243       {
<a name="l00244"></a>00244         <span class="comment">// Already factored, just need to call back_substitute.</span>
<a name="l00245"></a>00245         <span class="keywordflow">break</span>;
<a name="l00246"></a>00246       }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248     <span class="keywordflow">default</span>:
<a name="l00249"></a>00249       {
<a name="l00250"></a>00250         std::cerr &lt;&lt; <span class="stringliteral">"Error! This matrix already has a "</span>
<a name="l00251"></a>00251                   &lt;&lt; <span class="stringliteral">"different decomposition..."</span>
<a name="l00252"></a>00252                   &lt;&lt; std::endl;
<a name="l00253"></a>00253         libmesh_error();
<a name="l00254"></a>00254       }
<a name="l00255"></a>00255     }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="comment">// Perform back substitution</span>
<a name="l00258"></a>00258   this-&gt;<a class="code" href="classDenseMatrix.php#7162cded87fb34d00501233ca808c3fa">_lu_back_substitute</a> (b, x, partial_pivot);
<a name="l00259"></a>00259 }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00264"></a><a class="code" href="classDenseMatrix.php#7162cded87fb34d00501233ca808c3fa">00264</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7162cded87fb34d00501233ca808c3fa">DenseMatrix&lt;T&gt;::_lu_back_substitute</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00265"></a>00265                                           <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00266"></a>00266                                           <span class="keyword">const</span> <span class="keywordtype">bool</span> )<span class="keyword"> const</span>
<a name="l00267"></a>00267 <span class="keyword"></span>{
<a name="l00268"></a>00268   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00269"></a>00269     <a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a> = this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>() == n);
<a name="l00272"></a>00272   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>() == b.<a class="code" href="classDenseVector.php#1787e281ed3310eb776e77142562b68d">size</a>());
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   x.<a class="code" href="classDenseVector.php#3a9af103dc052f1dfdef1626692cd8cd">resize</a> (n);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   <span class="comment">// A convenient reference to *this</span>
<a name="l00277"></a>00277   <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   <span class="comment">// Transform the RHS vector</span>
<a name="l00280"></a>00280   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(n-1); i++)
<a name="l00281"></a>00281     {
<a name="l00282"></a>00282       <span class="comment">// Get the diagonal entry and take its inverse</span>
<a name="l00283"></a>00283       <span class="keyword">const</span> T diag = A(i,i);
<a name="l00284"></a>00284       
<a name="l00285"></a>00285       libmesh_assert (diag != <a class="code" href="namespacelibMesh.php#7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00286"></a>00286   
<a name="l00287"></a>00287       <span class="keyword">const</span> T diag_inv = 1./diag;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289       <span class="comment">// Get the entry b(i) and store it</span>
<a name="l00290"></a>00290       <span class="keyword">const</span> T bi = b(i);
<a name="l00291"></a>00291       
<a name="l00292"></a>00292       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=(i+1); j&lt;n; j++)
<a name="l00293"></a>00293         b(j) -= bi*A(j,i)*diag_inv;
<a name="l00294"></a>00294     }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="comment">// Perform back-substitution</span>
<a name="l00298"></a>00298   {
<a name="l00299"></a>00299     x(n-1) = b(n-1)/A(n-1,n-1);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=(n-1); i++)
<a name="l00302"></a>00302       {
<a name="l00303"></a>00303         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ib = (n-1)-i;
<a name="l00304"></a>00304 
<a name="l00305"></a>00305         <span class="comment">// Get the diagonal and take its inverse</span>
<a name="l00306"></a>00306         <span class="keyword">const</span> T diag = A(ib,ib);
<a name="l00307"></a>00307 
<a name="l00308"></a>00308         libmesh_assert (diag != <a class="code" href="namespacelibMesh.php#7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00309"></a>00309 
<a name="l00310"></a>00310         <span class="keyword">const</span> T diag_inv = 1./diag;
<a name="l00311"></a>00311         
<a name="l00312"></a>00312         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=(ib+1); j&lt;n; j++)
<a name="l00313"></a>00313           {
<a name="l00314"></a>00314             b(ib) -= A(ib,j)*x(j);
<a name="l00315"></a>00315             x(ib)  = b(ib)*diag_inv;
<a name="l00316"></a>00316           }
<a name="l00317"></a>00317       }
<a name="l00318"></a>00318   }
<a name="l00319"></a>00319 }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00323"></a><a class="code" href="classDenseMatrix.php#d8001c2fe3b274823a2bcf237887886a">00323</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#d8001c2fe3b274823a2bcf237887886a">DenseMatrix&lt;T&gt;::_lu_decompose</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot)
<a name="l00324"></a>00324 {
<a name="l00325"></a>00325   <span class="comment">// If this function was called, there better not be any</span>
<a name="l00326"></a>00326   <span class="comment">// previous decomposition of the matrix.</span>
<a name="l00327"></a>00327   libmesh_assert(this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> == <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>);
<a name="l00328"></a>00328   
<a name="l00329"></a>00329   <span class="comment">// Get the matrix size and make sure it is square</span>
<a name="l00330"></a>00330   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00331"></a>00331     <a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a> = this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>();
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   libmesh_assert (m == this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="comment">// A convenient reference to *this</span>
<a name="l00336"></a>00336   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00337"></a>00337   
<a name="l00338"></a>00338   <span class="comment">// Straight, vanilla LU factorization without pivoting</span>
<a name="l00339"></a>00339   <span class="keywordflow">if</span> (!partial_pivot)
<a name="l00340"></a>00340     {
<a name="l00341"></a>00341       
<a name="l00342"></a>00342       <span class="comment">// For each row in the matrix</span>
<a name="l00343"></a>00343       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; i++)
<a name="l00344"></a>00344         {
<a name="l00345"></a>00345           <span class="comment">// Get the diagonal entry and take its inverse</span>
<a name="l00346"></a>00346           <span class="keyword">const</span> T diag = A(i,i);
<a name="l00347"></a>00347 
<a name="l00348"></a>00348           libmesh_assert (diag != <a class="code" href="namespacelibMesh.php#7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350           <span class="keyword">const</span> T diag_inv = 1./diag;
<a name="l00351"></a>00351           
<a name="l00352"></a>00352           <span class="comment">// For each row in the submatrix</span>
<a name="l00353"></a>00353           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;m; j++)
<a name="l00354"></a>00354             {
<a name="l00355"></a>00355               <span class="comment">// Get the scale factor for this row</span>
<a name="l00356"></a>00356               <span class="keyword">const</span> T fact = A(j,i)*diag_inv;
<a name="l00357"></a>00357               
<a name="l00358"></a>00358               <span class="comment">// For each column in the subrow scale it</span>
<a name="l00359"></a>00359               <span class="comment">// by the factor</span>
<a name="l00360"></a>00360               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=i+1; k&lt;m; k++)
<a name="l00361"></a>00361                 A(j,k) -= fact*A(i,k);        
<a name="l00362"></a>00362             }
<a name="l00363"></a>00363         }
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365   
<a name="l00366"></a>00366   <span class="comment">// Do partial pivoting.</span>
<a name="l00367"></a>00367   <span class="keywordflow">else</span>
<a name="l00368"></a>00368     {
<a name="l00369"></a>00369       libmesh_error();
<a name="l00370"></a>00370     }
<a name="l00371"></a>00371   
<a name="l00372"></a>00372   <span class="comment">// Set the flag for LU decomposition</span>
<a name="l00373"></a>00373   this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79b75f9cd205ebf1b98c8b6763531a9d4b">LU</a>;
<a name="l00374"></a>00374 }
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00379"></a><a class="code" href="classDenseMatrix.php#9555f223e2e4e08461ffc68b9b252fb5">00379</a> T <a class="code" href="classDenseMatrix.php#9555f223e2e4e08461ffc68b9b252fb5">DenseMatrix&lt;T&gt;::det</a> ()
<a name="l00380"></a>00380 {
<a name="l00381"></a>00381   <span class="comment">// First LU decompose the matrix (without partial pivoting).</span>
<a name="l00382"></a>00382   <span class="comment">// Note that the lu_decompose routine will check to see if the</span>
<a name="l00383"></a>00383   <span class="comment">// matrix is square so we don't worry about it.</span>
<a name="l00384"></a>00384   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> == <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>)
<a name="l00385"></a>00385     this-&gt;<a class="code" href="classDenseMatrix.php#d8001c2fe3b274823a2bcf237887886a">_lu_decompose</a>(<span class="keyword">false</span>);
<a name="l00386"></a>00386   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> != <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79b75f9cd205ebf1b98c8b6763531a9d4b">LU</a>)
<a name="l00387"></a>00387     {
<a name="l00388"></a>00388       std::cerr &lt;&lt; <span class="stringliteral">"Error! Can't compute the determinant under "</span>
<a name="l00389"></a>00389                 &lt;&lt; <span class="stringliteral">"the current decomposition."</span>
<a name="l00390"></a>00390                 &lt;&lt; std::endl;
<a name="l00391"></a>00391       libmesh_error();
<a name="l00392"></a>00392     }
<a name="l00393"></a>00393   
<a name="l00394"></a>00394   <span class="comment">// A variable to keep track of the running product of diagonal terms.</span>
<a name="l00395"></a>00395   T determinant = 1.;
<a name="l00396"></a>00396   
<a name="l00397"></a>00397   <span class="comment">// Loop over diagonal terms, computing the product.  In practice,</span>
<a name="l00398"></a>00398   <span class="comment">// be careful because this value could easily become too large to</span>
<a name="l00399"></a>00399   <span class="comment">// fit in a double or float.  To be safe, one should keep track of</span>
<a name="l00400"></a>00400   <span class="comment">// the power (of 10) of the determinant in a separate variable</span>
<a name="l00401"></a>00401   <span class="comment">// and maintain an order 1 value for the determinant itself.</span>
<a name="l00402"></a>00402   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(); i++)
<a name="l00403"></a>00403     determinant *= (*<span class="keyword">this</span>)(i,i);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="comment">// Return the determinant</span>
<a name="l00406"></a>00406   <span class="keywordflow">return</span> determinant;
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 <span class="comment">// The cholesky solve function first decomposes the matrix</span>
<a name="l00412"></a>00412 <span class="comment">// with cholesky_decompose and then uses the cholesky_back_substitute</span>
<a name="l00413"></a>00413 <span class="comment">// routine to find the solution x.</span>
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00415"></a>00415 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00416"></a><a class="code" href="classDenseMatrix.php#7303f17ad11891bc43f2533688347f15">00416</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;T&gt;::cholesky_solve</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00417"></a>00417                                      <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x)
<a name="l00418"></a>00418 {
<a name="l00419"></a>00419   <span class="comment">// Check for a previous decomposition</span>
<a name="l00420"></a>00420   <span class="keywordflow">switch</span>(this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>)
<a name="l00421"></a>00421     {
<a name="l00422"></a>00422     <span class="keywordflow">case</span> <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>:
<a name="l00423"></a>00423       {
<a name="l00424"></a>00424         this-&gt;<a class="code" href="classDenseMatrix.php#a501a38d3d515b0abc6c83b243004aed">_cholesky_decompose</a> ();
<a name="l00425"></a>00425         <span class="keywordflow">break</span>;
<a name="l00426"></a>00426       }
<a name="l00427"></a>00427 
<a name="l00428"></a>00428     <span class="keywordflow">case</span> <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf790fd7d13452689b7c2cc7fab76c43c1db">CHOLESKY</a>:
<a name="l00429"></a>00429       {
<a name="l00430"></a>00430         <span class="comment">// Already factored, just need to call back_substitute.</span>
<a name="l00431"></a>00431         <span class="keywordflow">break</span>;
<a name="l00432"></a>00432       }
<a name="l00433"></a>00433       
<a name="l00434"></a>00434     <span class="keywordflow">default</span>:
<a name="l00435"></a>00435       {
<a name="l00436"></a>00436         std::cerr &lt;&lt; <span class="stringliteral">"Error! This matrix already has a "</span>
<a name="l00437"></a>00437                   &lt;&lt; <span class="stringliteral">"different decomposition..."</span>
<a name="l00438"></a>00438                   &lt;&lt; std::endl;
<a name="l00439"></a>00439         libmesh_error();
<a name="l00440"></a>00440       }
<a name="l00441"></a>00441     }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="comment">// Perform back substitution</span>
<a name="l00444"></a>00444   this-&gt;<a class="code" href="classDenseMatrix.php#1dd46dd8b694003773ba285c3d0a7857">_cholesky_back_substitute</a> (b, x);
<a name="l00445"></a>00445 }
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 <span class="comment">// This algorithm is based on the Cholesky decomposition in</span>
<a name="l00451"></a>00451 <span class="comment">// the Numerical Recipes in C book.</span>
<a name="l00452"></a>00452 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00453"></a><a class="code" href="classDenseMatrix.php#a501a38d3d515b0abc6c83b243004aed">00453</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a501a38d3d515b0abc6c83b243004aed">DenseMatrix&lt;T&gt;::_cholesky_decompose</a> ()
<a name="l00454"></a>00454 {
<a name="l00455"></a>00455   <span class="comment">// If we called this function, there better not be any</span>
<a name="l00456"></a>00456   <span class="comment">// previous decomposition of the matrix.</span>
<a name="l00457"></a>00457   libmesh_assert(this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> == <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>);
<a name="l00458"></a>00458   
<a name="l00459"></a>00459   <span class="comment">// Shorthand notation for number of rows and columns.</span>
<a name="l00460"></a>00460   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00461"></a>00461     <a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a> = this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(),
<a name="l00462"></a>00462     <a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a> = this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00463"></a>00463 
<a name="l00464"></a>00464   <span class="comment">// Just to be really sure...</span>
<a name="l00465"></a>00465   libmesh_assert(m==<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>);
<a name="l00466"></a>00466 
<a name="l00467"></a>00467   <span class="comment">// A convenient reference to *this</span>
<a name="l00468"></a>00468   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00469"></a>00469   
<a name="l00470"></a>00470   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00471"></a>00471     {
<a name="l00472"></a>00472       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i; j&lt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>; ++j)
<a name="l00473"></a>00473         {
<a name="l00474"></a>00474           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;i; ++k)
<a name="l00475"></a>00475             A(i,j) -= A(i,k) * A(j,k);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477           <span class="keywordflow">if</span> (i == j)
<a name="l00478"></a>00478             {
<a name="l00479"></a>00479 <span class="preprocessor">#ifndef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00480"></a>00480 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (A(i,j) &lt;= 0.0)
<a name="l00481"></a>00481                 {
<a name="l00482"></a>00482                   std::cerr &lt;&lt; <span class="stringliteral">"Error! Can only use Cholesky decomposition "</span>
<a name="l00483"></a>00483                             &lt;&lt; <span class="stringliteral">"with symmetric positive definite matrices."</span>
<a name="l00484"></a>00484                             &lt;&lt; std::endl;
<a name="l00485"></a>00485                   libmesh_error();
<a name="l00486"></a>00486                 }
<a name="l00487"></a>00487 <span class="preprocessor">#endif</span>
<a name="l00488"></a>00488 <span class="preprocessor"></span>
<a name="l00489"></a>00489               A(i,i) = std::sqrt(A(i,j));
<a name="l00490"></a>00490             }
<a name="l00491"></a>00491           <span class="keywordflow">else</span>
<a name="l00492"></a>00492             A(j,i) = A(i,j) / A(i,i);
<a name="l00493"></a>00493         }
<a name="l00494"></a>00494     }
<a name="l00495"></a>00495   
<a name="l00496"></a>00496   <span class="comment">// Set the flag for CHOLESKY decomposition</span>
<a name="l00497"></a>00497   this-&gt;<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf790fd7d13452689b7c2cc7fab76c43c1db">CHOLESKY</a>;
<a name="l00498"></a>00498 }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00503"></a>00503 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00504"></a><a class="code" href="classDenseMatrix.php#1dd46dd8b694003773ba285c3d0a7857">00504</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;T&gt;::_cholesky_back_substitute</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00505"></a>00505                                                 <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x)<span class="keyword"> const</span>
<a name="l00506"></a>00506 <span class="keyword"></span>{
<a name="l00507"></a>00507   <span class="comment">// Shorthand notation for number of rows and columns.</span>
<a name="l00508"></a>00508   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00509"></a>00509     <a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a> = this-&gt;<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>(),
<a name="l00510"></a>00510     <a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a> = this-&gt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>();
<a name="l00511"></a>00511 
<a name="l00512"></a>00512   <span class="comment">// Just to be really sure...</span>
<a name="l00513"></a>00513   libmesh_assert(m==<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>);
<a name="l00514"></a>00514 
<a name="l00515"></a>00515   <span class="comment">// A convenient reference to *this</span>
<a name="l00516"></a>00516   <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00517"></a>00517    
<a name="l00518"></a>00518   <span class="comment">// Now compute the solution to Ax =b using the factorization.</span>
<a name="l00519"></a>00519   x.<a class="code" href="classDenseVector.php#3a9af103dc052f1dfdef1626692cd8cd">resize</a>(m);
<a name="l00520"></a>00520   
<a name="l00521"></a>00521   <span class="comment">// Solve for Ly=b</span>
<a name="l00522"></a>00522   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>; ++i)
<a name="l00523"></a>00523     {
<a name="l00524"></a>00524       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;i; ++k)
<a name="l00525"></a>00525         b(i) -= A(i,k)*x(k);
<a name="l00526"></a>00526       
<a name="l00527"></a>00527       x(i) = b(i) / A(i,i);
<a name="l00528"></a>00528     }
<a name="l00529"></a>00529   
<a name="l00530"></a>00530   <span class="comment">// Solve for L^T x = y</span>
<a name="l00531"></a>00531   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00532"></a>00532     {
<a name="l00533"></a>00533       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ib = (n-1)-i;
<a name="l00534"></a>00534 
<a name="l00535"></a>00535       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=(ib+1); k&lt;n; ++k)
<a name="l00536"></a>00536         x(ib) -= A(k,ib) * x(k);
<a name="l00537"></a>00537       
<a name="l00538"></a>00538       x(ib) /= A(ib,ib);
<a name="l00539"></a>00539     }
<a name="l00540"></a>00540 }
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 <span class="comment">// This routine is commented out since it is not really a memory</span>
<a name="l00545"></a>00545 <span class="comment">// efficient implementation.  Also, you don't *need* the inverse</span>
<a name="l00546"></a>00546 <span class="comment">// for anything, instead just use lu_solve to solve Ax=b.</span>
<a name="l00547"></a>00547 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00548"></a>00548 <span class="comment">// void DenseMatrix&lt;T&gt;::inverse ()</span>
<a name="l00549"></a>00549 <span class="comment">// {</span>
<a name="l00550"></a>00550 <span class="comment">//   // First LU decompose the matrix (without partial pivoting).</span>
<a name="l00551"></a>00551 <span class="comment">//   // Note that the lu_decompose routine will check to see if the</span>
<a name="l00552"></a>00552 <span class="comment">//   // matrix is square so we don't worry about it.</span>
<a name="l00553"></a>00553 <span class="comment">//   if (!this-&gt;_lu_decomposed)</span>
<a name="l00554"></a>00554 <span class="comment">//     this-&gt;_lu_decompose(false);</span>
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="comment">//   // A unit vector which will be used as a rhs</span>
<a name="l00557"></a>00557 <span class="comment">//   // to pick off a single value each time.</span>
<a name="l00558"></a>00558 <span class="comment">//   DenseVector&lt;T&gt; e;</span>
<a name="l00559"></a>00559 <span class="comment">//   e.resize(this-&gt;m());</span>
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 <span class="comment">//   // An empty vector which will be used to hold the solution</span>
<a name="l00562"></a>00562 <span class="comment">//   // to the back substitutions.</span>
<a name="l00563"></a>00563 <span class="comment">//   DenseVector&lt;T&gt; x;</span>
<a name="l00564"></a>00564 <span class="comment">//   x.resize(this-&gt;m());</span>
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 <span class="comment">//   // An empty dense matrix to store the resulting inverse</span>
<a name="l00567"></a>00567 <span class="comment">//   // temporarily until we can overwrite A.</span>
<a name="l00568"></a>00568 <span class="comment">//   DenseMatrix&lt;T&gt; inv;</span>
<a name="l00569"></a>00569 <span class="comment">//   inv.resize(this-&gt;m(), this-&gt;n());</span>
<a name="l00570"></a>00570   
<a name="l00571"></a>00571 <span class="comment">//   // Resize the passed in matrix to hold the inverse</span>
<a name="l00572"></a>00572 <span class="comment">//   inv.resize(this-&gt;m(), this-&gt;n());</span>
<a name="l00573"></a>00573   
<a name="l00574"></a>00574 <span class="comment">//   for (unsigned int j=0; j&lt;this-&gt;n(); ++j)</span>
<a name="l00575"></a>00575 <span class="comment">//     {</span>
<a name="l00576"></a>00576 <span class="comment">//       e.zero();</span>
<a name="l00577"></a>00577 <span class="comment">//       e(j) = 1.;</span>
<a name="l00578"></a>00578 <span class="comment">//       this-&gt;_lu_back_substitute(e, x, false);</span>
<a name="l00579"></a>00579 <span class="comment">//       for (unsigned int i=0; i&lt;this-&gt;n(); ++i)</span>
<a name="l00580"></a>00580 <span class="comment">//      inv(i,j) = x(i);</span>
<a name="l00581"></a>00581 <span class="comment">//     }</span>
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 <span class="comment">//   // Now overwrite all the entries</span>
<a name="l00584"></a>00584 <span class="comment">//   *this = inv;</span>
<a name="l00585"></a>00585 <span class="comment">// }</span>
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00589"></a>00589 <span class="comment">// Explicit instantiations</span>
<a name="l00590"></a>00590 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Real&gt;</a>;
<a name="l00591"></a>00591 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;Real&gt;::cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;);
<a name="l00592"></a>00592 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;Real&gt;::_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Real&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00593"></a>00593 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;Real&gt;::cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;);
<a name="l00594"></a>00594 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;Real&gt;::_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00597"></a>00597 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Complex&gt;</a>;
<a name="l00598"></a>00598 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7303f17ad11891bc43f2533688347f15">DenseMatrix&lt;Complex&gt;::cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;,<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;);
<a name="l00599"></a>00599 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#1dd46dd8b694003773ba285c3d0a7857">DenseMatrix&lt;Complex&gt;::_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classDenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00600"></a>00600 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
