<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_d45fb629c53d016ea9ac26478e48620b.php">numerics</a>
  </div>
</div>
<div class="contents">
<h1>dense_matrix.h</h1><a href="dense__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>"</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include "<a class="code" href="dense__matrix__base_8h.php">dense_matrix_base.h</a>"</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classDenseVector.php">DenseVector</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// Dense Matrix class definition</span>
<a name="l00048"></a>00048 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00049"></a><a class="code" href="classDenseMatrix.php">00049</a> <span class="keyword">class </span><a class="code" href="classDenseMatrix.php">DenseMatrix</a> : <span class="keyword">public</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052   
<a name="l00056"></a>00056   <a class="code" href="classDenseMatrix.php#07f24658c14f42b8891fed8e5890a765">DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>=0,
<a name="l00057"></a>00057               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>=0);
<a name="l00058"></a>00058   
<a name="l00062"></a>00062   <a class="code" href="classDenseMatrix.php#07f24658c14f42b8891fed8e5890a765">DenseMatrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00063"></a>00063   
<a name="l00067"></a><a class="code" href="classDenseMatrix.php#f6829cfab27070260b9dd97cdc87e8f1">00067</a>   <span class="keyword">virtual</span> <a class="code" href="classDenseMatrix.php#f6829cfab27070260b9dd97cdc87e8f1">~DenseMatrix</a>() {}
<a name="l00068"></a>00068   
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   T <a class="code" href="classDenseMatrix.php#0fa309492ca2d0c29ac04200d4c4c21a">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00079"></a>00079                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   T &amp; <a class="code" href="classDenseMatrix.php#0fa309492ca2d0c29ac04200d4c4c21a">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00085"></a>00085                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00086"></a>00086 
<a name="l00090"></a><a class="code" href="classDenseMatrix.php#402a0f179fe89e492352ba0a27879995">00090</a>   <span class="keyword">virtual</span> T <a class="code" href="classDenseMatrix.php#402a0f179fe89e492352ba0a27879995">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00091"></a>00091                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); }
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classDenseMatrix.php#aa467e14640bb1b4f1858d55775e13b3">00096</a>   <span class="keyword">virtual</span> T &amp; <a class="code" href="classDenseMatrix.php#402a0f179fe89e492352ba0a27879995">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00097"></a>00097                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); } 
<a name="l00098"></a>00098 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7d06b0e1e75022a5fbdcbc4171ac6b5b">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2);
<a name="l00103"></a>00103   
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#56e32ffe655816974245f3daef9f6581">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#0c25dd3e8d8093f7443c4b6689c73b10">vector_mult</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, <span class="keyword">const</span> <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00113"></a>00113   
<a name="l00117"></a>00117   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#d293df7ee6583e348ec9b8499d4a75a8">operator = </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00118"></a>00118   
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#0df961e52a0694a9300dea1714a1a369">swap</a>(<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00123"></a>00123   
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>,
<a name="l00129"></a>00129               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>);
<a name="l00130"></a>00130   
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#351267a7851c029a0d004459503a11c6">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00135"></a>00135 
<a name="l00139"></a>00139   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#d7ff0060ad66019fd38e2fffbe8236f7">operator *= </a>(<span class="keyword">const</span> T factor);
<a name="l00140"></a>00140 
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#926f9d5c2903ba947f73176bdcafaa42">add</a> (<span class="keyword">const</span> T factor,
<a name="l00145"></a>00145             <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat);
<a name="l00146"></a>00146 
<a name="l00150"></a>00150   <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#dc172d92b644a789155f8bcbe3c0a39c">operator== </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00155"></a>00155   <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#9d051182d046604b61eabefa4a7993d5">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00160"></a>00160   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#37f84c6f02c320236ee22d4d11689282">operator+= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00161"></a>00161 
<a name="l00165"></a>00165   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#ff9623357e0dc5e47117353306cae23b">operator-= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00166"></a>00166 
<a name="l00172"></a>00172   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#89a7071cbca32b759c2b0955728578d0">min</a> () <span class="keyword">const</span>;
<a name="l00173"></a>00173 
<a name="l00179"></a>00179   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#860d9f18d875b6eb752443aaf6beff99">max</a> () <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00191"></a>00191   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#6abd86dc2628f0ebffc9661e98824cb5">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00192"></a>00192 
<a name="l00204"></a>00204   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#bc88ec7696ac80853dcebb1c9636e81c">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00205"></a>00205 
<a name="l00209"></a>00209   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#62832696c265cff213ff133f9e73ef34">left_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00210"></a>00210   
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#8a041f8b6c2f50de27565618331b16fb">right_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00216"></a>00216   
<a name="l00220"></a>00220   T <a class="code" href="classDenseMatrix.php#4ce520268efceb0e68897595d3b38318">transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00221"></a>00221                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00222"></a>00222 
<a name="l00226"></a>00226   <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> <a class="code" href="classDenseMatrix.php#e1716bba5985ba4753b74fba4e9a7d90">get_transpose</a>() <span class="keyword">const</span>;
<a name="l00227"></a>00227  
<a name="l00233"></a><a class="code" href="classDenseMatrix.php#528bde8c704176e220f23b79acdb11ec">00233</a>   std::vector&lt;T&gt;&amp; <a class="code" href="classDenseMatrix.php#528bde8c704176e220f23b79acdb11ec">get_values</a>() { <span class="keywordflow">return</span> <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>; }
<a name="l00234"></a>00234 
<a name="l00238"></a><a class="code" href="classDenseMatrix.php#716972aab21d2fd0d20aefc48ab6acff">00238</a>   <span class="keyword">const</span> std::vector&lt;T&gt;&amp; <a class="code" href="classDenseMatrix.php#716972aab21d2fd0d20aefc48ab6acff">get_values</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>; }
<a name="l00239"></a>00239 
<a name="l00246"></a><a class="code" href="classDenseMatrix.php#044d522b54b850609e6cee8b359373b9">00246</a>   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#044d522b54b850609e6cee8b359373b9">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00247"></a>00247                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00248"></a>00248                 <span class="keyword">const</span> T val,
<a name="l00249"></a>00249                 <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; rhs)
<a name="l00250"></a>00250   { <a class="code" href="classDenseMatrix.php#044d522b54b850609e6cee8b359373b9">DenseMatrixBase&lt;T&gt;::condense</a> (i, j, val, rhs); }
<a name="l00251"></a>00251 
<a name="l00255"></a>00255   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#477240f22a12d4bcf761b490414f4491">lu_solve</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00256"></a>00256                  <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00257"></a>00257                  <span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot = <span class="keyword">false</span>);
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00270"></a>00270   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00271"></a>00271   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7303f17ad11891bc43f2533688347f15">cholesky_solve</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00272"></a>00272                       <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   
<a name="l00280"></a>00280   T <a class="code" href="classDenseMatrix.php#9555f223e2e4e08461ffc68b9b252fb5">det</a>();
<a name="l00281"></a>00281 
<a name="l00290"></a>00290   <span class="comment">// void inverse();</span>
<a name="l00291"></a>00291   
<a name="l00292"></a>00292 <span class="keyword">private</span>:
<a name="l00293"></a>00293 
<a name="l00297"></a><a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">00297</a>   std::vector&lt;T&gt; <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>;
<a name="l00298"></a>00298 
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#d8001c2fe3b274823a2bcf237887886a">_lu_decompose</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot = <span class="keyword">false</span>);
<a name="l00305"></a>00305   
<a name="l00311"></a>00311   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#7162cded87fb34d00501233ca808c3fa">_lu_back_substitute</a> (<a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00312"></a>00312                             <a class="code" href="classDenseVector.php">DenseVector&lt;T&gt;</a>&amp; x,
<a name="l00313"></a>00313                             <span class="keyword">const</span> <span class="keywordtype">bool</span> partial_pivot = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00314"></a>00314   
<a name="l00321"></a>00321   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#a501a38d3d515b0abc6c83b243004aed">_cholesky_decompose</a>();
<a name="l00322"></a>00322 
<a name="l00329"></a>00329   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00330"></a>00330   <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#1dd46dd8b694003773ba285c3d0a7857">_cholesky_back_substitute</a>(<a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00331"></a>00331                                  <a class="code" href="classDenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x) <span class="keyword">const</span>;
<a name="l00332"></a>00332 
<a name="l00340"></a><a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">00340</a>   <span class="keyword">enum</span> <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79">DecompositionType</a> {<a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79b75f9cd205ebf1b98c8b6763531a9d4b">LU</a>=0, <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf790fd7d13452689b7c2cc7fab76c43c1db">CHOLESKY</a>=1, <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>};
<a name="l00341"></a>00341 
<a name="l00346"></a><a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">00346</a>   <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79">DecompositionType</a> <a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>;
<a name="l00347"></a>00347 };
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00357"></a><a class="code" href="namespaceDenseMatrices.php">00357</a> <span class="comment"></span><span class="keyword">namespace </span>DenseMatrices
<a name="l00358"></a>00358 {
<a name="l00359"></a>00359 
<a name="l00364"></a><a class="code" href="namespaceDenseMatrices.php#f147cb4fc0cc650438e683ae70b742aa">00364</a>   <span class="keyword">typedef</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Real&gt;</a> <a class="code" href="classDenseMatrix.php">RealDenseMatrix</a>;
<a name="l00365"></a>00365 
<a name="l00375"></a><a class="code" href="namespaceDenseMatrices.php#7a41ed10c5fac190d994359a809de205">00375</a>   <span class="keyword">typedef</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Complex&gt;</a> <a class="code" href="classDenseMatrix.php">ComplexDenseMatrix</a>;  
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 <span class="keyword">using namespace </span>DenseMatrices;
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00388"></a>00388 <span class="comment">// Dense Matrix member functions</span>
<a name="l00389"></a>00389 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00390"></a>00390 <span class="keyword">inline</span>
<a name="l00391"></a><a class="code" href="classDenseMatrix.php#07f24658c14f42b8891fed8e5890a765">00391</a> <a class="code" href="classDenseMatrix.php#07f24658c14f42b8891fed8e5890a765">DenseMatrix&lt;T&gt;::DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00392"></a>00392                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00393"></a>00393   : <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(m,n),
<a name="l00394"></a>00394     _decomposition_type(NONE)
<a name="l00395"></a>00395 {
<a name="l00396"></a>00396   this-&gt;<a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">resize</a>(m,n);
<a name="l00397"></a>00397 }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00402"></a>00402 <span class="keyword">inline</span>
<a name="l00403"></a><a class="code" href="classDenseMatrix.php#10f4b5fc5d788b443a2e926b9ad7b5cd">00403</a> <a class="code" href="classDenseMatrix.php#07f24658c14f42b8891fed8e5890a765">DenseMatrix&lt;T&gt;::DenseMatrix</a> (<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00404"></a>00404   : <a class="code" href="classDenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(other_matrix._m, other_matrix._n)
<a name="l00405"></a>00405 {
<a name="l00406"></a>00406   <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a> = other_matrix.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>;
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00412"></a>00412 <span class="keyword">inline</span>
<a name="l00413"></a><a class="code" href="classDenseMatrix.php#0df961e52a0694a9300dea1714a1a369">00413</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#0df961e52a0694a9300dea1714a1a369">DenseMatrix&lt;T&gt;::swap</a>(<a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00414"></a>00414 {
<a name="l00415"></a>00415   <a class="code" href="classDenseMatrix.php#0df961e52a0694a9300dea1714a1a369">std::swap</a>(this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>, other_matrix.<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00416"></a>00416   <a class="code" href="classDenseMatrix.php#0df961e52a0694a9300dea1714a1a369">std::swap</a>(this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>, other_matrix.<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00417"></a>00417   <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.swap(other_matrix.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>);
<a name="l00418"></a>00418   <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79">DecompositionType</a> _temp = <a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>;
<a name="l00419"></a>00419   <a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = other_matrix.<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>;
<a name="l00420"></a>00420   other_matrix.<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = _temp;
<a name="l00421"></a>00421 }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   
<a name="l00425"></a>00425 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00426"></a>00426 <span class="keyword">inline</span>
<a name="l00427"></a><a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">00427</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#8c19724598a1ac1e3c758aaad73beb1b">DenseMatrix&lt;T&gt;::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00428"></a>00428                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00429"></a>00429 {
<a name="l00430"></a>00430   <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.resize(m*n);
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a> = m;
<a name="l00433"></a>00433   this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a> = n;
<a name="l00434"></a>00434 
<a name="l00435"></a>00435   <a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>;
<a name="l00436"></a>00436   this-&gt;<a class="code" href="classDenseMatrix.php#3d3f0e57fc2e9dc7ed292cbd2124581e">zero</a>();
<a name="l00437"></a>00437 }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00442"></a>00442 <span class="keyword">inline</span>
<a name="l00443"></a><a class="code" href="classDenseMatrix.php#3d3f0e57fc2e9dc7ed292cbd2124581e">00443</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#3d3f0e57fc2e9dc7ed292cbd2124581e">DenseMatrix&lt;T&gt;::zero</a>()
<a name="l00444"></a>00444 {
<a name="l00445"></a>00445   <a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = <a class="code" href="classDenseMatrix.php#8f4bb90f1f58e9725d0fdfb2136edf79d27bac3460e39a7265587840269e7de7">NONE</a>;
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   std::fill (<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.begin(), <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.end(), 0.);
<a name="l00448"></a>00448 }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00453"></a>00453 <span class="keyword">inline</span>
<a name="l00454"></a><a class="code" href="classDenseMatrix.php#d293df7ee6583e348ec9b8499d4a75a8">00454</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#d293df7ee6583e348ec9b8499d4a75a8">DenseMatrix&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00455"></a>00455 {
<a name="l00456"></a>00456   this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a> = other_matrix.<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>;
<a name="l00457"></a>00457   this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a> = other_matrix.<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>;
<a name="l00458"></a>00458 
<a name="l00459"></a>00459   <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>                = other_matrix.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>;
<a name="l00460"></a>00460   <a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a> = other_matrix.<a class="code" href="classDenseMatrix.php#cf91e81fcfedfa7315e3d50a17a4d601">_decomposition_type</a>;
<a name="l00461"></a>00461 
<a name="l00462"></a>00462   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00463"></a>00463 }
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00468"></a>00468 <span class="keyword">inline</span>
<a name="l00469"></a><a class="code" href="classDenseMatrix.php#0fa309492ca2d0c29ac04200d4c4c21a">00469</a> T <a class="code" href="classDenseMatrix.php#0fa309492ca2d0c29ac04200d4c4c21a">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00470"></a>00470                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00471"></a>00471 <span class="keyword"></span>{
<a name="l00472"></a>00472   libmesh_assert (i*j&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size());
<a name="l00473"></a>00473   libmesh_assert (i &lt; this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00474"></a>00474   libmesh_assert (j &lt; this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00475"></a>00475   
<a name="l00476"></a>00476   
<a name="l00477"></a>00477   <span class="comment">//  return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00478"></a>00478   <span class="keywordflow">return</span> <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00479"></a>00479 }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00484"></a>00484 <span class="keyword">inline</span>
<a name="l00485"></a><a class="code" href="classDenseMatrix.php#c79773a59c9ea041f31f92840897dd30">00485</a> T &amp; <a class="code" href="classDenseMatrix.php#0fa309492ca2d0c29ac04200d4c4c21a">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00486"></a>00486                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00487"></a>00487 {
<a name="l00488"></a>00488   libmesh_assert (i*j&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size());
<a name="l00489"></a>00489   libmesh_assert (i &lt; this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00490"></a>00490   libmesh_assert (j &lt; this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00491"></a>00491   
<a name="l00492"></a>00492   <span class="comment">//return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00493"></a>00493   <span class="keywordflow">return</span> <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00494"></a>00494 }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497      
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00501"></a>00501 <span class="keyword">inline</span>
<a name="l00502"></a><a class="code" href="classDenseMatrix.php#351267a7851c029a0d004459503a11c6">00502</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#351267a7851c029a0d004459503a11c6">DenseMatrix&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00503"></a>00503 {
<a name="l00504"></a>00504   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size(); i++)
<a name="l00505"></a>00505     <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i] *= factor;
<a name="l00506"></a>00506 }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00511"></a>00511 <span class="keyword">inline</span>
<a name="l00512"></a><a class="code" href="classDenseMatrix.php#d7ff0060ad66019fd38e2fffbe8236f7">00512</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#d7ff0060ad66019fd38e2fffbe8236f7">DenseMatrix&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> T factor)
<a name="l00513"></a>00513 {
<a name="l00514"></a>00514   this-&gt;<a class="code" href="classDenseMatrix.php#351267a7851c029a0d004459503a11c6">scale</a>(factor);
<a name="l00515"></a>00515   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00516"></a>00516 }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00521"></a>00521 <span class="keyword">inline</span>
<a name="l00522"></a><a class="code" href="classDenseMatrix.php#926f9d5c2903ba947f73176bdcafaa42">00522</a> <span class="keywordtype">void</span> <a class="code" href="classDenseMatrix.php#926f9d5c2903ba947f73176bdcafaa42">DenseMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T factor, <span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat)
<a name="l00523"></a>00523 {
<a name="l00524"></a>00524   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size(); i++)
<a name="l00525"></a>00525     <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i] += factor * mat.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i];
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00531"></a>00531 <span class="keyword">inline</span>
<a name="l00532"></a><a class="code" href="classDenseMatrix.php#dc172d92b644a789155f8bcbe3c0a39c">00532</a> <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#dc172d92b644a789155f8bcbe3c0a39c">DenseMatrix&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00533"></a>00533 <span class="keyword"></span>{
<a name="l00534"></a>00534   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size(); i++)
<a name="l00535"></a>00535     <span class="keywordflow">if</span> (<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i] != mat.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i])
<a name="l00536"></a>00536       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00539"></a>00539 }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00544"></a>00544 <span class="keyword">inline</span>
<a name="l00545"></a><a class="code" href="classDenseMatrix.php#9d051182d046604b61eabefa4a7993d5">00545</a> <span class="keywordtype">bool</span> <a class="code" href="classDenseMatrix.php#9d051182d046604b61eabefa4a7993d5">DenseMatrix&lt;T&gt;::operator != </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00546"></a>00546 <span class="keyword"></span>{
<a name="l00547"></a>00547   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size(); i++)
<a name="l00548"></a>00548     <span class="keywordflow">if</span> (<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i] != mat.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i])
<a name="l00549"></a>00549       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00552"></a>00552 }
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00557"></a>00557 <span class="keyword">inline</span>
<a name="l00558"></a><a class="code" href="classDenseMatrix.php#37f84c6f02c320236ee22d4d11689282">00558</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#37f84c6f02c320236ee22d4d11689282">DenseMatrix&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00559"></a>00559 {
<a name="l00560"></a>00560   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size(); i++)
<a name="l00561"></a>00561     <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i] += mat.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i];
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00564"></a>00564 }
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00569"></a>00569 <span class="keyword">inline</span>
<a name="l00570"></a><a class="code" href="classDenseMatrix.php#ff9623357e0dc5e47117353306cae23b">00570</a> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classDenseMatrix.php#ff9623357e0dc5e47117353306cae23b">DenseMatrix&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00571"></a>00571 {
<a name="l00572"></a>00572   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>.size(); i++)
<a name="l00573"></a>00573     <a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i] -= mat.<a class="code" href="classDenseMatrix.php#67fff9b9c3f340ec72d6dcc41c553857">_val</a>[i];
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00576"></a>00576 }
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00581"></a>00581 <span class="keyword">inline</span>
<a name="l00582"></a><a class="code" href="classDenseMatrix.php#89a7071cbca32b759c2b0955728578d0">00582</a> <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#89a7071cbca32b759c2b0955728578d0">DenseMatrix&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00583"></a>00583 <span class="keyword"></span>{
<a name="l00584"></a>00584   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00585"></a>00585   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00586"></a>00586   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> my_min = <a class="code" href="libmesh__common_8h.php#8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>; i++)
<a name="l00589"></a>00589     {
<a name="l00590"></a>00590       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>; j++)
<a name="l00591"></a>00591         {
<a name="l00592"></a>00592           <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> current = <a class="code" href="libmesh__common_8h.php#8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00593"></a>00593           my_min = (my_min &lt; current? my_min : current);
<a name="l00594"></a>00594         }
<a name="l00595"></a>00595     }
<a name="l00596"></a>00596   <span class="keywordflow">return</span> my_min;
<a name="l00597"></a>00597 }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00602"></a>00602 <span class="keyword">inline</span>
<a name="l00603"></a><a class="code" href="classDenseMatrix.php#860d9f18d875b6eb752443aaf6beff99">00603</a> <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#860d9f18d875b6eb752443aaf6beff99">DenseMatrix&lt;T&gt;::max</a> ()<span class="keyword"> const</span>
<a name="l00604"></a>00604 <span class="keyword"></span>{
<a name="l00605"></a>00605   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00606"></a>00606   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00607"></a>00607   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> my_max = <a class="code" href="libmesh__common_8h.php#8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>; i++)
<a name="l00610"></a>00610     {
<a name="l00611"></a>00611       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>; j++)
<a name="l00612"></a>00612         {
<a name="l00613"></a>00613           <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> current = <a class="code" href="libmesh__common_8h.php#8c11facf4521382675d9dbb93a349a78">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00614"></a>00614           my_max = (my_max &gt; current? my_max : current);
<a name="l00615"></a>00615         }
<a name="l00616"></a>00616     }
<a name="l00617"></a>00617   <span class="keywordflow">return</span> my_max;
<a name="l00618"></a>00618 }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00623"></a>00623 <span class="keyword">inline</span>
<a name="l00624"></a><a class="code" href="classDenseMatrix.php#6abd86dc2628f0ebffc9661e98824cb5">00624</a> <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#6abd86dc2628f0ebffc9661e98824cb5">DenseMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00625"></a>00625 <span class="keyword"></span>{
<a name="l00626"></a>00626   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00627"></a>00627   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> columnsum = 0.;
<a name="l00630"></a>00630   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>; i++)
<a name="l00631"></a>00631     {
<a name="l00632"></a>00632       columnsum += std::abs((*<span class="keyword">this</span>)(i,0));
<a name="l00633"></a>00633     }
<a name="l00634"></a>00634   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> my_max = columnsum;
<a name="l00635"></a>00635   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j!=this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>; j++)
<a name="l00636"></a>00636     {
<a name="l00637"></a>00637       columnsum = 0.;
<a name="l00638"></a>00638       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>; i++)
<a name="l00639"></a>00639         {
<a name="l00640"></a>00640           columnsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00641"></a>00641         }
<a name="l00642"></a>00642       my_max = (my_max &gt; columnsum? my_max : columnsum);
<a name="l00643"></a>00643     }
<a name="l00644"></a>00644   <span class="keywordflow">return</span> my_max;
<a name="l00645"></a>00645 }
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00650"></a>00650 <span class="keyword">inline</span>
<a name="l00651"></a><a class="code" href="classDenseMatrix.php#bc88ec7696ac80853dcebb1c9636e81c">00651</a> <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classDenseMatrix.php#bc88ec7696ac80853dcebb1c9636e81c">DenseMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00652"></a>00652 <span class="keyword"></span>{
<a name="l00653"></a>00653   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>);
<a name="l00654"></a>00654   libmesh_assert (this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>);
<a name="l00655"></a>00655 
<a name="l00656"></a>00656   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> rowsum = 0.;
<a name="l00657"></a>00657   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>; j++)
<a name="l00658"></a>00658     {
<a name="l00659"></a>00659       rowsum += std::abs((*<span class="keyword">this</span>)(0,j));
<a name="l00660"></a>00660     }
<a name="l00661"></a>00661   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> my_max = rowsum;
<a name="l00662"></a>00662   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;<a class="code" href="classDenseMatrixBase.php#aecdb483ac1742384dcf2e8f6f5fc3e5">_m</a>; i++)
<a name="l00663"></a>00663     {
<a name="l00664"></a>00664       rowsum = 0.;
<a name="l00665"></a>00665       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;<a class="code" href="classDenseMatrixBase.php#0dcd22fecda2c896e16ff7cb957233a3">_n</a>; j++)
<a name="l00666"></a>00666         {
<a name="l00667"></a>00667           rowsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00668"></a>00668         }
<a name="l00669"></a>00669       my_max = (my_max &gt; rowsum? my_max : rowsum);
<a name="l00670"></a>00670     }
<a name="l00671"></a>00671   <span class="keywordflow">return</span> my_max;
<a name="l00672"></a>00672 }
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00677"></a>00677 <span class="keyword">inline</span>
<a name="l00678"></a><a class="code" href="classDenseMatrix.php#4ce520268efceb0e68897595d3b38318">00678</a> T <a class="code" href="classDenseMatrix.php#4ce520268efceb0e68897595d3b38318">DenseMatrix&lt;T&gt;::transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00679"></a>00679                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00680"></a>00680 <span class="keyword"></span>{
<a name="l00681"></a>00681   <span class="comment">// Implement in terms of operator()</span>
<a name="l00682"></a>00682   <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(j,i);
<a name="l00683"></a>00683 }
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00690"></a>00690 <span class="comment">// inline</span>
<a name="l00691"></a>00691 <span class="comment">// void DenseMatrix&lt;T&gt;::condense(const unsigned int iv,</span>
<a name="l00692"></a>00692 <span class="comment">//                            const unsigned int jv,</span>
<a name="l00693"></a>00693 <span class="comment">//                            const T val,</span>
<a name="l00694"></a>00694 <span class="comment">//                            DenseVector&lt;T&gt;&amp; rhs)</span>
<a name="l00695"></a>00695 <span class="comment">// {</span>
<a name="l00696"></a>00696 <span class="comment">//   libmesh_assert (this-&gt;_m == rhs.size());</span>
<a name="l00697"></a>00697 <span class="comment">//   libmesh_assert (iv == jv);</span>
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 <span class="comment">//   // move the known value into the RHS</span>
<a name="l00701"></a>00701 <span class="comment">//   // and zero the column</span>
<a name="l00702"></a>00702 <span class="comment">//   for (unsigned int i=0; i&lt;this-&gt;m(); i++)</span>
<a name="l00703"></a>00703 <span class="comment">//     {</span>
<a name="l00704"></a>00704 <span class="comment">//       rhs(i) -= ((*this)(i,jv))*val;</span>
<a name="l00705"></a>00705 <span class="comment">//       (*this)(i,jv) = 0.;</span>
<a name="l00706"></a>00706 <span class="comment">//     }</span>
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 <span class="comment">//   // zero the row</span>
<a name="l00709"></a>00709 <span class="comment">//   for (unsigned int j=0; j&lt;this-&gt;n(); j++)</span>
<a name="l00710"></a>00710 <span class="comment">//     (*this)(iv,j) = 0.;</span>
<a name="l00711"></a>00711 
<a name="l00712"></a>00712 <span class="comment">//   (*this)(iv,jv) = 1.;</span>
<a name="l00713"></a>00713 <span class="comment">//   rhs(iv) = val;</span>
<a name="l00714"></a>00714   
<a name="l00715"></a>00715 <span class="comment">// }</span>
<a name="l00716"></a>00716 
<a name="l00717"></a>00717 
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 <span class="preprocessor">#endif // #ifndef __dense_matrix_h__</span>
<a name="l00724"></a>00724 <span class="preprocessor"></span>
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
