<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_e3ef88e799b2c61590a14ff8ce14ac52.php">error_estimation</a>
  </div>
</div>
<div class="contents">
<h1>discontinuity_measure.h</h1><a href="discontinuity__measure_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __discontinuity_measure_h___</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __discontinuity_measure_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "<a class="code" href="jump__error__estimator_8h.php">jump_error_estimator.h</a>"</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Forward Declarations</span>
<a name="l00033"></a>00033 <span class="keyword">class </span><a class="code" href="classPoint.php">Point</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00046"></a><a class="code" href="classDiscontinuityMeasure.php">00046</a> <span class="keyword">class </span><a class="code" href="classDiscontinuityMeasure.php">DiscontinuityMeasure</a> : <span class="keyword">public</span> <a class="code" href="classJumpErrorEstimator.php">JumpErrorEstimator</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00055"></a><a class="code" href="classDiscontinuityMeasure.php#2410c0bb1a754e56fe0526d1b87ca51c">00055</a>   <a class="code" href="classDiscontinuityMeasure.php#2410c0bb1a754e56fe0526d1b87ca51c">DiscontinuityMeasure</a>() : <a class="code" href="classDiscontinuityMeasure.php#27753db6c3db971a6fac78713633770b">_bc_function</a>(NULL) { <a class="code" href="classErrorEstimator.php#c62239bfce2ba4a26d30910a120c876e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#4448492d578e5ad9c23eddd1518a009881428a949c80fd4e4178fe53fa94ce92">L2</a>; }
<a name="l00056"></a>00056   
<a name="l00060"></a><a class="code" href="classDiscontinuityMeasure.php#1a1ab1edae1025a2ba88523dd07582ab">00060</a>   <a class="code" href="classDiscontinuityMeasure.php#1a1ab1edae1025a2ba88523dd07582ab">~DiscontinuityMeasure</a>() {}
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <span class="keywordtype">void</span> <a class="code" href="classDiscontinuityMeasure.php#d2662ce6bc0452627036369c289748b0">attach_essential_bc_function</a> (std::pair&lt;bool,Real&gt; fptr(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00067"></a>00067                                                                <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00068"></a>00068                                                                <span class="keyword">const</span> std::string&amp; var_name));
<a name="l00069"></a>00069   
<a name="l00070"></a>00070 <span class="keyword">protected</span>:
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDiscontinuityMeasure.php#ae4a0d80b5d4c19e1dc2bb4e2297b26f">initialize</a>(<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00077"></a>00077                           <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00078"></a>00078                           <span class="keywordtype">bool</span> estimate_parent_error);
<a name="l00079"></a>00079 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classDiscontinuityMeasure.php#3b4cba658f02c091eb36fa2ef0418abd">internal_side_integration</a>();
<a name="l00085"></a>00085 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classDiscontinuityMeasure.php#34843b218f1609f7c28ff1120bedacdb">boundary_side_integration</a>();
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classDiscontinuityMeasure.php#6648503839debe006ab6008de173f4d2">00096</a>   <span class="keyword">const</span> <a class="code" href="classSystem.php">System</a> *<a class="code" href="classDiscontinuityMeasure.php#6648503839debe006ab6008de173f4d2">my_system</a>;
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   std::pair&lt;bool,Real&gt; (* _bc_function) (<span class="keyword">const</span> <a class="code" href="classSystem.php">System</a>&amp; system,
<a name="l00102"></a>00102                                          <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00103"></a>00103                                          <span class="keyword">const</span> std::string&amp; var_name);
<a name="l00104"></a>00104 };
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="preprocessor">#endif</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
