<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_1dd6a48f3fcf6bfd21e137625350089e.php">mesh</a>
  </div>
</div>
<div class="contents">
<h1>exodusII_io.h</h1><a href="exodusII__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __exodusII_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __exodusII_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include "<a class="code" href="mesh__input_8h.php">mesh_input.h</a>"</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "<a class="code" href="mesh__output_8h.php">mesh_output.h</a>"</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include "<a class="code" href="exodusII__io__helper_8h.php">exodusII_io_helper.h</a>"</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classSystem.php">System</a>;
<a name="l00036"></a>00036 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// ExodusII_IO class definition</span>
<a name="l00048"></a><a class="code" href="classExodusII__IO.php">00048</a> <span class="keyword">class </span><a class="code" href="classExodusII__IO.php">ExodusII_IO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00049"></a>00049                     <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a>00052  <span class="keyword">public</span>:
<a name="l00053"></a>00053   
<a name="l00058"></a>00058   <a class="code" href="classExodusII__IO.php#f6a9a480b03f9daae86f4ea9668e5cc9">ExodusII_IO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#2e8be596b1583aa3348740f461562d24">mesh</a>);
<a name="l00059"></a>00059   
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <a class="code" href="classExodusII__IO.php#745c4cee07f43d57b7d53a9cdfe281cb">~ExodusII_IO</a> ();
<a name="l00064"></a>00064   
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#71cded634eaffef4c0f2441ef65d5860">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#47f1b8befd1bbd18dfe20c810b9ade23">name</a>);
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#c2302f2c4760c5f7297208fe51eec14a">write</a> (<span class="keyword">const</span> std::string&amp; fname);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#7be8ae4b6f1bfbdbd91d94a93d2d848d">verbose</a> (<span class="keywordtype">bool</span> set_verbosity);
<a name="l00084"></a>00084 
<a name="l00089"></a>00089   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#55892412989599880fb49c6cf2440493">copy_nodal_solution</a>(<a class="code" href="classSystem.php">System</a>&amp; es, std::string nodal_var_name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> timestep=1);
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#c114febf1bd1647ad2a35c11d9cc8f25">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00095"></a>00095                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00096"></a>00096                          <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00097"></a>00097 
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classExodusII__IO.php#338a74fccc6053b4d43e02f552e4d091">write_timestep</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00103"></a>00103                        <span class="keyword">const</span> <a class="code" href="classEquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00104"></a>00104                        <span class="keyword">const</span> <span class="keywordtype">int</span> timestep,
<a name="l00105"></a>00105                        <span class="keyword">const</span> <span class="keywordtype">double</span> time);
<a name="l00106"></a>00106   
<a name="l00107"></a>00107  <span class="keyword">private</span>:
<a name="l00113"></a>00113 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00114"></a><a class="code" href="classExodusII__IO.php#3c60a07fe4616818923ffb3991e5f492">00114</a> <span class="preprocessor"></span>  <a class="code" href="classExodusII__IO__Helper.php">ExodusII_IO_Helper</a> <a class="code" href="classExodusII__IO.php#3c60a07fe4616818923ffb3991e5f492">exio_helper</a>;
<a name="l00115"></a>00115 <span class="preprocessor">#endif</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
<a name="l00120"></a><a class="code" href="classExodusII__IO.php#aeddf4036f344bf505e47b87ddb5fcf2">00120</a>   <span class="keywordtype">int</span> <a class="code" href="classExodusII__IO.php#aeddf4036f344bf505e47b87ddb5fcf2">_timestep</a>;
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classExodusII__IO.php#398a71df49bee40403d08e05955d8a46">00125</a>   <span class="keywordtype">bool</span> <a class="code" href="classExodusII__IO.php#398a71df49bee40403d08e05955d8a46">_verbose</a>;
<a name="l00126"></a>00126 };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif // #define __exodusII_io_h__</span>
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
