<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_d10cf71607aece8ba6d7eeee19922ee7.php">geom</a>
  </div>
</div>
<div class="contents">
<h1>face.h</h1><a href="face_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __face_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __face_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="elem_8h.php">elem.h</a>"</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Forward declarations</span>
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classMesh.php">Mesh</a>;
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// Face class definition</span>
<a name="l00044"></a><a class="code" href="classFace.php">00044</a> <span class="keyword">class </span><a class="code" href="classFace.php">Face</a> : <span class="keyword">public</span> <a class="code" href="classElem.php">Elem</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00052"></a><a class="code" href="classFace.php#9ff2bb41f2169b6b2fee55ffaf51372a">00052</a>   <a class="code" href="classFace.php#9ff2bb41f2169b6b2fee55ffaf51372a">Face</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00053"></a>00053         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00054"></a>00054         <a class="code" href="classElem.php">Elem</a>* p) :
<a name="l00055"></a>00055     <a class="code" href="classElem.php">Elem</a>(nn, ns, p) {}
<a name="l00056"></a>00056 
<a name="l00060"></a><a class="code" href="classFace.php#b6c2fa0d63270bde4b897ed3ac444ee4">00060</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFace.php#b6c2fa0d63270bde4b897ed3ac444ee4">dim</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00061"></a>00061 
<a name="l00066"></a><a class="code" href="classFace.php#a473b49d4a62b465f248ffcd4eafa578">00066</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFace.php#a473b49d4a62b465f248ffcd4eafa578">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00067"></a>00067 
<a name="l00071"></a><a class="code" href="classFace.php#302bddedbaafea7fa5f9db376a4e32dc">00071</a>   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classFace.php#302bddedbaafea7fa5f9db376a4e32dc">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00072"></a>00072 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classElem.php#554c146bcfb5537636bd77a157f21b85">build_side</a>(i); }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="comment">//   /**</span>
<a name="l00075"></a>00075 <span class="comment">//    * @returns 2</span>
<a name="l00076"></a>00076 <span class="comment">//    */</span>
<a name="l00077"></a>00077 <span class="comment">//   unsigned int n_children_per_side(const unsigned int) const { return 2; }</span>
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00085"></a><a class="code" href="classFace.php#63a3e82da3fde2b49b5ff463862902e2">00085</a>   <span class="keywordtype">bool</span> <a class="code" href="classFace.php#63a3e82da3fde2b49b5ff463862902e2">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="preprocessor">#endif</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>
<a name="l00089"></a>00089 };
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="preprocessor">#endif</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
