<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_6e2fb68797be948a28679468dc70630b.php">fe</a>
  </div>
</div>
<div class="contents">
<h1>fe_type.h</h1><a href="fe__type_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_type_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_type_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>"</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include "<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>"</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "<a class="code" href="enum__order_8h.php">enum_order.h</a>"</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include "<a class="code" href="enum__fe__family_8h.php">enum_fe_family.h</a>"</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="enum__inf__map__type_8h.php">enum_inf_map_type.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span><a class="code" href="classQBase.php">QBase</a>;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00042"></a><a class="code" href="classFEType.php">00042</a> <span class="keyword">class </span><a class="code" href="classFEType.php">FEType</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>  
<a name="l00052"></a><a class="code" href="classFEType.php#fbd3582a211927cd00f7c80be1fc38cc">00052</a>   <a class="code" href="classFEType.php#fbd3582a211927cd00f7c80be1fc38cc">FEType</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    o = <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>,
<a name="l00053"></a>00053          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> f = <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5ee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>) :
<a name="l00054"></a>00054     <a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>(o),
<a name="l00055"></a>00055     <a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>(f)
<a name="l00056"></a>00056   {}
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">//TODO:[BSK] Could these data types all be const?  </span>
<a name="l00060"></a>00060   <span class="comment">// [RHS] Order can't in the case of p refinement!</span>
<a name="l00064"></a><a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">00064</a> <span class="comment"></span>  <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00065"></a>00065 
<a name="l00070"></a><a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">00070</a>   <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>;
<a name="l00071"></a>00071     
<a name="l00072"></a>00072 <span class="preprocessor">#else</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>  
<a name="l00082"></a><a class="code" href="classFEType.php#e81a23eab32023cdce078c3820fc5dc1">00082</a>   <a class="code" href="classFEType.php#fbd3582a211927cd00f7c80be1fc38cc">FEType</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>      o  = <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>,
<a name="l00083"></a>00083          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a>   f  = <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5ee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>,
<a name="l00084"></a>00084          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>      ro = <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>,
<a name="l00085"></a>00085          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a>   rf = <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5c8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>,
<a name="l00086"></a>00086          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#e6721d46075567f5eb13dec5c2c924d7">InfMapType</a> im = <a class="code" href="namespacelibMeshEnums.php#e6721d46075567f5eb13dec5c2c924d750e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>) :
<a name="l00087"></a>00087     <a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>(o),
<a name="l00088"></a>00088     <a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a>(ro),
<a name="l00089"></a>00089     <a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>(f),
<a name="l00090"></a>00090     <a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a>(rf),
<a name="l00091"></a>00091     <a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a>(im)
<a name="l00092"></a>00092   {}
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">00103</a>   <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a>;
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>;
<a name="l00110"></a>00110 
<a name="l00116"></a><a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">00116</a>   <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a>;
<a name="l00117"></a>00117 
<a name="l00124"></a><a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">00124</a>   <a class="code" href="namespacelibMeshEnums.php#e6721d46075567f5eb13dec5c2c924d7">InfMapType</a> <a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a>;
<a name="l00125"></a>00125   
<a name="l00126"></a>00126 <span class="preprocessor">#endif // ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>
<a name="l00131"></a><a class="code" href="classFEType.php#95e28b5284374667fa3a24ee0cd3eec7">00131</a>   <span class="keywordtype">bool</span> <a class="code" href="classFEType.php#95e28b5284374667fa3a24ee0cd3eec7">operator== </a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp;f2)<span class="keyword"> const</span>
<a name="l00132"></a>00132 <span class="keyword">  </span>{
<a name="l00133"></a>00133     <span class="keywordflow">return</span> (<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> == f2.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>
<a name="l00134"></a>00134             &amp;&amp; <a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> == f2.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>
<a name="l00135"></a>00135 #ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS
<a name="l00136"></a>00136             &amp;&amp; <a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a> == f2.<a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a>
<a name="l00137"></a>00137             &amp;&amp; <a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a> == f2.<a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a>
<a name="l00138"></a>00138             &amp;&amp; <a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a> == f2.<a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a>
<a name="l00139"></a>00139 #endif <span class="comment">// ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00140"></a>00140             );
<a name="l00141"></a>00141   }
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classFEType.php#e353747698f2ec063ca64b30688d736d">00146</a>   <span class="keywordtype">bool</span> <a class="code" href="classFEType.php#e353747698f2ec063ca64b30688d736d">operator&lt; </a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a> &amp;f2)<span class="keyword"> const</span>
<a name="l00147"></a>00147 <span class="keyword">  </span>{
<a name="l00148"></a>00148     <span class="keywordflow">if</span> (<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> != f2.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>)
<a name="l00149"></a>00149       <span class="keywordflow">return</span> (<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> &lt; f2.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>);
<a name="l00150"></a>00150     <span class="keywordflow">if</span> (<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> != f2.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00151"></a>00151       <span class="keywordflow">return</span> (<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> &lt; f2.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a> != f2.<a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a>)
<a name="l00155"></a>00155       <span class="keywordflow">return</span> (<a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a> &lt; f2.<a class="code" href="classFEType.php#c56fd69c8a341e9df407de175e0c250a">radial_order</a>);
<a name="l00156"></a>00156     <span class="keywordflow">if</span> (<a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a> != f2.<a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a>)
<a name="l00157"></a>00157       <span class="keywordflow">return</span> (<a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a> &lt; f2.<a class="code" href="classFEType.php#7ed251e481daf9856b6624e97346d3c3">radial_family</a>);
<a name="l00158"></a>00158     <span class="keywordflow">if</span> (<a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a> != f2.<a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a>)
<a name="l00159"></a>00159       <span class="keywordflow">return</span> (<a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a> &lt; f2.<a class="code" href="classFEType.php#06a9a69581be9306ae474c256b9ee458">inf_map</a>);
<a name="l00160"></a>00160 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>    <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00162"></a>00162   }
<a name="l00163"></a>00163 
<a name="l00170"></a>00170   <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classFEType.php#523905bbc072eaa4664c6c1434a0c4e4">default_quadrature_order</a> () <span class="keyword">const</span>;
<a name="l00171"></a>00171 
<a name="l00178"></a>00178   <a class="code" href="classAutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classFEType.php#33013296ee9643faec0262714ad9163c">default_quadrature_rule</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00179"></a>00179                                           <span class="keyword">const</span> <span class="keywordtype">int</span> extraorder=0) <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   
<a name="l00182"></a>00182 <span class="keyword">private</span>:  
<a name="l00183"></a>00183   
<a name="l00184"></a>00184 };
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00189"></a>00189 <span class="comment">// FEType inline methods</span>
<a name="l00190"></a>00190 <span class="keyword">inline</span>
<a name="l00191"></a><a class="code" href="classFEType.php#523905bbc072eaa4664c6c1434a0c4e4">00191</a> <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classFEType.php#523905bbc072eaa4664c6c1434a0c4e4">FEType::default_quadrature_order</a> ()<span class="keyword"> const</span>
<a name="l00192"></a>00192 <span class="keyword"></span>{
<a name="l00193"></a>00193   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(2*<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>) + 1);
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="preprocessor">#endif // #ifndef __fe_type_h__</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
