<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="namespaces.php"><span>Namespace&nbsp;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespaceMeshTools.php">MeshTools</a>::<a class="el" href="namespaceMeshTools_1_1Private.php">Private</a>
  </div>
</div>
<div class="contents">
<h1>MeshTools::Private Namespace Reference</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceMeshTools_1_1Private.php#96ed88f210c1a01056f4598751269cd2">globally_renumber_nodes_and_elements</a> (<a class="el" href="classMeshBase.php">MeshBase</a> &amp;)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceMeshTools_1_1Private.php#f435c29becf70b3ce4a05360be28dbc5">fix_broken_node_and_element_numbering</a> (<a class="el" href="classSerialMesh.php">SerialMesh</a> &amp;)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceMeshTools_1_1Private.php#71fd69f647d0fefaadee5ba6e9b5f06a">fix_broken_node_and_element_numbering</a> (<a class="el" href="classParallelMesh.php">ParallelMesh</a> &amp;)</td></tr>

</table>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="71fd69f647d0fefaadee5ba6e9b5f06a"></a><!-- doxytag: member="MeshTools::Private::fix_broken_node_and_element_numbering" ref="71fd69f647d0fefaadee5ba6e9b5f06a" args="(ParallelMesh &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MeshTools::Private::fix_broken_node_and_element_numbering           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classParallelMesh.php">ParallelMesh</a> &amp;&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
There is no reason for a user to ever call this function.<p>
This function restores a previously broken element/node numbering such that <code>mesh.node(n)-&gt;id()</code> == n. 
<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01023">1023</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="parallel__mesh_8h_source.php#l00375">ParallelMesh::_elements</a>, <a class="el" href="parallel__mesh_8h_source.php#l00370">ParallelMesh::_nodes</a>, <a class="el" href="mapvector_8h_source.php#l00125">mapvector&lt; Val &gt;::begin()</a>, and <a class="el" href="mapvector_8h_source.php#l00133">mapvector&lt; Val &gt;::end()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l01024"></a>01024 {
<a name="l01025"></a>01025   <span class="comment">// We need access to iterators for the underlying containers,</span>
<a name="l01026"></a>01026   <span class="comment">// not the mapvector&lt;&gt; reimplementations.</span>
<a name="l01027"></a>01027   <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::maptype</a> &amp;nodes = mesh.<a class="code" href="classParallelMesh.php#24ee2ef5c854badf46bb366dad014436">_nodes</a>;
<a name="l01028"></a>01028   <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::maptype</a> &amp;elem  = mesh.<a class="code" href="classParallelMesh.php#589de5efc3000cfc1c94857c37244fa6">_elements</a>;
<a name="l01029"></a>01029   
<a name="l01030"></a>01030   <span class="comment">// Nodes first</span>
<a name="l01031"></a>01031   {
<a name="l01032"></a>01032     <a class="code" href="classmapvector.php">mapvector&lt;Node*&gt;::maptype::iterator</a>
<a name="l01033"></a>01033       it  = nodes.<a class="code" href="classmapvector.php#0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(),
<a name="l01034"></a>01034       end = nodes.<a class="code" href="classmapvector.php#15afca216def803488c97deed4f9fad3">end</a>();
<a name="l01035"></a>01035 
<a name="l01036"></a>01036     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01037"></a>01037       <span class="keywordflow">if</span> (it-&gt;second != NULL)
<a name="l01038"></a>01038         it-&gt;second-&gt;set_id() = it-&gt;first;
<a name="l01039"></a>01039   }
<a name="l01040"></a>01040 
<a name="l01041"></a>01041   <span class="comment">// Elements next</span>
<a name="l01042"></a>01042   {
<a name="l01043"></a>01043     <a class="code" href="classmapvector.php">mapvector&lt;Elem*&gt;::maptype::iterator</a>
<a name="l01044"></a>01044       it  = elem.<a class="code" href="classmapvector.php#0c2cd26e6ae1a7724fc718b707fb9c17">begin</a>(),
<a name="l01045"></a>01045       end = elem.<a class="code" href="classmapvector.php#15afca216def803488c97deed4f9fad3">end</a>();
<a name="l01046"></a>01046 
<a name="l01047"></a>01047     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01048"></a>01048       <span class="keywordflow">if</span> (it-&gt;second != NULL)
<a name="l01049"></a>01049         it-&gt;second-&gt;set_id() = it-&gt;first;
<a name="l01050"></a>01050   }
<a name="l01051"></a>01051 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="f435c29becf70b3ce4a05360be28dbc5"></a><!-- doxytag: member="MeshTools::Private::fix_broken_node_and_element_numbering" ref="f435c29becf70b3ce4a05360be28dbc5" args="(SerialMesh &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MeshTools::Private::fix_broken_node_and_element_numbering           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classSerialMesh.php">SerialMesh</a> &amp;&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
There is no reason for a user to ever call this function.<p>
This function restores a previously broken element/node numbering such that <code>mesh.node(n)-&gt;id()</code> == n. 
<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01008">1008</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>References <a class="el" href="serial__mesh_8h_source.php#l00313">SerialMesh::_elements</a>, and <a class="el" href="serial__mesh_8h_source.php#l00308">SerialMesh::_nodes</a>.</p>

<p>Referenced by <a class="el" href="equation__systems__io_8C_source.php#l00123">EquationSystems::_read_impl()</a>, and <a class="el" href="equation__systems__io_8C_source.php#l00343">EquationSystems::write()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l01009"></a>01009 {
<a name="l01010"></a>01010    <span class="comment">// Nodes first</span>
<a name="l01011"></a>01011   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classSerialMesh.php#e85db50b023e5950dcafb20da2f1578b">_nodes</a>.size(); n++)
<a name="l01012"></a>01012     <span class="keywordflow">if</span> (mesh.<a class="code" href="classSerialMesh.php#e85db50b023e5950dcafb20da2f1578b">_nodes</a>[n] != NULL)
<a name="l01013"></a>01013       mesh.<a class="code" href="classSerialMesh.php#e85db50b023e5950dcafb20da2f1578b">_nodes</a>[n]-&gt;set_id() = n;
<a name="l01014"></a>01014 
<a name="l01015"></a>01015   <span class="comment">// Elements next</span>
<a name="l01016"></a>01016   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classSerialMesh.php#a9818efdffad6dbd52ca09c0ad99a259">_elements</a>.size(); e++)
<a name="l01017"></a>01017     <span class="keywordflow">if</span> (mesh.<a class="code" href="classSerialMesh.php#a9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e] != NULL)
<a name="l01018"></a>01018       mesh.<a class="code" href="classSerialMesh.php#a9818efdffad6dbd52ca09c0ad99a259">_elements</a>[e]-&gt;set_id() = e; 
<a name="l01019"></a>01019 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="96ed88f210c1a01056f4598751269cd2"></a><!-- doxytag: member="MeshTools::Private::globally_renumber_nodes_and_elements" ref="96ed88f210c1a01056f4598751269cd2" args="(MeshBase &amp;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MeshTools::Private::globally_renumber_nodes_and_elements           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classMeshBase.php">MeshBase</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>mesh</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
There is no reason for a user to ever call this function.<p>
This function determines partition-agnostic global indices for all nodes and elements in the mesh. Note that after this function is called the mesh will likely be in an inconsistent state, i.e. <code>mesh.nodes(i)-&gt;id()</code> != i in the nodes container. Direct node/element access via the <code>mesh.node(n)</code> or <code>mesh.elem(e)</code> functions will likely fail. The original numbering can (and should) be restored with a subsequent call to <code>fix_node_and_element_numbering()</code>. 
<p>Definition at line <a class="el" href="mesh__tools_8C_source.php#l01001">1001</a> of file <a class="el" href="mesh__tools_8C_source.php">mesh_tools.C</a>.</p>

<p>Referenced by <a class="el" href="equation__systems__io_8C_source.php#l00123">EquationSystems::_read_impl()</a>, and <a class="el" href="equation__systems__io_8C_source.php#l00343">EquationSystems::write()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l01002"></a>01002 {
<a name="l01003"></a>01003   <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().assign_global_indices(mesh);
<a name="l01004"></a>01004 }
</pre></div>
<p>

</div>
</div><p>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
