<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="namespaces.php"><span>Namespace&nbsp;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespaceParallel.php">Parallel</a>::<a class="el" href="namespaceParallel_1_1Utils.php">Utils</a>
  </div>
</div>
<div class="contents">
<h1>Parallel::Utils Namespace Reference</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memTemplParams" nowrap colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#10a62091b54c73f7b5ea268e8dd7b178">is_sorted</a> (const std::vector&lt; KeyType &gt; &amp;v)</td></tr>

<tr><td class="memTemplParams" nowrap colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">double&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#7cb0d6aee3faa60b9d20c0db2d7fbb8b">to_double</a> (const KeyType &amp;k)</td></tr>

<tr><td class="memTemplParams" nowrap colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">KeyType&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#7a8f06337d63ab303f01e8033d0795e4">to_key_type</a> (const double f)</td></tr>

<tr><td class="memTemplParams" nowrap colspan="2">template&lt;&gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">double&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceParallel_1_1Utils.php#d9cdff5c825be76118631c141b6fa758">to_double</a> (const Hilbert::HilbertIndices &amp;bvt)</td></tr>

</table>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="10a62091b54c73f7b5ea268e8dd7b178"></a><!-- doxytag: member="Parallel::Utils::is_sorted" ref="10a62091b54c73f7b5ea268e8dd7b178" args="(const std::vector&lt; KeyType &gt; &amp;v)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool Parallel::Utils::is_sorted           </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; KeyType &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<a class="el" href="namespaceUtility.php">Utility</a> function that returns true if the vector v is sorted, false otherwise. O(N), the length of the vector. This is implemented solely because the std::is_sorted appears to be an STL extension. 
<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00047">47</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>

<p>Referenced by <a class="el" href="parallel__bin__sorter_8C_source.php#l00041">Parallel::BinSorter&lt; KeyType &gt;::BinSorter()</a>, and <a class="el" href="parallel__histogram_8C_source.php#l00038">Parallel::Histogram&lt; KeyType &gt;::Histogram()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00048"></a>00048       {
<a name="l00049"></a>00049         <span class="keywordflow">if</span> (v.empty())
<a name="l00050"></a>00050           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;v.size(); i++)
<a name="l00053"></a>00053           <span class="keywordflow">if</span> (v[i] &lt; v[i-1])
<a name="l00054"></a>00054             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056         <span class="keywordflow">return</span> <span class="keyword">true</span>;    
<a name="l00057"></a>00057       }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="d9cdff5c825be76118631c141b6fa758"></a><!-- doxytag: member="Parallel::Utils::to_double" ref="d9cdff5c825be76118631c141b6fa758" args="(const Hilbert::HilbertIndices &amp;bvt)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">double Parallel::Utils::to_double           </td>
          <td>(</td>
          <td class="paramtype">const Hilbert::HilbertIndices &amp;&nbsp;</td>
          <td class="paramname"> <em>bvt</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00087">87</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00088"></a>00088       {
<a name="l00089"></a>00089         <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(bvt.rack2);
<a name="l00090"></a>00090       }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="7cb0d6aee3faa60b9d20c0db2d7fbb8b"></a><!-- doxytag: member="Parallel::Utils::to_double" ref="7cb0d6aee3faa60b9d20c0db2d7fbb8b" args="(const KeyType &amp;k)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">double Parallel::Utils::to_double           </td>
          <td>(</td>
          <td class="paramtype">const KeyType &amp;&nbsp;</td>
          <td class="paramname"> <em>k</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
A utility function which converts whatever <code>KeyType</code> is to a <code>double</code> for the histogram bounds 
<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00065">65</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>

<p>Referenced by <a class="el" href="parallel__bin__sorter_8C_source.php#l00056">Parallel::BinSorter&lt; KeyType &gt;::binsort()</a>, and <a class="el" href="parallel__histogram_8C_source.php#l00047">Parallel::Histogram&lt; KeyType &gt;::make_histogram()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00066"></a>00066       {
<a name="l00067"></a>00067         <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(k);
<a name="l00068"></a>00068       }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="7a8f06337d63ab303f01e8033d0795e4"></a><!-- doxytag: member="Parallel::Utils::to_key_type" ref="7a8f06337d63ab303f01e8033d0795e4" args="(const double f)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">Hilbert::HilbertIndices Parallel::Utils::to_key_type           </td>
          <td>(</td>
          <td class="paramtype">const double&nbsp;</td>
          <td class="paramname"> <em>f</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
A utility to convert a <code>double</code> to some sort of <code>KeyType</code>, for interpreting how histogram bounds relate to <code>KeyType</code> positions. 
<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00078">78</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00079"></a>00079       {
<a name="l00080"></a>00080         <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>KeyType<span class="keyword">&gt;</span>(f);
<a name="l00081"></a>00081       }
</pre></div>
<p>

</div>
</div><p>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
