<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="namespaces.php"><span>Namespace&nbsp;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>QuadratureRules Namespace Reference</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">std::string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#977a91f607c81062f220472d2552964c">name</a> (const QuadratureType t)</td></tr>

<tr><td colspan="2"><br><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#e0de7916cc1e4da0bd8b1c5568d25945">num_rules</a> = 5</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">const QuadratureType&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#6cd73c12440db2f13e7c5a67896f1bd0">valid_elem_rules</a> []</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">const unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceQuadratureRules.php#83bb3bf0f93c7de93bff9b1398a1e763">num_valid_elem_rules</a> = 3</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
A namespace for utility functions for quadrature rules. 
<p>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="977a91f607c81062f220472d2552964c"></a><!-- doxytag: member="QuadratureRules::name" ref="977a91f607c81062f220472d2552964c" args="(const QuadratureType t)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string QuadratureRules::name           </td>
          <td>(</td>
          <td class="paramtype">const QuadratureType&nbsp;</td>
          <td class="paramname"> <em>t</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a standard string representation for the specific quadrature rule. 
<p>Definition at line <a class="el" href="quadrature__rules_8C_source.php#l00030">30</a> of file <a class="el" href="quadrature__rules_8C_source.php">quadrature_rules.C</a>.</p>

<p>References <a class="el" href="enum__quadrature__type_8h_source.php#l00032">libMeshEnums::QGAUSS</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00034">libMeshEnums::QJACOBI_1_0</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00035">libMeshEnums::QJACOBI_2_0</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00037">libMeshEnums::QSIMPSON</a>, and <a class="el" href="enum__quadrature__type_8h_source.php#l00038">libMeshEnums::QTRAP</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00031"></a>00031 {
<a name="l00032"></a>00032   std::string its_name;
<a name="l00033"></a>00033   
<a name="l00034"></a>00034   <span class="keywordflow">switch</span> (q)
<a name="l00035"></a>00035     {
<a name="l00036"></a>00036       
<a name="l00037"></a>00037     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716ad11bd5a126c073e475e588e38016b3785">QGAUSS</a>:
<a name="l00038"></a>00038       its_name = <span class="stringliteral">"Gauss-Legendre Quadrature"</span>;
<a name="l00039"></a>00039       <span class="keywordflow">break</span>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716add3a339e15685559999115b81f6d38370">QJACOBI_1_0</a>:
<a name="l00042"></a>00042       its_name = <span class="stringliteral">"Jacobi(1,0)-Gauss Quadrature"</span>;
<a name="l00043"></a>00043       <span class="keywordflow">break</span>;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716ad52629eed7dec8b36fbd387b3dd51d48d">QJACOBI_2_0</a>:
<a name="l00046"></a>00046       its_name = <span class="stringliteral">"Jacobi(2,0)-Gauss Quadrature"</span>;
<a name="l00047"></a>00047       <span class="keywordflow">break</span>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716adeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>:
<a name="l00050"></a>00050       its_name = <span class="stringliteral">"Simpson Rule"</span>;
<a name="l00051"></a>00051       <span class="keywordflow">break</span>;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716ad26431abeff146407680a87ae0dd3a39a">QTRAP</a>:
<a name="l00054"></a>00054       its_name = <span class="stringliteral">"Trapezoidal Rule"</span>;
<a name="l00055"></a>00055       <span class="keywordflow">break</span>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058     <span class="keywordflow">default</span>:
<a name="l00059"></a>00059       { 
<a name="l00060"></a>00060         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Bad qt="</span> &lt;&lt; q &lt;&lt; std::endl;
<a name="l00061"></a>00061         libmesh_error();
<a name="l00062"></a>00062       }
<a name="l00063"></a>00063     }
<a name="l00064"></a>00064   
<a name="l00065"></a>00065   <span class="keywordflow">return</span> its_name;
<a name="l00066"></a>00066 }
</pre></div>
<p>

</div>
</div><p>
<hr><h2>Variable Documentation</h2>
<a class="anchor" name="e0de7916cc1e4da0bd8b1c5568d25945"></a><!-- doxytag: member="QuadratureRules::num_rules" ref="e0de7916cc1e4da0bd8b1c5568d25945" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const unsigned int <a class="el" href="namespaceQuadratureRules.php#e0de7916cc1e4da0bd8b1c5568d25945">QuadratureRules::num_rules</a> = 5          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The number of quadrature rules that are defined (INVALD_Q_RULE excluded). You might have to update this if you add a new one! 
<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00045">45</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="83bb3bf0f93c7de93bff9b1398a1e763"></a><!-- doxytag: member="QuadratureRules::num_valid_elem_rules" ref="83bb3bf0f93c7de93bff9b1398a1e763" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const unsigned int <a class="el" href="namespaceQuadratureRules.php#83bb3bf0f93c7de93bff9b1398a1e763">QuadratureRules::num_valid_elem_rules</a> = 3          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The number of valid quadrature rules for numerical integration over geometric entities. 
<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00060">60</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="6cd73c12440db2f13e7c5a67896f1bd0"></a><!-- doxytag: member="QuadratureRules::valid_elem_rules" ref="6cd73c12440db2f13e7c5a67896f1bd0" args="[]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QuadratureType <a class="el" href="namespaceQuadratureRules.php#6cd73c12440db2f13e7c5a67896f1bd0">QuadratureRules::valid_elem_rules</a>[]          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>Initial value:</b><div class="fragment"><pre class="fragment"> {<a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716ad11bd5a126c073e475e588e38016b3785">QGAUSS</a>,
                                             <a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716adeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>,
                                             <a class="code" href="namespacelibMeshEnums.php#4650fed21cdce6d06df0add57ee716ad26431abeff146407680a87ae0dd3a39a">QTRAP</a>}
</pre></div>The types of quadrature rules that may be used for numerical integration over geometric entities. 
<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00052">52</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div><p>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
