<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="namespaces.php"><span>Namespace&nbsp;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>SparsityPattern Namespace Reference</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSparsityPattern_1_1Graph.php">Graph</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSparsityPattern_1_1Build.php">Build</a></td></tr>

<tr><td colspan="2"><br><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector&lt; unsigned <br class="typebreak">
int, <br class="typebreak">
<a class="el" href="classThreads_1_1scalable__allocator.php">Threads::scalable_allocator</a><br class="typebreak">
&lt; unsigned int &gt; &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceSparsityPattern.php#380dc3cd41bc4aab23a1c916181104b3">Row</a></td></tr>

<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memTemplParams" nowrap colspan="2">template&lt;typename BidirectionalIterator &gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">static void&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceSparsityPattern.php#bcab8a87e8229861015b1de4bc8f60ff">sort_row</a> (const BidirectionalIterator begin, BidirectionalIterator middle, const BidirectionalIterator end)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceSparsityPattern.php#853789831aeb290de9ca4a4a33c71ea9">_dummy_function</a> (void)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This defines the sparsity pattern, or graph, of a sparse matrix. The format is quite simple -- the global indices of the nonzero entries in each row are packed into a vector. The global indices (i,j) of the nth nonzero entry of row i are given by j = sparsity_pattern[i][n]; 
<p>
<hr><h2>Typedef Documentation</h2>
<a class="anchor" name="380dc3cd41bc4aab23a1c916181104b3"></a><!-- doxytag: member="SparsityPattern::Row" ref="380dc3cd41bc4aab23a1c916181104b3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;unsigned int, <a class="el" href="classThreads_1_1scalable__allocator.php">Threads::scalable_allocator</a>&lt;unsigned int&gt; &gt; <a class="el" href="namespaceSparsityPattern.php#380dc3cd41bc4aab23a1c916181104b3">SparsityPattern::Row</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="dof__map_8h_source.php#l00072">72</a> of file <a class="el" href="dof__map_8h_source.php">dof_map.h</a>.</p>

</div>
</div><p>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="853789831aeb290de9ca4a4a33c71ea9"></a><!-- doxytag: member="SparsityPattern::_dummy_function" ref="853789831aeb290de9ca4a4a33c71ea9" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SparsityPattern::_dummy_function           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Dummy function that does nothing but can be used to prohibit compiler optimization in some situations where some compilers have optimization bugs. 
<p>Definition at line <a class="el" href="dof__map_8C_source.php#l01823">1823</a> of file <a class="el" href="dof__map_8C_source.php">dof_map.C</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8h_source.php#l00932">sort_row()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l01824"></a>01824 {
<a name="l01825"></a>01825 }
</pre></div>
<p>

</div>
</div><p>
<a class="anchor" name="bcab8a87e8229861015b1de4bc8f60ff"></a><!-- doxytag: member="SparsityPattern::sort_row" ref="bcab8a87e8229861015b1de4bc8f60ff" args="(const BidirectionalIterator begin, BidirectionalIterator middle, const BidirectionalIterator end)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename BidirectionalIterator &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void SparsityPattern::sort_row           </td>
          <td>(</td>
          <td class="paramtype">const BidirectionalIterator&nbsp;</td>
          <td class="paramname"> <em>begin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">BidirectionalIterator&nbsp;</td>
          <td class="paramname"> <em>middle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const BidirectionalIterator&nbsp;</td>
          <td class="paramname"> <em>end</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [inline, static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Splices the two sorted ranges [begin,middle) and [middle,end) into one sorted range [begin,end). This method is much like std::inplace_merge except it assumes the intersection of the two sorted ranges is empty and that any element in each range occurs only once in that range. Additionally, this sort occurs in-place, while std::inplace_merge may use a temporary buffer. 
<p>Definition at line <a class="el" href="dof__map_8h_source.php#l00932">932</a> of file <a class="el" href="dof__map_8h_source.php">dof_map.h</a>.</p>

<p>References <a class="el" href="dof__map_8C_source.php#l01823">_dummy_function()</a>.</p>

<p>Referenced by <a class="el" href="dof__map_8C_source.php#l01831">SparsityPattern::Build::operator()()</a>.</p>
<div class="fragment"><pre class="fragment"><a name="l00935"></a>00935 {
<a name="l00936"></a>00936   <span class="keywordflow">if</span> ((begin == middle) || (middle == end)) <span class="keywordflow">return</span>;
<a name="l00937"></a>00937 
<a name="l00938"></a>00938   libmesh_assert (std::distance (begin,  middle) &gt; 0);
<a name="l00939"></a>00939   libmesh_assert (std::distance (middle, end)    &gt; 0);
<a name="l00940"></a>00940   libmesh_assert (std::unique (begin,  middle) == middle);
<a name="l00941"></a>00941   libmesh_assert (std::unique (middle, end)    == end);
<a name="l00942"></a>00942   
<a name="l00943"></a>00943   <span class="keywordflow">while</span> (middle != end)
<a name="l00944"></a>00944     {
<a name="l00945"></a>00945       BidirectionalIterator
<a name="l00946"></a>00946         b = middle,
<a name="l00947"></a>00947         a = b-1;
<a name="l00948"></a>00948 
<a name="l00949"></a>00949       <span class="comment">// Bubble-sort the middle value downward</span>
<a name="l00950"></a>00950       <span class="keywordflow">while</span> (!(*a &lt; *b)) <span class="comment">// *a &amp; *b are less-than comparable, so use &lt;</span>
<a name="l00951"></a>00951         {
<a name="l00952"></a>00952           std::swap (*a, *b);
<a name="l00953"></a>00953 
<a name="l00954"></a>00954 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l00955"></a>00955 <span class="preprocessor"></span>          <span class="comment">/* Prohibit optimization at this point since gcc 3.3.5 seems</span>
<a name="l00956"></a>00956 <span class="comment">             to have a bug.  */</span>
<a name="l00957"></a>00957           <a class="code" href="namespaceSparsityPattern.php#853789831aeb290de9ca4a4a33c71ea9">SparsityPattern::_dummy_function</a>();
<a name="l00958"></a>00958 <span class="preprocessor">#endif</span>
<a name="l00959"></a>00959 <span class="preprocessor"></span>
<a name="l00960"></a>00960           <span class="keywordflow">if</span> (a == begin) <span class="keywordflow">break</span>;
<a name="l00961"></a>00961           
<a name="l00962"></a>00962           b=a;
<a name="l00963"></a>00963           --a;
<a name="l00964"></a>00964         }
<a name="l00965"></a>00965       
<a name="l00966"></a>00966       ++middle;
<a name="l00967"></a>00967     }
<a name="l00968"></a>00968 
<a name="l00969"></a>00969   <span class="comment">// Assure the algorithm worked if we are in DEBUG mode</span>
<a name="l00970"></a>00970 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00971"></a>00971 <span class="preprocessor"></span>  {
<a name="l00972"></a>00972     <span class="comment">// SGI STL extension!</span>
<a name="l00973"></a>00973     <span class="comment">// libmesh_assert (std::is_sorted(begin,end));</span>
<a name="l00974"></a>00974     
<a name="l00975"></a>00975     BidirectionalIterator
<a name="l00976"></a>00976       prev  = begin,
<a name="l00977"></a>00977       first = begin;
<a name="l00978"></a>00978 
<a name="l00979"></a>00979     <span class="keywordflow">for</span> (++first; first != end; prev=first, ++first)
<a name="l00980"></a>00980       <span class="keywordflow">if</span> (*first &lt; *prev)
<a name="l00981"></a>00981         libmesh_assert(<span class="keyword">false</span>);
<a name="l00982"></a>00982   }  
<a name="l00983"></a>00983 <span class="preprocessor">#endif</span>
<a name="l00984"></a>00984 <span class="preprocessor"></span>
<a name="l00985"></a>00985   <span class="comment">// Make sure the two ranges did not contain any common elements</span>
<a name="l00986"></a>00986   libmesh_assert (std::unique (begin, end) == end);
<a name="l00987"></a>00987 }
</pre></div>
<p>

</div>
</div><p>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
