<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_17ac460506c8e7bb91dbc4cd8f04436f.php">numerics</a>
  </div>
</div>
<div class="contents">
<h1>nonlinear_solver.C</h1><a href="nonlinear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "<a class="code" href="nonlinear__solver_8h.php">nonlinear_solver.h</a>"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "<a class="code" href="petsc__nonlinear__solver_8h.php">petsc_nonlinear_solver.h</a>"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "<a class="code" href="trilinos__nox__nonlinear__solver_8h.php">trilinos_nox_nonlinear_solver.h</a>"</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>"</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// NonlinearSolver members</span>
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00034"></a>00034 <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;T&gt;</a> &gt;
<a name="l00035"></a><a class="code" href="classNonlinearSolver.php#6e494135a2809ffb3676d2733d746975">00035</a> <a class="code" href="classNonlinearSolver.php#6e494135a2809ffb3676d2733d746975">NonlinearSolver&lt;T&gt;::build</a>(<a class="code" href="classNonlinearImplicitSystem.php">sys_type</a>&amp; s, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <span class="comment">// Build the appropriate solver</span>
<a name="l00038"></a>00038   <span class="keywordflow">switch</span> (solver_package)
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#2785fa3c3529ebe4c62dc593b12b65d84bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>:
<a name="l00043"></a>00043       {
<a name="l00044"></a>00044         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classPetscNonlinearSolver.php">PetscNonlinearSolver&lt;T&gt;</a>(s));
<a name="l00045"></a>00045         <span class="keywordflow">return</span> ap;
<a name="l00046"></a>00046       }
<a name="l00047"></a>00047 <span class="preprocessor">#endif</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>      
<a name="l00049"></a>00049 <span class="preprocessor">#ifdef LIBMESH_HAVE_NOX</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="libmesh_8C.php#eb3d2e133be6abf302776ec5d939c457">TRILINOS_SOLVERS</a>:
<a name="l00051"></a>00051       {
<a name="l00052"></a>00052         <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classNoxNonlinearSolver.php">NoxNonlinearSolver&lt;T&gt;</a>(s));
<a name="l00053"></a>00053         <span class="keywordflow">return</span> ap;
<a name="l00054"></a>00054       }
<a name="l00055"></a>00055 <span class="preprocessor">#endif</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>
<a name="l00057"></a>00057     <span class="keywordflow">default</span>:
<a name="l00058"></a>00058       std::cerr &lt;&lt; <span class="stringliteral">"ERROR:  Unrecognized solver package: "</span>
<a name="l00059"></a>00059                 &lt;&lt; solver_package
<a name="l00060"></a>00060                 &lt;&lt; std::endl;
<a name="l00061"></a>00061       libmesh_error();
<a name="l00062"></a>00062     }
<a name="l00063"></a>00063     
<a name="l00064"></a>00064   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;T&gt;</a> &gt; ap(NULL);
<a name="l00065"></a>00065   <span class="keywordflow">return</span> ap;    
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00069"></a>00069 <span class="keywordtype">void</span>
<a name="l00070"></a><a class="code" href="classNonlinearSolver.php#173944a3be8013718f72e84630141b58">00070</a> <a class="code" href="classNonlinearSolver.php#173944a3be8013718f72e84630141b58">NonlinearSolver&lt;T&gt;::attach_preconditioner</a>(<a class="code" href="classPreconditioner.php">Preconditioner&lt;T&gt;</a> * preconditioner)
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classNonlinearSolver.php#b91df0629f0ebe03af1fc4ef3dd89fcf">_is_initialized</a>)
<a name="l00073"></a>00073   {
<a name="l00074"></a>00074     std::cerr&lt;&lt;<span class="stringliteral">"Preconditioner must be attached before the solver is initialized!"</span>&lt;&lt;std::endl;
<a name="l00075"></a>00075     libmesh_error();
<a name="l00076"></a>00076   }
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   <a class="code" href="classNonlinearSolver.php#59c9ee5ab780fe8c365f8f757ffffd89">_preconditioner</a> = preconditioner;
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00083"></a>00083 <span class="comment">// Explicit instantiations</span>
<a name="l00084"></a>00084 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classNonlinearSolver.php">NonlinearSolver&lt;Number&gt;</a>;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
