<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_12dde00871161206ce0977ae60ddb68a.php">mesh</a>
  </div>
</div>
<div class="contents">
<h1>off_io.C</h1><a href="off__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "<a class="code" href="off__io_8h.php">off_io.h</a>"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "<a class="code" href="mesh__base_8h.php">mesh_base.h</a>"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "<a class="code" href="face__tri3_8h.php">face_tri3.h</a>"</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// OFFIO class members</span>
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="classOFFIO.php#6de28e47f2c15d9fe2c6397cc2907340">00033</a> <span class="keywordtype">void</span> <a class="code" href="classOFFIO.php#6de28e47f2c15d9fe2c6397cc2907340">OFFIO::read</a>(<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   std::ifstream in (name.c_str());
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <a class="code" href="classOFFIO.php#5611a5b95bfd5f0be74893f8096bc1ba">read_stream</a>(in);
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classOFFIO.php#5611a5b95bfd5f0be74893f8096bc1ba">00042</a> <span class="keywordtype">void</span> <a class="code" href="classOFFIO.php#5611a5b95bfd5f0be74893f8096bc1ba">OFFIO::read_stream</a>(std::istream&amp; in)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00045"></a>00045   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00046"></a>00046   <span class="comment">// broadcast later</span>
<a name="l00047"></a>00047   libmesh_assert(<a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="comment">// Get a reference to the mesh</span>
<a name="l00050"></a>00050   <a class="code" href="classMeshBase.php">MeshBase</a>&amp; <a class="code" href="classMeshInput.php#2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00051"></a>00051   
<a name="l00052"></a>00052   <span class="comment">// Clear any existing mesh data</span>
<a name="l00053"></a>00053   mesh.<a class="code" href="classMeshBase.php#efd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l00054"></a>00054   
<a name="l00055"></a>00055   <span class="comment">// STL only works in 2D</span>
<a name="l00056"></a>00056   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>() == 2);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// Check the input buffer</span>
<a name="l00059"></a>00059   libmesh_assert (in.good());
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, ne, nf;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   std::string label;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">// Read the first string.  It should say "OFF"</span>
<a name="l00066"></a>00066   in &gt;&gt; label;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   libmesh_assert (label == <span class="stringliteral">"OFF"</span>);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// read the number of nodes, faces, and edges</span>
<a name="l00071"></a>00071   in &gt;&gt; nn &gt;&gt; nf &gt;&gt; ne;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// resize local vectors.</span>
<a name="l00074"></a>00074   <span class="comment">//  _nodes.resize(nn);</span>
<a name="l00075"></a>00075   <span class="comment">//_elements.resize(nf);</span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> x=0., y=0., z=0.;
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="comment">// Read the nodes</span>
<a name="l00081"></a>00081   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nn; n++)
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083       libmesh_assert (in.good());
<a name="l00084"></a>00084 
<a name="l00085"></a>00085       in &gt;&gt; x
<a name="l00086"></a>00086          &gt;&gt; y
<a name="l00087"></a>00087          &gt;&gt; z;
<a name="l00088"></a>00088       
<a name="l00089"></a>00089       mesh.<a class="code" href="classMeshBase.php#01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> ( <a class="code" href="classPoint.php">Point</a>(x,y,z), n );
<a name="l00090"></a>00090     }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dummy, n0, n1, n2;
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="comment">// Read the triangles</span>
<a name="l00095"></a>00095   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;nf; e++)
<a name="l00096"></a>00096     {
<a name="l00097"></a>00097       libmesh_assert (in.good());
<a name="l00098"></a>00098       
<a name="l00099"></a>00099       <span class="comment">// _elements[e] = new Tri3;</span>
<a name="l00100"></a>00100       <span class="comment">// _elements[e]-&gt;set_id (e);</span>
<a name="l00101"></a>00101       <a class="code" href="classElem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>;
<a name="l00102"></a>00102       elem-&gt;<a class="code" href="classDofObject.php#4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>(e);
<a name="l00103"></a>00103       mesh.<a class="code" href="classMeshBase.php#0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (elem);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105       <span class="comment">// The number of nodes in the object</span>
<a name="l00106"></a>00106       in &gt;&gt; dummy;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108       libmesh_assert (dummy == 3);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110       in &gt;&gt; n0
<a name="l00111"></a>00111          &gt;&gt; n1
<a name="l00112"></a>00112          &gt;&gt; n2;
<a name="l00113"></a>00113       
<a name="l00114"></a>00114       elem-&gt;set_node(0) = mesh.<a class="code" href="classMeshBase.php#1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(n0);
<a name="l00115"></a>00115       elem-&gt;set_node(1) = mesh.<a class="code" href="classMeshBase.php#1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(n1);
<a name="l00116"></a>00116       elem-&gt;set_node(2) = mesh.<a class="code" href="classMeshBase.php#1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(n2);
<a name="l00117"></a>00117     }  
<a name="l00118"></a>00118 }
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
