<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_361f0d26873fea657d27c122b56a597d.php">partitioning</a>
  </div>
</div>
<div class="contents">
<h1>partitioner_factory.C</h1><a href="partitioner__factory_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "<a class="code" href="centroid__partitioner_8h.php">centroid_partitioner.h</a>"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "<a class="code" href="metis__partitioner_8h.php">metis_partitioner.h</a>"</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="parmetis__partitioner_8h.php">parmetis_partitioner.h</a>"</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include "<a class="code" href="linear__partitioner_8h.php">linear_partitioner.h</a>"</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "<a class="code" href="hilbert__sfc__partitioner_8h.php">hilbert_sfc_partitioner.h</a>"</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include "<a class="code" href="morton__sfc__partitioner_8h.php">morton_sfc_partitioner.h</a>"</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="factory_8h.php">factory.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//-------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// Full specialization for the Factory&lt;Partitioner&gt;</span>
<a name="l00037"></a>00037 <span class="keyword">template</span>&lt;&gt;
<a name="l00038"></a>00038 std::map&lt;std::string, Factory&lt;Partitioner&gt;*&gt;&amp;
<a name="l00039"></a><a class="code" href="classFactory.php#584d78010cf60dad5fa73645042774a8">00039</a> <a class="code" href="classFactory.php#90ade05e5c9cdcf4a1437da3bf9e176c">Factory&lt;Partitioner&gt;::factory_map</a>()
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="keyword">static</span> std::map&lt;std::string, Factory&lt;Partitioner&gt;*&gt; _map;
<a name="l00042"></a>00042   <span class="keywordflow">return</span> _map;      
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// Register Partitioning classes with the factory.  These will never</span>
<a name="l00049"></a>00049 <span class="comment">// be called from user code, they just need to get instantiated.  Hide</span>
<a name="l00050"></a>00050 <span class="comment">// them in an anonymous namespace to prevent name clashes</span>
<a name="l00051"></a>00051 <span class="keyword">namespace </span>{
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="preprocessor">#ifdef LIBMESH_HAVE_METIS</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>  <a class="code" href="classFactoryImp.php">FactoryImp&lt;MetisPartitioner,      Partitioner&gt;</a> metis    (<span class="stringliteral">"Metis"</span>);
<a name="l00055"></a>00055 <span class="preprocessor">#endif</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  
<a name="l00057"></a>00057 <span class="preprocessor">#ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>  <a class="code" href="classFactoryImp.php">FactoryImp&lt;ParmetisPartitioner,   Partitioner&gt;</a> parmetis (<span class="stringliteral">"Parmetis"</span>);
<a name="l00059"></a>00059 <span class="preprocessor">#endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>
<a name="l00061"></a>00061 <span class="preprocessor">#ifdef LIBMESH_HAVE_SFCURVES</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>  <a class="code" href="classFactoryImp.php">FactoryImp&lt;SFCPartitioner,        Partitioner&gt;</a> sfc      (<span class="stringliteral">"SFCurves"</span>);
<a name="l00063"></a>00063   <a class="code" href="classFactoryImp.php">FactoryImp&lt;HilbertSFCPartitioner, Partitioner&gt;</a> hilbert  (<span class="stringliteral">"Hilbert"</span>);
<a name="l00064"></a>00064   <a class="code" href="classFactoryImp.php">FactoryImp&lt;MortonSFCPartitioner,  Partitioner&gt;</a> morton   (<span class="stringliteral">"Morton"</span>);
<a name="l00065"></a>00065 <span class="preprocessor">#endif</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>  
<a name="l00067"></a>00067   <a class="code" href="classFactoryImp.php">FactoryImp&lt;LinearPartitioner,     Partitioner&gt;</a> linear   (<span class="stringliteral">"Linear"</span>);
<a name="l00068"></a>00068   <a class="code" href="classFactoryImp.php">FactoryImp&lt;CentroidPartitioner,   Partitioner&gt;</a> centroid (<span class="stringliteral">"Centroid"</span>);
<a name="l00069"></a>00069   
<a name="l00070"></a>00070 }
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
