<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_2f51703d7c2a1bb69d989db1554dec74.php">solvers</a>
  </div>
</div>
<div class="contents">
<h1>petsc_diff_solver.C</h1><a href="petsc__diff__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include "<a class="code" href="diff__system_8h.php">diff_system.h</a>"</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include "<a class="code" href="dof__map_8h.php">dof_map.h</a>"</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include "<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>"</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "<a class="code" href="linear__solver_8h.php">linear_solver.h</a>"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "<a class="code" href="petsc__diff__solver_8h.php">petsc_diff_solver.h</a>"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>"</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Functions with C linkage to pass to PETSc.  PETSc will call these</span>
<a name="l00033"></a>00033 <span class="comment">// methods as needed.</span>
<a name="l00034"></a>00034 <span class="comment">//</span>
<a name="l00035"></a>00035 <span class="comment">// Since they must have C linkage they have no knowledge of a namespace.</span>
<a name="l00036"></a>00036 <span class="comment">// Give them an obscure name to avoid namespace pollution.</span>
<a name="l00037"></a>00037 <span class="keyword">extern</span> <span class="stringliteral">"C"</span>
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <span class="comment">// Older versions of PETSc do not have the different int typedefs.</span>
<a name="l00040"></a>00040   <span class="comment">// On 64-bit machines, PetscInt may actually be a long long int.</span>
<a name="l00041"></a>00041   <span class="comment">// This change occurred in Petsc-2.2.1.</span>
<a name="l00042"></a>00042 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00043"></a><a class="code" href="petsc__diff__solver_8C.php#efae79199a0dda59581d16f802913456">00043</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#efae79199a0dda59581d16f802913456">PetscErrorCode</a>;
<a name="l00044"></a><a class="code" href="petsc__diff__solver_8C.php#515706180f960b30595b607f2d734d14">00044</a>   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8C.php#515706180f960b30595b607f2d734d14">PetscInt</a>;
<a name="l00045"></a>00045 <span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a>00047 <span class="comment">// Function to hand to PETSc's SNES,</span>
<a name="l00048"></a>00048 <span class="comment">// which monitors convergence at X</span>
<a name="l00049"></a>00049 PetscErrorCode
<a name="l00050"></a><a class="code" href="petsc__diff__solver_8C.php#d231197b0b8e9d27ef453831a34d5d8f">00050</a> <a class="code" href="petsc__diff__solver_8C.php#d231197b0b8e9d27ef453831a34d5d8f">__libmesh_petsc_diff_solver_monitor</a> (SNES, PetscInt its,
<a name="l00051"></a>00051                                      PetscReal fnorm, <span class="keywordtype">void</span> *)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   std::cout &lt;&lt; <span class="stringliteral">"  PetscDiffSolver step "</span> &lt;&lt; its
<a name="l00054"></a>00054             &lt;&lt; <span class="stringliteral">", |residual|_2 = "</span> &lt;&lt; fnorm &lt;&lt; std::endl;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keywordflow">return</span> 0;
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="comment">// Functions to hand to PETSc's SNES,</span>
<a name="l00060"></a>00060 <span class="comment">// which compute the residual or jacobian at X</span>
<a name="l00061"></a>00061 PetscErrorCode
<a name="l00062"></a><a class="code" href="petsc__diff__solver_8C.php#6a66616f39fff0e22f601401162c9526">00062</a> <a class="code" href="petsc__diff__solver_8C.php#6a66616f39fff0e22f601401162c9526">__libmesh_petsc_diff_solver_residual</a> (SNES, Vec x, Vec r, <span class="keywordtype">void</span> *ctx)
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   libmesh_assert (x   != NULL);
<a name="l00065"></a>00065   libmesh_assert (r   != NULL);
<a name="l00066"></a>00066   libmesh_assert (ctx != NULL);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>&amp; solver =
<a name="l00069"></a>00069     *(<span class="keyword">static_cast&lt;</span><a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>*<span class="keyword">&gt;</span> (ctx));
<a name="l00070"></a>00070   <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> &amp;sys = solver.<a class="code" href="classDiffSolver.php#4caf9ee24e332e6cda6c8bb3ea032b87">system</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_system =
<a name="l00073"></a>00073     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classSystem.php#d679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00074"></a>00074   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a>&amp; R_system =
<a name="l00075"></a>00075     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classExplicitSystem.php#b4c08a2268bb5d270a821fc0ce56920a">rhs</a>);
<a name="l00076"></a>00076   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> X_input(x), R_input(r);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// DiffSystem assembles from the solution and into the rhs, so swap</span>
<a name="l00079"></a>00079   <span class="comment">// those with our input vectors before assembling.  They'll probably</span>
<a name="l00080"></a>00080   <span class="comment">// already be references to the same vectors, but PETSc might do</span>
<a name="l00081"></a>00081   <span class="comment">// something tricky.</span>
<a name="l00082"></a>00082   X_input.swap(X_system);
<a name="l00083"></a>00083   R_input.swap(R_system);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// We may need to correct a non-conforming solution</span>
<a name="l00086"></a>00086   sys.<a class="code" href="classSystem.php#f5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#b8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(sys);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00089"></a>00089   sys.<a class="code" href="classSystem.php#dd4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00092"></a>00092   sys.<a class="code" href="classDifferentiableSystem.php#f2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00093"></a>00093   R_system.close();
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// Swap back</span>
<a name="l00096"></a>00096   X_input.swap(X_system);
<a name="l00097"></a>00097   R_input.swap(R_system);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// No errors, we hope</span>
<a name="l00100"></a>00100   <span class="keywordflow">return</span> 0;
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 PetscErrorCode
<a name="l00105"></a><a class="code" href="petsc__diff__solver_8C.php#71ea94f62359c7bd59bad291a9cc7df2">00105</a> <a class="code" href="petsc__diff__solver_8C.php#71ea94f62359c7bd59bad291a9cc7df2">__libmesh_petsc_diff_solver_jacobian</a> (SNES, Vec x, Mat *j, Mat *pc,
<a name="l00106"></a>00106                                       MatStructure *msflag, <span class="keywordtype">void</span> *ctx)
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   libmesh_assert (x   != NULL);
<a name="l00109"></a>00109   libmesh_assert (j   != NULL);
<a name="l00110"></a>00110 <span class="comment">//  libmesh_assert (pc  == j);  // We don't use separate preconditioners yet</span>
<a name="l00111"></a>00111   libmesh_assert (ctx != NULL);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>&amp; solver =
<a name="l00114"></a>00114     *(<span class="keyword">static_cast&lt;</span><a class="code" href="classPetscDiffSolver.php">PetscDiffSolver</a>*<span class="keyword">&gt;</span> (ctx));
<a name="l00115"></a>00115   <a class="code" href="classDifferentiableSystem.php">DifferentiableSystem</a> &amp;sys = solver.<a class="code" href="classDiffSolver.php#4caf9ee24e332e6cda6c8bb3ea032b87">system</a>();
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_system =
<a name="l00118"></a>00118     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classSystem.php#d679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>());
<a name="l00119"></a>00119   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> X_input(x);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;Number&gt;</a> J_input(*pc);
<a name="l00122"></a>00122   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;Number&gt;</a>&amp; J_system =
<a name="l00123"></a>00123     *libmesh_cast_ptr&lt;PetscMatrix&lt;Number&gt;*&gt;(sys.<a class="code" href="classImplicitSystem.php#9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="comment">// DiffSystem assembles from the solution and into the jacobian, so</span>
<a name="l00126"></a>00126   <span class="comment">// swap those with our input vectors before assembling.  They'll</span>
<a name="l00127"></a>00127   <span class="comment">// probably already be references to the same vectors, but PETSc</span>
<a name="l00128"></a>00128   <span class="comment">// might do something tricky.</span>
<a name="l00129"></a>00129   X_input.swap(X_system);
<a name="l00130"></a>00130   J_input.<a class="code" href="classPetscMatrix.php#af70f96b16c6604e67edc21e24dbb87b">swap</a>(J_system);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// We may need to correct a non-conforming solution</span>
<a name="l00133"></a>00133   sys.<a class="code" href="classSystem.php#f5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#b8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(sys);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00136"></a>00136   sys.<a class="code" href="classSystem.php#dd4b09ec4fb0679b8623c01218cafa5b">update</a>();
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00139"></a>00139   sys.<a class="code" href="classDifferentiableSystem.php#f2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00140"></a>00140   J_system.<a class="code" href="classPetscMatrix.php#431196369d051b83ea1e3d595ec2dc0d">close</a>();
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// Swap back</span>
<a name="l00143"></a>00143   X_input.swap(X_system);
<a name="l00144"></a>00144   J_input.<a class="code" href="classPetscMatrix.php#af70f96b16c6604e67edc21e24dbb87b">swap</a>(J_system);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   *msflag = SAME_NONZERO_PATTERN;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// No errors, we hope</span>
<a name="l00149"></a>00149   <span class="keywordflow">return</span> 0;
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 } <span class="comment">// extern "C"</span>
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classPetscDiffSolver.php#175d8f80d3c3f2aa93431c9bc5b63312">00155</a> <a class="code" href="classPetscDiffSolver.php#175d8f80d3c3f2aa93431c9bc5b63312">PetscDiffSolver::PetscDiffSolver</a> (<a class="code" href="classDifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00156"></a>00156   : <a class="code" href="classDiffSolver.php">Parent</a>(s)
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158   <span class="keywordtype">int</span> ierr=0;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,1,2)</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>  <span class="comment">// At least until Petsc 2.1.1, the SNESCreate had a different</span>
<a name="l00162"></a>00162   <span class="comment">// calling syntax.  The second argument was of type SNESProblemType,</span>
<a name="l00163"></a>00163   <span class="comment">// and could have a value of either SNES_NONLINEAR_EQUATIONS or</span>
<a name="l00164"></a>00164   <span class="comment">// SNES_UNCONSTRAINED_MINIMIZATION.</span>
<a name="l00165"></a>00165   ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, SNES_NONLINEAR_EQUATIONS, &amp;<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00166"></a>00166   CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00167"></a>00167 <span class="preprocessor">#else</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>  ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,&amp;<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00169"></a>00169   CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00170"></a>00170 <span class="preprocessor">#endif</span>
<a name="l00171"></a>00171 <span class="preprocessor"></span>
<a name="l00172"></a>00172 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>  ierr = SNESSetMonitor (<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>, <a class="code" href="petsc__diff__solver_8C.php#d231197b0b8e9d27ef453831a34d5d8f">__libmesh_petsc_diff_solver_monitor</a>,
<a name="l00174"></a>00174                          <span class="keyword">this</span>, PETSC_NULL);
<a name="l00175"></a>00175 <span class="preprocessor">#else</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>  <span class="comment">// API name change in PETSc 2.3.3</span>
<a name="l00177"></a>00177   ierr = SNESMonitorSet (<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>, <a class="code" href="petsc__diff__solver_8C.php#d231197b0b8e9d27ef453831a34d5d8f">__libmesh_petsc_diff_solver_monitor</a>,
<a name="l00178"></a>00178                          <span class="keyword">this</span>, PETSC_NULL);
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>  CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   ierr = SNESSetFromOptions(<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00183"></a>00183   CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a><a class="code" href="classPetscDiffSolver.php#1d1aa101888ade3f1159cf60b0f13415">00189</a> <a class="code" href="classPetscDiffSolver.php#1d1aa101888ade3f1159cf60b0f13415">PetscDiffSolver::~PetscDiffSolver</a> ()
<a name="l00190"></a>00190 {
<a name="l00191"></a>00191   <span class="keywordtype">int</span> ierr=0;
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   ierr = SNESDestroy(<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>);
<a name="l00194"></a>00194   CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classPetscDiffSolver.php#aa0948133945299347da5a52df0f4f2d">00199</a> <span class="keywordtype">void</span> <a class="code" href="classPetscDiffSolver.php#aa0948133945299347da5a52df0f4f2d">PetscDiffSolver::reinit</a>()
<a name="l00200"></a>00200 {
<a name="l00201"></a>00201   <a class="code" href="classDiffSolver.php#f577460d7836c62c1aed2455c9085e32">Parent::reinit</a>();
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="classPetscDiffSolver.php#9794d490c7c1accad00a876df088deb3">00206</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscDiffSolver.php#9794d490c7c1accad00a876df088deb3">PetscDiffSolver::solve</a>()
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   START_LOG(<span class="stringliteral">"solve()"</span>, <span class="stringliteral">"PetscDiffSolver"</span>);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> &amp;x =
<a name="l00211"></a>00211     *(libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#d679ef41b83fdefc3fe649e99672a941">solution</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>()));
<a name="l00212"></a>00212   <a class="code" href="classPetscMatrix.php">PetscMatrix&lt;Number&gt;</a> &amp;jac =
<a name="l00213"></a>00213     *(libmesh_cast_ptr&lt;PetscMatrix&lt;Number&gt;*&gt;(<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#9bd7b51f027338353a5329b63b75b1a0">matrix</a>));
<a name="l00214"></a>00214   <a class="code" href="classPetscVector.php">PetscVector&lt;Number&gt;</a> &amp;r =
<a name="l00215"></a>00215     *(libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#b4c08a2268bb5d270a821fc0ce56920a">rhs</a>));
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   x.<a class="code" href="classPetscVector.php#ba0946fa812f249899f4ab12c0cf330c">close</a>();
<a name="l00218"></a>00218   r.<a class="code" href="classPetscVector.php#ba0946fa812f249899f4ab12c0cf330c">close</a>();
<a name="l00219"></a>00219   jac.<a class="code" href="classPetscMatrix.php#431196369d051b83ea1e3d595ec2dc0d">close</a>();
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span>  <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#f5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#b8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>);
<a name="l00223"></a>00223 <span class="preprocessor">#endif</span>
<a name="l00224"></a>00224 <span class="preprocessor"></span>
<a name="l00225"></a>00225   <span class="keywordtype">int</span> ierr = 0;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   ierr = SNESSetFunction (<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>, r.<a class="code" href="classPetscVector.php#da77db22640adec265059dd445404f6d">vec</a>(),
<a name="l00228"></a>00228                           <a class="code" href="petsc__diff__solver_8C.php#6a66616f39fff0e22f601401162c9526">__libmesh_petsc_diff_solver_residual</a>, <span class="keyword">this</span>);
<a name="l00229"></a>00229     CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   ierr = SNESSetJacobian (<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>, jac.<a class="code" href="classPetscMatrix.php#612eda163983cf42adb5a2151045f28b">mat</a>(), jac.<a class="code" href="classPetscMatrix.php#612eda163983cf42adb5a2151045f28b">mat</a>(),
<a name="l00232"></a>00232                           <a class="code" href="petsc__diff__solver_8C.php#71ea94f62359c7bd59bad291a9cc7df2">__libmesh_petsc_diff_solver_jacobian</a>, <span class="keyword">this</span>);
<a name="l00233"></a>00233     CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="preprocessor"># if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>
<a name="l00237"></a>00237   ierr = SNESSolve (<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>, x.<a class="code" href="classPetscVector.php#da77db22640adec265059dd445404f6d">vec</a>(), &amp;<a class="code" href="classDiffSolver.php#79d256bff5a88d89aec8941041dc89a9">_outer_iterations</a>);
<a name="l00238"></a>00238          CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="comment">// 2.2.x style</span>
<a name="l00241"></a>00241 <span class="preprocessor">#elif PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>
<a name="l00243"></a>00243   ierr = SNESSolve (<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>, x.<a class="code" href="classPetscVector.php#da77db22640adec265059dd445404f6d">vec</a>());
<a name="l00244"></a>00244          CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="comment">// 2.3.x &amp; newer style</span>
<a name="l00247"></a>00247 <span class="preprocessor">#else</span>
<a name="l00248"></a>00248 <span class="preprocessor"></span>
<a name="l00249"></a>00249   ierr = SNESSolve (<a class="code" href="classPetscDiffSolver.php#9b7462cdd86f11393111ac1112e3fd77">_snes</a>, PETSC_NULL, x.<a class="code" href="classPetscVector.php#da77db22640adec265059dd445404f6d">vec</a>());
<a name="l00250"></a>00250          CHKERRABORT(<a class="code" href="namespacelibMesh.php#30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,ierr);
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 <span class="preprocessor">#endif</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span>
<a name="l00254"></a>00254   STOP_LOG(<span class="stringliteral">"solve()"</span>, <span class="stringliteral">"PetscDiffSolver"</span>);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">// FIXME - We'll worry about getting the solve result right later...</span>
<a name="l00257"></a>00257   
<a name="l00258"></a>00258   <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#53b19ea21f16ad97e89858bff63071ee7a3ff540e243e45764a90666389ba012">DiffSolver::CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00259"></a>00259 }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="classPetscDiffSolver.php#425e5c3f57fc020040cfbe07759d7762">00263</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classPetscDiffSolver.php#425e5c3f57fc020040cfbe07759d7762">PetscDiffSolver::adjoint_solve</a>()
<a name="l00264"></a>00264 {
<a name="l00265"></a>00265   START_LOG(<span class="stringliteral">"adjoint_solve()"</span>, <span class="stringliteral">"PetscDiffSolver"</span>);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00268"></a>00268   <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classDifferentiableSystem.php#f2770154003897eef7c70a5318478393">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00269"></a>00269   <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#55129db49268936e33686bc1beaaa1e9">close</a>();
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// But take the adjoint</span>
<a name="l00272"></a>00272   <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#9bd7b51f027338353a5329b63b75b1a0">matrix</a>-&gt;<a class="code" href="classSparseMatrix.php#7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a>(*<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#9bd7b51f027338353a5329b63b75b1a0">matrix</a>);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="keywordflow">if</span> (<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">"Preconditioner"</span>))
<a name="l00275"></a>00275     {
<a name="l00276"></a>00276       <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp;pre = <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">"Preconditioner"</span>);
<a name="l00277"></a>00277       pre.<a class="code" href="classSparseMatrix.php#7f1c4ddda074a4e1aa63bf7d2f780492">get_transpose</a>(pre);
<a name="l00278"></a>00278     }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="comment">// And set the right hand side to the quantity of interest</span>
<a name="l00281"></a>00281   <span class="comment">// derivative</span>
<a name="l00282"></a>00282   <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#563d121d2398bdc54dbe60eda789ddaa">assemble_qoi_derivative</a>();
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="comment">// Then build something to solve the _linear_ system</span>
<a name="l00285"></a>00285   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; linear_solver = <a class="code" href="classDiffSolver.php#4329eed9150ced6af7f969015fc14dfb">LinearSolver&lt;Number&gt;::build</a>();
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="comment">// Solve the linear system.  Two cases:</span>
<a name="l00288"></a>00288   <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00289"></a>00289     (<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#a23d50b0a898aaee758d4a98c996a4df">have_matrix</a>(<span class="stringliteral">"Preconditioner"</span>)) ?
<a name="l00290"></a>00290   <span class="comment">// 1.) User-supplied preconditioner</span>
<a name="l00291"></a>00291     linear_solver-&gt;solve (*<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#9bd7b51f027338353a5329b63b75b1a0">matrix</a>,
<a name="l00292"></a>00292                           <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#719365410b024d2ddab0b1bada55753d">get_matrix</a>(<span class="stringliteral">"Preconditioner"</span>),
<a name="l00293"></a>00293                           *<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#d679ef41b83fdefc3fe649e99672a941">solution</a>, *<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#b4c08a2268bb5d270a821fc0ce56920a">rhs</a>,
<a name="l00294"></a>00294                           <a class="code" href="classDiffSolver.php#a61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>,
<a name="l00295"></a>00295                           <a class="code" href="classDiffSolver.php#44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>) :
<a name="l00296"></a>00296   <span class="comment">// 2.) Use system matrix for the preconditioner</span>
<a name="l00297"></a>00297     linear_solver-&gt;solve (*<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classImplicitSystem.php#9bd7b51f027338353a5329b63b75b1a0">matrix</a>,
<a name="l00298"></a>00298                           *<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#d679ef41b83fdefc3fe649e99672a941">solution</a>, *<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classExplicitSystem.php#b4c08a2268bb5d270a821fc0ce56920a">rhs</a>,
<a name="l00299"></a>00299                           <a class="code" href="classDiffSolver.php#a61c00b75cbbd6910882c7a415d9d22a">relative_residual_tolerance</a>, 
<a name="l00300"></a>00300                           <a class="code" href="classDiffSolver.php#44125d46d2f5df9f29392cbe81069bf6">max_linear_iterations</a>);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00303"></a>00303   <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#dd4b09ec4fb0679b8623c01218cafa5b">update</a> ();
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00306"></a>00306 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00307"></a>00307 <span class="preprocessor"></span>  <a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>.<a class="code" href="classSystem.php#f5da386e5c0e0863542691c26efe0405">get_dof_map</a>().<a class="code" href="classDofMap.php#b8f806aded3f8351a9f0f6bbf8ae8274">enforce_constraints_exactly</a>(<a class="code" href="classDiffSolver.php#85dc8547a41ba6b109433147355a48aa">_system</a>);
<a name="l00308"></a>00308 <span class="preprocessor">#endif</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span>
<a name="l00310"></a>00310   STOP_LOG(<span class="stringliteral">"adjoint_solve()"</span>, <span class="stringliteral">"PetscDiffSolver"</span>);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="comment">// FIXME - We'll worry about getting the solve result right later...</span>
<a name="l00313"></a>00313   
<a name="l00314"></a>00314   <span class="keywordflow">return</span> <a class="code" href="classDiffSolver.php#53b19ea21f16ad97e89858bff63071ee7a3ff540e243e45764a90666389ba012">DiffSolver::CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00315"></a>00315 }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 <span class="preprocessor">#endif // LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
