<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_761160be8471a35631e13b5b753c2d12.php">quadrature</a>
  </div>
</div>
<div class="contents">
<h1>quadrature_gm_3D.C</h1><a href="quadrature__gm__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include "<a class="code" href="quadrature__gm_8h.php">quadrature_gm.h</a>"</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="classQGrundmann__Moller.php#c612af7c72943ec85a02b0093e756efa">00027</a> <span class="keywordtype">void</span> <a class="code" href="classQGrundmann__Moller.php#c612af7c72943ec85a02b0093e756efa">QGrundmann_Moller::init_3D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00028"></a>00028                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030   <span class="comment">// Nearly all GM rules contain negative weights, so if you are not</span>
<a name="l00031"></a>00031   <span class="comment">// allowing rules with negative weights, we cannot continue!</span>
<a name="l00032"></a>00032   <span class="keywordflow">if</span> (!<a class="code" href="classQBase.php#8d178a77bd09f56326ee6135e9c43d8b">allow_rules_with_negative_weights</a>)
<a name="l00033"></a>00033     {
<a name="l00034"></a>00034       std::cerr &lt;&lt; <span class="stringliteral">"You requested a Grundmann-Moller rule but\n"</span>
<a name="l00035"></a>00035                 &lt;&lt; <span class="stringliteral">"are not allowing rules with negative weights!\n"</span>
<a name="l00036"></a>00036                 &lt;&lt; <span class="stringliteral">"Either select a different quadrature class or\n"</span>
<a name="l00037"></a>00037                 &lt;&lt; <span class="stringliteral">"set allow_rules_with_negative_weights==true."</span> 
<a name="l00038"></a>00038                 &lt;&lt; std::endl;
<a name="l00039"></a>00039       
<a name="l00040"></a>00040       libmesh_error();
<a name="l00041"></a>00041     }
<a name="l00042"></a>00042   
<a name="l00043"></a>00043   <span class="keywordflow">switch</span> (_type)
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#54ee290fca7f0c26eb1e5986f52714574d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00046"></a>00046     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#54ee290fca7f0c26eb1e5986f527145701f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00047"></a>00047       {
<a name="l00048"></a>00048         <span class="comment">// Untested above _order=23 but should work...</span>
<a name="l00049"></a>00049         <a class="code" href="classQGrundmann__Moller.php#0857d51c854735a8540316c04b8ab2b6">gm_rule</a>( (_order + 2*p)/2 );
<a name="l00050"></a>00050         <span class="keywordflow">return</span>;
<a name="l00051"></a>00051         
<a name="l00052"></a>00052       } <span class="comment">// end case TET4, TET10</span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055       
<a name="l00056"></a>00056       <span class="comment">//---------------------------------------------</span>
<a name="l00057"></a>00057       <span class="comment">// Unsupported element type</span>
<a name="l00058"></a>00058     <span class="keywordflow">default</span>:
<a name="l00059"></a>00059       {
<a name="l00060"></a>00060         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Unsupported element type: "</span> &lt;&lt; _type &lt;&lt; std::endl;
<a name="l00061"></a>00061         libmesh_error();
<a name="l00062"></a>00062       }
<a name="l00063"></a>00063     } <span class="comment">// end switch (_type)</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">// We must have returned or errored-out by this point.  If not,</span>
<a name="l00066"></a>00066   <span class="comment">// throw an error now.</span>
<a name="l00067"></a>00067   libmesh_error();
<a name="l00068"></a>00068   <span class="keywordflow">return</span>;
<a name="l00069"></a>00069 }
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
