<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_4cb381224d5c2cf05fb3516ed27ee655.php">base</a>
  </div>
</div>
<div class="contents">
<h1>reference_counted_object.h</h1><a href="reference__counted__object_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001  <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __reference_counted_object_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __reference_counted_object_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;typeinfo&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include "<a class="code" href="reference__counter_8h.php">reference_counter.h</a>"</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00065"></a>00065 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// ReferenceCounter class definition</span>
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00068"></a><a class="code" href="classReferenceCountedObject.php">00068</a> <span class="keyword">class </span><a class="code" href="classReferenceCountedObject.php">ReferenceCountedObject</a> : <span class="keyword">public</span> <a class="code" href="classReferenceCounter.php">ReferenceCounter</a>
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070 <span class="keyword">protected</span>:
<a name="l00071"></a>00071 
<a name="l00077"></a><a class="code" href="classReferenceCountedObject.php#009a291faea9c63df4e27d29a4b3ff7f">00077</a>   <a class="code" href="classReferenceCountedObject.php#009a291faea9c63df4e27d29a4b3ff7f">ReferenceCountedObject</a> ()
<a name="l00078"></a>00078   {
<a name="l00079"></a>00079 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>    
<a name="l00081"></a>00081     <a class="code" href="classReferenceCounter.php#9a9c62e0d9c6738995dc3acafe795d0e">increment_constructor_count</a>(<span class="keyword">typeid</span>(T).<a class="code" href="namespaceQuality.php#47f1b8befd1bbd18dfe20c810b9ade23">name</a>());
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="preprocessor">#endif</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>  }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="keyword">public</span>:
<a name="l00087"></a>00087   
<a name="l00091"></a><a class="code" href="classReferenceCountedObject.php#857a595d850c8f3badf8d2b2b5142729">00091</a>   <span class="keyword">virtual</span> <a class="code" href="classReferenceCountedObject.php#857a595d850c8f3badf8d2b2b5142729">~ReferenceCountedObject</a> ()
<a name="l00092"></a>00092   {
<a name="l00093"></a>00093 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>    
<a name="l00095"></a>00095     <a class="code" href="classReferenceCounter.php#84339666391c278727332f5935751517">increment_destructor_count</a>(<span class="keyword">typeid</span>(T).<a class="code" href="namespaceQuality.php#47f1b8befd1bbd18dfe20c810b9ade23">name</a>());
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="preprocessor">#endif</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>  }
<a name="l00099"></a>00099   
<a name="l00100"></a>00100 <span class="keyword">private</span>:
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 };
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="preprocessor">#endif // end #ifndef __reference_counted_object_h__</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span>
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
