<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_d45fb629c53d016ea9ac26478e48620b.php">numerics</a>
  </div>
</div>
<div class="contents">
<h1>slepc_eigen_solver.h</h1><a href="slepc__eigen__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __slepc_eigen_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __slepc_eigen_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="eigen__solver_8h.php">eigen_solver.h</a>"</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include "<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>"</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>"</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00037"></a>00037 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; defined(LIBMESH_HAVE_PETSC)</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifndef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor"># include &lt;slepceps.h&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor"># include &lt;slepcversion.h&gt;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#else</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor"># include &lt;slepceps.h&gt;</span>
<a name="l00044"></a>00044 <span class="preprocessor"># include &lt;slepcversion.h&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">// A convenient macro for comparing SLEPc versions.</span>
<a name="l00049"></a>00049 <span class="comment">// Returns 1 if the current SLEPc version is &lt; major.minor.subminor</span>
<a name="l00050"></a>00050 <span class="comment">// and zero otherwise.</span>
<a name="l00051"></a>00051 <span class="preprocessor">#define SLEPC_VERSION_LESS_THAN(major,minor,subminor)                               \</span>
<a name="l00052"></a>00052 <span class="preprocessor">  ((SLEPC_VERSION_MAJOR &lt; (major) ||                                                \</span>
<a name="l00053"></a>00053 <span class="preprocessor">    (SLEPC_VERSION_MAJOR == (major) &amp;&amp; (SLEPC_VERSION_MINOR &lt; (minor) ||            \</span>
<a name="l00054"></a>00054 <span class="preprocessor">                                  (SLEPC_VERSION_MINOR == (minor) &amp;&amp;                \</span>
<a name="l00055"></a>00055 <span class="preprocessor">                                   SLEPC_VERSION_SUBMINOR &lt; (subminor))))) ? 1 : 0)</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00064"></a>00064 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00065"></a><a class="code" href="classSlepcEigenSolver.php">00065</a> <span class="keyword">class </span><a class="code" href="classSlepcEigenSolver.php">SlepcEigenSolver</a> : <span class="keyword">public</span> <a class="code" href="classEigenSolver.php">EigenSolver</a>&lt;T&gt;
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="keyword">public</span>:
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <a class="code" href="classSlepcEigenSolver.php#75bb3a03da03080a1f56fef8a9acaa9b">SlepcEigenSolver</a>();
<a name="l00074"></a>00074     
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <a class="code" href="classSlepcEigenSolver.php#bb743cf07c7c7464d6423a7ce7b99550">~SlepcEigenSolver</a>();
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   
<a name="l00085"></a>00085   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#da66948bab2a240a013853730cf99924">clear</a>();
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#294a5ff9e998c09fa5a2fa65af7f8ce7">init</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093        
<a name="l00104"></a>00104   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#182a3ddba170ddca0f2363383bd2b521">solve_standard</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00105"></a>00105                                                          <span class="keywordtype">int</span> nev,
<a name="l00106"></a>00106                                                          <span class="keywordtype">int</span> ncv,
<a name="l00107"></a>00107                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00108"></a>00108                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00109"></a>00109 
<a name="l00114"></a>00114   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#182a3ddba170ddca0f2363383bd2b521">solve_standard</a> (<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix,
<a name="l00115"></a>00115                                                          <span class="keywordtype">int</span> nev,
<a name="l00116"></a>00116                                                          <span class="keywordtype">int</span> ncv,
<a name="l00117"></a>00117                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00118"></a>00118                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00119"></a>00119   
<a name="l00120"></a>00120 
<a name="l00133"></a>00133   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#b9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00134"></a>00134                                                            <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00135"></a>00135                                                            <span class="keywordtype">int</span> nev,
<a name="l00136"></a>00136                                                            <span class="keywordtype">int</span> ncv,
<a name="l00137"></a>00137                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00138"></a>00138                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00139"></a>00139 
<a name="l00144"></a>00144     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#b9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00145"></a>00145                                                            <a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00146"></a>00146                                                            <span class="keywordtype">int</span> nev,
<a name="l00147"></a>00147                                                            <span class="keywordtype">int</span> ncv,
<a name="l00148"></a>00148                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00149"></a>00149                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00150"></a>00150 
<a name="l00161"></a>00161     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#b9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00162"></a>00162                                                            <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00163"></a>00163                                                            <span class="keywordtype">int</span> nev,
<a name="l00164"></a>00164                                                            <span class="keywordtype">int</span> ncv,
<a name="l00165"></a>00165                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00166"></a>00166                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00167"></a>00167 
<a name="l00178"></a>00178     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#b9a657adf5ad54ed8e85225bc1553275">solve_generalized</a>(<a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00179"></a>00179                                                            <a class="code" href="classShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00180"></a>00180                                                            <span class="keywordtype">int</span> nev,
<a name="l00181"></a>00181                                                            <span class="keywordtype">int</span> ncv,
<a name="l00182"></a>00182                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00183"></a>00183                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185  
<a name="l00186"></a>00186  
<a name="l00193"></a>00193   std::pair&lt;Real, Real&gt; <a class="code" href="classSlepcEigenSolver.php#fe25c6b6bb795271ca34917a5c6794d8">get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00194"></a>00194                                        <a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in);
<a name="l00195"></a>00195 
<a name="l00200"></a>00200   <a class="code" href="libmesh__common_8h.php#b685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classSlepcEigenSolver.php#236eef6e58f5092fb35bcae21a439dcf">get_relative_error</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00201"></a>00201 
<a name="l00205"></a>00205   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#c5baa682ab5eb63dfd8734a0dddd6336">attach_deflation_space</a>(<a class="code" href="classNumericVector.php">NumericVector&lt;T&gt;</a>&amp; deflation_vector);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="keyword">private</span>:
<a name="l00208"></a>00208 
<a name="l00212"></a>00212   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#e2ce977bfa02d860215441038b6a3e6e">_solve_standard_helper</a> (Mat mat,
<a name="l00213"></a>00213                                                          <span class="keywordtype">int</span> nev,
<a name="l00214"></a>00214                                                          <span class="keywordtype">int</span> ncv,
<a name="l00215"></a>00215                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00216"></a>00216                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00217"></a>00217 
<a name="l00221"></a>00221   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classSlepcEigenSolver.php#6009a0dbee13ea7dbffba69ef26be1ea">_solve_generalized_helper</a> (Mat mat_A,
<a name="l00222"></a>00222                                                                  Mat mat_B,
<a name="l00223"></a>00223                                                                  <span class="keywordtype">int</span> nev,
<a name="l00224"></a>00224                                                                  <span class="keywordtype">int</span> ncv,
<a name="l00225"></a>00225                                                                  <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00226"></a>00226                                                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00227"></a>00227 
<a name="l00232"></a>00232   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#a31985ca6678c3370a0645acb7cbafd6">set_slepc_solver_type</a> ();
<a name="l00233"></a>00233 
<a name="l00238"></a>00238   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#14e834219079c4b1df00aa6ca970a179">set_slepc_problem_type</a> ();
<a name="l00239"></a>00239 
<a name="l00244"></a>00244   <span class="keywordtype">void</span> <a class="code" href="classSlepcEigenSolver.php#e4eb2c3afdf92ed2f21e0948f7614897">set_slepc_position_of_spectrum</a>();
<a name="l00245"></a>00245 
<a name="l00251"></a>00251   <span class="keyword">static</span> <a class="code" href="petsc__linear__solver_8C.php#efae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classSlepcEigenSolver.php#c2ba414670ebffafb034e6cfb126900d">_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest);
<a name="l00252"></a>00252 
<a name="l00258"></a>00258   <span class="keyword">static</span> <a class="code" href="petsc__linear__solver_8C.php#efae79199a0dda59581d16f802913456">PetscErrorCode</a> <a class="code" href="classSlepcEigenSolver.php#0924faa62e95ac9fb09fb8071138138f">_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest);
<a name="l00259"></a>00259 
<a name="l00263"></a><a class="code" href="classSlepcEigenSolver.php#b0122a73f6797a500e472f32696d91a2">00263</a>   EPS <a class="code" href="classSlepcEigenSolver.php#b0122a73f6797a500e472f32696d91a2">_eps</a>;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 };
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00269"></a>00269 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00270"></a>00270 <span class="keyword">inline</span>
<a name="l00271"></a><a class="code" href="classSlepcEigenSolver.php#75bb3a03da03080a1f56fef8a9acaa9b">00271</a> <a class="code" href="classSlepcEigenSolver.php#75bb3a03da03080a1f56fef8a9acaa9b">SlepcEigenSolver&lt;T&gt;::SlepcEigenSolver</a> ()
<a name="l00272"></a>00272 {
<a name="l00273"></a>00273   this-&gt;<a class="code" href="classEigenSolver.php#29dd62ae6fea3bc7240d50e3b785c1f7">_eigen_solver_type</a>  = <a class="code" href="namespacelibMeshEnums.php#4b230c3a7c3d5488c3c46bd9d03ce80212dfe2dfbb1204d9ac57ca8efc947146">ARNOLDI</a>;
<a name="l00274"></a>00274   this-&gt;<a class="code" href="classEigenSolver.php#2c8c9a52b3ad05719e53fae54edb47e8">_eigen_problem_type</a> = <a class="code" href="namespacelibMeshEnums.php#834a7caabd0c61943731bb38bfc673012b61471cb234c46e5f054bc73c2221de">NHEP</a>;
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00280"></a>00280 <span class="keyword">inline</span>
<a name="l00281"></a><a class="code" href="classSlepcEigenSolver.php#bb743cf07c7c7464d6423a7ce7b99550">00281</a> <a class="code" href="classSlepcEigenSolver.php#bb743cf07c7c7464d6423a7ce7b99550">SlepcEigenSolver&lt;T&gt;::~SlepcEigenSolver</a> ()
<a name="l00282"></a>00282 {
<a name="l00283"></a>00283   this-&gt;<a class="code" href="classSlepcEigenSolver.php#da66948bab2a240a013853730cf99924">clear</a> ();
<a name="l00284"></a>00284 }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00288"></a>00288 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __slepc_linear_solver_h__</span>
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
