<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_2f51703d7c2a1bb69d989db1554dec74.php">solvers</a>
  </div>
</div>
<div class="contents">
<h1>steady_solver.C</h1><a href="steady__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include "<a class="code" href="diff__solver_8h.php">diff_solver.h</a>"</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include "<a class="code" href="diff__system_8h.php">diff_system.h</a>"</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include "<a class="code" href="steady__solver_8h.php">steady_solver.h</a>"</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="classSteadySolver.php#888037e4814bd1473147d1d1ebb326fb">00027</a> <a class="code" href="classSteadySolver.php#888037e4814bd1473147d1d1ebb326fb">SteadySolver::~SteadySolver</a> ()
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 }
<a name="l00030"></a>00030   
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="classSteadySolver.php#c0e0e93e6f59f26895c5100fd5b2ad87">00033</a> <span class="keywordtype">bool</span> <a class="code" href="classSteadySolver.php#c0e0e93e6f59f26895c5100fd5b2ad87">SteadySolver::element_residual</a>(<span class="keywordtype">bool</span> request_jacobian,
<a name="l00034"></a>00034                                     <a class="code" href="classDiffContext.php">DiffContext</a>&amp; context)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   <span class="comment">// If a fixed solution is requested, it will just be the current</span>
<a name="l00037"></a>00037   <span class="comment">// solution</span>
<a name="l00038"></a>00038   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040       context.<a class="code" href="classDiffContext.php#1ab7c2721bfd00d5483f7625fb49e421">elem_fixed_solution</a> = context.<a class="code" href="classDiffContext.php#00ea517d8b076d10da898e921522ba98">elem_solution</a>;
<a name="l00041"></a>00041       context.<a class="code" href="classDiffContext.php#ad59fbaa6442d15ef901607827ed9e9c">fixed_solution_derivative</a> = 1.0;
<a name="l00042"></a>00042     }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00045"></a>00045     <a class="code" href="classTimeSolver.php#6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#518a1763297cc2706185c539cc4fcec5">element_time_derivative</a>(request_jacobian, context);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="comment">// The user shouldn't compute a jacobian unless requested</span>
<a name="l00048"></a>00048   libmesh_assert(request_jacobian || !jacobian_computed);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordtype">bool</span> jacobian_computed2 =
<a name="l00051"></a>00051     <a class="code" href="classTimeSolver.php#6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#516241801a3773a0c9d4a4b0d12de174">element_constraint</a>(jacobian_computed, context);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">// The user shouldn't compute a jacobian unless requested</span>
<a name="l00054"></a>00054   libmesh_assert (jacobian_computed || !jacobian_computed2);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keywordflow">return</span> jacobian_computed2;
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classSteadySolver.php#b8a70755195ba17201eabf41b199f668">00061</a> <span class="keywordtype">bool</span> <a class="code" href="classSteadySolver.php#b8a70755195ba17201eabf41b199f668">SteadySolver::side_residual</a>(<span class="keywordtype">bool</span> request_jacobian,
<a name="l00062"></a>00062                                  <a class="code" href="classDiffContext.php">DiffContext</a>&amp; context)
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   <span class="comment">// If a fixed solution is requested, it will just be the current</span>
<a name="l00065"></a>00065   <span class="comment">// solution</span>
<a name="l00066"></a>00066   <span class="keywordflow">if</span> (<a class="code" href="classTimeSolver.php#6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#3e9645837798cc7d10d127b9ce54b0e1">use_fixed_solution</a>)
<a name="l00067"></a>00067     {
<a name="l00068"></a>00068       context.<a class="code" href="classDiffContext.php#1ab7c2721bfd00d5483f7625fb49e421">elem_fixed_solution</a> = context.<a class="code" href="classDiffContext.php#00ea517d8b076d10da898e921522ba98">elem_solution</a>;
<a name="l00069"></a>00069       context.<a class="code" href="classDiffContext.php#ad59fbaa6442d15ef901607827ed9e9c">fixed_solution_derivative</a> = 1.0;
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00073"></a>00073     <a class="code" href="classTimeSolver.php#6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#990b76eb7ed84572c0384d90fe51fbaf">side_time_derivative</a>(request_jacobian, context);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">// The user shouldn't compute a jacobian unless requested</span>
<a name="l00076"></a>00076   libmesh_assert (request_jacobian || !jacobian_computed);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="keywordtype">bool</span> jacobian_computed2 =
<a name="l00079"></a>00079     <a class="code" href="classTimeSolver.php#6c90837206b6e36e31df811e8b6ac491">_system</a>.<a class="code" href="classDifferentiableSystem.php#9520b686cc6181bff6888e0a96dd0c27">side_constraint</a>(jacobian_computed, context);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// The user shouldn't compute a jacobian unless requested</span>
<a name="l00082"></a>00082   libmesh_assert (jacobian_computed || !jacobian_computed2);
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <span class="keywordflow">return</span> jacobian_computed2;
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
