<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_254623858702432f2abcbee36308d248.php">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_4cb381224d5c2cf05fb3516ed27ee655.php">base</a>
  </div>
</div>
<div class="contents">
<h1>variant_filter_iterator.h</h1><a href="variant__filter__iterator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __variant_filter_iterator_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __variant_filter_iterator_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::swap</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;cstdlib&gt;</span>   <span class="comment">// for std::abort()</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 3)  &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &lt;typeinfo&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#endif</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Predicate, <span class="keyword">class</span> Type, <span class="keyword">class</span> ReferenceType = Type&amp;, <span class="keyword">class</span> Po<span class="keywordtype">int</span>erType = Type*&gt;
<a name="l00047"></a>00047 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 3)  &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l00048"></a><a class="code" href="classvariant__filter__iterator.php">00048</a> <span class="preprocessor"></span><span class="keyword">class </span><a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a> : <span class="keyword">public</span> std::forward_iterator&lt;std::forward_iterator_tag, Type&gt;
<a name="l00049"></a>00049 #else
<a name="l00050"></a>00050 class <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a> : <span class="keyword">public</span> std::iterator&lt;std::forward_iterator_tag,  Type&gt;
<a name="l00051"></a>00051 #endif
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00057"></a>00057   <span class="keyword">typedef</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a> <a class="code" href="classvariant__filter__iterator.php">Iterator</a>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00068"></a>00068   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>
<a name="l00069"></a><a class="code" href="structvariant__filter__iterator_1_1IterBase.php#98aeadf88739211693b7e73529040b85">00069</a>   {
<a name="l00070"></a>00070     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#98aeadf88739211693b7e73529040b85">~IterBase</a>() {}
<a name="l00071"></a>00071     <span class="keyword">virtual</span>  <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#21f29418376c68d57fc5d21000379751">clone</a>() <span class="keyword">const</span> = 0 ;
<a name="l00072"></a>00072     <span class="keyword">virtual</span> ReferenceType <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#16f042ee7760e371e91fef4a95eb0cdf">operator*</a>() <span class="keyword">const</span> = 0;    <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00073"></a>00073     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#0dffb156fea66739c1c1dcace6a3daa8">operator++</a>() = 0;          <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00074"></a>00074     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#d950ec9d5c1e122a832a57f5e37b7fc6">equal</a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a> *other) <span class="keyword">const</span> = 0;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="comment">// Similar to clone function above, but returns a pointer to a copy of a different type.</span>
<a name="l00077"></a><a class="code" href="structvariant__filter__iterator_1_1IterBase.php#f18d02ffa3020f00726d6a723530ef06">00077</a>     <span class="comment">// typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::IterBase const_IterBase;</span>
<a name="l00078"></a>00078     <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">variant_filter_iterator&lt;Predicate, Type const, Type const &amp; , Type const*&gt;::IterBase</a> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">const_IterBase</a>;
<a name="l00079"></a>00079     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">const_IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#7ce190637309c41cf5514547dd0a6b21">const_clone</a>() <span class="keyword">const</span> = 0;
<a name="l00080"></a>00080   };
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   
<a name="l00091"></a>00091   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>
<a name="l00092"></a><a class="code" href="structvariant__filter__iterator_1_1PredBase.php#ae08a3ace0c8ffe3d10499656076cccf">00092</a>   {
<a name="l00093"></a>00093     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#ae08a3ace0c8ffe3d10499656076cccf">~PredBase</a>() {}
<a name="l00094"></a>00094     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#1a1f2c652e009c29c8d55172102066fc">clone</a>() <span class="keyword">const</span> = 0 ;
<a name="l00095"></a>00095     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#e34310ba9e58eed92243cdafd44d53e7">operator()</a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* in) <span class="keyword">const</span> = 0;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="comment">// Similar to clone function above, but returns a pointer to a copy of a different type.</span>
<a name="l00098"></a><a class="code" href="structvariant__filter__iterator_1_1PredBase.php#f87a419fd9c9cd0c839cb36ac2b47760">00098</a>     <span class="comment">// typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::PredBase const_PredBase;</span>
<a name="l00099"></a>00099     <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">variant_filter_iterator&lt;Predicate, Type const,  Type const &amp;,  Type const *&gt;::PredBase</a> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">const_PredBase</a>;
<a name="l00100"></a>00100     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">const_PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#f7478ab145480b27f7e6ec6be0aef64f">const_clone</a>() <span class="keyword">const</span> = 0;
<a name="l00101"></a>00101   };
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   
<a name="l00112"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php">00112</a>   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> IterType&gt;
<a name="l00113"></a>00113   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter</a> : <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>
<a name="l00114"></a>00114   {
<a name="l00115"></a>00115     
<a name="l00119"></a>00119     <a class="code" href="structvariant__filter__iterator_1_1Iter.php#551cc198d1b7b9b38f4074296320f076">Iter</a> (<span class="keyword">const</span> IterType&amp; v) :
<a name="l00120"></a>00120       <a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a> (v)
<a name="l00121"></a>00121     {
<a name="l00122"></a>00122       <span class="comment">// std::cout &lt;&lt; "In Iter&lt;IterType&gt;::Iter(const IterType&amp; v)" &lt;&lt; std::endl;</span>
<a name="l00123"></a>00123     }
<a name="l00124"></a>00124     
<a name="l00125"></a>00125 
<a name="l00129"></a>00129     <a class="code" href="structvariant__filter__iterator_1_1Iter.php#551cc198d1b7b9b38f4074296320f076">Iter</a> (<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter</a>&amp; other) :
<a name="l00130"></a>00130       <a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>(other.<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>)
<a name="l00131"></a>00131     {}
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00137"></a>00137     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php#526b6ce05a87a9b9fa852e9ada4b42ff">~Iter</a> () {}
<a name="l00138"></a>00138     
<a name="l00143"></a>00143     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Iter.php#11befbafac66da26deddded1dde7dd11">clone</a>()<span class="keyword"> const</span>
<a name="l00144"></a>00144 <span class="keyword">    </span>{
<a name="l00145"></a>00145 <span class="preprocessor">#ifdef __SUNPRO_CC      </span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a> *copy = 
<a name="l00147"></a>00147         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00148"></a>00148 <span class="preprocessor">#else</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a> *copy = 
<a name="l00150"></a>00150         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);      
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>      
<a name="l00153"></a>00153       <span class="keywordflow">return</span> copy;
<a name="l00154"></a>00154     }
<a name="l00155"></a>00155 
<a name="l00160"></a>00160     <span class="keyword">virtual</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase::const_IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Iter.php#47a238588cd276035a424d5729aa5cf4">const_clone</a>()<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword">    </span>{
<a name="l00165"></a>00165       <span class="comment">// typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::template Iter&lt;IterType&gt; const_Iter;</span>
<a name="l00166"></a>00166       <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type const, Type const &amp;,  Type const *&gt;::template</a> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a> const_Iter;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168       <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase::const_IterBase</a>* copy =
<a name="l00169"></a>00169         <span class="keyword">new</span> const_Iter(<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171       <span class="keywordflow">return</span> copy;
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173 
<a name="l00177"></a>00177     <span class="keyword">virtual</span> ReferenceType <a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5bd948431a1b0a0b2b30e47d975fe5a">operator*</a>() <span class="keyword">const</span>   <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00178"></a>00178     {
<a name="l00179"></a>00179       <span class="keywordflow">return</span> *<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>;
<a name="l00180"></a>00180     }
<a name="l00181"></a>00181 
<a name="l00185"></a>00185     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php#61bdfd437b4e3fa6b4a82bbe822e76aa">operator++</a>()         <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00186"></a>00186     {
<a name="l00187"></a>00187       ++<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>;
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189 
<a name="l00196"></a>00196     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php#1df6b54eac34da7595985bc827b435c0">equal</a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a> *other)<span class="keyword"> const</span>
<a name="l00197"></a>00197 <span class="keyword">    </span>{
<a name="l00198"></a>00198 <span class="preprocessor">#if defined(__SUNPRO_CC) || (defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 3)  &amp;&amp; !defined(__INTEL_COMPILER))</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>      <span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a>* p = 
<a name="l00200"></a>00200         <span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a>*<span class="keyword">&gt;</span>(other);
<a name="l00201"></a>00201 <span class="preprocessor">#else      </span>
<a name="l00202"></a>00202 <span class="preprocessor"></span>      <span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>* p = 
<a name="l00203"></a>00203         <span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>*<span class="keyword">&gt;</span>(other);      
<a name="l00204"></a>00204 <span class="preprocessor">#endif</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>      <span class="comment">// Check for failed cast</span>
<a name="l00206"></a>00206       <span class="keywordflow">if</span> (p == NULL)
<a name="l00207"></a>00207         {
<a name="l00208"></a>00208           <span class="comment">// std::cerr &lt;&lt; "Dynamic cast failed in Iter::equal(...)" &lt;&lt; std::endl;</span>
<a name="l00209"></a>00209           std::abort();
<a name="l00210"></a>00210         }
<a name="l00211"></a>00211       
<a name="l00212"></a>00212       <span class="keywordflow">return</span> (<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a> == p-&gt;<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00213"></a>00213     }
<a name="l00214"></a>00214 
<a name="l00218"></a>00218     IterType <a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>;
<a name="l00219"></a>00219   };
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   
<a name="l00229"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php">00229</a>   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> IterType, <span class="keyword">typename</span> PredType&gt;
<a name="l00230"></a>00230   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred</a> : <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>
<a name="l00231"></a>00231   {
<a name="l00235"></a>00235     <a class="code" href="structvariant__filter__iterator_1_1Pred.php#e66454fe61d27a236a0898dae2222f82">Pred</a> (<span class="keyword">const</span> PredType&amp; v) :
<a name="l00236"></a>00236       <a class="code" href="structvariant__filter__iterator_1_1Pred.php#33306ebf933db66f4a2d073b80f43a30">pred_data</a> (v) {}
<a name="l00237"></a>00237 
<a name="l00241"></a>00241     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php#41b7670454e6a726e6dbeda42430d504">~Pred</a> () {}
<a name="l00242"></a>00242 
<a name="l00246"></a>00246     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Pred.php#92eb71efd52707d2f9bc9e999a9cd6db">clone</a>()<span class="keyword"> const</span>
<a name="l00247"></a>00247 <span class="keyword">    </span>{
<a name="l00248"></a>00248 <span class="preprocessor">#ifdef __SUNPRO_CC</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Pred.php">variant_filter_iterator::Pred&lt;IterType,PredType&gt;</a> *copy = 
<a name="l00250"></a>00250         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php">variant_filter_iterator::Pred&lt;IterType,PredType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Pred.php#33306ebf933db66f4a2d073b80f43a30">pred_data</a>);
<a name="l00251"></a>00251 <span class="preprocessor">#else</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred&lt;IterType,PredType&gt;</a> *copy = 
<a name="l00253"></a>00253         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred&lt;IterType,PredType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Pred.php#33306ebf933db66f4a2d073b80f43a30">pred_data</a>);
<a name="l00254"></a>00254 <span class="preprocessor">#endif</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>      
<a name="l00256"></a>00256       <span class="keywordflow">return</span> copy;
<a name="l00257"></a>00257     }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00264"></a>00264     <span class="keyword">virtual</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase::const_PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Pred.php#f7125d2d7b518d6a9e78177c8d0a65b5">const_clone</a>()<span class="keyword"> const</span>
<a name="l00265"></a>00265 <span class="keyword">    </span>{
<a name="l00269"></a>00269       <span class="comment">//      typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::template Pred&lt;IterType, PredType&gt; const_Pred;</span>
<a name="l00270"></a>00270       <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type const, Type const &amp;,  Type const *&gt;::template</a> <a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred&lt;IterType, PredType&gt;</a> const_Pred;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273       <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase::const_PredBase</a>* copy =
<a name="l00274"></a>00274         <span class="keyword">new</span> const_Pred(<a class="code" href="structvariant__filter__iterator_1_1Pred.php#33306ebf933db66f4a2d073b80f43a30">pred_data</a>);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276       <span class="keywordflow">return</span> copy;
<a name="l00277"></a>00277     }
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280     
<a name="l00281"></a>00281     
<a name="l00285"></a>00285     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php#8015c99778c86868d8e17deb591808a6">operator() </a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* in)<span class="keyword"> const</span>
<a name="l00286"></a>00286 <span class="keyword">    </span>{
<a name="l00287"></a>00287       libmesh_assert (in != NULL);
<a name="l00288"></a>00288       
<a name="l00289"></a>00289       <span class="comment">// Attempt downcast</span>
<a name="l00290"></a>00290 <span class="preprocessor">#if defined(__SUNPRO_CC) || (defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 3)  &amp;&amp; !defined(__INTEL_COMPILER))</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span>      <span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a>* p =
<a name="l00292"></a>00292         <span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a>* <span class="keyword">&gt;</span>(in);
<a name="l00293"></a>00293 <span class="preprocessor">#else</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span>      <span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>* p =
<a name="l00295"></a>00295         <span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>* <span class="keyword">&gt;</span>(in);
<a name="l00296"></a>00296 <span class="preprocessor">#endif</span>
<a name="l00297"></a>00297 <span class="preprocessor"></span>      
<a name="l00298"></a>00298       <span class="comment">// Check for failure</span>
<a name="l00299"></a>00299       <span class="keywordflow">if</span> ( p == NULL )
<a name="l00300"></a>00300         {
<a name="l00301"></a>00301           <span class="comment">// std::cerr &lt;&lt; "Dynamic cast failed in Pred::op()" &lt;&lt; std::endl;</span>
<a name="l00302"></a>00302           <span class="comment">// std::cerr &lt;&lt; "typeid(IterType).name()=" &lt;&lt; typeid(IterType).name() &lt;&lt; std::endl;</span>
<a name="l00303"></a>00303           std::abort();
<a name="l00304"></a>00304         }
<a name="l00305"></a>00305       
<a name="l00306"></a>00306       <span class="comment">// Return result of op() for the user's predicate.</span>
<a name="l00307"></a>00307       <span class="keywordflow">return</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php#33306ebf933db66f4a2d073b80f43a30">pred_data</a>(p-&gt;<a class="code" href="structvariant__filter__iterator_1_1Iter.php#b5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00308"></a>00308     }
<a name="l00309"></a>00309     
<a name="l00313"></a>00313     PredType <a class="code" href="structvariant__filter__iterator_1_1Pred.php#33306ebf933db66f4a2d073b80f43a30">pred_data</a>;
<a name="l00314"></a>00314   };
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="keyword">public</span>:
<a name="l00328"></a>00328   <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00329"></a>00329 
<a name="l00334"></a>00334   <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* <a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>;
<a name="l00335"></a>00335 
<a name="l00341"></a>00341   <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>* <a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a>;
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   
<a name="l00345"></a>00345 <span class="keyword">public</span>:
<a name="l00351"></a><a class="code" href="classvariant__filter__iterator.php#b37227024b090401527ec1bc8f833963">00351</a>   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00352"></a>00352   <a class="code" href="classvariant__filter__iterator.php#f3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00353"></a>00353                            <span class="keyword">const</span> IterType&amp; e,
<a name="l00354"></a>00354                            <span class="keyword">const</span> PredType&amp; p ):
<a name="l00355"></a>00355     <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a> ( new Iter&lt;IterType&gt;(d) ), <span class="comment">// note: uses default IterBase copy constructor</span>
<a name="l00356"></a>00356     <a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>  ( new Iter&lt;IterType&gt;(e) ),
<a name="l00357"></a>00357     <a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a> ( new Pred&lt;IterType,PredType&gt;(p) )
<a name="l00358"></a>00358   {
<a name="l00359"></a>00359     this-&gt;<a class="code" href="classvariant__filter__iterator.php#4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>();
<a name="l00360"></a>00360   }
<a name="l00361"></a>00361   
<a name="l00365"></a>00365   <a class="code" href="classvariant__filter__iterator.php#f3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> () :
<a name="l00366"></a>00366     <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>(NULL),
<a name="l00367"></a>00367     <a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>(NULL),
<a name="l00368"></a>00368     <a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a>(NULL) {}
<a name="l00369"></a>00369 
<a name="l00374"></a>00374   <a class="code" href="classvariant__filter__iterator.php#f3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> (<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a>&amp; rhs) :
<a name="l00375"></a>00375     <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>-&gt;clone() : NULL),
<a name="l00376"></a>00376     <a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>  (rhs.<a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>  != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>-&gt;clone()  : NULL),
<a name="l00377"></a>00377     <a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a>-&gt;clone() : NULL) {}
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00392"></a><a class="code" href="classvariant__filter__iterator.php#d584a71be98357fd31de2866e013663e">00392</a>   <span class="keyword">template</span> &lt;<span class="keyword">class</span> OtherType, <span class="keyword">class</span> OtherReferenceType, <span class="keyword">class</span> OtherPo<span class="keywordtype">int</span>erType&gt;
<a name="l00393"></a>00393   <a class="code" href="classvariant__filter__iterator.php#f3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> (<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, OtherType, OtherReferenceType, OtherPointerType&gt;</a>&amp; rhs)
<a name="l00394"></a>00394     : <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>-&gt;const_clone() : NULL),
<a name="l00395"></a>00395       <a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>  (rhs.<a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>  != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>-&gt;const_clone()  : NULL),
<a name="l00396"></a>00396       <a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a>-&gt;const_clone() : NULL)
<a name="l00397"></a>00397   {
<a name="l00398"></a>00398     <span class="comment">// std::cout &lt;&lt; "Called templated copy constructor for variant_filter_iterator" &lt;&lt; std::endl;</span>
<a name="l00399"></a>00399   }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   
<a name="l00405"></a>00405   
<a name="l00409"></a>00409   <span class="keyword">virtual</span> <a class="code" href="classvariant__filter__iterator.php#b44e43ae0e17f90b99f298b0d823cdc7">~variant_filter_iterator</a>()
<a name="l00410"></a>00410   {
<a name="l00411"></a>00411     <span class="keyword">delete</span> <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>; <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a> = NULL;
<a name="l00412"></a>00412     <span class="keyword">delete</span> <a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>;  <a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>  = NULL;
<a name="l00413"></a>00413     <span class="keyword">delete</span> <a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a>; <a class="code" href="classvariant__filter__iterator.php#313cad79630e8e081d2a0379b125a6ca">pred</a> = NULL;
<a name="l00414"></a>00414   }
<a name="l00415"></a>00415   
<a name="l00419"></a>00419   ReferenceType <a class="code" href="classvariant__filter__iterator.php#4bb7a327fcb2664488f4dfee1d5dc595">operator*</a>()<span class="keyword"> const</span>
<a name="l00420"></a>00420 <span class="keyword">  </span>{
<a name="l00421"></a>00421     <span class="keywordflow">return</span> **<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00422"></a>00422   }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00428"></a>00428   PointerType <a class="code" href="classvariant__filter__iterator.php#2011fabe87e16e10e7e9831fdd30aa53">operator-&gt;</a>()<span class="keyword"> const</span>
<a name="l00429"></a>00429 <span class="keyword">  </span>{
<a name="l00430"></a>00430     <span class="keywordflow">return</span> (&amp;**<span class="keyword">this</span>);
<a name="l00431"></a>00431   }
<a name="l00432"></a>00432   
<a name="l00436"></a>00436   <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a>&amp; <a class="code" href="classvariant__filter__iterator.php#c98d8f165f14deae8050c7e062d0e78e">operator++</a>()
<a name="l00437"></a>00437   {
<a name="l00438"></a>00438     ++*<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00439"></a>00439     this-&gt;<a class="code" href="classvariant__filter__iterator.php#4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>();
<a name="l00440"></a>00440     <span class="keywordflow">return</span> (*<span class="keyword">this</span>);
<a name="l00441"></a>00441   }
<a name="l00442"></a>00442 
<a name="l00446"></a>00446   <span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a> <a class="code" href="classvariant__filter__iterator.php#c98d8f165f14deae8050c7e062d0e78e">operator++</a>(<span class="keywordtype">int</span>) <span class="comment">// const here to prevent iterator++++ type operations</span>
<a name="l00447"></a>00447   {
<a name="l00448"></a>00448     <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a> oldValue(*<span class="keyword">this</span>); <span class="comment">// standard is to return old value</span>
<a name="l00449"></a>00449     ++*<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00450"></a>00450     this-&gt;<a class="code" href="classvariant__filter__iterator.php#4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>();
<a name="l00451"></a>00451     <span class="keywordflow">return</span> oldValue;
<a name="l00452"></a>00452   }
<a name="l00453"></a>00453 
<a name="l00460"></a>00460   <span class="keywordtype">bool</span> <a class="code" href="classvariant__filter__iterator.php#525841235875ad49bbe5ee29681edb8c">equal</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&amp; other)<span class="keyword"> const</span>
<a name="l00461"></a>00461 <span class="keyword">  </span>{
<a name="l00462"></a>00462     <span class="keywordflow">return</span> <a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>-&gt;<a class="code" href="structvariant__filter__iterator_1_1IterBase.php#d950ec9d5c1e122a832a57f5e37b7fc6">equal</a>(other.<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>);
<a name="l00463"></a>00463   }
<a name="l00464"></a>00464 
<a name="l00468"></a>00468   <span class="keywordtype">void</span> <a class="code" href="classvariant__filter__iterator.php#1170519c7839bb1f534e68fe4481e222">swap</a>(<a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a>&amp; lhs, <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a>&amp; rhs)
<a name="l00469"></a>00469   {
<a name="l00470"></a>00470     <span class="comment">// Swap the data pointers</span>
<a name="l00471"></a>00471     <a class="code" href="classvariant__filter__iterator.php#1170519c7839bb1f534e68fe4481e222">std::swap</a> (lhs.data, rhs.data);
<a name="l00472"></a>00472 
<a name="l00473"></a>00473     <span class="comment">// Swap the end pointers</span>
<a name="l00474"></a>00474     <a class="code" href="classvariant__filter__iterator.php#1170519c7839bb1f534e68fe4481e222">std::swap</a> (lhs.end, rhs.end);
<a name="l00475"></a>00475 
<a name="l00476"></a>00476     <span class="comment">// Also swap the predicate objects.</span>
<a name="l00477"></a>00477     <a class="code" href="classvariant__filter__iterator.php#1170519c7839bb1f534e68fe4481e222">std::swap</a> (lhs.pred, rhs.pred);
<a name="l00478"></a>00478   }
<a name="l00479"></a>00479 
<a name="l00483"></a>00483   <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a>&amp; <a class="code" href="classvariant__filter__iterator.php#3f7dce148857c6a2f6b66a92ec16347e">operator=</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a>&amp; rhs)
<a name="l00484"></a>00484   {
<a name="l00485"></a>00485     <a class="code" href="classvariant__filter__iterator.php#23c53659ac9157dec76f6c88ef503a97">Iterator</a> temp(rhs);
<a name="l00486"></a>00486     <a class="code" href="classvariant__filter__iterator.php#1170519c7839bb1f534e68fe4481e222">swap</a>(temp, *<span class="keyword">this</span>);
<a name="l00487"></a>00487     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00488"></a>00488   }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491   
<a name="l00492"></a>00492 <span class="keyword">private</span>:
<a name="l00493"></a>00493   
<a name="l00498"></a>00498   <span class="keywordtype">void</span> <a class="code" href="classvariant__filter__iterator.php#4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>()
<a name="l00499"></a>00499   {
<a name="l00500"></a>00500     <span class="keywordflow">while</span> ( !<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>-&gt;<a class="code" href="structvariant__filter__iterator_1_1IterBase.php#d950ec9d5c1e122a832a57f5e37b7fc6">equal</a>(<a class="code" href="classvariant__filter__iterator.php#79bde51f62b20c1c11836ee498eff219">end</a>) &amp;&amp; !(*pred)(<a class="code" href="classvariant__filter__iterator.php#938a5a347ebca2588769ffce74daa428">data</a>) )
<a name="l00501"></a>00501       ++(*data);
<a name="l00502"></a>00502   }  
<a name="l00503"></a>00503 };
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00511"></a>00511 <span class="comment">// op==</span>
<a name="l00512"></a>00512 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Predicate, <span class="keyword">class</span> Type, <span class="keyword">class</span> ReferenceType, <span class="keyword">class</span> Po<span class="keywordtype">int</span>erType&gt;
<a name="l00513"></a><a class="code" href="variant__filter__iterator_8h.php#3201fc9c9bbdb9eaf27ae0bbee186846">00513</a> <span class="keyword">inline</span>
<a name="l00514"></a>00514 <span class="keywordtype">bool</span> <a class="code" href="variant__filter__iterator_8h.php#3201fc9c9bbdb9eaf27ae0bbee186846">operator==</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; x,
<a name="l00515"></a>00515                 <span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; y)
<a name="l00516"></a>00516 {
<a name="l00517"></a>00517   <span class="keywordflow">return</span> x.<a class="code" href="classvariant__filter__iterator.php#525841235875ad49bbe5ee29681edb8c">equal</a>(y);
<a name="l00518"></a>00518 }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 <span class="comment">// op!=</span>
<a name="l00523"></a>00523 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Predicate, <span class="keyword">class</span> Type, <span class="keyword">class</span> ReferenceType, <span class="keyword">class</span> Po<span class="keywordtype">int</span>erType&gt;
<a name="l00524"></a><a class="code" href="variant__filter__iterator_8h.php#bca78fc01f1572f1977080638637880d">00524</a> <span class="keyword">inline</span>
<a name="l00525"></a>00525 <span class="keywordtype">bool</span> <a class="code" href="variant__filter__iterator_8h.php#bca78fc01f1572f1977080638637880d">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; x,
<a name="l00526"></a>00526                 <span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; y)
<a name="l00527"></a>00527 {
<a name="l00528"></a>00528   <span class="keywordflow">return</span> !(x == y);
<a name="l00529"></a>00529 }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
