<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_c882f73b5d86302f490d6b16e92f14fb.php">base</a>
  </div>
</div>
<div class="contents">
<h1>dof_map.C</h1><a href="dof__map_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id$</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public  License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes -------------------------------------</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill, std::equal_range, std::max, std::lower_bound, etc.</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "<a class="code" href="coupling__matrix_8h.php">coupling_matrix.h</a>"</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>"</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include "<a class="code" href="dense__vector__base_8h.php">dense_vector_base.h</a>"</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "<a class="code" href="dof__map_8h.php">dof_map.h</a>"</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include "<a class="code" href="elem_8h.php">elem.h</a>"</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="fe__interface_8h.php">fe_interface.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="fe__type_8h.php">fe_type.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="fe__base_8h.php">fe_base.h</a>"</span> <span class="comment">// FEBase::build() for continuity test</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="mesh__base_8h.php">mesh_base.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>"</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include "<a class="code" href="parallel_8h.php">parallel.h</a>"</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include "<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>"</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include "<a class="code" href="string__to__enum_8h.php">string_to_enum.h</a>"</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include "<a class="code" href="threads__allocators_8h.php">threads_allocators.h</a>"</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// DofMap member functions</span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">// Destructor</span>
<a name="l00049"></a><a class="code" href="classDofMap.php#a7869f6f73f55a110c2667de5a33cfc9">00049</a> <a class="code" href="classDofMap.php#a7869f6f73f55a110c2667de5a33cfc9">DofMap::~DofMap</a>()
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051   this-&gt;<a class="code" href="classDofMap.php#e0336e2fe65c48efdc56ea25f3d4126e">clear</a>();
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classDofMap.php#71c41090c25a812734d342fbcaf12498">00056</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#71c41090c25a812734d342fbcaf12498">DofMap::add_variable</a> (<span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a> &amp;var)
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>.push_back (var);
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">00063</a> <span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a> &amp; <a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">DofMap::variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   libmesh_assert (c &lt; <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>.size());
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>[c];
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classDofMap.php#32045dc65a75bb5c78c5ca20358a10f4">00072</a> <a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classDofMap.php#32045dc65a75bb5c78c5ca20358a10f4">DofMap::variable_order</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00073"></a>00073 <span class="keyword"></span>{
<a name="l00074"></a>00074   libmesh_assert (c &lt; <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>.size());
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>[c].type().order;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">00081</a> <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; <a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">DofMap::variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00082"></a>00082 <span class="keyword"></span>{
<a name="l00083"></a>00083   libmesh_assert (c &lt; <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>.size());
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordflow">return</span> <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>[c].type();
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classDofMap.php#bf8a314c9f21240129e140664d04ed53">00090</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#bf8a314c9f21240129e140664d04ed53">DofMap::attach_matrix</a> (<a class="code" href="classSparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp; matrix)
<a name="l00091"></a>00091 {
<a name="l00092"></a>00092   <a class="code" href="classDofMap.php#fcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>.push_back(&amp;matrix);
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   matrix.<a class="code" href="classSparseMatrix.php#962f53b3692ce1e275655cd1bdc3afc4">attach_dof_map</a> (*<span class="keyword">this</span>);
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classDofMap.php#ce354d1aea94151ea259e3e084fdac37">00099</a> <a class="code" href="classDofObject.php">DofObject</a>* <a class="code" href="classDofMap.php#ce354d1aea94151ea259e3e084fdac37">DofMap::node_ptr</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00100"></a>00100 <span class="keyword"></span>{
<a name="l00101"></a>00101   <span class="keywordflow">return</span> mesh.<a class="code" href="classMeshBase.php#1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(i);
<a name="l00102"></a>00102 }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classDofMap.php#7769da176038f8f29b8de691c838f19d">00106</a> <a class="code" href="classDofObject.php">DofObject</a>* <a class="code" href="classDofMap.php#7769da176038f8f29b8de691c838f19d">DofMap::elem_ptr</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword"></span>{
<a name="l00108"></a>00108   <span class="keywordflow">return</span> mesh.<a class="code" href="classMeshBase.php#574a1283614a386b1a8b69a8fe517214">elem</a>(i);
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00114"></a><a class="code" href="classDofMap.php#6d4ceeec9e3656d39038f9f8030edbeb">00114</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#6d4ceeec9e3656d39038f9f8030edbeb">DofMap::set_nonlocal_dof_objects</a>(iterator_type objects_begin,
<a name="l00115"></a>00115                                       iterator_type objects_end,
<a name="l00116"></a>00116                                       <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00117"></a>00117                                       dofobject_accessor objects)
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00120"></a>00120   parallel_only();
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// First, iterate over local objects to find out how many</span>
<a name="l00123"></a>00123   <span class="comment">// are on each processor</span>
<a name="l00124"></a>00124   std::vector&lt;unsigned int&gt;
<a name="l00125"></a>00125     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   iterator_type it  = objects_begin;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordflow">for</span> (; it != objects_end; ++it)
<a name="l00130"></a>00130     {
<a name="l00131"></a>00131       <a class="code" href="classDofObject.php">DofObject</a> *obj = *it;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133       <span class="keywordflow">if</span> (obj)
<a name="l00134"></a>00134         {
<a name="l00135"></a>00135           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l00136"></a>00136           <span class="comment">// We'd better be completely partitioned by now</span>
<a name="l00137"></a>00137           libmesh_assert(obj_procid != <a class="code" href="classDofObject.php#d9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l00138"></a>00138           ghost_objects_from_proc[obj_procid]++;
<a name="l00139"></a>00139         }
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   std::vector&lt;unsigned int&gt; objects_on_proc(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00143"></a>00143   Parallel::allgather(ghost_objects_from_proc[<a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()],
<a name="l00144"></a>00144                       objects_on_proc);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00148"></a>00148     libmesh_assert(ghost_objects_from_proc[p] &lt;= objects_on_proc[p]);
<a name="l00149"></a>00149 <span class="preprocessor">#endif</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>
<a name="l00151"></a>00151   <span class="comment">// Request sets to send to each processor</span>
<a name="l00152"></a>00152   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00153"></a>00153     requested_ids(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// We know how many of our objects live on each processor, so</span>
<a name="l00156"></a>00156   <span class="comment">// reserve() space for requests from each.</span>
<a name="l00157"></a>00157   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00158"></a>00158     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00159"></a>00159       requested_ids[p].reserve(ghost_objects_from_proc[p]);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="keywordflow">for</span> (it = objects_begin; it != objects_end; ++it)
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163       <a class="code" href="classDofObject.php">DofObject</a> *obj = *it;
<a name="l00164"></a>00164       <span class="keywordflow">if</span> (obj-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>() != <a class="code" href="classDofObject.php#d9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>)
<a name="l00165"></a>00165         requested_ids[obj-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>()].push_back(obj-&gt;<a class="code" href="classDofObject.php#d3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00166"></a>00166     }
<a name="l00167"></a>00167 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00169"></a>00169     libmesh_assert(requested_ids[p].size() == ghost_objects_from_proc[p]);
<a name="l00170"></a>00170 <span class="preprocessor">#endif</span>
<a name="l00171"></a>00171 <span class="preprocessor"></span>
<a name="l00172"></a>00172   <span class="comment">// Next set ghost object n_comps from other processors</span>
<a name="l00173"></a>00173   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00176"></a>00176       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00177"></a>00177                              <a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00178"></a>00178       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00179"></a>00179                                <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00180"></a>00180                                <a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00181"></a>00181       std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l00182"></a>00182       Parallel::send_receive(procup, requested_ids[procup],
<a name="l00183"></a>00183                              procdown, request_to_fill);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185       <span class="comment">// Fill those requests</span>
<a name="l00186"></a>00186       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a> = this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>();
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       std::vector&lt;unsigned int&gt; ghost_data
<a name="l00189"></a>00189         (request_to_fill.size() * 2 * n_variables);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l00192"></a>00192         {
<a name="l00193"></a>00193           <a class="code" href="classDofObject.php">DofObject</a> *requested = (this-&gt;*objects)(mesh, request_to_fill[i]);
<a name="l00194"></a>00194           libmesh_assert(requested);
<a name="l00195"></a>00195           libmesh_assert(requested-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00196"></a>00196           libmesh_assert(requested-&gt;<a class="code" href="classDofObject.php#39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(this-&gt;sys_number()) == n_variables);
<a name="l00197"></a>00197           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != n_variables; ++v)
<a name="l00198"></a>00198             {
<a name="l00199"></a>00199               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l00200"></a>00200                 requested-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v);
<a name="l00201"></a>00201               ghost_data[i*2*n_variables+v] = n_comp;
<a name="l00202"></a>00202               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a> = n_comp ?
<a name="l00203"></a>00203                 requested-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v, 0) : 0;
<a name="l00204"></a>00204               libmesh_assert(first_dof != <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00205"></a>00205               ghost_data[i*2*n_variables+n_variables+v] = first_dof;
<a name="l00206"></a>00206             }
<a name="l00207"></a>00207         }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209       <span class="comment">// Trade back the results</span>
<a name="l00210"></a>00210       std::vector&lt;unsigned int&gt; filled_request;
<a name="l00211"></a>00211       Parallel::send_receive(procdown, ghost_data,
<a name="l00212"></a>00212                              procup, filled_request);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214       <span class="comment">// And copy the id changes we've now been informed of</span>
<a name="l00215"></a>00215       libmesh_assert(filled_request.size() ==
<a name="l00216"></a>00216              requested_ids[procup].size() * 2 * n_variables);
<a name="l00217"></a>00217       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != requested_ids[procup].size(); ++i)
<a name="l00218"></a>00218         {
<a name="l00219"></a>00219           <a class="code" href="classDofObject.php">DofObject</a> *requested = (this-&gt;*objects)(mesh, requested_ids[procup][i]);
<a name="l00220"></a>00220           libmesh_assert(requested);
<a name="l00221"></a>00221           libmesh_assert (requested-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == procup);
<a name="l00222"></a>00222           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != n_variables; ++v)
<a name="l00223"></a>00223             {
<a name="l00224"></a>00224               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = filled_request[i*2*n_variables+v];
<a name="l00225"></a>00225               requested-&gt;<a class="code" href="classDofObject.php#3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v, n_comp);
<a name="l00226"></a>00226               <span class="keywordflow">if</span> (n_comp)
<a name="l00227"></a>00227                 {
<a name="l00228"></a>00228                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a> = 
<a name="l00229"></a>00229                     filled_request[i*2*n_variables+n_variables+v];
<a name="l00230"></a>00230                   libmesh_assert(first_dof != <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00231"></a>00231                   requested-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>
<a name="l00232"></a>00232                     (this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v, 0, first_dof);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234                   <span class="comment">// don't forget to add these remote dofs to the _send_list</span>
<a name="l00235"></a>00235                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp!=n_comp; ++comp)
<a name="l00236"></a>00236                     <a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.push_back(first_dof+comp);
<a name="l00237"></a>00237                 }
<a name="l00238"></a>00238             }
<a name="l00239"></a>00239         }
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00243"></a>00243 <span class="preprocessor"></span>  <span class="comment">// Double check for invalid dofs</span>
<a name="l00244"></a>00244   <span class="keywordflow">for</span> (it = objects_begin; it != objects_end; ++it)
<a name="l00245"></a>00245     {
<a name="l00246"></a>00246       <a class="code" href="classDofObject.php">DofObject</a> *obj = *it;
<a name="l00247"></a>00247       libmesh_assert (obj);
<a name="l00248"></a>00248       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a> = obj-&gt;<a class="code" href="classDofObject.php#39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>());
<a name="l00249"></a>00249       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != n_variables; ++v)
<a name="l00250"></a>00250         {
<a name="l00251"></a>00251           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l00252"></a>00252             obj-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v);
<a name="l00253"></a>00253           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a> = n_comp ?
<a name="l00254"></a>00254             obj-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v, 0) : 0;
<a name="l00255"></a>00255           libmesh_assert(first_dof != <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00256"></a>00256         }
<a name="l00257"></a>00257     }
<a name="l00258"></a>00258 <span class="preprocessor">#endif</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>}
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="classDofMap.php#ed3c9f2c9e0ef0019fba7bb1c1c2a6db">00263</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#ed3c9f2c9e0ef0019fba7bb1c1c2a6db">DofMap::reinit</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00264"></a>00264 {
<a name="l00265"></a>00265   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#960bff880e04431f031b46e797af38cc">is_prepared</a>());
<a name="l00266"></a>00266   
<a name="l00267"></a>00267   START_LOG(<span class="stringliteral">"reinit()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l00268"></a>00268   
<a name="l00269"></a>00269   <span class="comment">//this-&gt;clear();</span>
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_var = this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>();
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00274"></a>00274 <span class="preprocessor"></span>  
<a name="l00275"></a>00275   <span class="comment">//------------------------------------------------------------</span>
<a name="l00276"></a>00276   <span class="comment">// Clear the old_dof_objects for all the nodes</span>
<a name="l00277"></a>00277   <span class="comment">// and elements so that we can overwrite them</span>
<a name="l00278"></a>00278   {
<a name="l00279"></a>00279     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classMeshBase.php#2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00280"></a>00280     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classMeshBase.php#b9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00281"></a>00281     
<a name="l00282"></a>00282     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00283"></a>00283       {
<a name="l00284"></a>00284         (*node_it)-&gt;clear_old_dof_object();
<a name="l00285"></a>00285         libmesh_assert ((*node_it)-&gt;old_dof_object == NULL);
<a name="l00286"></a>00286       }
<a name="l00287"></a>00287     
<a name="l00288"></a>00288     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#fc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00289"></a>00289     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00290"></a>00290     
<a name="l00291"></a>00291     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00292"></a>00292       {
<a name="l00293"></a>00293         (*elem_it)-&gt;clear_old_dof_object();
<a name="l00294"></a>00294         libmesh_assert ((*elem_it)-&gt;old_dof_object == NULL);
<a name="l00295"></a>00295       }
<a name="l00296"></a>00296   }
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   
<a name="l00299"></a>00299   <span class="comment">//------------------------------------------------------------</span>
<a name="l00300"></a>00300   <span class="comment">// Set the old_dof_objects for the elements that</span>
<a name="l00301"></a>00301   <span class="comment">// weren't just created, if these old dof objects</span>
<a name="l00302"></a>00302   <span class="comment">// had variables</span>
<a name="l00303"></a>00303   {
<a name="l00304"></a>00304     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#fc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00305"></a>00305     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00306"></a>00306     
<a name="l00307"></a>00307     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00308"></a>00308       {
<a name="l00309"></a>00309         <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00310"></a>00310 
<a name="l00311"></a>00311         <span class="comment">// Skip the elements that were just refined</span>
<a name="l00312"></a>00312         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#946039859488cca879512de516fef82928fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>) <span class="keywordflow">continue</span>;
<a name="l00313"></a>00313 
<a name="l00314"></a>00314         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00315"></a>00315           {
<a name="l00316"></a>00316             <a class="code" href="classNode.php">Node</a>* node = elem-&gt;<a class="code" href="classElem.php#68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318             <span class="keywordflow">if</span> (node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a> == NULL)
<a name="l00319"></a>00319               <span class="keywordflow">if</span> (node-&gt;<a class="code" href="classDofObject.php#2821e7fa9b17c8c6d76949e397cea418">has_dofs</a>())
<a name="l00320"></a>00320                 node-&gt;<a class="code" href="classDofObject.php#1c5a6980e35d8420b13fe2d7bff63a67">set_old_dof_object</a>();
<a name="l00321"></a>00321           }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323         libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a> == NULL);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#2821e7fa9b17c8c6d76949e397cea418">has_dofs</a>())
<a name="l00326"></a>00326           elem-&gt;<a class="code" href="classDofObject.php#1c5a6980e35d8420b13fe2d7bff63a67">set_old_dof_object</a>();
<a name="l00327"></a>00327       }
<a name="l00328"></a>00328   }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00331"></a>00331 <span class="preprocessor"></span>
<a name="l00332"></a>00332   
<a name="l00333"></a>00333   <span class="comment">//------------------------------------------------------------</span>
<a name="l00334"></a>00334   <span class="comment">// Then set the number of variables for each \p DofObject</span>
<a name="l00335"></a>00335   <span class="comment">// equal to n_variables() for this system.  This will</span>
<a name="l00336"></a>00336   <span class="comment">// handle new \p DofObjects that may have just been created</span>
<a name="l00337"></a>00337   {
<a name="l00338"></a>00338     <span class="comment">// All the nodes</span>
<a name="l00339"></a>00339     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classMeshBase.php#2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00340"></a>00340     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classMeshBase.php#b9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00341"></a>00341 
<a name="l00342"></a>00342     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00343"></a>00343       (*node_it)-&gt;set_n_vars(this-&gt;sys_number(),n_var);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345     <span class="comment">// All the elements</span>
<a name="l00346"></a>00346     <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#fc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00347"></a>00347     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00348"></a>00348 
<a name="l00349"></a>00349     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00350"></a>00350       (*elem_it)-&gt;set_n_vars(this-&gt;sys_number(),n_var);
<a name="l00351"></a>00351   }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   <span class="comment">// Zero _n_SCALAR_dofs, it will be updated below.</span>
<a name="l00355"></a>00355   this-&gt;<a class="code" href="classDofMap.php#e00169f4e682f51d64ea1f4e95c5f2df">_n_SCALAR_dofs</a> = 0;
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   <span class="comment">//------------------------------------------------------------</span>
<a name="l00358"></a>00358   <span class="comment">// Next allocate space for the DOF indices</span>
<a name="l00359"></a>00359   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>(); var++)
<a name="l00360"></a>00360     {
<a name="l00361"></a>00361       <span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a> &amp;var_description = this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var);
<a name="l00362"></a>00362       <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; base_fe_type              = this-&gt;<a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">variable_type</a>(var);
<a name="l00363"></a>00363 
<a name="l00364"></a>00364       <span class="comment">// Skip dof counting for a SCALAR variable</span>
<a name="l00365"></a>00365       <span class="keywordflow">if</span>(base_fe_type.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00366"></a>00366       {
<a name="l00367"></a>00367         <span class="comment">// TODO: This only works in serial at the moment</span>
<a name="l00368"></a>00368         <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00369"></a>00369           libmesh_not_implemented();
<a name="l00370"></a>00370 
<a name="l00371"></a>00371         this-&gt;<a class="code" href="classDofMap.php#e00169f4e682f51d64ea1f4e95c5f2df">_n_SCALAR_dofs</a> += base_fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00372"></a>00372         <span class="keywordflow">continue</span>;
<a name="l00373"></a>00373       }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375       <span class="comment">// This should be constant even on p-refined elements</span>
<a name="l00376"></a>00376       <span class="keyword">const</span> <span class="keywordtype">bool</span> extra_hanging_dofs =
<a name="l00377"></a>00377         <a class="code" href="classFEInterface.php#3d821150f7d5a6315292b5c2117ef417">FEInterface::extra_hanging_dofs</a>(base_fe_type);
<a name="l00378"></a>00378 
<a name="l00379"></a>00379       <span class="comment">// For all the active elements</span>
<a name="l00380"></a>00380       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00381"></a>00381       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00382"></a>00382  
<a name="l00383"></a>00383       <span class="comment">// Count vertex degrees of freedom first</span>
<a name="l00384"></a>00384       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00385"></a>00385         {
<a name="l00386"></a>00386           <a class="code" href="classElem.php">Elem</a>* elem  = *elem_it;
<a name="l00387"></a>00387           libmesh_assert (elem != NULL);
<a name="l00388"></a>00388           
<a name="l00389"></a>00389           <span class="comment">// Skip the numbering if this variable is </span>
<a name="l00390"></a>00390           <span class="comment">// not active on this element's subdoman</span>
<a name="l00391"></a>00391           <span class="keywordflow">if</span> (!var_description.<a class="code" href="classSystem_1_1Variable.php#d6639756dcb5050d014cddb818d13df9">active_on_subdomain</a>(elem-&gt;<a class="code" href="classElem.php#cc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>()))
<a name="l00392"></a>00392             <span class="keywordflow">continue</span>;
<a name="l00393"></a>00393 
<a name="l00394"></a>00394           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classElem.php#9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00395"></a>00395           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classElem.php#72c710c9b4ebbbdebb707e74165d9625">dim</a>();
<a name="l00396"></a>00396 
<a name="l00397"></a>00397           <a class="code" href="classFEType.php">FEType</a> fe_type = base_fe_type;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span>          <span class="comment">// Make sure we haven't done more p refinement than we can</span>
<a name="l00401"></a>00401           <span class="comment">// handle</span>
<a name="l00402"></a>00402           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() + base_fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> &gt;
<a name="l00403"></a>00403               <a class="code" href="classFEInterface.php#a5e5dfcfc5a000f3fe044153aa068bba">FEInterface::max_order</a>(base_fe_type, type))
<a name="l00404"></a>00404             {
<a name="l00405"></a>00405 <span class="preprocessor">#  ifdef DEBUG</span>
<a name="l00406"></a>00406 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (<a class="code" href="classFEInterface.php#a5e5dfcfc5a000f3fe044153aa068bba">FEInterface::max_order</a>(base_fe_type,type) &lt;
<a name="l00407"></a>00407                   <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(base_fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>))
<a name="l00408"></a>00408                 {
<a name="l00409"></a>00409                   std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Finite element "</span>
<a name="l00410"></a>00410                     &lt;&lt; <a class="code" href="namespaceUtility.php#471c3c643ffcb4e482c415c57529257a">Utility::enum_to_string</a>(base_fe_type.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00411"></a>00411                     &lt;&lt; <span class="stringliteral">" on geometric element "</span>
<a name="l00412"></a>00412                     &lt;&lt; <a class="code" href="namespaceUtility.php#471c3c643ffcb4e482c415c57529257a">Utility::enum_to_string</a>(type) &lt;&lt; std::endl
<a name="l00413"></a>00413                     &lt;&lt; <span class="stringliteral">"only supports FEInterface::max_order = "</span> 
<a name="l00414"></a>00414                     &lt;&lt; <a class="code" href="classFEInterface.php#a5e5dfcfc5a000f3fe044153aa068bba">FEInterface::max_order</a>(base_fe_type,type)
<a name="l00415"></a>00415                     &lt;&lt; <span class="stringliteral">", not fe_type.order = "</span> &lt;&lt; base_fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>
<a name="l00416"></a>00416                     &lt;&lt; std::endl;
<a name="l00417"></a>00417 
<a name="l00418"></a>00418                   libmesh_error();
<a name="l00419"></a>00419                 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421               std::cerr &lt;&lt; <span class="stringliteral">"WARNING: Finite element "</span>
<a name="l00422"></a>00422                     &lt;&lt; <a class="code" href="namespaceUtility.php#471c3c643ffcb4e482c415c57529257a">Utility::enum_to_string</a>(base_fe_type.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00423"></a>00423                     &lt;&lt; <span class="stringliteral">" on geometric element "</span>
<a name="l00424"></a>00424                     &lt;&lt; <a class="code" href="namespaceUtility.php#471c3c643ffcb4e482c415c57529257a">Utility::enum_to_string</a>(type) &lt;&lt; std::endl
<a name="l00425"></a>00425                     &lt;&lt; <span class="stringliteral">"could not be p refined past FEInterface::max_order = "</span> 
<a name="l00426"></a>00426                     &lt;&lt; <a class="code" href="classFEInterface.php#a5e5dfcfc5a000f3fe044153aa068bba">FEInterface::max_order</a>(base_fe_type,type)
<a name="l00427"></a>00427                     &lt;&lt; std::endl;
<a name="l00428"></a>00428 <span class="preprocessor">#  endif</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>              elem-&gt;<a class="code" href="classElem.php#e5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(<a class="code" href="classFEInterface.php#a5e5dfcfc5a000f3fe044153aa068bba">FEInterface::max_order</a>(base_fe_type,type)
<a name="l00430"></a>00430                                 - base_fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>);
<a name="l00431"></a>00431             }
<a name="l00432"></a>00432 <span class="preprocessor">#endif</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>
<a name="l00434"></a>00434           fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> +
<a name="l00435"></a>00435                                              elem-&gt;<a class="code" href="classElem.php#66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00436"></a>00436              
<a name="l00437"></a>00437           <span class="comment">// Allocate the vertex DOFs</span>
<a name="l00438"></a>00438           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00439"></a>00439             {
<a name="l00440"></a>00440               <a class="code" href="classNode.php">Node</a>* node = elem-&gt;<a class="code" href="classElem.php#68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#fb4be0284f273d7d53cd0e994e6f1d7e">is_vertex</a>(n))
<a name="l00443"></a>00443                 {
<a name="l00444"></a>00444                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_node_dofs =
<a name="l00445"></a>00445                     node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vertex_dofs =
<a name="l00448"></a>00448                     <a class="code" href="namespacestd.php#6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classFEInterface.php#67e0d0d4c13c51f66c65ae9c2c4114c4">FEInterface::n_dofs_at_node</a>(dim, fe_type,
<a name="l00449"></a>00449                                                          type, n),
<a name="l00450"></a>00450                              old_node_dofs);
<a name="l00451"></a>00451                   
<a name="l00452"></a>00452                   <span class="comment">// Some discontinuous FEs have no vertex dofs</span>
<a name="l00453"></a>00453                   <span class="keywordflow">if</span> (vertex_dofs &gt; old_node_dofs)
<a name="l00454"></a>00454                     {
<a name="l00455"></a>00455                       node-&gt;<a class="code" href="classDofObject.php#3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var,
<a name="l00456"></a>00456                                        vertex_dofs);
<a name="l00457"></a>00457                       <span class="comment">// Abusing dof_number to set a "this is a</span>
<a name="l00458"></a>00458                       <span class="comment">// vertex" flag</span>
<a name="l00459"></a>00459                       node-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(),
<a name="l00460"></a>00460                                            var, 0, vertex_dofs);
<a name="l00461"></a>00461                     }
<a name="l00462"></a>00462                 }
<a name="l00463"></a>00463             }
<a name="l00464"></a>00464         } <span class="comment">// done counting vertex dofs</span>
<a name="l00465"></a>00465 
<a name="l00466"></a>00466       <span class="comment">// count edge &amp; face dofs next</span>
<a name="l00467"></a>00467       elem_it = mesh.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00468"></a>00468 
<a name="l00469"></a>00469       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00470"></a>00470         {
<a name="l00471"></a>00471           <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00472"></a>00472           libmesh_assert (elem != NULL);
<a name="l00473"></a>00473           
<a name="l00474"></a>00474           <span class="comment">// Skip the numbering if this variable is </span>
<a name="l00475"></a>00475           <span class="comment">// not active on this element's subdoman</span>
<a name="l00476"></a>00476           <span class="keywordflow">if</span> (!var_description.<a class="code" href="classSystem_1_1Variable.php#d6639756dcb5050d014cddb818d13df9">active_on_subdomain</a>(elem-&gt;<a class="code" href="classElem.php#cc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>()))
<a name="l00477"></a>00477             <span class="keywordflow">continue</span>;
<a name="l00478"></a>00478 
<a name="l00479"></a>00479           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classElem.php#9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l00480"></a>00480           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classElem.php#72c710c9b4ebbbdebb707e74165d9625">dim</a>();
<a name="l00481"></a>00481              
<a name="l00482"></a>00482           <a class="code" href="classFEType.php">FEType</a> fe_type = base_fe_type;
<a name="l00483"></a>00483           fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> +
<a name="l00484"></a>00484                                              elem-&gt;<a class="code" href="classElem.php#66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l00485"></a>00485 
<a name="l00486"></a>00486           <span class="comment">// Allocate the edge and face DOFs</span>
<a name="l00487"></a>00487           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00488"></a>00488             {
<a name="l00489"></a>00489               <a class="code" href="classNode.php">Node</a>* node = elem-&gt;<a class="code" href="classElem.php#68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00490"></a>00490 
<a name="l00491"></a>00491               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_node_dofs =
<a name="l00492"></a>00492                 node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var);
<a name="l00493"></a>00493 
<a name="l00494"></a>00494               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vertex_dofs = old_node_dofs?
<a name="l00495"></a>00495                 node-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a> (this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(),var,0):0;
<a name="l00496"></a>00496 
<a name="l00497"></a>00497               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_node_dofs =
<a name="l00498"></a>00498                 <a class="code" href="classFEInterface.php#67e0d0d4c13c51f66c65ae9c2c4114c4">FEInterface::n_dofs_at_node</a>(dim, fe_type, type, n);
<a name="l00499"></a>00499 
<a name="l00500"></a>00500               <span class="comment">// We've already allocated vertex DOFs</span>
<a name="l00501"></a>00501               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#fb4be0284f273d7d53cd0e994e6f1d7e">is_vertex</a>(n))
<a name="l00502"></a>00502                 {
<a name="l00503"></a>00503                   libmesh_assert(old_node_dofs &gt;= vertex_dofs);
<a name="l00504"></a>00504                   libmesh_assert(vertex_dofs &gt;= new_node_dofs);
<a name="l00505"></a>00505                 }
<a name="l00506"></a>00506               <span class="comment">// We need to allocate the rest</span>
<a name="l00507"></a>00507               <span class="keywordflow">else</span>
<a name="l00508"></a>00508                 {
<a name="l00509"></a>00509                   <span class="comment">// If this has no dofs yet, it needs no vertex</span>
<a name="l00510"></a>00510                   <span class="comment">// dofs, so we just give it edge or face dofs</span>
<a name="l00511"></a>00511                   <span class="keywordflow">if</span> (!old_node_dofs)
<a name="l00512"></a>00512                     {
<a name="l00513"></a>00513                       node-&gt;<a class="code" href="classDofObject.php#3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var,
<a name="l00514"></a>00514                                        new_node_dofs);
<a name="l00515"></a>00515                       <span class="comment">// Abusing dof_number to set a "this has no</span>
<a name="l00516"></a>00516                       <span class="comment">// vertex dofs" flag</span>
<a name="l00517"></a>00517                       <span class="keywordflow">if</span> (new_node_dofs)
<a name="l00518"></a>00518                         node-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(),
<a name="l00519"></a>00519                                              var, 0, 0);
<a name="l00520"></a>00520                     }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522                   <span class="comment">// If this has dofs, but has no vertex dofs,</span>
<a name="l00523"></a>00523                   <span class="comment">// it may still need more edge or face dofs if</span>
<a name="l00524"></a>00524                   <span class="comment">// we're p-refined.</span>
<a name="l00525"></a>00525                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (vertex_dofs == 0)
<a name="l00526"></a>00526                     {
<a name="l00527"></a>00527                       <span class="keywordflow">if</span> (new_node_dofs &gt; old_node_dofs)
<a name="l00528"></a>00528                         {
<a name="l00529"></a>00529                           node-&gt;<a class="code" href="classDofObject.php#3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var,
<a name="l00530"></a>00530                                            new_node_dofs);
<a name="l00531"></a>00531                           node-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(),
<a name="l00532"></a>00532                                                var, 0, vertex_dofs);
<a name="l00533"></a>00533                         }
<a name="l00534"></a>00534                     }
<a name="l00535"></a>00535                   <span class="comment">// If this is another element's vertex,</span>
<a name="l00536"></a>00536                   <span class="comment">// add more (non-overlapping) edge/face dofs if</span>
<a name="l00537"></a>00537                   <span class="comment">// necessary</span>
<a name="l00538"></a>00538                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (extra_hanging_dofs)
<a name="l00539"></a>00539                     {
<a name="l00540"></a>00540                       <span class="keywordflow">if</span> (new_node_dofs &gt; old_node_dofs - vertex_dofs)
<a name="l00541"></a>00541                         {
<a name="l00542"></a>00542                           node-&gt;<a class="code" href="classDofObject.php#3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var,
<a name="l00543"></a>00543                                            vertex_dofs + new_node_dofs);
<a name="l00544"></a>00544                           node-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(),
<a name="l00545"></a>00545                                                var, 0, vertex_dofs);
<a name="l00546"></a>00546                         }
<a name="l00547"></a>00547                     }
<a name="l00548"></a>00548                   <span class="comment">// If this is another element's vertex, add any</span>
<a name="l00549"></a>00549                   <span class="comment">// (overlapping) edge/face dofs if necessary</span>
<a name="l00550"></a>00550                   <span class="keywordflow">else</span>
<a name="l00551"></a>00551                     {
<a name="l00552"></a>00552                       libmesh_assert(old_node_dofs &gt;= vertex_dofs);
<a name="l00553"></a>00553                       <span class="keywordflow">if</span> (new_node_dofs &gt; old_node_dofs)
<a name="l00554"></a>00554                         {
<a name="l00555"></a>00555                           node-&gt;<a class="code" href="classDofObject.php#3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var,
<a name="l00556"></a>00556                                            new_node_dofs);
<a name="l00557"></a>00557                           node-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(),
<a name="l00558"></a>00558                                                var, 0, vertex_dofs);
<a name="l00559"></a>00559                         }
<a name="l00560"></a>00560                     }
<a name="l00561"></a>00561                 }
<a name="l00562"></a>00562             }
<a name="l00563"></a>00563           <span class="comment">// Allocate the element DOFs</span>
<a name="l00564"></a>00564           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dofs_per_elem =
<a name="l00565"></a>00565                           <a class="code" href="classFEInterface.php#f3b7b306ff86eb750b9f5a3c2d807045">FEInterface::n_dofs_per_elem</a>(dim, fe_type,
<a name="l00566"></a>00566                                                        type);
<a name="l00567"></a>00567 
<a name="l00568"></a>00568           elem-&gt;<a class="code" href="classDofObject.php#3874991f58387ca4b4a8c4a3e570d315">set_n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), var, dofs_per_elem);
<a name="l00569"></a>00569 
<a name="l00570"></a>00570         }
<a name="l00571"></a>00571     }
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   <span class="comment">// Calling DofMap::reinit() by itself makes little sense,</span>
<a name="l00574"></a>00574   <span class="comment">// so we won't bother with nonlocal DofObjects.</span>
<a name="l00575"></a>00575   <span class="comment">// Those will be fixed by distribute_dofs</span>
<a name="l00576"></a>00576 <span class="comment">/*</span>
<a name="l00577"></a>00577 <span class="comment">  //------------------------------------------------------------</span>
<a name="l00578"></a>00578 <span class="comment">  // At this point, all n_comp and dof_number values on local</span>
<a name="l00579"></a>00579 <span class="comment">  // DofObjects should be correct, but a ParallelMesh might have</span>
<a name="l00580"></a>00580 <span class="comment">  // incorrect values on non-local DofObjects.  Let's request the</span>
<a name="l00581"></a>00581 <span class="comment">  // correct values from each other processor.</span>
<a name="l00582"></a>00582 <span class="comment"></span>
<a name="l00583"></a>00583 <span class="comment">  this-&gt;set_nonlocal_n_comps(mesh.nodes_begin(),</span>
<a name="l00584"></a>00584 <span class="comment">                             mesh.nodes_end(),</span>
<a name="l00585"></a>00585 <span class="comment">                             mesh,</span>
<a name="l00586"></a>00586 <span class="comment">                             &amp;DofMap::node_ptr);</span>
<a name="l00587"></a>00587 <span class="comment"></span>
<a name="l00588"></a>00588 <span class="comment">  this-&gt;set_nonlocal_n_comps(mesh.elements_begin(),</span>
<a name="l00589"></a>00589 <span class="comment">                             mesh.elements_end(),</span>
<a name="l00590"></a>00590 <span class="comment">                             mesh,</span>
<a name="l00591"></a>00591 <span class="comment">                             &amp;DofMap::elem_ptr);</span>
<a name="l00592"></a>00592 <span class="comment">*/</span>
<a name="l00593"></a>00593 
<a name="l00594"></a>00594   <span class="comment">//------------------------------------------------------------</span>
<a name="l00595"></a>00595   <span class="comment">// Finally, clear all the current DOF indices</span>
<a name="l00596"></a>00596   <span class="comment">// (distribute_dofs expects them cleared!)</span>
<a name="l00597"></a>00597   this-&gt;<a class="code" href="classDofMap.php#f4df7a1bb1553a016e9c9828e5bfabca">invalidate_dofs</a>(mesh);
<a name="l00598"></a>00598   
<a name="l00599"></a>00599   STOP_LOG(<span class="stringliteral">"reinit()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l00600"></a>00600 }
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 
<a name="l00604"></a><a class="code" href="classDofMap.php#f4df7a1bb1553a016e9c9828e5bfabca">00604</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#f4df7a1bb1553a016e9c9828e5bfabca">DofMap::invalidate_dofs</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l00605"></a>00605 <span class="keyword"></span>{
<a name="l00606"></a>00606   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>();
<a name="l00607"></a>00607 
<a name="l00608"></a>00608   <span class="comment">// All the nodes</span>
<a name="l00609"></a>00609   <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classMeshBase.php#2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l00610"></a>00610   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classMeshBase.php#b9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l00611"></a>00611 
<a name="l00612"></a>00612   <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00613"></a>00613     (*node_it)-&gt;invalidate_dofs(sys_num);
<a name="l00614"></a>00614   
<a name="l00615"></a>00615   <span class="comment">// All the elements</span>
<a name="l00616"></a>00616   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00617"></a>00617   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00618"></a>00618 
<a name="l00619"></a>00619   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00620"></a>00620     (*elem_it)-&gt;invalidate_dofs(sys_num);
<a name="l00621"></a>00621 }
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a><a class="code" href="classDofMap.php#e0336e2fe65c48efdc56ea25f3d4126e">00625</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#e0336e2fe65c48efdc56ea25f3d4126e">DofMap::clear</a>()
<a name="l00626"></a>00626 {
<a name="l00627"></a>00627   <span class="comment">// we don't want to clear</span>
<a name="l00628"></a>00628   <span class="comment">// the coupling matrix!</span>
<a name="l00629"></a>00629   <span class="comment">// It should not change...</span>
<a name="l00630"></a>00630   <span class="comment">//_dof_coupling-&gt;clear();</span>
<a name="l00631"></a>00631 
<a name="l00632"></a>00632   <a class="code" href="classDofMap.php#3e9ccce69be8f933be4f077b45ad4104">_variables</a>.clear();  
<a name="l00633"></a>00633   <a class="code" href="classDofMap.php#12a958965f4c50fcb94b8ac7967ee472">_first_df</a>.clear();
<a name="l00634"></a>00634   <a class="code" href="classDofMap.php#269555a44eebdf18497433c382ba29e9">_end_df</a>.clear();
<a name="l00635"></a>00635   <a class="code" href="classDofMap.php#8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.clear();
<a name="l00636"></a>00636   <a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.clear();
<a name="l00637"></a>00637   <a class="code" href="classDofMap.php#1a3d7ce4ddc7c2a899156b236494fe23">_n_nz</a>.clear();
<a name="l00638"></a>00638   <a class="code" href="classDofMap.php#3fbe36d4243308c59f7ddd273bae51f0">_n_oz</a>.clear();
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00642"></a>00642 <span class="preprocessor"></span>
<a name="l00643"></a>00643   <a class="code" href="classDofMap.php#f301f7e968260dd826d4479a1a8884e8">_dof_constraints</a>.clear();
<a name="l00644"></a>00644   <a class="code" href="classDofMap.php#9073a73bc3c155cc0a89884b97860c19">_n_old_dfs</a> = 0;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 <span class="preprocessor">#endif</span>
<a name="l00647"></a>00647 <span class="preprocessor"></span>
<a name="l00648"></a>00648   <a class="code" href="classDofMap.php#fcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>.clear();
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   <a class="code" href="classDofMap.php#e6954665b4f9471893dfff74fd70c643">_n_dfs</a> = 0;
<a name="l00651"></a>00651 }
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a><a class="code" href="classDofMap.php#cb78beb9cb3a932223a6577457c686d4">00655</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#cb78beb9cb3a932223a6577457c686d4">DofMap::distribute_dofs</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00658"></a>00658   parallel_only();
<a name="l00659"></a>00659 
<a name="l00660"></a>00660   <span class="comment">// Log how long it takes to distribute the degrees of freedom</span>
<a name="l00661"></a>00661   START_LOG(<span class="stringliteral">"distribute_dofs()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l00662"></a>00662 
<a name="l00663"></a>00663   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#960bff880e04431f031b46e797af38cc">is_prepared</a>());
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00666"></a>00666   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_proc  = <a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00667"></a>00667   
<a name="l00668"></a>00668 <span class="comment">//  libmesh_assert (this-&gt;n_variables() &gt; 0);</span>
<a name="l00669"></a>00669   libmesh_assert (proc_id &lt; n_proc);
<a name="l00670"></a>00670   
<a name="l00671"></a>00671   <span class="comment">// re-init in case the mesh has changed</span>
<a name="l00672"></a>00672   this-&gt;<a class="code" href="classDofMap.php#ed3c9f2c9e0ef0019fba7bb1c1c2a6db">reinit</a>(mesh);
<a name="l00673"></a>00673   
<a name="l00674"></a>00674   <span class="comment">// By default distribute variables in a</span>
<a name="l00675"></a>00675   <span class="comment">// var-major fashion, but allow run-time</span>
<a name="l00676"></a>00676   <span class="comment">// specification</span>
<a name="l00677"></a>00677   <span class="keywordtype">bool</span> node_major_dofs = <a class="code" href="namespacelibMesh.php#d19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">"--node_major_dofs"</span>);
<a name="l00678"></a>00678 
<a name="l00679"></a>00679   <span class="comment">// The DOF counter, will be incremented as we encounter</span>
<a name="l00680"></a>00680   <span class="comment">// new degrees of freedom</span>
<a name="l00681"></a>00681   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> next_free_dof = 0;
<a name="l00682"></a>00682 
<a name="l00683"></a>00683   <span class="comment">// Clear the send list before we rebuild it</span>
<a name="l00684"></a>00684   <a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.clear();
<a name="l00685"></a>00685 
<a name="l00686"></a>00686   <span class="comment">// Set temporary DOF indices on this processor</span>
<a name="l00687"></a>00687   <span class="keywordflow">if</span> (node_major_dofs)
<a name="l00688"></a>00688     this-&gt;<a class="code" href="classDofMap.php#60d9bace2cf72a1d02d22b4976a5fb67">distribute_local_dofs_node_major</a> (next_free_dof, mesh);
<a name="l00689"></a>00689   <span class="keywordflow">else</span>
<a name="l00690"></a>00690     this-&gt;<a class="code" href="classDofMap.php#b4b5f48efe6a8994e673ba1fe9b87409">distribute_local_dofs_var_major</a> (next_free_dof, mesh);
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <span class="comment">// Get DOF counts on all processors</span>
<a name="l00693"></a>00693   std::vector&lt;unsigned int&gt; dofs_on_proc(n_proc, 0);
<a name="l00694"></a>00694   Parallel::allgather(next_free_dof, dofs_on_proc);
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="comment">// Resize the _first_df and _end_df arrays</span>
<a name="l00697"></a>00697   <a class="code" href="classDofMap.php#12a958965f4c50fcb94b8ac7967ee472">_first_df</a>.resize(n_proc);
<a name="l00698"></a>00698   <a class="code" href="classDofMap.php#269555a44eebdf18497433c382ba29e9">_end_df</a>.resize (n_proc);
<a name="l00699"></a>00699 
<a name="l00700"></a>00700   <span class="comment">// Get DOF offsets</span>
<a name="l00701"></a>00701   <a class="code" href="classDofMap.php#12a958965f4c50fcb94b8ac7967ee472">_first_df</a>[0] = 0;
<a name="l00702"></a>00702   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i &lt; n_proc; ++i)
<a name="l00703"></a>00703     <a class="code" href="classDofMap.php#12a958965f4c50fcb94b8ac7967ee472">_first_df</a>[i] = <a class="code" href="classDofMap.php#269555a44eebdf18497433c382ba29e9">_end_df</a>[i-1] = <a class="code" href="classDofMap.php#12a958965f4c50fcb94b8ac7967ee472">_first_df</a>[i-1] + dofs_on_proc[i-1];
<a name="l00704"></a>00704   <a class="code" href="classDofMap.php#269555a44eebdf18497433c382ba29e9">_end_df</a>[n_proc-1] = <a class="code" href="classDofMap.php#12a958965f4c50fcb94b8ac7967ee472">_first_df</a>[n_proc-1] + dofs_on_proc[n_proc-1];
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="comment">// Clear all the current DOF indices</span>
<a name="l00707"></a>00707   <span class="comment">// (distribute_dofs expects them cleared!)</span>
<a name="l00708"></a>00708   this-&gt;<a class="code" href="classDofMap.php#f4df7a1bb1553a016e9c9828e5bfabca">invalidate_dofs</a>(mesh);
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   next_free_dof = <a class="code" href="classDofMap.php#12a958965f4c50fcb94b8ac7967ee472">_first_df</a>[proc_id];
<a name="l00711"></a>00711 
<a name="l00712"></a>00712   <span class="comment">// Set permanent DOF indices on this processor</span>
<a name="l00713"></a>00713   <span class="keywordflow">if</span> (node_major_dofs)
<a name="l00714"></a>00714     this-&gt;<a class="code" href="classDofMap.php#60d9bace2cf72a1d02d22b4976a5fb67">distribute_local_dofs_node_major</a> (next_free_dof, mesh);
<a name="l00715"></a>00715   <span class="keywordflow">else</span>
<a name="l00716"></a>00716     this-&gt;<a class="code" href="classDofMap.php#b4b5f48efe6a8994e673ba1fe9b87409">distribute_local_dofs_var_major</a> (next_free_dof, mesh);
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   libmesh_assert(next_free_dof == <a class="code" href="classDofMap.php#269555a44eebdf18497433c382ba29e9">_end_df</a>[proc_id]);
<a name="l00719"></a>00719 
<a name="l00720"></a>00720   <span class="comment">//------------------------------------------------------------</span>
<a name="l00721"></a>00721   <span class="comment">// At this point, all n_comp and dof_number values on local</span>
<a name="l00722"></a>00722   <span class="comment">// DofObjects should be correct, but a ParallelMesh might have</span>
<a name="l00723"></a>00723   <span class="comment">// incorrect values on non-local DofObjects.  Let's request the</span>
<a name="l00724"></a>00724   <span class="comment">// correct values from each other processor.</span>
<a name="l00725"></a>00725 
<a name="l00726"></a>00726   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00727"></a>00727     {
<a name="l00728"></a>00728       this-&gt;<a class="code" href="classDofMap.php#6d4ceeec9e3656d39038f9f8030edbeb">set_nonlocal_dof_objects</a>(mesh.<a class="code" href="classMeshBase.php#2683097ac8a923892fa43a1a911a273d">nodes_begin</a>(),
<a name="l00729"></a>00729                                      mesh.<a class="code" href="classMeshBase.php#b9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>(),
<a name="l00730"></a>00730                                      mesh, &amp;<a class="code" href="classDofMap.php#ce354d1aea94151ea259e3e084fdac37">DofMap::node_ptr</a>);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732       this-&gt;<a class="code" href="classDofMap.php#6d4ceeec9e3656d39038f9f8030edbeb">set_nonlocal_dof_objects</a>(mesh.<a class="code" href="classMeshBase.php#fc498f8b812e8256531089b5ee849be3">elements_begin</a>(),
<a name="l00733"></a>00733                                      mesh.<a class="code" href="classMeshBase.php#7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(),
<a name="l00734"></a>00734                                      mesh, &amp;<a class="code" href="classDofMap.php#7769da176038f8f29b8de691c838f19d">DofMap::elem_ptr</a>);
<a name="l00735"></a>00735     }
<a name="l00736"></a>00736   
<a name="l00737"></a>00737   <span class="comment">// Set the total number of degrees of freedom</span>
<a name="l00738"></a>00738 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00739"></a>00739 <span class="preprocessor"></span>  <a class="code" href="classDofMap.php#9073a73bc3c155cc0a89884b97860c19">_n_old_dfs</a> = <a class="code" href="classDofMap.php#e6954665b4f9471893dfff74fd70c643">_n_dfs</a>;
<a name="l00740"></a>00740 <span class="preprocessor">#endif</span>
<a name="l00741"></a>00741 <span class="preprocessor"></span>  <a class="code" href="classDofMap.php#e6954665b4f9471893dfff74fd70c643">_n_dfs</a> = <a class="code" href="classDofMap.php#269555a44eebdf18497433c382ba29e9">_end_df</a>[n_proc-1];
<a name="l00742"></a>00742 
<a name="l00743"></a>00743   STOP_LOG(<span class="stringliteral">"distribute_dofs()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l00744"></a>00744 
<a name="l00745"></a>00745   <span class="comment">// Note that in the add_neighbors_to_send_list nodes on processor</span>
<a name="l00746"></a>00746   <span class="comment">// boundaries that are shared by multiple elements are added for</span>
<a name="l00747"></a>00747   <span class="comment">// each element.</span>
<a name="l00748"></a>00748   this-&gt;<a class="code" href="classDofMap.php#2f3a85a70469f194d37b1e13f222683a">add_neighbors_to_send_list</a>(mesh);
<a name="l00749"></a>00749   
<a name="l00750"></a>00750   <span class="comment">// Here we used to clean up that data structure; now System and</span>
<a name="l00751"></a>00751   <span class="comment">// EquationSystems call that for us, after we've added constraint</span>
<a name="l00752"></a>00752   <span class="comment">// dependencies to the send_list too.</span>
<a name="l00753"></a>00753   <span class="comment">// this-&gt;sort_send_list ();</span>
<a name="l00754"></a>00754 }
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 
<a name="l00757"></a><a class="code" href="classDofMap.php#60d9bace2cf72a1d02d22b4976a5fb67">00757</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#60d9bace2cf72a1d02d22b4976a5fb67">DofMap::distribute_local_dofs_node_major</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;next_free_dof,
<a name="l00758"></a>00758                                               <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00759"></a>00759 {
<a name="l00760"></a>00760   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>();
<a name="l00761"></a>00761   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars  = this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>();
<a name="l00762"></a>00762 
<a name="l00763"></a>00763   <span class="comment">// We now only add remote dofs to the _send_list</span>
<a name="l00764"></a>00764   <span class="comment">// unsigned int send_list_size = 0;</span>
<a name="l00765"></a>00765 
<a name="l00766"></a>00766   <span class="comment">// _var_first_local_df does not work with node_major dofs</span>
<a name="l00767"></a>00767   <a class="code" href="classDofMap.php#8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.resize(n_vars+1);
<a name="l00768"></a>00768   std::fill (<a class="code" href="classDofMap.php#8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.begin(),
<a name="l00769"></a>00769              <a class="code" href="classDofMap.php#8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.end(),
<a name="l00770"></a>00770              <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00771"></a>00771 
<a name="l00772"></a>00772   <span class="comment">// Set _n_SCALAR_dofs</span>
<a name="l00773"></a>00773   this-&gt;<a class="code" href="classDofMap.php#e00169f4e682f51d64ea1f4e95c5f2df">_n_SCALAR_dofs</a> = 0;
<a name="l00774"></a>00774   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;n_vars; var++)
<a name="l00775"></a>00775   {
<a name="l00776"></a>00776     <span class="keywordflow">if</span>( this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var).<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a> )
<a name="l00777"></a>00777     {
<a name="l00778"></a>00778       <span class="comment">// TODO: This only works in serial at the moment</span>
<a name="l00779"></a>00779       <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00780"></a>00780         libmesh_not_implemented();
<a name="l00781"></a>00781 
<a name="l00782"></a>00782       this-&gt;_n_SCALAR_dofs += this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var).<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00783"></a>00783       <span class="keywordflow">continue</span>;
<a name="l00784"></a>00784     }
<a name="l00785"></a>00785   }
<a name="l00786"></a>00786   
<a name="l00787"></a>00787   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00788"></a>00788   <span class="comment">// First count and assign temporary numbers to local dofs</span>
<a name="l00789"></a>00789   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00790"></a>00790   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();  
<a name="l00791"></a>00791   
<a name="l00792"></a>00792   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00793"></a>00793     {
<a name="l00794"></a>00794       <span class="comment">// Only number dofs connected to active</span>
<a name="l00795"></a>00795       <span class="comment">// elements on this processor.</span>
<a name="l00796"></a>00796       <a class="code" href="classElem.php">Elem</a>* elem                 = *elem_it;
<a name="l00797"></a>00797       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#cc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00798"></a>00798       
<a name="l00799"></a>00799       <span class="comment">// First number the nodal DOFS</span>
<a name="l00800"></a>00800       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_nodes; n++)
<a name="l00801"></a>00801         {
<a name="l00802"></a>00802           <a class="code" href="classNode.php">Node</a>* node = elem-&gt;<a class="code" href="classElem.php#68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00803"></a>00803 
<a name="l00804"></a>00804           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;n_vars; var++)
<a name="l00805"></a>00805           {
<a name="l00806"></a>00806               <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>) &amp;&amp;
<a name="l00807"></a>00807                   (this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var).active_on_subdomain(elem-&gt;<a class="code" href="classElem.php#cc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>())) )
<a name="l00808"></a>00808               {
<a name="l00809"></a>00809                 <span class="comment">// assign dof numbers (all at once) if this is</span>
<a name="l00810"></a>00810                 <span class="comment">// our node and if they aren't already there</span>
<a name="l00811"></a>00811                 <span class="keywordflow">if</span> ((node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var) &gt; 0) &amp;&amp;
<a name="l00812"></a>00812                     (node-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) &amp;&amp;
<a name="l00813"></a>00813                     (node-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,var,0) ==
<a name="l00814"></a>00814                      <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>))
<a name="l00815"></a>00815                   {
<a name="l00816"></a>00816                     node-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(sys_num,
<a name="l00817"></a>00817                                          var,
<a name="l00818"></a>00818                                          0,
<a name="l00819"></a>00819                                          next_free_dof);
<a name="l00820"></a>00820                     next_free_dof += node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var);
<a name="l00821"></a>00821                   }
<a name="l00822"></a>00822               }
<a name="l00823"></a>00823           }
<a name="l00824"></a>00824         }
<a name="l00825"></a>00825 
<a name="l00826"></a>00826       <span class="comment">// Now number the element DOFS</span>
<a name="l00827"></a>00827       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;n_vars; var++)
<a name="l00828"></a>00828         <span class="keywordflow">if</span> ( (this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>) &amp;&amp;
<a name="l00829"></a>00829              (this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var).active_on_subdomain(elem-&gt;<a class="code" href="classElem.php#cc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>())) )
<a name="l00830"></a>00830           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var) &gt; 0)
<a name="l00831"></a>00831             {
<a name="l00832"></a>00832               libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,var,0) ==
<a name="l00833"></a>00833                               <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00834"></a>00834 
<a name="l00835"></a>00835               elem-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(sys_num,
<a name="l00836"></a>00836                                    var,
<a name="l00837"></a>00837                                    0,
<a name="l00838"></a>00838                                    next_free_dof);
<a name="l00839"></a>00839 
<a name="l00840"></a>00840               next_free_dof += elem-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var);
<a name="l00841"></a>00841             }
<a name="l00842"></a>00842     } <span class="comment">// done looping over elements</span>
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00845"></a>00845 <span class="preprocessor"></span><span class="comment">// Make sure we didn't miss any nodes</span>
<a name="l00846"></a>00846   <a class="code" href="namespaceMeshTools.php#8459293294733e3d034d2fec20501759">MeshTools::libmesh_assert_valid_node_procids</a>(mesh);
<a name="l00847"></a>00847 
<a name="l00848"></a>00848   <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classMeshBase.php#6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>();
<a name="l00849"></a>00849   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classMeshBase.php#e23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>();
<a name="l00850"></a>00850   <span class="keywordflow">for</span> (; node_it != node_end; ++node_it)
<a name="l00851"></a>00851     {
<a name="l00852"></a>00852       <a class="code" href="classNode.php">Node</a> *obj = *node_it;
<a name="l00853"></a>00853       libmesh_assert(obj);
<a name="l00854"></a>00854       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a> = obj-&gt;<a class="code" href="classDofObject.php#39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>());
<a name="l00855"></a>00855       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != n_variables; ++v)
<a name="l00856"></a>00856         {
<a name="l00857"></a>00857           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l00858"></a>00858             obj-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v);
<a name="l00859"></a>00859           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a> = n_comp ?
<a name="l00860"></a>00860             obj-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v, 0) : 0;
<a name="l00861"></a>00861           libmesh_assert(first_dof != <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00862"></a>00862         }
<a name="l00863"></a>00863     }
<a name="l00864"></a>00864 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00865"></a>00865 <span class="preprocessor"></span>}
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 
<a name="l00869"></a><a class="code" href="classDofMap.php#b4b5f48efe6a8994e673ba1fe9b87409">00869</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#b4b5f48efe6a8994e673ba1fe9b87409">DofMap::distribute_local_dofs_var_major</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;next_free_dof,
<a name="l00870"></a>00870                                              <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00871"></a>00871 {
<a name="l00872"></a>00872   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>();
<a name="l00873"></a>00873   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars  = this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>();
<a name="l00874"></a>00874 
<a name="l00875"></a>00875   <span class="comment">// We now only add remote dofs to the _send_list</span>
<a name="l00876"></a>00876   <span class="comment">// unsigned int send_list_size = 0;</span>
<a name="l00877"></a>00877 
<a name="l00878"></a>00878   <span class="comment">// We will cache the first local index for each variable</span>
<a name="l00879"></a>00879   <a class="code" href="classDofMap.php#8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.clear();
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   <span class="comment">// Zero _n_SCALAR_dofs, we will set it below</span>
<a name="l00882"></a>00882   this-&gt;<a class="code" href="classDofMap.php#e00169f4e682f51d64ea1f4e95c5f2df">_n_SCALAR_dofs</a> = 0;
<a name="l00883"></a>00883 
<a name="l00884"></a>00884   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00885"></a>00885   <span class="comment">// First count and assign temporary numbers to local dofs</span>
<a name="l00886"></a>00886   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> var=0; var&lt;n_vars; var++)
<a name="l00887"></a>00887     {
<a name="l00888"></a>00888       <a class="code" href="classDofMap.php#8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.push_back(next_free_dof);
<a name="l00889"></a>00889 
<a name="l00890"></a>00890       <span class="keyword">const</span> <a class="code" href="classSystem_1_1Variable.php">System::Variable</a> var_description = this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var);
<a name="l00891"></a>00891 
<a name="l00892"></a>00892       <span class="comment">// Skip dof counting for a SCALAR variable</span>
<a name="l00893"></a>00893       <span class="keywordflow">if</span>(var_description.<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00894"></a>00894       {
<a name="l00895"></a>00895         <span class="comment">// TODO: This only works in serial at the moment</span>
<a name="l00896"></a>00896         <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00897"></a>00897           libmesh_not_implemented();
<a name="l00898"></a>00898 
<a name="l00899"></a>00899         this-&gt;<a class="code" href="classDofMap.php#e00169f4e682f51d64ea1f4e95c5f2df">_n_SCALAR_dofs</a> += var_description.<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00900"></a>00900         <span class="keywordflow">continue</span>;
<a name="l00901"></a>00901       }
<a name="l00902"></a>00902 
<a name="l00903"></a>00903       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classMeshBase.php#9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00904"></a>00904       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classMeshBase.php#779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00905"></a>00905 
<a name="l00906"></a>00906       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00907"></a>00907         {
<a name="l00908"></a>00908           <span class="comment">// Only number dofs connected to active</span>
<a name="l00909"></a>00909           <span class="comment">// elements on this processor.</span>
<a name="l00910"></a>00910           <a class="code" href="classElem.php">Elem</a>* elem  = *elem_it;
<a name="l00911"></a>00911 
<a name="l00912"></a>00912           <span class="comment">// ... and only variables which are active on</span>
<a name="l00913"></a>00913           <span class="comment">// on this element's subdomain</span>
<a name="l00914"></a>00914           <span class="keywordflow">if</span> (!var_description.<a class="code" href="classSystem_1_1Variable.php#d6639756dcb5050d014cddb818d13df9">active_on_subdomain</a>(elem-&gt;<a class="code" href="classElem.php#cc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>()))
<a name="l00915"></a>00915             <span class="keywordflow">continue</span>;
<a name="l00916"></a>00916 
<a name="l00917"></a>00917           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#cc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00918"></a>00918           
<a name="l00919"></a>00919           <span class="comment">// First number the nodal DOFS</span>
<a name="l00920"></a>00920           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_nodes; n++)
<a name="l00921"></a>00921             {
<a name="l00922"></a>00922               <a class="code" href="classNode.php">Node</a>* node = elem-&gt;<a class="code" href="classElem.php#68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l00923"></a>00923               
<a name="l00924"></a>00924               <span class="comment">// assign dof numbers (all at once) if this is</span>
<a name="l00925"></a>00925               <span class="comment">// our node and if they aren't already there</span>
<a name="l00926"></a>00926               <span class="keywordflow">if</span> ((node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var) &gt; 0) &amp;&amp;
<a name="l00927"></a>00927                   (node-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) &amp;&amp;
<a name="l00928"></a>00928                   (node-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,var,0) ==
<a name="l00929"></a>00929                    <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>))
<a name="l00930"></a>00930                 {
<a name="l00931"></a>00931                   node-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(sys_num,
<a name="l00932"></a>00932                                        var,
<a name="l00933"></a>00933                                        0,
<a name="l00934"></a>00934                                        next_free_dof);
<a name="l00935"></a>00935                   next_free_dof += node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var);
<a name="l00936"></a>00936                 }
<a name="l00937"></a>00937             }
<a name="l00938"></a>00938                   
<a name="l00939"></a>00939           <span class="comment">// Now number the element DOFS</span>
<a name="l00940"></a>00940           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var) &gt; 0)
<a name="l00941"></a>00941             {
<a name="l00942"></a>00942               libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,var,0) ==
<a name="l00943"></a>00943                       <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00944"></a>00944 
<a name="l00945"></a>00945               elem-&gt;<a class="code" href="classDofObject.php#13635f9e4f4d398bbc4015cfaeaa5f99">set_dof_number</a>(sys_num,
<a name="l00946"></a>00946                                    var,
<a name="l00947"></a>00947                                    0,
<a name="l00948"></a>00948                                    next_free_dof);
<a name="l00949"></a>00949 
<a name="l00950"></a>00950               next_free_dof += elem-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,var);
<a name="l00951"></a>00951             }
<a name="l00952"></a>00952         } <span class="comment">// end loop on elements</span>
<a name="l00953"></a>00953     } <span class="comment">// end loop on variables</span>
<a name="l00954"></a>00954 
<a name="l00955"></a>00955   <span class="comment">// Cache the last local dof number too</span>
<a name="l00956"></a>00956   <a class="code" href="classDofMap.php#8592d66151f1635707d6522dfb1bb59e">_var_first_local_df</a>.push_back(next_free_dof);
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00959"></a>00959 <span class="preprocessor"></span>  <span class="comment">// Make sure we didn't miss any nodes</span>
<a name="l00960"></a>00960   <a class="code" href="namespaceMeshTools.php#8459293294733e3d034d2fec20501759">MeshTools::libmesh_assert_valid_node_procids</a>(mesh);
<a name="l00961"></a>00961 
<a name="l00962"></a>00962   <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classMeshBase.php#6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>();
<a name="l00963"></a>00963   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classMeshBase.php#e23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>();
<a name="l00964"></a>00964   <span class="keywordflow">for</span> (; node_it != node_end; ++node_it)
<a name="l00965"></a>00965     {
<a name="l00966"></a>00966       <a class="code" href="classNode.php">Node</a> *obj = *node_it;
<a name="l00967"></a>00967       libmesh_assert(obj);
<a name="l00968"></a>00968       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a> = obj-&gt;<a class="code" href="classDofObject.php#39e3c25ce80fe829a2f8b8cff46b7731">n_vars</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>());
<a name="l00969"></a>00969       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v != n_variables; ++v)
<a name="l00970"></a>00970         {
<a name="l00971"></a>00971           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp =
<a name="l00972"></a>00972             obj-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v);
<a name="l00973"></a>00973           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a> = n_comp ?
<a name="l00974"></a>00974             obj-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>(), v, 0) : 0;
<a name="l00975"></a>00975           libmesh_assert(first_dof != <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l00976"></a>00976         }
<a name="l00977"></a>00977     }
<a name="l00978"></a>00978 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00979"></a>00979 <span class="preprocessor"></span>}
<a name="l00980"></a>00980 
<a name="l00981"></a>00981 
<a name="l00982"></a>00982 
<a name="l00983"></a><a class="code" href="classDofMap.php#2f3a85a70469f194d37b1e13f222683a">00983</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#2f3a85a70469f194d37b1e13f222683a">DofMap::add_neighbors_to_send_list</a>(<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l00984"></a>00984 {
<a name="l00985"></a>00985   START_LOG(<span class="stringliteral">"add_neighbors_to_send_list()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l00986"></a>00986   
<a name="l00987"></a>00987   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00988"></a>00988   <span class="comment">// We need to add the DOFs from elements that live on neighboring processors</span>
<a name="l00989"></a>00989   <span class="comment">// that are neighbors of the elements on the local processor</span>
<a name="l00990"></a>00990   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00991"></a>00991 
<a name="l00992"></a>00992   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       local_elem_it
<a name="l00993"></a>00993     = mesh.<a class="code" href="classMeshBase.php#9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00994"></a>00994   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> local_elem_end
<a name="l00995"></a>00995     = mesh.<a class="code" href="classMeshBase.php#779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>(); 
<a name="l00996"></a>00996 
<a name="l00997"></a>00997   std::vector&lt;bool&gt; node_on_processor(mesh.<a class="code" href="classMeshBase.php#5a56e1b57f60d011b67f1f43ff8a5891">max_node_id</a>(), <span class="keyword">false</span>);
<a name="l00998"></a>00998   std::vector&lt;unsigned int&gt; di;
<a name="l00999"></a>00999   std::vector&lt;const Elem *&gt; family;
<a name="l01000"></a>01000 
<a name="l01001"></a>01001   <span class="comment">// Loop over the active local elements, adding all active elements</span>
<a name="l01002"></a>01002   <span class="comment">// that neighbor an active local element to the send list.</span>
<a name="l01003"></a>01003   <span class="keywordflow">for</span> ( ; local_elem_it != local_elem_end; ++local_elem_it)
<a name="l01004"></a>01004     {
<a name="l01005"></a>01005       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *local_elem_it;
<a name="l01006"></a>01006 
<a name="l01007"></a>01007       <span class="comment">// Flag all the nodes of active local elements as seen</span>
<a name="l01008"></a>01008       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n!=elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l01009"></a>01009         node_on_processor[elem-&gt;<a class="code" href="classElem.php#2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] = <span class="keyword">true</span>;
<a name="l01010"></a>01010 
<a name="l01011"></a>01011       <span class="comment">// Loop over the neighbors of those elements</span>
<a name="l01012"></a>01012       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
<a name="l01013"></a>01013         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) != NULL)
<a name="l01014"></a>01014           {
<a name="l01015"></a>01015             family.clear();
<a name="l01016"></a>01016             
<a name="l01017"></a>01017             <span class="comment">// Find all the active elements that neighbor elem</span>
<a name="l01018"></a>01018 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01019"></a>01019 <span class="preprocessor"></span>            <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s)-&gt;<a class="code" href="classElem.php#cb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01020"></a>01020               elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s)-&gt;<a class="code" href="classElem.php#26ca00dd9c91f9f086d755eb3f58d4ff">active_family_tree_by_neighbor</a>(family, elem);
<a name="l01021"></a>01021             <span class="keywordflow">else</span>
<a name="l01022"></a>01022 <span class="preprocessor">#endif</span>
<a name="l01023"></a>01023 <span class="preprocessor"></span>              family.push_back(elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s));
<a name="l01024"></a>01024 
<a name="l01025"></a>01025             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=family.size(); ++i)
<a name="l01026"></a>01026               <span class="comment">// If the neighbor lives on a different processor</span>
<a name="l01027"></a>01027               <span class="keywordflow">if</span> (family[i]-&gt;<a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>() != <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01028"></a>01028                 {
<a name="l01029"></a>01029                   <span class="comment">// Get the DOF indices for this neighboring element</span>
<a name="l01030"></a>01030                   this-&gt;<a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (family[i], di);
<a name="l01031"></a>01031 
<a name="l01032"></a>01032                   <span class="comment">// Insert the remote DOF indices into the send list</span>
<a name="l01033"></a>01033                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != di.size(); ++j)
<a name="l01034"></a>01034                     <span class="keywordflow">if</span> (di[j] &lt; this-&gt;<a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a>() ||
<a name="l01035"></a>01035                         di[j] &gt;= this-&gt;<a class="code" href="classDofMap.php#b838f2e72aaf8614c97fcd47a13781b8">end_dof</a>())
<a name="l01036"></a>01036                       <a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.push_back(di[j]);
<a name="l01037"></a>01037                 }
<a name="l01038"></a>01038           }
<a name="l01039"></a>01039     }
<a name="l01040"></a>01040 
<a name="l01041"></a>01041   <span class="comment">// Now loop over all non_local active elements and add any missing</span>
<a name="l01042"></a>01042   <span class="comment">// nodal-only neighbors</span>
<a name="l01043"></a>01043   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it
<a name="l01044"></a>01044     = mesh.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l01045"></a>01045   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end
<a name="l01046"></a>01046     = mesh.<a class="code" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>();
<a name="l01047"></a>01047   
<a name="l01048"></a>01048   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01049"></a>01049     {
<a name="l01050"></a>01050       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l01051"></a>01051 
<a name="l01052"></a>01052       <span class="comment">// If this is one of our elements, we've already added it</span>
<a name="l01053"></a>01053       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01054"></a>01054         <span class="keywordflow">continue</span>;
<a name="l01055"></a>01055 
<a name="l01056"></a>01056       <span class="comment">// Do we need to add the element DOFs?</span>
<a name="l01057"></a>01057       <span class="keywordtype">bool</span> add_elem_dofs = <span class="keyword">false</span>;
<a name="l01058"></a>01058       
<a name="l01059"></a>01059       <span class="comment">// Check all the nodes of the element to see if it</span>
<a name="l01060"></a>01060       <span class="comment">// shares a node with us</span>
<a name="l01061"></a>01061       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n!=elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l01062"></a>01062         <span class="keywordflow">if</span> (node_on_processor[elem-&gt;<a class="code" href="classElem.php#2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)])
<a name="l01063"></a>01063           add_elem_dofs = <span class="keyword">true</span>;
<a name="l01064"></a>01064 
<a name="l01065"></a>01065       <span class="comment">// Add the element degrees of freedom if it shares at</span>
<a name="l01066"></a>01066       <span class="comment">// least one node.</span>
<a name="l01067"></a>01067       <span class="keywordflow">if</span> (add_elem_dofs)
<a name="l01068"></a>01068         {
<a name="l01069"></a>01069           <span class="comment">// Get the DOF indices for this neighboring element</span>
<a name="l01070"></a>01070           this-&gt;<a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, di);
<a name="l01071"></a>01071 
<a name="l01072"></a>01072           <span class="comment">// Insert the remote DOF indices into the send list</span>
<a name="l01073"></a>01073             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != di.size(); ++j)
<a name="l01074"></a>01074               <span class="keywordflow">if</span> (di[j] &lt; this-&gt;<a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a>() ||
<a name="l01075"></a>01075                   di[j] &gt;= this-&gt;<a class="code" href="classDofMap.php#b838f2e72aaf8614c97fcd47a13781b8">end_dof</a>())
<a name="l01076"></a>01076                 <a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.push_back(di[j]);
<a name="l01077"></a>01077         }
<a name="l01078"></a>01078     }
<a name="l01079"></a>01079   
<a name="l01080"></a>01080   STOP_LOG(<span class="stringliteral">"add_neighbors_to_send_list()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l01081"></a>01081 }
<a name="l01082"></a>01082 
<a name="l01083"></a>01083 
<a name="l01084"></a>01084 
<a name="l01085"></a><a class="code" href="classDofMap.php#d46e1ea51922aeb2828beb1527294694">01085</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#d46e1ea51922aeb2828beb1527294694">DofMap::prepare_send_list</a> ()
<a name="l01086"></a>01086 {
<a name="l01087"></a>01087   START_LOG(<span class="stringliteral">"prepare_send_list()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l01088"></a>01088   
<a name="l01089"></a>01089   <span class="comment">// First sort the send list.  After this</span>
<a name="l01090"></a>01090   <span class="comment">// duplicated elements will be adjacent in the</span>
<a name="l01091"></a>01091   <span class="comment">// vector</span>
<a name="l01092"></a>01092   std::sort(<a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.begin(), <a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.end());
<a name="l01093"></a>01093 
<a name="l01094"></a>01094   <span class="comment">// Now use std::unique to remove duplicate entries  </span>
<a name="l01095"></a>01095   std::vector&lt;unsigned int&gt;::iterator new_end =
<a name="l01096"></a>01096     std::unique (<a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.begin(), <a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.end());
<a name="l01097"></a>01097 
<a name="l01098"></a>01098   <span class="comment">// Remove the end of the send_list.  Use the "swap trick"</span>
<a name="l01099"></a>01099   <span class="comment">// from Effective STL</span>
<a name="l01100"></a>01100   std::vector&lt;unsigned int&gt; (<a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>.begin(), new_end).swap (<a class="code" href="classDofMap.php#83806e00bbf1297f50e95d1c93f7a8b6">_send_list</a>);
<a name="l01101"></a>01101   
<a name="l01102"></a>01102   STOP_LOG(<span class="stringliteral">"prepare_send_list()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l01103"></a>01103 }
<a name="l01104"></a>01104 
<a name="l01105"></a>01105 
<a name="l01106"></a>01106 
<a name="l01107"></a><a class="code" href="classDofMap.php#b8138ba1a23074b2424c6fd85c9a6d0b">01107</a> <span class="keywordtype">bool</span> <a class="code" href="classDofMap.php#b8138ba1a23074b2424c6fd85c9a6d0b">DofMap::use_coupled_neighbor_dofs</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01108"></a>01108 <span class="keyword"></span>{
<a name="l01109"></a>01109   <span class="comment">// If we were asked on the command line, then we need to</span>
<a name="l01110"></a>01110   <span class="comment">// include sensitivities between neighbor degrees of freedom</span>
<a name="l01111"></a>01111   <span class="keywordtype">bool</span> implicit_neighbor_dofs = 
<a name="l01112"></a>01112     <a class="code" href="namespacelibMesh.php#d19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">"--implicit_neighbor_dofs"</span>);
<a name="l01113"></a>01113 
<a name="l01114"></a>01114   <span class="comment">// look at all the variables in this system.  If every one is</span>
<a name="l01115"></a>01115   <span class="comment">// discontinuous then the user must be doing DG/FVM, so be nice</span>
<a name="l01116"></a>01116   <span class="comment">// and  force implicit_neighbor_dofs=true</span>
<a name="l01117"></a>01117   {
<a name="l01118"></a>01118     <span class="keywordtype">bool</span> all_discontinuous_dofs = <span class="keyword">true</span>;
<a name="l01119"></a>01119     
<a name="l01120"></a>01120     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>(); var++)
<a name="l01121"></a>01121       <span class="keywordflow">if</span> (<a class="code" href="classFEBase.php#3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a> (mesh.<a class="code" href="classMeshBase.php#81ce19df31062ba94d8fea90f050a649">mesh_dimension</a>(),
<a name="l01122"></a>01122                          this-&gt;<a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">variable_type</a>(var))-&gt;get_continuity() !=  <a class="code" href="namespacelibMeshEnums.php#5061b5224c9a6d92d69b978b5733cb1406624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01123"></a>01123         all_discontinuous_dofs = <span class="keyword">false</span>;
<a name="l01124"></a>01124 
<a name="l01125"></a>01125     <span class="keywordflow">if</span> (all_discontinuous_dofs)
<a name="l01126"></a>01126       implicit_neighbor_dofs = <span class="keyword">true</span>;
<a name="l01127"></a>01127   }
<a name="l01128"></a>01128   
<a name="l01129"></a>01129   <span class="keywordflow">return</span> implicit_neighbor_dofs;
<a name="l01130"></a>01130 }
<a name="l01131"></a>01131 
<a name="l01132"></a>01132 
<a name="l01133"></a>01133 
<a name="l01134"></a><a class="code" href="classDofMap.php#b51821ee7bdb1c6fb8f92821afea2530">01134</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#b51821ee7bdb1c6fb8f92821afea2530">DofMap::compute_sparsity</a>(<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)
<a name="l01135"></a>01135 {
<a name="l01136"></a>01136   libmesh_assert (mesh.<a class="code" href="classMeshBase.php#960bff880e04431f031b46e797af38cc">is_prepared</a>());
<a name="l01137"></a>01137   libmesh_assert (this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>());
<a name="l01138"></a>01138 
<a name="l01139"></a>01139   START_LOG(<span class="stringliteral">"compute_sparsity()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l01140"></a>01140 
<a name="l01141"></a>01141   <span class="comment">// Compute the sparsity structure of the global matrix.  This can be</span>
<a name="l01142"></a>01142   <span class="comment">// fed into a PetscMatrix to allocate exacly the number of nonzeros</span>
<a name="l01143"></a>01143   <span class="comment">// necessary to store the matrix.  This algorithm should be linear</span>
<a name="l01144"></a>01144   <span class="comment">// in the (# of elements)*(# nodes per element)</span>
<a name="l01145"></a>01145 
<a name="l01146"></a>01146   <span class="comment">// We can be more efficient in the threaded sparsity pattern assembly</span>
<a name="l01147"></a>01147   <span class="comment">// if we don't need the exact pattern.  For some sparse matrix formats</span>
<a name="l01148"></a>01148   <span class="comment">// a good upper bound will suffice.</span>
<a name="l01149"></a>01149   <span class="keywordtype">bool</span> need_full_sparsity_pattern=<span class="keyword">false</span>;
<a name="l01150"></a>01150   std::vector&lt;SparseMatrix&lt;Number&gt;* &gt;::iterator
<a name="l01151"></a>01151     pos = <a class="code" href="classDofMap.php#fcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>.begin(),
<a name="l01152"></a>01152     end = <a class="code" href="classDofMap.php#fcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>.end();
<a name="l01153"></a>01153       
<a name="l01154"></a>01154   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l01155"></a>01155     <span class="keywordflow">if</span> ((*pos)-&gt;need_full_sparsity_pattern())
<a name="l01156"></a>01156       need_full_sparsity_pattern = <span class="keyword">true</span>;
<a name="l01157"></a>01157 
<a name="l01158"></a>01158   <span class="comment">// See if we need to include sparsity pattern entries for coupling</span>
<a name="l01159"></a>01159   <span class="comment">// between neighbor dofs</span>
<a name="l01160"></a>01160   <span class="keywordtype">bool</span> implicit_neighbor_dofs = this-&gt;<a class="code" href="classDofMap.php#b8138ba1a23074b2424c6fd85c9a6d0b">use_coupled_neighbor_dofs</a>(mesh);
<a name="l01161"></a>01161   
<a name="l01162"></a>01162   <span class="comment">// We can compute the sparsity pattern in parallel on multiple</span>
<a name="l01163"></a>01163   <span class="comment">// threads.  The goal is for each thread to compute the full sparsity</span>
<a name="l01164"></a>01164   <span class="comment">// pattern for a subset of elements.  These sparsity patterns can</span>
<a name="l01165"></a>01165   <span class="comment">// be efficiently merged in the SparsityPattern::Build::join()</span>
<a name="l01166"></a>01166   <span class="comment">// method, especially if there is not too much overlap between them.</span>
<a name="l01167"></a>01167   <span class="comment">// Even better, if the full sparsity pattern is not needed then</span>
<a name="l01168"></a>01168   <span class="comment">// the number of nonzeros per row can be estimated from the</span>
<a name="l01169"></a>01169   <span class="comment">// sparsity patterns created on each thread.</span>
<a name="l01170"></a>01170   <a class="code" href="classSparsityPattern_1_1Build.php">SparsityPattern::Build</a> sp (mesh,
<a name="l01171"></a>01171                              *<span class="keyword">this</span>,
<a name="l01172"></a>01172                              <a class="code" href="classDofMap.php#4d50b4c013a93b8036c126ced15ecbe6">_dof_coupling</a>,
<a name="l01173"></a>01173                              implicit_neighbor_dofs,
<a name="l01174"></a>01174                              need_full_sparsity_pattern);
<a name="l01175"></a>01175   
<a name="l01176"></a>01176   <a class="code" href="namespaceThreads.php#5957a49c5a5b3a757b655cb6f8a2d933">Threads::parallel_reduce</a> (<a class="code" href="classStoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classMeshBase.php#fa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>(),
<a name="l01177"></a>01177                                             mesh.<a class="code" href="classMeshBase.php#8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>()), sp);
<a name="l01178"></a>01178 
<a name="l01179"></a>01179 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01180"></a>01180 <span class="preprocessor"></span>  <span class="comment">// Avoid declaring these variables unless asserts are enabled.</span>
<a name="l01181"></a>01181   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id        = mesh.<a class="code" href="classMeshBase.php#ba369b64ee6185d86a6b60089ba5af60">processor_id</a>();
<a name="l01182"></a>01182   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_proc = this-&gt;<a class="code" href="classDofMap.php#9c7492c5d5f1eacd327f0c902590eda7">n_dofs_on_processor</a>(proc_id);
<a name="l01183"></a>01183 <span class="preprocessor">#endif</span>
<a name="l01184"></a>01184 <span class="preprocessor"></span>  libmesh_assert (sp.<a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.size() == n_dofs_on_proc);
<a name="l01185"></a>01185 
<a name="l01186"></a>01186   <span class="comment">// steal the n_nz and n_oz arrays from sp -- it won't need them any more,</span>
<a name="l01187"></a>01187   <span class="comment">// and this is more efficient than copying them.</span>
<a name="l01188"></a>01188   <a class="code" href="classDofMap.php#1a3d7ce4ddc7c2a899156b236494fe23">_n_nz</a>.swap(sp.<a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>);
<a name="l01189"></a>01189   <a class="code" href="classDofMap.php#3fbe36d4243308c59f7ddd273bae51f0">_n_oz</a>.swap(sp.<a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>);
<a name="l01190"></a>01190   
<a name="l01191"></a>01191   STOP_LOG(<span class="stringliteral">"compute_sparsity()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l01192"></a>01192   
<a name="l01193"></a>01193   <span class="comment">// We are done with the sparsity_pattern.  However, quite a</span>
<a name="l01194"></a>01194   <span class="comment">// lot has gone into computing it.  It is possible that some</span>
<a name="l01195"></a>01195   <span class="comment">// \p SparseMatrix implementations want to see it.  Let them</span>
<a name="l01196"></a>01196   <span class="comment">// see it before we throw it away.</span>
<a name="l01197"></a>01197   pos = <a class="code" href="classDofMap.php#fcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>.begin();
<a name="l01198"></a>01198   end = <a class="code" href="classDofMap.php#fcf540dc957d2a3d4c3acff70e6513c1">_matrices</a>.end();
<a name="l01199"></a>01199       
<a name="l01200"></a>01200   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l01201"></a>01201     (*pos)-&gt;update_sparsity_pattern (sp.<a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>);     
<a name="l01202"></a>01202 }
<a name="l01203"></a>01203 
<a name="l01204"></a>01204 
<a name="l01205"></a>01205 
<a name="l01206"></a><a class="code" href="classDofMap.php#cfbb9dbe71246f5d086077a3f4a5cced">01206</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#cfbb9dbe71246f5d086077a3f4a5cced">DofMap::extract_local_vector</a> (<span class="keyword">const</span> <a class="code" href="classNumericVector.php">NumericVector&lt;Number&gt;</a>&amp; Ug,
<a name="l01207"></a>01207                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices,
<a name="l01208"></a>01208                                    <a class="code" href="classDenseVectorBase.php">DenseVectorBase&lt;Number&gt;</a>&amp; Ue)<span class="keyword"> const</span>
<a name="l01209"></a>01209 <span class="keyword"></span>{
<a name="l01210"></a>01210 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01211"></a>01211 <span class="preprocessor"></span>
<a name="l01212"></a>01212   <span class="comment">// Trivial mapping</span>
<a name="l01213"></a>01213   libmesh_assert (dof_indices.size() == Ue.<a class="code" href="classDenseVectorBase.php#f27a452cf8a2a5ec845e040c85761572">size</a>());
<a name="l01214"></a>01214   <span class="keywordtype">bool</span> has_constrained_dofs = <span class="keyword">false</span>;
<a name="l01215"></a>01215 
<a name="l01216"></a>01216   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> il=0; il&lt;dof_indices.size(); il++)
<a name="l01217"></a>01217     {
<a name="l01218"></a>01218       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = dof_indices[il];
<a name="l01219"></a>01219 
<a name="l01220"></a>01220       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofMap.php#923a6811ca54a01cc1e6dee8570a281f">is_constrained_dof</a> (ig)) has_constrained_dofs = <span class="keyword">true</span>;
<a name="l01221"></a>01221       
<a name="l01222"></a>01222       libmesh_assert ((il &gt;= Ug.<a class="code" href="classNumericVector.php#dbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>()) &amp;&amp;
<a name="l01223"></a>01223               (il &lt;  Ug.<a class="code" href="classNumericVector.php#e3230edd5439110231dfe3d4f01dfe52">last_local_index</a>()));
<a name="l01224"></a>01224 
<a name="l01225"></a>01225       Ue.<a class="code" href="classDenseVectorBase.php#ab66dfa4cd02da710e367a112ac9f64f">el</a>(il) = Ug(ig);
<a name="l01226"></a>01226     }
<a name="l01227"></a>01227 
<a name="l01228"></a>01228   <span class="comment">// If the element has any constrained DOFs then we need</span>
<a name="l01229"></a>01229   <span class="comment">// to account for them in the mapping.  This will handle</span>
<a name="l01230"></a>01230   <span class="comment">// the case that the input vector is not constrained.</span>
<a name="l01231"></a>01231   <span class="keywordflow">if</span> (has_constrained_dofs)
<a name="l01232"></a>01232     {
<a name="l01233"></a>01233       <span class="comment">// Copy the input DOF indices.</span>
<a name="l01234"></a>01234       std::vector&lt;unsigned int&gt; constrained_dof_indices(dof_indices);
<a name="l01235"></a>01235 
<a name="l01236"></a>01236       <a class="code" href="classDenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l01237"></a>01237 
<a name="l01238"></a>01238       this-&gt;<a class="code" href="classDofMap.php#c6f698a546466fbd8a8b5ca355d54013">build_constraint_matrix</a> (C, constrained_dof_indices);
<a name="l01239"></a>01239 
<a name="l01240"></a>01240       libmesh_assert (dof_indices.size()             == C.<a class="code" href="classDenseMatrixBase.php#38c8f3c669b291931e3d26a0213ba554">m</a>());
<a name="l01241"></a>01241       libmesh_assert (constrained_dof_indices.size() == C.<a class="code" href="classDenseMatrixBase.php#9e2309c94c840b4570283c63634f11e1">n</a>());
<a name="l01242"></a>01242 
<a name="l01243"></a>01243       <span class="comment">// zero-out Ue</span>
<a name="l01244"></a>01244       Ue.<a class="code" href="classDenseVectorBase.php#e88adbbd553f5498793694254e3c6cbb">zero</a>();
<a name="l01245"></a>01245 
<a name="l01246"></a>01246       <span class="comment">// compute Ue = C Ug, with proper mapping.</span>
<a name="l01247"></a>01247       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l01248"></a>01248         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;constrained_dof_indices.size(); j++)
<a name="l01249"></a>01249           {
<a name="l01250"></a>01250             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = constrained_dof_indices[j];
<a name="l01251"></a>01251 
<a name="l01252"></a>01252             libmesh_assert ((jg &gt;= Ug.<a class="code" href="classNumericVector.php#dbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>()) &amp;&amp;
<a name="l01253"></a>01253                     (jg &lt;  Ug.<a class="code" href="classNumericVector.php#e3230edd5439110231dfe3d4f01dfe52">last_local_index</a>()));
<a name="l01254"></a>01254             
<a name="l01255"></a>01255             Ue.<a class="code" href="classDenseVectorBase.php#ab66dfa4cd02da710e367a112ac9f64f">el</a>(i) += C(i,j)*Ug(jg);      
<a name="l01256"></a>01256           }
<a name="l01257"></a>01257     }  
<a name="l01258"></a>01258    
<a name="l01259"></a>01259 <span class="preprocessor">#else</span>
<a name="l01260"></a>01260 <span class="preprocessor"></span>  
<a name="l01261"></a>01261   <span class="comment">// Trivial mapping</span>
<a name="l01262"></a>01262   libmesh_assert (dof_indices.size() == Ue.<a class="code" href="classDenseVectorBase.php#f27a452cf8a2a5ec845e040c85761572">size</a>());
<a name="l01263"></a>01263   
<a name="l01264"></a>01264   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> il=0; il&lt;dof_indices.size(); il++)
<a name="l01265"></a>01265     {
<a name="l01266"></a>01266       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = dof_indices[il];
<a name="l01267"></a>01267       
<a name="l01268"></a>01268       libmesh_assert ((ig &gt;= Ug.<a class="code" href="classNumericVector.php#dbe9067eff8c949bfdd591b4bee6b87d">first_local_index</a>()) &amp;&amp; (ig &lt;  Ug.<a class="code" href="classNumericVector.php#e3230edd5439110231dfe3d4f01dfe52">last_local_index</a>()));
<a name="l01269"></a>01269 
<a name="l01270"></a>01270       Ue.<a class="code" href="classDenseVectorBase.php#ab66dfa4cd02da710e367a112ac9f64f">el</a>(il) = Ug(ig);
<a name="l01271"></a>01271     }
<a name="l01272"></a>01272   
<a name="l01273"></a>01273 <span class="preprocessor">#endif</span>
<a name="l01274"></a>01274 <span class="preprocessor"></span>}
<a name="l01275"></a>01275 
<a name="l01276"></a>01276 
<a name="l01277"></a>01277 
<a name="l01278"></a><a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">01278</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">DofMap::dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l01279"></a>01279                           std::vector&lt;unsigned int&gt;&amp; di,
<a name="l01280"></a>01280                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn)<span class="keyword"> const</span>
<a name="l01281"></a>01281 <span class="keyword"></span>{
<a name="l01282"></a>01282   START_LOG(<span class="stringliteral">"dof_indices()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l01283"></a>01283   
<a name="l01284"></a>01284   libmesh_assert (elem != NULL);
<a name="l01285"></a>01285   
<a name="l01286"></a>01286   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#cc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l01287"></a>01287   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type        = elem-&gt;<a class="code" href="classElem.php#9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l01288"></a>01288   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>();
<a name="l01289"></a>01289   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars  = this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>();
<a name="l01290"></a>01290   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim     = elem-&gt;<a class="code" href="classElem.php#72c710c9b4ebbbdebb707e74165d9625">dim</a>();
<a name="l01291"></a>01291   
<a name="l01292"></a>01292   <span class="comment">// Clear the DOF indices vector</span>
<a name="l01293"></a>01293   di.clear();
<a name="l01294"></a>01294   
<a name="l01295"></a>01295 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01296"></a>01296 <span class="preprocessor"></span>  <span class="comment">// Check that sizes match in DEBUG mode</span>
<a name="l01297"></a>01297   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_size = 0;
<a name="l01298"></a>01298 <span class="preprocessor">#endif</span>
<a name="l01299"></a>01299 <span class="preprocessor"></span>
<a name="l01300"></a>01300   <span class="comment">// Create a vector to store the variable numbers</span>
<a name="l01301"></a>01301   <span class="comment">// of SCALAR variables that we've requested</span>
<a name="l01302"></a>01302   std::vector&lt;unsigned int&gt; SCALAR_var_numbers;
<a name="l01303"></a>01303   SCALAR_var_numbers.clear();
<a name="l01304"></a>01304 
<a name="l01305"></a>01305   <span class="comment">// Get the dof numbers</span>
<a name="l01306"></a>01306   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_vars; v++)
<a name="l01307"></a>01307     <span class="keywordflow">if</span> ((v == vn) || (vn == <a class="code" href="namespacelibMesh.php#5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>))
<a name="l01308"></a>01308     {
<a name="l01309"></a>01309       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).type().family == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01310"></a>01310       {
<a name="l01311"></a>01311         <span class="comment">// TODO: This only works in serial at the moment</span>
<a name="l01312"></a>01312         <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01313"></a>01313           libmesh_not_implemented();
<a name="l01314"></a>01314 
<a name="l01315"></a>01315         <span class="comment">// We asked for this variable, so add it to the vector.</span>
<a name="l01316"></a>01316         SCALAR_var_numbers.push_back(v);
<a name="l01317"></a>01317 
<a name="l01318"></a>01318 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01319"></a>01319 <span class="preprocessor"></span>        <a class="code" href="classFEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">variable_type</a>(v);
<a name="l01320"></a>01320         tot_size += <a class="code" href="classDofMap.php#e7db3f0773e85ababc4f9db1cfa24d3e">FEInterface::n_dofs</a>(dim,
<a name="l01321"></a>01321                                           fe_type,
<a name="l01322"></a>01322                                           type);
<a name="l01323"></a>01323 <span class="preprocessor">#endif</span>
<a name="l01324"></a>01324 <span class="preprocessor"></span>      }
<a name="l01325"></a>01325       <span class="keywordflow">else</span>
<a name="l01326"></a>01326       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).active_on_subdomain(elem-&gt;<a class="code" href="classElem.php#cc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>()))
<a name="l01327"></a>01327         { <span class="comment">// Do this for all the variables if one was not specified</span>
<a name="l01328"></a>01328           <span class="comment">// or just for the specified variable</span>
<a name="l01329"></a>01329 
<a name="l01330"></a>01330           <span class="comment">// Increase the polynomial order on p refined elements</span>
<a name="l01331"></a>01331           <a class="code" href="classFEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">variable_type</a>(v);
<a name="l01332"></a>01332           fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> +
<a name="l01333"></a>01333                                              elem-&gt;<a class="code" href="classElem.php#66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l01334"></a>01334 
<a name="l01335"></a>01335           <span class="keyword">const</span> <span class="keywordtype">bool</span> extra_hanging_dofs =
<a name="l01336"></a>01336             <a class="code" href="classFEInterface.php#3d821150f7d5a6315292b5c2117ef417">FEInterface::extra_hanging_dofs</a>(fe_type);
<a name="l01337"></a>01337 
<a name="l01338"></a>01338 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01339"></a>01339 <span class="preprocessor"></span>          tot_size += <a class="code" href="classDofMap.php#e7db3f0773e85ababc4f9db1cfa24d3e">FEInterface::n_dofs</a>(dim,
<a name="l01340"></a>01340                                           fe_type,
<a name="l01341"></a>01341                                           type);
<a name="l01342"></a>01342 <span class="preprocessor">#endif</span>
<a name="l01343"></a>01343 <span class="preprocessor"></span>        
<a name="l01344"></a>01344           <span class="comment">// Get the node-based DOF numbers</span>
<a name="l01345"></a>01345           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_nodes; n++)
<a name="l01346"></a>01346             {       
<a name="l01347"></a>01347               <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node      = elem-&gt;<a class="code" href="classElem.php#68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l01348"></a>01348             
<a name="l01349"></a>01349               <span class="comment">// There is a potential problem with h refinement.  Imagine a</span>
<a name="l01350"></a>01350               <span class="comment">// quad9 that has a linear FE on it.  Then, on the hanging side,</span>
<a name="l01351"></a>01351               <span class="comment">// it can falsely identify a DOF at the mid-edge node. This is why</span>
<a name="l01352"></a>01352               <span class="comment">// we call FEInterface instead of node-&gt;n_comp() directly.</span>
<a name="l01353"></a>01353               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classFEInterface.php#67e0d0d4c13c51f66c65ae9c2c4114c4">FEInterface::n_dofs_at_node</a> (dim,
<a name="l01354"></a>01354                                                                    fe_type,
<a name="l01355"></a>01355                                                                    type,
<a name="l01356"></a>01356                                                                    n);
<a name="l01357"></a>01357 
<a name="l01358"></a>01358               <span class="comment">// If this is a non-vertex on a hanging node with extra</span>
<a name="l01359"></a>01359               <span class="comment">// degrees of freedom, we use the non-vertex dofs (which</span>
<a name="l01360"></a>01360               <span class="comment">// come in reverse order starting from the end, to</span>
<a name="l01361"></a>01361               <span class="comment">// simplify p refinement)</span>
<a name="l01362"></a>01362               <span class="keywordflow">if</span> (extra_hanging_dofs &amp;&amp; !elem-&gt;<a class="code" href="classElem.php#fb4be0284f273d7d53cd0e994e6f1d7e">is_vertex</a>(n))
<a name="l01363"></a>01363                 {
<a name="l01364"></a>01364                   <span class="keyword">const</span> <span class="keywordtype">int</span> dof_offset = node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,v) - nc;
<a name="l01365"></a>01365 
<a name="l01366"></a>01366                   <span class="comment">// We should never have fewer dofs than necessary on a</span>
<a name="l01367"></a>01367                   <span class="comment">// node unless we're getting indices on a parent element,</span>
<a name="l01368"></a>01368                   <span class="comment">// and we should never need the indices on such a node</span>
<a name="l01369"></a>01369                   <span class="keywordflow">if</span> (dof_offset &lt; 0)
<a name="l01370"></a>01370                     {
<a name="l01371"></a>01371                       libmesh_assert(!elem-&gt;<a class="code" href="classElem.php#cb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l01372"></a>01372                       di.resize(di.size() + nc, <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01373"></a>01373                     }
<a name="l01374"></a>01374                   <span class="keywordflow">else</span>
<a name="l01375"></a>01375                     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=node-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,v)-1; i&gt;=dof_offset; i--)
<a name="l01376"></a>01376                       {
<a name="l01377"></a>01377                         libmesh_assert (node-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i) !=
<a name="l01378"></a>01378                                         <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01379"></a>01379                         di.push_back(node-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i));
<a name="l01380"></a>01380                       }
<a name="l01381"></a>01381                 }
<a name="l01382"></a>01382               <span class="comment">// If this is a vertex or an element without extra hanging</span>
<a name="l01383"></a>01383               <span class="comment">// dofs, our dofs come in forward order coming from the</span>
<a name="l01384"></a>01384               <span class="comment">// beginning</span>
<a name="l01385"></a>01385               <span class="keywordflow">else</span>
<a name="l01386"></a>01386                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01387"></a>01387                   {
<a name="l01388"></a>01388                     libmesh_assert (node-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i) !=
<a name="l01389"></a>01389                                     <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01390"></a>01390                     di.push_back(node-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i));
<a name="l01391"></a>01391                   }
<a name="l01392"></a>01392             }
<a name="l01393"></a>01393         
<a name="l01394"></a>01394           <span class="comment">// If there are any element-based DOF numbers, get them</span>
<a name="l01395"></a>01395           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classFEInterface.php#f3b7b306ff86eb750b9f5a3c2d807045">FEInterface::n_dofs_per_elem</a>(dim,
<a name="l01396"></a>01396                                                                fe_type,
<a name="l01397"></a>01397                                                                type);
<a name="l01398"></a>01398           <span class="comment">// We should never have fewer dofs than necessary on an</span>
<a name="l01399"></a>01399           <span class="comment">// element unless we're getting indices on a parent element,</span>
<a name="l01400"></a>01400           <span class="comment">// and we should never need those indices</span>
<a name="l01401"></a>01401           <span class="keywordflow">if</span> (nc != 0)
<a name="l01402"></a>01402             {
<a name="l01403"></a>01403               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#221af22104bf374c293dc59f9afb8226">n_systems</a>() &gt; sys_num &amp;&amp;
<a name="l01404"></a>01404                   nc &lt;= elem-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,v))
<a name="l01405"></a>01405                 {
<a name="l01406"></a>01406                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01407"></a>01407                     {
<a name="l01408"></a>01408                       libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i) !=
<a name="l01409"></a>01409                                       <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01410"></a>01410                     
<a name="l01411"></a>01411                       di.push_back(elem-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i));
<a name="l01412"></a>01412                     }
<a name="l01413"></a>01413                 }
<a name="l01414"></a>01414               <span class="keywordflow">else</span>
<a name="l01415"></a>01415                 {
<a name="l01416"></a>01416                   libmesh_assert(!elem-&gt;<a class="code" href="classElem.php#cb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() || fe_type.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5ee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l01417"></a>01417                   di.resize(di.size() + nc, <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01418"></a>01418                 }
<a name="l01419"></a>01419             }
<a name="l01420"></a>01420         }
<a name="l01421"></a>01421       } <span class="comment">// end loop over variables</span>
<a name="l01422"></a>01422 
<a name="l01423"></a>01423   <span class="comment">// Finally append any SCALAR dofs that we asked for.</span>
<a name="l01424"></a>01424   <span class="comment">// First we need to find out the first dof index for each</span>
<a name="l01425"></a>01425   <span class="comment">// SCALAR.</span>
<a name="l01426"></a>01426   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_SCALAR_dof_index = <a class="code" href="classDofMap.php#e7db3f0773e85ababc4f9db1cfa24d3e">n_dofs</a>() - <a class="code" href="classDofMap.php#01ce910408a9aca97a8898d11e6adce8">n_SCALAR_dofs</a>();
<a name="l01427"></a>01427   std::map&lt;unsigned int, unsigned int&gt; SCALAR_first_dof_index;
<a name="l01428"></a>01428   SCALAR_first_dof_index.clear();
<a name="l01429"></a>01429 
<a name="l01430"></a>01430   <span class="comment">// iterate over _all_ of the SCALARs and store each one's first dof index</span>
<a name="l01431"></a>01431   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_vars; v++)
<a name="l01432"></a>01432     <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).type().family == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01433"></a>01433     {
<a name="l01434"></a>01434       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_n_SCALAR_dofs = this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l01435"></a>01435       SCALAR_first_dof_index.insert(
<a name="l01436"></a>01436         std::pair&lt;unsigned int, unsigned int&gt;(v,first_SCALAR_dof_index) );
<a name="l01437"></a>01437       first_SCALAR_dof_index += current_n_SCALAR_dofs;
<a name="l01438"></a>01438     }
<a name="l01439"></a>01439 
<a name="l01440"></a>01440   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_var_numbers.size(); i++)
<a name="l01441"></a>01441   {
<a name="l01442"></a>01442     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_number = SCALAR_var_numbers[i];
<a name="l01443"></a>01443 
<a name="l01444"></a>01444     <span class="comment">// Now use current_SCALAR_var_number to index into</span>
<a name="l01445"></a>01445     <span class="comment">// SCALAR_first_dof_index</span>
<a name="l01446"></a>01446     std::map&lt;unsigned int, unsigned int&gt;::const_iterator iter =
<a name="l01447"></a>01447       SCALAR_first_dof_index.find(var_number);
<a name="l01448"></a>01448 
<a name="l01449"></a>01449 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01450"></a>01450 <span class="preprocessor"></span>    libmesh_assert(iter != SCALAR_first_dof_index.end());
<a name="l01451"></a>01451 <span class="preprocessor">#endif</span>
<a name="l01452"></a>01452 <span class="preprocessor"></span>
<a name="l01453"></a>01453     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_first_SCALAR_dof_index = iter-&gt;second;
<a name="l01454"></a>01454 
<a name="l01455"></a>01455     <span class="comment">// Also, get the number of SCALAR dofs from the variable order</span>
<a name="l01456"></a>01456     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_n_SCALAR_dofs = this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var_number).<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l01457"></a>01457 
<a name="l01458"></a>01458     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;current_n_SCALAR_dofs; j++)
<a name="l01459"></a>01459     {
<a name="l01460"></a>01460       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = current_first_SCALAR_dof_index+j;
<a name="l01461"></a>01461       di.push_back(index);
<a name="l01462"></a>01462     }
<a name="l01463"></a>01463   }
<a name="l01464"></a>01464 
<a name="l01465"></a>01465 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01466"></a>01466 <span class="preprocessor"></span>  libmesh_assert (tot_size == di.size());
<a name="l01467"></a>01467 <span class="preprocessor">#endif</span>
<a name="l01468"></a>01468 <span class="preprocessor"></span>  
<a name="l01469"></a>01469   STOP_LOG(<span class="stringliteral">"dof_indices()"</span>, <span class="stringliteral">"DofMap"</span>);  
<a name="l01470"></a>01470 }
<a name="l01471"></a>01471  
<a name="l01472"></a>01472 
<a name="l01473"></a>01473 
<a name="l01474"></a>01474 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01475"></a>01475 <span class="preprocessor"></span>
<a name="l01476"></a><a class="code" href="classDofMap.php#36e8bfaebc24fb9ac8919e5fc1e6f687">01476</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#36e8bfaebc24fb9ac8919e5fc1e6f687">DofMap::old_dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l01477"></a>01477                               std::vector&lt;unsigned int&gt;&amp; di,
<a name="l01478"></a>01478                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn)<span class="keyword"> const</span>
<a name="l01479"></a>01479 <span class="keyword"></span>{
<a name="l01480"></a>01480   START_LOG(<span class="stringliteral">"old_dof_indices()"</span>, <span class="stringliteral">"DofMap"</span>);
<a name="l01481"></a>01481   
<a name="l01482"></a>01482   libmesh_assert (elem != NULL);
<a name="l01483"></a>01483   libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a> != NULL);
<a name="l01484"></a>01484             
<a name="l01485"></a>01485 
<a name="l01486"></a>01486   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#cc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = elem-&gt;<a class="code" href="classElem.php#60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l01487"></a>01487   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type        = elem-&gt;<a class="code" href="classElem.php#9700699e6d71d5b50ab11b72bfdb2f02">type</a>();
<a name="l01488"></a>01488   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classDofMap.php#ec0a44994fb968a2104423cca68ff500">sys_number</a>();
<a name="l01489"></a>01489   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vars  = this-&gt;<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>();
<a name="l01490"></a>01490   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim     = elem-&gt;<a class="code" href="classElem.php#72c710c9b4ebbbdebb707e74165d9625">dim</a>();
<a name="l01491"></a>01491   
<a name="l01492"></a>01492   <span class="comment">// Clear the DOF indices vector.</span>
<a name="l01493"></a>01493   di.clear();
<a name="l01494"></a>01494 
<a name="l01495"></a>01495 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01496"></a>01496 <span class="preprocessor"></span>  <span class="comment">// Check that sizes match</span>
<a name="l01497"></a>01497   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_size = 0;
<a name="l01498"></a>01498 <span class="preprocessor">#endif</span>
<a name="l01499"></a>01499 <span class="preprocessor"></span>
<a name="l01500"></a>01500   <span class="comment">// Create a vector to store the variable numbers</span>
<a name="l01501"></a>01501   <span class="comment">// of SCALAR variables that we've requested</span>
<a name="l01502"></a>01502   std::vector&lt;unsigned int&gt; SCALAR_var_numbers;
<a name="l01503"></a>01503   SCALAR_var_numbers.clear();
<a name="l01504"></a>01504   
<a name="l01505"></a>01505   <span class="comment">// Get the dof numbers</span>
<a name="l01506"></a>01506   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_vars; v++)
<a name="l01507"></a>01507     <span class="keywordflow">if</span> ((v == vn) || (vn == <a class="code" href="namespacelibMesh.php#5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>))
<a name="l01508"></a>01508     {
<a name="l01509"></a>01509       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).type().family == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01510"></a>01510         {
<a name="l01511"></a>01511           <span class="comment">// TODO: This only works in serial at the moment</span>
<a name="l01512"></a>01512           <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#d3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01513"></a>01513             libmesh_not_implemented();
<a name="l01514"></a>01514 
<a name="l01515"></a>01515           <span class="comment">// We asked for this variable, so add it to the vector.</span>
<a name="l01516"></a>01516           SCALAR_var_numbers.push_back(v);
<a name="l01517"></a>01517 
<a name="l01518"></a>01518 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01519"></a>01519 <span class="preprocessor"></span>          <a class="code" href="classFEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">variable_type</a>(v);
<a name="l01520"></a>01520           tot_size += <a class="code" href="classDofMap.php#e7db3f0773e85ababc4f9db1cfa24d3e">FEInterface::n_dofs</a>(dim,
<a name="l01521"></a>01521                                           fe_type,
<a name="l01522"></a>01522                                           type);
<a name="l01523"></a>01523 <span class="preprocessor">#endif</span>
<a name="l01524"></a>01524 <span class="preprocessor"></span>        }
<a name="l01525"></a>01525       <span class="keywordflow">else</span>
<a name="l01526"></a>01526       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).active_on_subdomain(elem-&gt;<a class="code" href="classElem.php#cc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>()))
<a name="l01527"></a>01527         { <span class="comment">// Do this for all the variables if one was not specified</span>
<a name="l01528"></a>01528           <span class="comment">// or just for the specified variable</span>
<a name="l01529"></a>01529         
<a name="l01530"></a>01530           <span class="comment">// Increase the polynomial order on p refined elements,</span>
<a name="l01531"></a>01531           <span class="comment">// but make sure you get the right polynomial order for</span>
<a name="l01532"></a>01532           <span class="comment">// the OLD degrees of freedom</span>
<a name="l01533"></a>01533           <span class="keywordtype">int</span> p_adjustment = 0;
<a name="l01534"></a>01534           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#946039859488cca879512de516fef82928fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>)
<a name="l01535"></a>01535             {
<a name="l01536"></a>01536               libmesh_assert (elem-&gt;<a class="code" href="classElem.php#66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &gt; 0);
<a name="l01537"></a>01537               p_adjustment = -1;
<a name="l01538"></a>01538             }
<a name="l01539"></a>01539           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#946039859488cca879512de516fef829d2c57c7a107071f8229a64a5af22202f">Elem::JUST_COARSENED</a>)
<a name="l01540"></a>01540             {
<a name="l01541"></a>01541               p_adjustment = 1;
<a name="l01542"></a>01542             }
<a name="l01543"></a>01543           <a class="code" href="classFEType.php">FEType</a> fe_type = this-&gt;<a class="code" href="classDofMap.php#e3c63266417020f38af6e5cc40efca76">variable_type</a>(v);
<a name="l01544"></a>01544           fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#ec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a> +
<a name="l01545"></a>01545                                              elem-&gt;<a class="code" href="classElem.php#66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() +
<a name="l01546"></a>01546                                              p_adjustment);
<a name="l01547"></a>01547 
<a name="l01548"></a>01548           <span class="keyword">const</span> <span class="keywordtype">bool</span> extra_hanging_dofs =
<a name="l01549"></a>01549             <a class="code" href="classFEInterface.php#3d821150f7d5a6315292b5c2117ef417">FEInterface::extra_hanging_dofs</a>(fe_type);
<a name="l01550"></a>01550 
<a name="l01551"></a>01551 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01552"></a>01552 <span class="preprocessor"></span>          tot_size += <a class="code" href="classDofMap.php#e7db3f0773e85ababc4f9db1cfa24d3e">FEInterface::n_dofs</a>(dim,
<a name="l01553"></a>01553                                           fe_type,
<a name="l01554"></a>01554                                           type);
<a name="l01555"></a>01555 <span class="preprocessor">#endif</span>
<a name="l01556"></a>01556 <span class="preprocessor"></span>        
<a name="l01557"></a>01557           <span class="comment">// Get the node-based DOF numbers</span>
<a name="l01558"></a>01558           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_nodes; n++)
<a name="l01559"></a>01559             {
<a name="l01560"></a>01560               <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node      = elem-&gt;<a class="code" href="classElem.php#68359ea98eafc947ea5af014bdea03fb">get_node</a>(n);
<a name="l01561"></a>01561             
<a name="l01562"></a>01562               <span class="comment">// There is a potential problem with h refinement.  Imagine a</span>
<a name="l01563"></a>01563               <span class="comment">// quad9 that has a linear FE on it.  Then, on the hanging side,</span>
<a name="l01564"></a>01564               <span class="comment">// it can falsely identify a DOF at the mid-edge node. This is why</span>
<a name="l01565"></a>01565               <span class="comment">// we call FEInterface instead of node-&gt;n_comp() directly.</span>
<a name="l01566"></a>01566               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classFEInterface.php#67e0d0d4c13c51f66c65ae9c2c4114c4">FEInterface::n_dofs_at_node</a> (dim,
<a name="l01567"></a>01567                                                                    fe_type,
<a name="l01568"></a>01568                                                                    type,
<a name="l01569"></a>01569                                                                    n);
<a name="l01570"></a>01570               libmesh_assert (node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a> != NULL);
<a name="l01571"></a>01571             
<a name="l01572"></a>01572               <span class="comment">// If this is a non-vertex on a hanging node with extra</span>
<a name="l01573"></a>01573               <span class="comment">// degrees of freedom, we use the non-vertex dofs (which</span>
<a name="l01574"></a>01574               <span class="comment">// come in reverse order starting from the end, to</span>
<a name="l01575"></a>01575               <span class="comment">// simplify p refinement)</span>
<a name="l01576"></a>01576               <span class="keywordflow">if</span> (extra_hanging_dofs &amp;&amp; !elem-&gt;<a class="code" href="classElem.php#fb4be0284f273d7d53cd0e994e6f1d7e">is_vertex</a>(n))
<a name="l01577"></a>01577                 {
<a name="l01578"></a>01578                   <span class="keyword">const</span> <span class="keywordtype">int</span> dof_offset = 
<a name="l01579"></a>01579                     node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,v) - nc;
<a name="l01580"></a>01580             
<a name="l01581"></a>01581                   <span class="comment">// We should never have fewer dofs than necessary on a</span>
<a name="l01582"></a>01582                   <span class="comment">// node unless we're getting indices on a parent element</span>
<a name="l01583"></a>01583                   <span class="comment">// or a just-coarsened element</span>
<a name="l01584"></a>01584                   <span class="keywordflow">if</span> (dof_offset &lt; 0)
<a name="l01585"></a>01585                     {
<a name="l01586"></a>01586                       libmesh_assert(!elem-&gt;<a class="code" href="classElem.php#cb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() || elem-&gt;<a class="code" href="classElem.php#563d04d228653b467b919b2346d64ad4">refinement_flag</a>() ==
<a name="l01587"></a>01587                                      <a class="code" href="classElem.php#946039859488cca879512de516fef829d2c57c7a107071f8229a64a5af22202f">Elem::JUST_COARSENED</a>);
<a name="l01588"></a>01588                       di.resize(di.size() + nc, <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01589"></a>01589                     }
<a name="l01590"></a>01590                   <span class="keywordflow">else</span>
<a name="l01591"></a>01591                     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,v)-1;
<a name="l01592"></a>01592                          i&gt;=dof_offset; i--)
<a name="l01593"></a>01593                       {
<a name="l01594"></a>01594                         libmesh_assert (node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i) !=
<a name="l01595"></a>01595                                         <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01596"></a>01596                         di.push_back(node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i));
<a name="l01597"></a>01597                       }
<a name="l01598"></a>01598                 }
<a name="l01599"></a>01599               <span class="comment">// If this is a vertex or an element without extra hanging</span>
<a name="l01600"></a>01600               <span class="comment">// dofs, our dofs come in forward order coming from the</span>
<a name="l01601"></a>01601               <span class="comment">// beginning</span>
<a name="l01602"></a>01602               <span class="keywordflow">else</span>
<a name="l01603"></a>01603                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01604"></a>01604                   {
<a name="l01605"></a>01605                     libmesh_assert (node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i) !=
<a name="l01606"></a>01606                                     <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01607"></a>01607                     di.push_back(node-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i));
<a name="l01608"></a>01608                   }
<a name="l01609"></a>01609             }
<a name="l01610"></a>01610         
<a name="l01611"></a>01611           <span class="comment">// If there are any element-based DOF numbers, get them</span>
<a name="l01612"></a>01612           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = <a class="code" href="classFEInterface.php#f3b7b306ff86eb750b9f5a3c2d807045">FEInterface::n_dofs_per_elem</a>(dim,
<a name="l01613"></a>01613                                                                fe_type,
<a name="l01614"></a>01614                                                                type);
<a name="l01615"></a>01615 
<a name="l01616"></a>01616           <span class="comment">// We should never have fewer dofs than necessary on an</span>
<a name="l01617"></a>01617           <span class="comment">// element unless we're getting indices on a parent element</span>
<a name="l01618"></a>01618           <span class="comment">// or a just-coarsened element</span>
<a name="l01619"></a>01619           <span class="keywordflow">if</span> (nc != 0)
<a name="l01620"></a>01620             {
<a name="l01621"></a>01621               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#221af22104bf374c293dc59f9afb8226">n_systems</a>() &gt; sys_num &amp;&amp;
<a name="l01622"></a>01622                   nc &lt;= elem-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#9388a06483961ab49a5da79e476bd255">n_comp</a>(sys_num,v))
<a name="l01623"></a>01623                 {
<a name="l01624"></a>01624                   libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a> != NULL);
<a name="l01625"></a>01625                 
<a name="l01626"></a>01626                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nc; i++)
<a name="l01627"></a>01627                     {
<a name="l01628"></a>01628                       libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i) !=
<a name="l01629"></a>01629                                       <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01630"></a>01630                     
<a name="l01631"></a>01631                       di.push_back(elem-&gt;<a class="code" href="classDofObject.php#d56c44a9df5498f7816988dc1e3445e0">old_dof_object</a>-&gt;<a class="code" href="classDofObject.php#7a6fadd50e52b87f098acfd4c833087f">dof_number</a>(sys_num,v,i));
<a name="l01632"></a>01632                     }
<a name="l01633"></a>01633                 }
<a name="l01634"></a>01634               <span class="keywordflow">else</span>
<a name="l01635"></a>01635                 {
<a name="l01636"></a>01636                   libmesh_assert(!elem-&gt;<a class="code" href="classElem.php#cb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() || fe_type.<a class="code" href="classFEType.php#22c439dc134e1ba4695d39368fc55e99">family</a> == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d5ee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> ||
<a name="l01637"></a>01637                                  elem-&gt;<a class="code" href="classElem.php#563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#946039859488cca879512de516fef829d2c57c7a107071f8229a64a5af22202f">Elem::JUST_COARSENED</a>);
<a name="l01638"></a>01638                   di.resize(di.size() + nc, <a class="code" href="classDofObject.php#35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>);
<a name="l01639"></a>01639                 }
<a name="l01640"></a>01640             }
<a name="l01641"></a>01641         }
<a name="l01642"></a>01642     } <span class="comment">// end loop over variables</span>
<a name="l01643"></a>01643 
<a name="l01644"></a>01644   <span class="comment">// Finally append any SCALAR dofs that we asked for.</span>
<a name="l01645"></a>01645   <span class="comment">// First we need to find out the first dof index for each</span>
<a name="l01646"></a>01646   <span class="comment">// SCALAR.</span>
<a name="l01647"></a>01647   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_SCALAR_dof_index = <a class="code" href="classDofMap.php#17f186f2dad6ab7bf0bf88f148149b06">n_old_dofs</a>() - <a class="code" href="classDofMap.php#01ce910408a9aca97a8898d11e6adce8">n_SCALAR_dofs</a>();
<a name="l01648"></a>01648   std::map&lt;unsigned int, unsigned int&gt; SCALAR_first_dof_index;
<a name="l01649"></a>01649   SCALAR_first_dof_index.clear();
<a name="l01650"></a>01650 
<a name="l01651"></a>01651   <span class="comment">// iterate over _all_ of the SCALARs and store each one's first dof index</span>
<a name="l01652"></a>01652   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_vars; v++)
<a name="l01653"></a>01653     <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).type().family == <a class="code" href="namespacelibMeshEnums.php#6438eaaa28d7dbe2aa2f19e9de2ef0d52ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01654"></a>01654     {
<a name="l01655"></a>01655       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_n_SCALAR_dofs = this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(v).<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l01656"></a>01656       SCALAR_first_dof_index.insert(
<a name="l01657"></a>01657         std::pair&lt;unsigned int, unsigned int&gt;(v,first_SCALAR_dof_index) );
<a name="l01658"></a>01658       first_SCALAR_dof_index += current_n_SCALAR_dofs;
<a name="l01659"></a>01659     }
<a name="l01660"></a>01660 
<a name="l01661"></a>01661   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_var_numbers.size(); i++)
<a name="l01662"></a>01662   {
<a name="l01663"></a>01663     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_number = SCALAR_var_numbers[i];
<a name="l01664"></a>01664 
<a name="l01665"></a>01665     <span class="comment">// Now use current_SCALAR_var_number to index into</span>
<a name="l01666"></a>01666     <span class="comment">// SCALAR_first_dof_index</span>
<a name="l01667"></a>01667     std::map&lt;unsigned int, unsigned int&gt;::const_iterator iter =
<a name="l01668"></a>01668       SCALAR_first_dof_index.find(var_number);
<a name="l01669"></a>01669 
<a name="l01670"></a>01670 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01671"></a>01671 <span class="preprocessor"></span>    libmesh_assert(iter != SCALAR_first_dof_index.end());
<a name="l01672"></a>01672 <span class="preprocessor">#endif</span>
<a name="l01673"></a>01673 <span class="preprocessor"></span>
<a name="l01674"></a>01674     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_first_SCALAR_dof_index = iter-&gt;second;
<a name="l01675"></a>01675 
<a name="l01676"></a>01676     <span class="comment">// Also, get the number of SCALAR dofs from the variable order</span>
<a name="l01677"></a>01677     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_n_SCALAR_dofs = this-&gt;<a class="code" href="classDofMap.php#77e4bce38abc337921ce8a0d4ee9460d">variable</a>(var_number).<a class="code" href="classSystem_1_1Variable.php#bcdad7a16d98f5884d82583452eccb80">type</a>().<a class="code" href="classFEType.php#72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l01678"></a>01678 
<a name="l01679"></a>01679     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;current_n_SCALAR_dofs; j++)
<a name="l01680"></a>01680     {
<a name="l01681"></a>01681       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = current_first_SCALAR_dof_index+j;
<a name="l01682"></a>01682       di.push_back(index);
<a name="l01683"></a>01683     }
<a name="l01684"></a>01684   }
<a name="l01685"></a>01685   
<a name="l01686"></a>01686 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01687"></a>01687 <span class="preprocessor"></span>  libmesh_assert (tot_size == di.size());
<a name="l01688"></a>01688 <span class="preprocessor">#endif</span>
<a name="l01689"></a>01689 <span class="preprocessor"></span>  
<a name="l01690"></a>01690   STOP_LOG(<span class="stringliteral">"old_dof_indices()"</span>, <span class="stringliteral">"DofMap"</span>);  
<a name="l01691"></a>01691 }
<a name="l01692"></a>01692 
<a name="l01693"></a>01693 
<a name="l01694"></a>01694 
<a name="l01695"></a>01695 <span class="comment">/*</span>
<a name="l01696"></a>01696 <span class="comment">void DofMap::augment_send_list_for_projection(const MeshBase&amp; mesh)</span>
<a name="l01697"></a>01697 <span class="comment">{</span>
<a name="l01698"></a>01698 <span class="comment">  // Loop over the active local elements in the mesh.</span>
<a name="l01699"></a>01699 <span class="comment">  // If the element was just refined and its parent lives</span>
<a name="l01700"></a>01700 <span class="comment">  // on a different processor then we need to augment the</span>
<a name="l01701"></a>01701 <span class="comment">  // _send_list with the parent's DOF indices so that we</span>
<a name="l01702"></a>01702 <span class="comment">  // can access the parent's data for computing solution</span>
<a name="l01703"></a>01703 <span class="comment">  // projections, etc...</span>
<a name="l01704"></a>01704 <span class="comment"></span>
<a name="l01705"></a>01705 <span class="comment">  // The DOF indices for the parent</span>
<a name="l01706"></a>01706 <span class="comment">  std::vector&lt;unsigned int&gt; di;</span>
<a name="l01707"></a>01707 <span class="comment"></span>
<a name="l01708"></a>01708 <span class="comment">  // Flag telling us if we need to re-sort the send_list.</span>
<a name="l01709"></a>01709 <span class="comment">  // Note we won't need to re-sort unless a child with a</span>
<a name="l01710"></a>01710 <span class="comment">  // parent belonging to a different processor is found</span>
<a name="l01711"></a>01711 <span class="comment">  bool needs_sorting = false;</span>
<a name="l01712"></a>01712 <span class="comment">  </span>
<a name="l01713"></a>01713 <span class="comment">  </span>
<a name="l01714"></a>01714 <span class="comment">  MeshBase::const_element_iterator       elem_it  = mesh.active_local_elements_begin();</span>
<a name="l01715"></a>01715 <span class="comment">  const MeshBase::const_element_iterator elem_end = mesh.active_local_elements_end(); </span>
<a name="l01716"></a>01716 <span class="comment"></span>
<a name="l01717"></a>01717 <span class="comment">  for ( ; elem_it != elem_end; ++elem_it)</span>
<a name="l01718"></a>01718 <span class="comment">    {</span>
<a name="l01719"></a>01719 <span class="comment">      const Elem* const elem   = *elem_it;</span>
<a name="l01720"></a>01720 <span class="comment"></span>
<a name="l01721"></a>01721 <span class="comment">      // We only need to consider the children that</span>
<a name="l01722"></a>01722 <span class="comment">      // were just refined</span>
<a name="l01723"></a>01723 <span class="comment">      if (elem-&gt;refinement_flag() != Elem::JUST_REFINED) continue;</span>
<a name="l01724"></a>01724 <span class="comment">      </span>
<a name="l01725"></a>01725 <span class="comment">      const Elem* const parent = elem-&gt;parent();</span>
<a name="l01726"></a>01726 <span class="comment"></span>
<a name="l01727"></a>01727 <span class="comment">      // If the parent lives on another processor</span>
<a name="l01728"></a>01728 <span class="comment">      // than the child</span>
<a name="l01729"></a>01729 <span class="comment">      if (parent != NULL)</span>
<a name="l01730"></a>01730 <span class="comment">        if (parent-&gt;processor_id() != elem-&gt;processor_id())</span>
<a name="l01731"></a>01731 <span class="comment">          {</span>
<a name="l01732"></a>01732 <span class="comment">            // Get the DOF indices for the parent</span>
<a name="l01733"></a>01733 <span class="comment">            this-&gt;dof_indices (parent, di);</span>
<a name="l01734"></a>01734 <span class="comment"></span>
<a name="l01735"></a>01735 <span class="comment">            // Insert the DOF indices into the send list</span>
<a name="l01736"></a>01736 <span class="comment">            _send_list.insert (_send_list.end(),</span>
<a name="l01737"></a>01737 <span class="comment">                               di.begin(), di.end());</span>
<a name="l01738"></a>01738 <span class="comment"></span>
<a name="l01739"></a>01739 <span class="comment">            // We will need to re-sort the send list</span>
<a name="l01740"></a>01740 <span class="comment">            needs_sorting = true;           </span>
<a name="l01741"></a>01741 <span class="comment">          }</span>
<a name="l01742"></a>01742 <span class="comment">    }</span>
<a name="l01743"></a>01743 <span class="comment"></span>
<a name="l01744"></a>01744 <span class="comment">  // The send-list might need to be sorted again.</span>
<a name="l01745"></a>01745 <span class="comment">  if (needs_sorting) this-&gt;sort_send_list ();</span>
<a name="l01746"></a>01746 <span class="comment">}</span>
<a name="l01747"></a>01747 <span class="comment">*/</span>
<a name="l01748"></a>01748 
<a name="l01749"></a>01749 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l01750"></a>01750 <span class="preprocessor"></span>
<a name="l01751"></a>01751 
<a name="l01752"></a>01752 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l01753"></a>01753 <span class="preprocessor"></span>
<a name="l01754"></a><a class="code" href="classDofMap.php#7020b9e29c89828384a6480f07eadd43">01754</a> <span class="keywordtype">void</span> <a class="code" href="classDofMap.php#7020b9e29c89828384a6480f07eadd43">DofMap::find_connected_dofs</a> (std::vector&lt;unsigned int&gt;&amp; elem_dofs)<span class="keyword"> const</span>
<a name="l01755"></a>01755 <span class="keyword"></span>{
<a name="l01756"></a>01756   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l01757"></a>01757 
<a name="l01758"></a>01758   <span class="comment">// First insert the DOFS we already depend on into the set.  </span>
<a name="l01759"></a>01759   RCSet dof_set (elem_dofs.begin(), elem_dofs.end());
<a name="l01760"></a>01760 
<a name="l01761"></a>01761   <span class="keywordtype">bool</span> done = <span class="keyword">true</span>;
<a name="l01762"></a>01762     
<a name="l01763"></a>01763   <span class="comment">// Next insert any dofs those might be constrained in terms</span>
<a name="l01764"></a>01764   <span class="comment">// of.  Note that in this case we may not be done:  Those may</span>
<a name="l01765"></a>01765   <span class="comment">// in turn depend on others.  So, we need to repeat this process</span>
<a name="l01766"></a>01766   <span class="comment">// in that case until the system depends only on unconstrained</span>
<a name="l01767"></a>01767   <span class="comment">// degrees of freedom.</span>
<a name="l01768"></a>01768   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l01769"></a>01769     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classDofMap.php#923a6811ca54a01cc1e6dee8570a281f">is_constrained_dof</a>(elem_dofs[i]))
<a name="l01770"></a>01770       {
<a name="l01771"></a>01771         <span class="comment">// If the DOF is constrained</span>
<a name="l01772"></a>01772         DofConstraints::const_iterator
<a name="l01773"></a>01773           pos = <a class="code" href="classDofMap.php#f301f7e968260dd826d4479a1a8884e8">_dof_constraints</a>.find(elem_dofs[i]);
<a name="l01774"></a>01774         
<a name="l01775"></a>01775         libmesh_assert (pos != <a class="code" href="classDofMap.php#f301f7e968260dd826d4479a1a8884e8">_dof_constraints</a>.end());
<a name="l01776"></a>01776         
<a name="l01777"></a>01777         <span class="keyword">const</span> <a class="code" href="dof__map_8h.php#553e286d6e25f03a15b1c300bc373791">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l01778"></a>01778         
<a name="l01779"></a>01779 <span class="comment">// adaptive p refinement currently gives us lots of empty constraint</span>
<a name="l01780"></a>01780 <span class="comment">// rows - we should optimize those DoFs away in the future.  [RHS]</span>
<a name="l01781"></a>01781 <span class="comment">//      libmesh_assert (!constraint_row.empty());</span>
<a name="l01782"></a>01782         
<a name="l01783"></a>01783         DofConstraintRow::const_iterator it     = constraint_row.begin();
<a name="l01784"></a>01784         DofConstraintRow::const_iterator it_end = constraint_row.end();
<a name="l01785"></a>01785         
<a name="l01786"></a>01786         
<a name="l01787"></a>01787         <span class="comment">// Add the DOFs this dof is constrained in terms of.</span>
<a name="l01788"></a>01788         <span class="comment">// note that these dofs might also be constrained, so</span>
<a name="l01789"></a>01789         <span class="comment">// we will need to call this function recursively.</span>
<a name="l01790"></a>01790         <span class="keywordflow">for</span> ( ; it != it_end; ++it)
<a name="l01791"></a>01791           <span class="keywordflow">if</span> (!dof_set.count (it-&gt;first))
<a name="l01792"></a>01792             {
<a name="l01793"></a>01793               dof_set.insert (it-&gt;first);
<a name="l01794"></a>01794               done = <span class="keyword">false</span>;
<a name="l01795"></a>01795             }
<a name="l01796"></a>01796         }
<a name="l01797"></a>01797   
<a name="l01798"></a>01798   
<a name="l01799"></a>01799   <span class="comment">// If not done then we need to do more work</span>
<a name="l01800"></a>01800   <span class="comment">// (obviously :-) )!</span>
<a name="l01801"></a>01801   <span class="keywordflow">if</span> (!done)
<a name="l01802"></a>01802     {
<a name="l01803"></a>01803       <span class="comment">// Fill the vector with the contents of the set</span>
<a name="l01804"></a>01804       elem_dofs.clear();      
<a name="l01805"></a>01805       elem_dofs.insert (elem_dofs.end(),
<a name="l01806"></a>01806                         dof_set.begin(), dof_set.end());
<a name="l01807"></a>01807       
<a name="l01808"></a>01808 
<a name="l01809"></a>01809       <span class="comment">// May need to do this recursively.  It is possible</span>
<a name="l01810"></a>01810       <span class="comment">// that we just replaced a constrained DOF with another</span>
<a name="l01811"></a>01811       <span class="comment">// constrained DOF.</span>
<a name="l01812"></a>01812       this-&gt;<a class="code" href="classDofMap.php#7020b9e29c89828384a6480f07eadd43">find_connected_dofs</a> (elem_dofs);
<a name="l01813"></a>01813       
<a name="l01814"></a>01814     } <span class="comment">// end if (!done)</span>
<a name="l01815"></a>01815 }
<a name="l01816"></a>01816 
<a name="l01817"></a>01817 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l01818"></a>01818 <span class="preprocessor"></span>
<a name="l01819"></a>01819 
<a name="l01820"></a>01820 
<a name="l01821"></a>01821 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l01822"></a>01822 <span class="preprocessor"></span>
<a name="l01823"></a><a class="code" href="namespaceSparsityPattern.php#853789831aeb290de9ca4a4a33c71ea9">01823</a> <span class="keywordtype">void</span> <a class="code" href="namespaceSparsityPattern.php#853789831aeb290de9ca4a4a33c71ea9">SparsityPattern::_dummy_function</a>(<span class="keywordtype">void</span>)
<a name="l01824"></a>01824 {
<a name="l01825"></a>01825 }
<a name="l01826"></a>01826 
<a name="l01827"></a>01827 <span class="preprocessor">#endif</span>
<a name="l01828"></a>01828 <span class="preprocessor"></span>
<a name="l01829"></a>01829 
<a name="l01830"></a>01830 
<a name="l01831"></a><a class="code" href="classSparsityPattern_1_1Build.php#b923b00f57240c48fa6171f762e92f47">01831</a> <span class="keywordtype">void</span> <a class="code" href="classSparsityPattern_1_1Build.php#b923b00f57240c48fa6171f762e92f47">SparsityPattern::Build::operator()</a>(<span class="keyword">const</span> <a class="code" href="classStoredRange.php">ConstElemRange</a> &amp;range)
<a name="l01832"></a>01832 {
<a name="l01833"></a>01833   <span class="comment">// Compute the sparsity structure of the global matrix.  This can be</span>
<a name="l01834"></a>01834   <span class="comment">// fed into a PetscMatrix to allocate exacly the number of nonzeros</span>
<a name="l01835"></a>01835   <span class="comment">// necessary to store the matrix.  This algorithm should be linear</span>
<a name="l01836"></a>01836   <span class="comment">// in the (# of elements)*(# nodes per element)</span>
<a name="l01837"></a>01837   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id           = <a class="code" href="classSparsityPattern_1_1Build.php#8dfe00458fdffa32b6461df05b7b4f16">mesh</a>.<a class="code" href="classMeshBase.php#ba369b64ee6185d86a6b60089ba5af60">processor_id</a>();
<a name="l01838"></a>01838   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_proc    = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#9c7492c5d5f1eacd327f0c902590eda7">n_dofs_on_processor</a>(proc_id);
<a name="l01839"></a>01839   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_dof_on_proc = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a>(proc_id);
<a name="l01840"></a>01840   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> end_dof_on_proc   = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#b838f2e72aaf8614c97fcd47a13781b8">end_dof</a>(proc_id);
<a name="l01841"></a>01841 
<a name="l01842"></a>01842   <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.resize(n_dofs_on_proc);
<a name="l01843"></a>01843   
<a name="l01844"></a>01844   <span class="comment">// If the user did not explicitly specify the DOF coupling</span>
<a name="l01845"></a>01845   <span class="comment">// then all the DOFS are coupled to each other.  Furthermore,</span>
<a name="l01846"></a>01846   <span class="comment">// we can take a shortcut and do this more quickly here.  So</span>
<a name="l01847"></a>01847   <span class="comment">// we use an if-test.</span>
<a name="l01848"></a>01848   <span class="keywordflow">if</span> ((<a class="code" href="classSparsityPattern_1_1Build.php#ccbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a> == NULL) || (<a class="code" href="classSparsityPattern_1_1Build.php#ccbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a>-&gt;<a class="code" href="classCouplingMatrix.php#ed22bc105cd6bd1925ebbdc1e833848e">empty</a>()))
<a name="l01849"></a>01849     {
<a name="l01850"></a>01850       std::vector&lt;unsigned int&gt;
<a name="l01851"></a>01851         element_dofs,
<a name="l01852"></a>01852         neighbor_dofs,
<a name="l01853"></a>01853         dofs_to_add;
<a name="l01854"></a>01854 
<a name="l01855"></a>01855       std::vector&lt;const Elem*&gt; active_neighbors;
<a name="l01856"></a>01856 
<a name="l01857"></a>01857       <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#b2657352e8f9c79ab6fa4085c0bdd0d8">ConstElemRange::const_iterator</a> elem_it = range.<a class="code" href="classStoredRange.php#5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>() ; elem_it != range.<a class="code" href="classStoredRange.php#bc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++elem_it)
<a name="l01858"></a>01858         {
<a name="l01859"></a>01859           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem = *elem_it;
<a name="l01860"></a>01860 
<a name="l01861"></a>01861           <span class="comment">// Get the global indices of the DOFs with support on this element</span>
<a name="l01862"></a>01862           <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, element_dofs);
<a name="l01863"></a>01863 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l01864"></a>01864 <span class="preprocessor"></span>          <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#7020b9e29c89828384a6480f07eadd43">find_connected_dofs</a> (element_dofs);
<a name="l01865"></a>01865 <span class="preprocessor">#endif</span>
<a name="l01866"></a>01866 <span class="preprocessor"></span>
<a name="l01867"></a>01867           <span class="comment">// We can be more efficient if we sort the element DOFs</span>
<a name="l01868"></a>01868           <span class="comment">// into increasing order</span>
<a name="l01869"></a>01869           std::sort(element_dofs.begin(), element_dofs.end());
<a name="l01870"></a>01870           
<a name="l01871"></a>01871           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_element = element_dofs.size();
<a name="l01872"></a>01872             
<a name="l01873"></a>01873           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_on_element; i++)
<a name="l01874"></a>01874             {
<a name="l01875"></a>01875               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = element_dofs[i];
<a name="l01876"></a>01876               
<a name="l01877"></a>01877               <span class="comment">// Only bother if this matrix row will be stored</span>
<a name="l01878"></a>01878               <span class="comment">// on this processor.</span>
<a name="l01879"></a>01879               <span class="keywordflow">if</span> ((ig &gt;= first_dof_on_proc) &amp;&amp;
<a name="l01880"></a>01880                   (ig &lt;  end_dof_on_proc))
<a name="l01881"></a>01881                 {
<a name="l01882"></a>01882                   <span class="comment">// This is what I mean</span>
<a name="l01883"></a>01883                   <span class="comment">// libmesh_assert ((ig - first_dof_on_proc) &gt;= 0);</span>
<a name="l01884"></a>01884                   <span class="comment">// but do the test like this because ig and</span>
<a name="l01885"></a>01885                   <span class="comment">// first_dof_on_proc are unsigned ints</span>
<a name="l01886"></a>01886                   libmesh_assert (ig &gt;= first_dof_on_proc);
<a name="l01887"></a>01887                   libmesh_assert ((ig - first_dof_on_proc) &lt; <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.size());
<a name="l01888"></a>01888                   
<a name="l01889"></a>01889                   <a class="code" href="namespaceSparsityPattern.php#380dc3cd41bc4aab23a1c916181104b3">SparsityPattern::Row</a> &amp;row = <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>[ig - first_dof_on_proc];
<a name="l01890"></a>01890 
<a name="l01891"></a>01891                   <span class="comment">// If the row is empty we will add *all* the element DOFs,</span>
<a name="l01892"></a>01892                   <span class="comment">// so just do that.</span>
<a name="l01893"></a>01893                   <span class="keywordflow">if</span> (row.empty())
<a name="l01894"></a>01894                     {
<a name="l01895"></a>01895                       row.insert(row.end(),
<a name="l01896"></a>01896                                  element_dofs.begin(),
<a name="l01897"></a>01897                                  element_dofs.end());
<a name="l01898"></a>01898                     }
<a name="l01899"></a>01899                   <span class="keywordflow">else</span>
<a name="l01900"></a>01900                     {             
<a name="l01901"></a>01901                       <span class="comment">// Build a list of the DOF indices not found in the</span>
<a name="l01902"></a>01902                       <span class="comment">// sparsity pattern</span>
<a name="l01903"></a>01903                       dofs_to_add.clear();
<a name="l01904"></a>01904 
<a name="l01905"></a>01905                       <span class="comment">// Cache iterators.  Low will move forward, subsequent</span>
<a name="l01906"></a>01906                       <span class="comment">// searches will be on smaller ranges</span>
<a name="l01907"></a>01907                       SparsityPattern::Row::iterator
<a name="l01908"></a>01908                         low  = std::lower_bound (row.begin(), row.end(), element_dofs.front()),
<a name="l01909"></a>01909                         high = std::upper_bound (low,         row.end(), element_dofs.back());
<a name="l01910"></a>01910                   
<a name="l01911"></a>01911                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_dofs_on_element; j++)
<a name="l01912"></a>01912                         {
<a name="l01913"></a>01913                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = element_dofs[j];
<a name="l01914"></a>01914                           
<a name="l01915"></a>01915                           <span class="comment">// See if jg is in the sorted range</span>
<a name="l01916"></a>01916                           std::pair&lt;SparsityPattern::Row::iterator,
<a name="l01917"></a>01917                                     SparsityPattern::Row::iterator&gt;
<a name="l01918"></a>01918                             pos = std::equal_range (low, high, jg);
<a name="l01919"></a>01919                         
<a name="l01920"></a>01920                           <span class="comment">// Must add jg if it wasn't found</span>
<a name="l01921"></a>01921                           <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l01922"></a>01922                             dofs_to_add.push_back(jg);
<a name="l01923"></a>01923                         
<a name="l01924"></a>01924                           <span class="comment">// pos.first is now a valid lower bound for any</span>
<a name="l01925"></a>01925                           <span class="comment">// remaining element DOFs. (That's why we sorted them.)</span>
<a name="l01926"></a>01926                           <span class="comment">// Use it for the next search</span>
<a name="l01927"></a>01927                           low = pos.first;
<a name="l01928"></a>01928                         }
<a name="l01929"></a>01929 
<a name="l01930"></a>01930                       <span class="comment">// Add to the sparsity pattern</span>
<a name="l01931"></a>01931                       <span class="keywordflow">if</span> (!dofs_to_add.empty())
<a name="l01932"></a>01932                         {
<a name="l01933"></a>01933                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_size = row.size();
<a name="l01934"></a>01934                           
<a name="l01935"></a>01935                           row.insert (row.end(),
<a name="l01936"></a>01936                                       dofs_to_add.begin(),
<a name="l01937"></a>01937                                       dofs_to_add.end());
<a name="l01938"></a>01938                       
<a name="l01939"></a>01939                           <a class="code" href="namespaceSparsityPattern.php#bcab8a87e8229861015b1de4bc8f60ff">SparsityPattern::sort_row</a> (row.begin(), row.begin()+old_size, row.end());
<a name="l01940"></a>01940                         }
<a name="l01941"></a>01941                     }
<a name="l01942"></a>01942                   
<a name="l01943"></a>01943                   <span class="comment">// Now (possibly) add dofs from neighboring elements</span>
<a name="l01944"></a>01944                   <span class="comment">// TODO:[BSK] optimize this like above!</span>
<a name="l01945"></a>01945                   <span class="keywordflow">if</span> (<a class="code" href="classSparsityPattern_1_1Build.php#e23a805dd67ee6f28494b0477f59173f">implicit_neighbor_dofs</a>)
<a name="l01946"></a>01946                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l01947"></a>01947                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) != NULL)
<a name="l01948"></a>01948                         {
<a name="l01949"></a>01949                           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> neighbor_0 = elem-&gt;<a class="code" href="classElem.php#a2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s);
<a name="l01950"></a>01950 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01951"></a>01951 <span class="preprocessor"></span>                          neighbor_0-&gt;<a class="code" href="classElem.php#26ca00dd9c91f9f086d755eb3f58d4ff">active_family_tree_by_neighbor</a>(active_neighbors,elem);
<a name="l01952"></a>01952 <span class="preprocessor">#else</span>
<a name="l01953"></a>01953 <span class="preprocessor"></span>                          active_neighbors.clear();
<a name="l01954"></a>01954                           active_neighbors.push_back(neighbor_0);
<a name="l01955"></a>01955 <span class="preprocessor">#endif</span>
<a name="l01956"></a>01956 <span class="preprocessor"></span>                          
<a name="l01957"></a>01957                           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a=0; a != active_neighbors.size(); ++a)
<a name="l01958"></a>01958                             {
<a name="l01959"></a>01959                               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *neighbor = active_neighbors[a];
<a name="l01960"></a>01960                               
<a name="l01961"></a>01961                               <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (neighbor, neighbor_dofs);
<a name="l01962"></a>01962 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l01963"></a>01963 <span class="preprocessor"></span>                              <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#7020b9e29c89828384a6480f07eadd43">find_connected_dofs</a> (neighbor_dofs);
<a name="l01964"></a>01964 <span class="preprocessor">#endif                        </span>
<a name="l01965"></a>01965 <span class="preprocessor"></span>                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_neighbor = neighbor_dofs.size();
<a name="l01966"></a>01966                               
<a name="l01967"></a>01967                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_dofs_on_neighbor; j++)
<a name="l01968"></a>01968                                 {
<a name="l01969"></a>01969                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = neighbor_dofs[j];
<a name="l01970"></a>01970                                   
<a name="l01971"></a>01971                                   <span class="comment">// See if jg is in the sorted range</span>
<a name="l01972"></a>01972                                   std::pair&lt;SparsityPattern::Row::iterator,
<a name="l01973"></a>01973                                             SparsityPattern::Row::iterator&gt;
<a name="l01974"></a>01974                                     pos = std::equal_range (row.begin(), row.end(), jg);
<a name="l01975"></a>01975                                 
<a name="l01976"></a>01976                                   <span class="comment">// Insert jg if it wasn't found</span>
<a name="l01977"></a>01977                                   <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l01978"></a>01978                                     row.insert (pos.first, jg);
<a name="l01979"></a>01979                                 }    
<a name="l01980"></a>01980                             }
<a name="l01981"></a>01981                         }
<a name="l01982"></a>01982                 }
<a name="l01983"></a>01983             }
<a name="l01984"></a>01984         }             
<a name="l01985"></a>01985     } 
<a name="l01986"></a>01986 
<a name="l01987"></a>01987 
<a name="l01988"></a>01988   
<a name="l01989"></a>01989   <span class="comment">// This is what we do in the case that the user has specified</span>
<a name="l01990"></a>01990   <span class="comment">// explicit DOF coupling.</span>
<a name="l01991"></a>01991   <span class="keywordflow">else</span>
<a name="l01992"></a>01992     {
<a name="l01993"></a>01993       libmesh_assert (<a class="code" href="classSparsityPattern_1_1Build.php#ccbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a> != NULL);
<a name="l01994"></a>01994       libmesh_assert (<a class="code" href="classSparsityPattern_1_1Build.php#ccbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a>-&gt;<a class="code" href="classCouplingMatrix.php#873ea83161bff58bc9f4b5ff771500ea">size</a>() ==
<a name="l01995"></a>01995                       <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>());
<a name="l01996"></a>01996       
<a name="l01997"></a>01997       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_var = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#9658690be6efd4fdfb0cdd5b806748d2">n_variables</a>();
<a name="l01998"></a>01998       
<a name="l01999"></a>01999       std::vector&lt;unsigned int&gt;
<a name="l02000"></a>02000         element_dofs_i,
<a name="l02001"></a>02001         element_dofs_j,
<a name="l02002"></a>02002         dofs_to_add;
<a name="l02003"></a>02003 
<a name="l02004"></a>02004 
<a name="l02005"></a>02005       <span class="keywordflow">for</span> (<a class="code" href="classStoredRange.php#b2657352e8f9c79ab6fa4085c0bdd0d8">ConstElemRange::const_iterator</a> elem_it = range.<a class="code" href="classStoredRange.php#5f753b5b424dff3ab8030ce64d7a9f0a">begin</a>() ; elem_it != range.<a class="code" href="classStoredRange.php#bc8b19e0ebe76d4cda84e870e652fcf6">end</a>(); ++elem_it)
<a name="l02006"></a>02006         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vi=0; vi&lt;n_var; vi++)
<a name="l02007"></a>02007           {
<a name="l02008"></a>02008             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem = *elem_it;
<a name="l02009"></a>02009             
<a name="l02010"></a>02010             <span class="comment">// Find element dofs for variable vi</span>
<a name="l02011"></a>02011             <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, element_dofs_i, vi);
<a name="l02012"></a>02012 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l02013"></a>02013 <span class="preprocessor"></span>            <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#7020b9e29c89828384a6480f07eadd43">find_connected_dofs</a> (element_dofs_i);
<a name="l02014"></a>02014 <span class="preprocessor">#endif</span>
<a name="l02015"></a>02015 <span class="preprocessor"></span>
<a name="l02016"></a>02016             <span class="comment">// We can be more efficient if we sort the element DOFs</span>
<a name="l02017"></a>02017             <span class="comment">// into increasing order</span>
<a name="l02018"></a>02018             std::sort(element_dofs_i.begin(), element_dofs_i.end());
<a name="l02019"></a>02019             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_element_i = element_dofs_i.size();
<a name="l02020"></a>02020             
<a name="l02021"></a>02021             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vj=0; vj&lt;n_var; vj++)
<a name="l02022"></a>02022               <span class="keywordflow">if</span> ((*<a class="code" href="classSparsityPattern_1_1Build.php#ccbeb2e353d5791440f9d2b1ef1742e7">dof_coupling</a>)(vi,vj)) <span class="comment">// If vi couples to vj</span>
<a name="l02023"></a>02023                 {
<a name="l02024"></a>02024                   <span class="comment">// Find element dofs for variable vj, note that</span>
<a name="l02025"></a>02025                   <span class="comment">// if vi==vj we already have the dofs.</span>
<a name="l02026"></a>02026                   <span class="keywordflow">if</span> (vi != vj)
<a name="l02027"></a>02027                     {
<a name="l02028"></a>02028                       <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#fc5ee41412dcab63d5507efbf5d8482d">dof_indices</a> (elem, element_dofs_j, vj);
<a name="l02029"></a>02029 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l02030"></a>02030 <span class="preprocessor"></span>                      <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#7020b9e29c89828384a6480f07eadd43">find_connected_dofs</a> (element_dofs_j);
<a name="l02031"></a>02031 <span class="preprocessor">#endif</span>
<a name="l02032"></a>02032 <span class="preprocessor"></span>
<a name="l02033"></a>02033                       <span class="comment">// We can be more efficient if we sort the element DOFs</span>
<a name="l02034"></a>02034                       <span class="comment">// into increasing order</span>
<a name="l02035"></a>02035                       std::sort (element_dofs_j.begin(), element_dofs_j.end());
<a name="l02036"></a>02036                     }
<a name="l02037"></a>02037                   <span class="keywordflow">else</span>
<a name="l02038"></a>02038                     element_dofs_j = element_dofs_i;
<a name="l02039"></a>02039                   
<a name="l02040"></a>02040                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_element_j =
<a name="l02041"></a>02041                     element_dofs_j.size();
<a name="l02042"></a>02042                   
<a name="l02043"></a>02043                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_on_element_i; i++)
<a name="l02044"></a>02044                     {
<a name="l02045"></a>02045                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ig = element_dofs_i[i];
<a name="l02046"></a>02046                       
<a name="l02047"></a>02047                       <span class="comment">// We are only interested in computing the sparsity pattern</span>
<a name="l02048"></a>02048                       <span class="comment">// for the rows in [range.begin(),range.end()).  So, if this</span>
<a name="l02049"></a>02049                       <span class="comment">// element's DOFs are not in that range just go ahead to the</span>
<a name="l02050"></a>02050                       <span class="comment">// next one.</span>
<a name="l02051"></a>02051                       <span class="comment">//              </span>
<a name="l02052"></a>02052                       <span class="comment">// Also, only bother if this matrix row will be stored</span>
<a name="l02053"></a>02053                       <span class="comment">// on this processor.</span>
<a name="l02054"></a>02054                       <span class="keywordflow">if</span> ((ig &gt;= first_dof_on_proc) &amp;&amp;
<a name="l02055"></a>02055                           (ig &lt;  end_dof_on_proc))                      
<a name="l02056"></a>02056                         {
<a name="l02057"></a>02057                           <span class="comment">// This is what I mean</span>
<a name="l02058"></a>02058                           <span class="comment">// libmesh_assert ((ig - first_dof_on_proc) &gt;= 0);</span>
<a name="l02059"></a>02059                           <span class="comment">// but do the test like this because ig and</span>
<a name="l02060"></a>02060                           <span class="comment">// first_dof_on_proc are unsigned ints</span>
<a name="l02061"></a>02061                           libmesh_assert (ig &gt;= first_dof_on_proc);
<a name="l02062"></a>02062                           libmesh_assert (ig &lt; (<a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.size() +
<a name="l02063"></a>02063                                         first_dof_on_proc));
<a name="l02064"></a>02064                           
<a name="l02065"></a>02065                           <a class="code" href="namespaceSparsityPattern.php#380dc3cd41bc4aab23a1c916181104b3">SparsityPattern::Row</a> &amp;row = <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>[ig - first_dof_on_proc];
<a name="l02066"></a>02066 
<a name="l02067"></a>02067                           <span class="comment">// If the row is empty we will add *all* the element j DOFs,</span>
<a name="l02068"></a>02068                           <span class="comment">// so just do that.</span>
<a name="l02069"></a>02069                           <span class="keywordflow">if</span> (row.empty())
<a name="l02070"></a>02070                             {
<a name="l02071"></a>02071                               row.insert(row.end(),
<a name="l02072"></a>02072                                          element_dofs_j.begin(),
<a name="l02073"></a>02073                                          element_dofs_j.end());
<a name="l02074"></a>02074                             }
<a name="l02075"></a>02075                           <span class="keywordflow">else</span>
<a name="l02076"></a>02076                             {             
<a name="l02077"></a>02077                               <span class="comment">// Build a list of the DOF indices not found in the</span>
<a name="l02078"></a>02078                               <span class="comment">// sparsity pattern</span>
<a name="l02079"></a>02079                               dofs_to_add.clear();
<a name="l02080"></a>02080 
<a name="l02081"></a>02081                               <span class="comment">// Cache iterators.  Low will move forward, subsequent</span>
<a name="l02082"></a>02082                               <span class="comment">// searches will be on smaller ranges</span>
<a name="l02083"></a>02083                               SparsityPattern::Row::iterator
<a name="l02084"></a>02084                                 low  = std::lower_bound (row.begin(), row.end(), element_dofs_j.front()),
<a name="l02085"></a>02085                                 high = std::upper_bound (low,         row.end(), element_dofs_j.back());
<a name="l02086"></a>02086 
<a name="l02087"></a>02087                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_dofs_on_element_j; j++)
<a name="l02088"></a>02088                                 {
<a name="l02089"></a>02089                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jg = element_dofs_j[j];
<a name="l02090"></a>02090                                   
<a name="l02091"></a>02091                                   <span class="comment">// See if jg is in the sorted range</span>
<a name="l02092"></a>02092                                   std::pair&lt;SparsityPattern::Row::iterator,
<a name="l02093"></a>02093                                             SparsityPattern::Row::iterator&gt;
<a name="l02094"></a>02094                                     pos = std::equal_range (low, high, jg);
<a name="l02095"></a>02095                               
<a name="l02096"></a>02096                                   <span class="comment">// Must add jg if it wasn't found</span>
<a name="l02097"></a>02097                                   <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l02098"></a>02098                                     dofs_to_add.push_back(jg);
<a name="l02099"></a>02099                                 
<a name="l02100"></a>02100                                   <span class="comment">// pos.first is now a valid lower bound for any</span>
<a name="l02101"></a>02101                                   <span class="comment">// remaining element j DOFs. (That's why we sorted them.)</span>
<a name="l02102"></a>02102                                   <span class="comment">// Use it for the next search</span>
<a name="l02103"></a>02103                                   low = pos.first;
<a name="l02104"></a>02104                                 }
<a name="l02105"></a>02105                               
<a name="l02106"></a>02106                               <span class="comment">// Add to the sparsity pattern</span>
<a name="l02107"></a>02107                               <span class="keywordflow">if</span> (!dofs_to_add.empty())
<a name="l02108"></a>02108                                 {
<a name="l02109"></a>02109                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_size = row.size();
<a name="l02110"></a>02110                                   
<a name="l02111"></a>02111                                   row.insert (row.end(),
<a name="l02112"></a>02112                                               dofs_to_add.begin(),
<a name="l02113"></a>02113                                               dofs_to_add.end());
<a name="l02114"></a>02114                       
<a name="l02115"></a>02115                                   <a class="code" href="namespaceSparsityPattern.php#bcab8a87e8229861015b1de4bc8f60ff">SparsityPattern::sort_row</a> (row.begin(), row.begin()+old_size, row.end());
<a name="l02116"></a>02116                                 }
<a name="l02117"></a>02117                             }
<a name="l02118"></a>02118                         }
<a name="l02119"></a>02119                     }
<a name="l02120"></a>02120                 }
<a name="l02121"></a>02121           }
<a name="l02122"></a>02122     }
<a name="l02123"></a>02123   
<a name="l02124"></a>02124   <span class="comment">// Now the full sparsity structure is built for all of the</span>
<a name="l02125"></a>02125   <span class="comment">// DOFs connected to our rows of the matrix.</span>
<a name="l02126"></a>02126   <a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>.resize (n_dofs_on_proc);
<a name="l02127"></a>02127   <a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>.resize (n_dofs_on_proc);
<a name="l02128"></a>02128 
<a name="l02129"></a>02129   <span class="comment">// First zero the counters.</span>
<a name="l02130"></a>02130   std::fill(<a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>.begin(), <a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>.end(), 0);
<a name="l02131"></a>02131   std::fill(<a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>.begin(), <a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>.end(), 0);
<a name="l02132"></a>02132   
<a name="l02133"></a>02133   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_on_proc; i++)
<a name="l02134"></a>02134     {
<a name="l02135"></a>02135       <span class="comment">// Get the row of the sparsity pattern</span>
<a name="l02136"></a>02136       <span class="keyword">const</span> <a class="code" href="namespaceSparsityPattern.php#380dc3cd41bc4aab23a1c916181104b3">SparsityPattern::Row</a> &amp;row = <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>[i];
<a name="l02137"></a>02137 
<a name="l02138"></a>02138       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;row.size(); j++)
<a name="l02139"></a>02139         <span class="keywordflow">if</span> ((row[j] &lt; first_dof_on_proc) || (row[j] &gt;= end_dof_on_proc))
<a name="l02140"></a>02140           <a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>[i]++;
<a name="l02141"></a>02141         <span class="keywordflow">else</span>
<a name="l02142"></a>02142           <a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[i]++;
<a name="l02143"></a>02143     }
<a name="l02144"></a>02144 }
<a name="l02145"></a>02145 
<a name="l02146"></a>02146 
<a name="l02147"></a>02147 
<a name="l02148"></a><a class="code" href="classSparsityPattern_1_1Build.php#6bd8b255d207b566d298bba535e0f2e0">02148</a> <span class="keywordtype">void</span> <a class="code" href="classSparsityPattern_1_1Build.php#6bd8b255d207b566d298bba535e0f2e0">SparsityPattern::Build::join</a> (<span class="keyword">const</span> <a class="code" href="classSparsityPattern_1_1Build.php">SparsityPattern::Build</a> &amp;other)
<a name="l02149"></a>02149 {
<a name="l02150"></a>02150   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id           = <a class="code" href="classSparsityPattern_1_1Build.php#8dfe00458fdffa32b6461df05b7b4f16">mesh</a>.<a class="code" href="classMeshBase.php#ba369b64ee6185d86a6b60089ba5af60">processor_id</a>();
<a name="l02151"></a>02151   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_global_dofs     = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#e7db3f0773e85ababc4f9db1cfa24d3e">n_dofs</a>();
<a name="l02152"></a>02152   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_on_proc    = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#9c7492c5d5f1eacd327f0c902590eda7">n_dofs_on_processor</a>(proc_id);
<a name="l02153"></a>02153   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_dof_on_proc = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#4908535aa4a29e6441c197c8f7cd594e">first_dof</a>(proc_id);
<a name="l02154"></a>02154   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> end_dof_on_proc   = <a class="code" href="classSparsityPattern_1_1Build.php#a25aa26eabe02d301da420af81f8d38f">dof_map</a>.<a class="code" href="classDofMap.php#b838f2e72aaf8614c97fcd47a13781b8">end_dof</a>(proc_id);
<a name="l02155"></a>02155 
<a name="l02156"></a>02156   libmesh_assert (<a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.size() ==  other.<a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.size());
<a name="l02157"></a>02157   libmesh_assert (<a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>.size() == <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.size());
<a name="l02158"></a>02158   libmesh_assert (<a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>.size() == <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>.size());
<a name="l02159"></a>02159   
<a name="l02160"></a>02160   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r=0; r&lt;n_dofs_on_proc; r++)
<a name="l02161"></a>02161     {
<a name="l02162"></a>02162       <span class="comment">// incriment the number of on and off-processor nonzeros in this row</span>
<a name="l02163"></a>02163       <span class="comment">// (note this will be an upper bound unless we need the full sparsity pattern)</span>
<a name="l02164"></a>02164       <a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[r] += other.<a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[r];  <a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[r] = <a class="code" href="namespacestd.php#4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[r], n_dofs_on_proc);
<a name="l02165"></a>02165       <a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>[r] += other.<a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>[r];  <a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>[r] = <a class="code" href="namespacestd.php#4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>[r], n_global_dofs-<a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[r]);
<a name="l02166"></a>02166 
<a name="l02167"></a>02167       <span class="keywordflow">if</span> (<a class="code" href="classSparsityPattern_1_1Build.php#7391c2b856f66ea6e659fcf1fb9d02e4">need_full_sparsity_pattern</a>)
<a name="l02168"></a>02168         {
<a name="l02169"></a>02169           <a class="code" href="namespaceSparsityPattern.php#380dc3cd41bc4aab23a1c916181104b3">SparsityPattern::Row</a>       &amp;my_row    = <a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>[r];
<a name="l02170"></a>02170           <span class="keyword">const</span> <a class="code" href="namespaceSparsityPattern.php#380dc3cd41bc4aab23a1c916181104b3">SparsityPattern::Row</a> &amp;their_row = other.<a class="code" href="classSparsityPattern_1_1Build.php#8f5b5c39334d20908f82d7921a526289">sparsity_pattern</a>[r];
<a name="l02171"></a>02171       
<a name="l02172"></a>02172           <span class="comment">// simple copy if I have no dofs</span>
<a name="l02173"></a>02173           <span class="keywordflow">if</span> (my_row.empty())
<a name="l02174"></a>02174             my_row = their_row;
<a name="l02175"></a>02175           
<a name="l02176"></a>02176           <span class="comment">// otherwise add their DOFs to mine, resort, and re-unique the row</span>
<a name="l02177"></a>02177           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!their_row.empty()) <span class="comment">// do nothing for the trivial case where </span>
<a name="l02178"></a>02178             {                          <span class="comment">// their row is empty</span>
<a name="l02179"></a>02179               my_row.insert (my_row.end(),
<a name="l02180"></a>02180                              their_row.begin(),
<a name="l02181"></a>02181                              their_row.end());
<a name="l02182"></a>02182 
<a name="l02183"></a>02183               <span class="comment">// We cannot use SparsityPattern::sort_row() here because it expects</span>
<a name="l02184"></a>02184               <span class="comment">// the [begin,middle) [middle,end) to be non-overlapping.  This is not</span>
<a name="l02185"></a>02185               <span class="comment">// necessarily the case here, so use std::sort()</span>
<a name="l02186"></a>02186               std::sort (my_row.begin(), my_row.end());
<a name="l02187"></a>02187          
<a name="l02188"></a>02188               my_row.erase(std::unique (my_row.begin(), my_row.end()), my_row.end());
<a name="l02189"></a>02189             }
<a name="l02190"></a>02190 
<a name="l02191"></a>02191           <span class="comment">// fix the number of on and off-processor nonzeros in this row</span>
<a name="l02192"></a>02192           <a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[r] = <a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>[r] = 0;
<a name="l02193"></a>02193           
<a name="l02194"></a>02194           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;my_row.size(); j++)
<a name="l02195"></a>02195             <span class="keywordflow">if</span> ((my_row[j] &lt; first_dof_on_proc) || (my_row[j] &gt;= end_dof_on_proc))
<a name="l02196"></a>02196               <a class="code" href="classSparsityPattern_1_1Build.php#86edb077e8f9a93385d516a9b45be9d1">n_oz</a>[r]++;
<a name="l02197"></a>02197             <span class="keywordflow">else</span>
<a name="l02198"></a>02198               <a class="code" href="classSparsityPattern_1_1Build.php#f60829aa8bb28e66372629218421bb65">n_nz</a>[r]++;
<a name="l02199"></a>02199         }
<a name="l02200"></a>02200     }
<a name="l02201"></a>02201 }
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
