<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.php"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.php"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.php"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_3a549c4e12a94f1be9ddd857f62acaab.php">src</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_288d00b243f8ec58fc9bc51e9d244dd1.php">utils</a>
  </div>
</div>
<div class="contents">
<h1>xdr_cxx.C</h1><a href="xdr__cxx_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// "$Id$\n"</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C/C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "<a class="code" href="parallel_8h.php">parallel.h</a>"</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="o__f__stream_8h.php">o_f_stream.h</a>"</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor"># include "gzstream.h"</span>
<a name="l00031"></a>00031 <span class="preprocessor">#endif</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Anonymous namespace for implementation details.</span>
<a name="l00035"></a>00035 <span class="keyword">namespace </span>{
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="comment">// Nasty hacks for reading/writing zipped files</span>
<a name="l00038"></a>00038   <span class="keywordtype">void</span> zip_file (<span class="keyword">const</span> std::string &amp;unzipped_name)
<a name="l00039"></a>00039   {
<a name="l00040"></a>00040     <span class="comment">// There's no parallel bzip2 for us to call</span>
<a name="l00041"></a>00041     libmesh_assert(<a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="preprocessor">#ifdef LIBMESH_HAVE_BZIP</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>    START_LOG(<span class="stringliteral">"system(bzip2)"</span>, <span class="stringliteral">"XdrIO"</span>);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     std::string system_string = <span class="stringliteral">"bzip2 -f "</span>;
<a name="l00047"></a>00047     system_string += unzipped_name;
<a name="l00048"></a>00048     std::system(system_string.c_str());
<a name="l00049"></a>00049      
<a name="l00050"></a>00050     STOP_LOG(<span class="stringliteral">"system(bzip2)"</span>, <span class="stringliteral">"XdrIO"</span>);
<a name="l00051"></a>00051 <span class="preprocessor">#else</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>    std::cerr &lt;&lt; <span class="stringliteral">"ERROR: need bzip2/bunzip2 to handle .bz2 files!!!"</span>
<a name="l00053"></a>00053               &lt;&lt; std::endl;
<a name="l00054"></a>00054     libmesh_error();
<a name="l00055"></a>00055 <span class="preprocessor">#endif</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   std::string unzip_file (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespaceQuality.php#47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00059"></a>00059   {
<a name="l00060"></a>00060     <span class="comment">// There's no parallel bunzip2 for us to call</span>
<a name="l00061"></a>00061     libmesh_assert(<a class="code" href="namespacelibMesh.php#4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063     std::string new_name = name;
<a name="l00064"></a>00064     <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">".bz2"</span>) == 4)
<a name="l00065"></a>00065       {
<a name="l00066"></a>00066         new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00067"></a>00067 <span class="preprocessor">#ifdef LIBMESH_HAVE_BZIP</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>        START_LOG(<span class="stringliteral">"system(bunzip2)"</span>, <span class="stringliteral">"XdrIO"</span>);
<a name="l00069"></a>00069         std::string system_string = <span class="stringliteral">"bunzip2 -f -k "</span>;
<a name="l00070"></a>00070         system_string += name;
<a name="l00071"></a>00071         std::system(system_string.c_str());
<a name="l00072"></a>00072         STOP_LOG(<span class="stringliteral">"system(bunzip2)"</span>, <span class="stringliteral">"XdrIO"</span>);
<a name="l00073"></a>00073 <span class="preprocessor">#else</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>        std::cerr &lt;&lt; <span class="stringliteral">"ERROR: need bzip2/bunzip2 to handle .bz2 files!!!"</span>
<a name="l00075"></a>00075                   &lt;&lt; std::endl;
<a name="l00076"></a>00076         libmesh_error();
<a name="l00077"></a>00077 <span class="preprocessor">#endif</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>      }
<a name="l00079"></a>00079     <span class="keywordflow">return</span> new_name;
<a name="l00080"></a>00080   }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// remove an unzipped file</span>
<a name="l00083"></a>00083   <span class="keywordtype">void</span> remove_unzipped_file (<span class="keyword">const</span> std::string &amp;name)
<a name="l00084"></a>00084   {
<a name="l00085"></a>00085     <span class="comment">// If we temporarily decompressed a .bz2 file, remove the</span>
<a name="l00086"></a>00086     <span class="comment">// uncompressed version</span>
<a name="l00087"></a>00087     <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">".bz2"</span>) == 4)
<a name="l00088"></a>00088       {
<a name="l00089"></a>00089         <span class="keyword">const</span> std::string new_name(name.begin(), name.end()-4);
<a name="l00090"></a>00090         std::remove(new_name.c_str());
<a name="l00091"></a>00091       }
<a name="l00092"></a>00092   }
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00096"></a>00096 <span class="comment">// Xdr class implementation</span>
<a name="l00097"></a>00097 <a class="code" href="classXdr.php#71201e933ce19bbd66d1f1cdc7ba0a48">Xdr::Xdr</a> (<span class="keyword">const</span> std::string&amp; name, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> m) :
<a name="l00098"></a>00098   mode(m),
<a name="l00099"></a>00099   file_name(name),
<a name="l00100"></a>00100 #ifdef LIBMESH_HAVE_XDR
<a name="l00101"></a>00101   xdrs(NULL),
<a name="l00102"></a>00102   fp(NULL),
<a name="l00103"></a>00103 #endif
<a name="l00104"></a>00104   in(NULL),
<a name="l00105"></a>00105   out(NULL),
<a name="l00106"></a>00106   comm_len(xdr_MAX_STRING_LENGTH),
<a name="l00107"></a>00107   gzipped_file(false),
<a name="l00108"></a>00108   bzipped_file(false)
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110   this-&gt;open(name);
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a><a class="code" href="classXdr.php#67fc8bd3cd8a85b04e43655a60dffdec">00115</a> <a class="code" href="classXdr.php#67fc8bd3cd8a85b04e43655a60dffdec">Xdr::~Xdr</a>()
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   this-&gt;<a class="code" href="classXdr.php#68dc02dd44f5f69b76813967d1d611cf">close</a>();
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classXdr.php#c8622354e4d5395d4c777fb4062dc334">00122</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#c8622354e4d5395d4c777fb4062dc334">Xdr::open</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   <a class="code" href="classXdr.php#991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = name;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (name == <span class="stringliteral">""</span>)
<a name="l00127"></a>00127     <span class="keywordflow">return</span>;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00130"></a>00130     {
<a name="l00131"></a>00131     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00132"></a>00132     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00133"></a>00133       {
<a name="l00134"></a>00134 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>
<a name="l00136"></a>00136         <a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a> = fopen(name.c_str(), (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>) ? <span class="stringliteral">"w"</span> : <span class="stringliteral">"r"</span>);
<a name="l00137"></a>00137         libmesh_assert (<a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a>);
<a name="l00138"></a>00138         <a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a> = <span class="keyword">new</span> XDR;
<a name="l00139"></a>00139         xdrstdio_create (<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, <a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a>, (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>) ? XDR_ENCODE : XDR_DECODE);
<a name="l00140"></a>00140 <span class="preprocessor">#else</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>        
<a name="l00142"></a>00142         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00143"></a>00143                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00144"></a>00144                   &lt;&lt; std::endl
<a name="l00145"></a>00145                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00146"></a>00146                   &lt;&lt; std::endl;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148         libmesh_error();
<a name="l00149"></a>00149         
<a name="l00150"></a>00150 <span class="preprocessor">#endif</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00152"></a>00152 
<a name="l00153"></a>00153       }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00156"></a>00156       {
<a name="l00157"></a>00157         <a class="code" href="classXdr.php#64c209ad9346d907ee753635a7480d3f">gzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">".gz"</span>)  == 3);
<a name="l00158"></a>00158         <a class="code" href="classXdr.php#38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">".bz2"</span>) == 4);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#64c209ad9346d907ee753635a7480d3f">gzipped_file</a>)
<a name="l00161"></a>00161           {
<a name="l00162"></a>00162 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>            igzstream *inf = <span class="keyword">new</span> igzstream;
<a name="l00164"></a>00164             libmesh_assert (inf != NULL);
<a name="l00165"></a>00165             <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#fba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(inf);
<a name="l00166"></a>00166             inf-&gt;open(name.c_str(), std::ios::in);
<a name="l00167"></a>00167 <span class="preprocessor">#else</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>            std::cerr &lt;&lt; <span class="stringliteral">"ERROR: need gzstream to handle .gz files!!!"</span>
<a name="l00169"></a>00169                       &lt;&lt; std::endl;
<a name="l00170"></a>00170             libmesh_error();
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>          }
<a name="l00173"></a>00173         <span class="keywordflow">else</span>
<a name="l00174"></a>00174           {
<a name="l00175"></a>00175             std::ifstream *inf = <span class="keyword">new</span> std::ifstream;
<a name="l00176"></a>00176             libmesh_assert (inf != NULL);
<a name="l00177"></a>00177             <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#fba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(inf);
<a name="l00178"></a>00178             
<a name="l00179"></a>00179             std::string new_name(<a class="code" href="classXdr.php#38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a> ? unzip_file(name) : name);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181             inf-&gt;open(new_name.c_str(), std::ios::in);
<a name="l00182"></a>00182           }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00185"></a>00185         <span class="keywordflow">return</span>;
<a name="l00186"></a>00186       }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00189"></a>00189       {
<a name="l00190"></a>00190         <a class="code" href="classXdr.php#64c209ad9346d907ee753635a7480d3f">gzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">".gz"</span>)  == 3);
<a name="l00191"></a>00191         <a class="code" href="classXdr.php#38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">".bz2"</span>) == 4);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#64c209ad9346d907ee753635a7480d3f">gzipped_file</a>)
<a name="l00194"></a>00194           {
<a name="l00195"></a>00195 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00196"></a>00196 <span class="preprocessor"></span>            ogzstream *outf = <span class="keyword">new</span> ogzstream;
<a name="l00197"></a>00197             libmesh_assert (outf != NULL);
<a name="l00198"></a>00198             <a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#fba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(outf);
<a name="l00199"></a>00199             outf-&gt;open(name.c_str(), std::ios::out);
<a name="l00200"></a>00200 <span class="preprocessor">#else</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>            std::cerr &lt;&lt; <span class="stringliteral">"ERROR: need gzstream to handle .gz files!!!"</span>
<a name="l00202"></a>00202                       &lt;&lt; std::endl;
<a name="l00203"></a>00203             libmesh_error();
<a name="l00204"></a>00204 <span class="preprocessor">#endif</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>          }
<a name="l00206"></a>00206         <span class="keywordflow">else</span>
<a name="l00207"></a>00207           {
<a name="l00208"></a>00208             std::ofstream *outf = <span class="keyword">new</span> std::ofstream;
<a name="l00209"></a>00209             libmesh_assert (outf != NULL);
<a name="l00210"></a>00210             <a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#fba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(outf);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212             std::string new_name = name;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a>)
<a name="l00215"></a>00215               new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00216"></a>00216 
<a name="l00217"></a>00217             outf-&gt;open(new_name.c_str(), std::ios::out);
<a name="l00218"></a>00218           }
<a name="l00219"></a>00219         
<a name="l00220"></a>00220         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00221"></a>00221         <span class="keywordflow">return</span>;
<a name="l00222"></a>00222       }
<a name="l00223"></a>00223       
<a name="l00224"></a>00224     <span class="keywordflow">default</span>:
<a name="l00225"></a>00225       libmesh_error();
<a name="l00226"></a>00226     }  
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classXdr.php#68dc02dd44f5f69b76813967d1d611cf">00231</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#68dc02dd44f5f69b76813967d1d611cf">Xdr::close</a> ()
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00234"></a>00234     {
<a name="l00235"></a>00235     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00236"></a>00236     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00237"></a>00237       {
<a name="l00238"></a>00238 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>
<a name="l00240"></a>00240         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>)
<a name="l00241"></a>00241           {
<a name="l00242"></a>00242             xdr_destroy (<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>);
<a name="l00243"></a>00243             <span class="keyword">delete</span> <a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>;
<a name="l00244"></a>00244             <a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a> = NULL;
<a name="l00245"></a>00245           }
<a name="l00246"></a>00246         
<a name="l00247"></a>00247         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a>)
<a name="l00248"></a>00248           {
<a name="l00249"></a>00249             fflush(<a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a>);
<a name="l00250"></a>00250             fclose(<a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a>);
<a name="l00251"></a>00251             <a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a> = NULL;
<a name="l00252"></a>00252           }
<a name="l00253"></a>00253 <span class="preprocessor">#else</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>        
<a name="l00255"></a>00255         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00256"></a>00256                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00257"></a>00257                   &lt;&lt; std::endl
<a name="l00258"></a>00258                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00259"></a>00259                   &lt;&lt; std::endl;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261         libmesh_error();
<a name="l00262"></a>00262         
<a name="l00263"></a>00263 <span class="preprocessor">#endif</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span>        <a class="code" href="classXdr.php#991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = <span class="stringliteral">""</span>;
<a name="l00265"></a>00265         <span class="keywordflow">return</span>;
<a name="l00266"></a>00266       }
<a name="l00267"></a>00267       
<a name="l00268"></a>00268     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00269"></a>00269       {
<a name="l00270"></a>00270         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00271"></a>00271           {
<a name="l00272"></a>00272             <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#fba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>();    
<a name="l00273"></a>00273             
<a name="l00274"></a>00274             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a>)
<a name="l00275"></a>00275               remove_unzipped_file(<a class="code" href="classXdr.php#991eb4c2747e6cf24ddaf32ff053d35c">file_name</a>);
<a name="l00276"></a>00276           }
<a name="l00277"></a>00277         <a class="code" href="classXdr.php#991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = <span class="stringliteral">""</span>;
<a name="l00278"></a>00278         <span class="keywordflow">return</span>;
<a name="l00279"></a>00279       }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00282"></a>00282       {
<a name="l00283"></a>00283         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00284"></a>00284           {
<a name="l00285"></a>00285             <a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#fba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>();      
<a name="l00286"></a>00286 
<a name="l00287"></a>00287             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a>)
<a name="l00288"></a>00288               zip_file(std::string(<a class="code" href="classXdr.php#991eb4c2747e6cf24ddaf32ff053d35c">file_name</a>.begin(), <a class="code" href="classXdr.php#991eb4c2747e6cf24ddaf32ff053d35c">file_name</a>.end()-4));
<a name="l00289"></a>00289           }
<a name="l00290"></a>00290         <a class="code" href="classXdr.php#991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = <span class="stringliteral">""</span>;
<a name="l00291"></a>00291         <span class="keywordflow">return</span>;
<a name="l00292"></a>00292       }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294     <span class="keywordflow">default</span>:
<a name="l00295"></a>00295       libmesh_error();
<a name="l00296"></a>00296     }
<a name="l00297"></a>00297 }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a><a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">00301</a> <span class="keywordtype">bool</span> <a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">Xdr::is_open</a>()<span class="keyword"> const</span>
<a name="l00302"></a>00302 <span class="keyword"></span>{
<a name="l00303"></a>00303   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00304"></a>00304     {
<a name="l00305"></a>00305     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00306"></a>00306     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00307"></a>00307       {
<a name="l00308"></a>00308 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span>
<a name="l00310"></a>00310         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#b3197bdc430b239a1c65e5d656e591d1">fp</a>)
<a name="l00311"></a>00311           <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>)
<a name="l00312"></a>00312             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00313"></a>00313 
<a name="l00314"></a>00314         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 <span class="preprocessor">#else</span>
<a name="l00317"></a>00317 <span class="preprocessor"></span>        
<a name="l00318"></a>00318         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00319"></a>00319                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00320"></a>00320                   &lt;&lt; std::endl
<a name="l00321"></a>00321                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00322"></a>00322                   &lt;&lt; std::endl;
<a name="l00323"></a>00323 
<a name="l00324"></a>00324         libmesh_error();
<a name="l00325"></a>00325 
<a name="l00326"></a>00326         <span class="keywordflow">return</span> <span class="keyword">false</span>;   
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="preprocessor">#endif</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00330"></a>00330       }
<a name="l00331"></a>00331       
<a name="l00332"></a>00332     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00333"></a>00333       {
<a name="l00334"></a>00334         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00335"></a>00335           <span class="keywordflow">return</span> <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good();
<a name="l00336"></a>00336         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00337"></a>00337       }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00340"></a>00340       {
<a name="l00341"></a>00341         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00342"></a>00342           <span class="keywordflow">return</span> <a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good();
<a name="l00343"></a>00343         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00344"></a>00344       }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346     <span class="keywordflow">default</span>:
<a name="l00347"></a>00347       libmesh_error();
<a name="l00348"></a>00348     }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00351"></a>00351 }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a><a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">00355</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00356"></a>00356 {
<a name="l00357"></a>00357   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00358"></a>00358     {
<a name="l00359"></a>00359     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00360"></a>00360     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00361"></a>00361       {
<a name="l00362"></a>00362 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00363"></a>00363 <span class="preprocessor"></span>
<a name="l00364"></a>00364         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00365"></a>00365 
<a name="l00366"></a>00366         xdr_int(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 <span class="preprocessor">#else</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>        
<a name="l00370"></a>00370         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00371"></a>00371                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00372"></a>00372                   &lt;&lt; std::endl
<a name="l00373"></a>00373                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00374"></a>00374                   &lt;&lt; std::endl;
<a name="l00375"></a>00375 
<a name="l00376"></a>00376         libmesh_error();
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="preprocessor">#endif</span>
<a name="l00379"></a>00379 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00380"></a>00380       }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00383"></a>00383       {
<a name="l00384"></a>00384         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00385"></a>00385         
<a name="l00386"></a>00386         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388         <span class="keywordflow">return</span>;
<a name="l00389"></a>00389       }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00392"></a>00392       {
<a name="l00393"></a>00393         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00394"></a>00394         
<a name="l00395"></a>00395         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397         <span class="keywordflow">return</span>;
<a name="l00398"></a>00398       }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400     <span class="keywordflow">default</span>:
<a name="l00401"></a>00401       libmesh_error();
<a name="l00402"></a>00402     }
<a name="l00403"></a>00403 }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a><a class="code" href="classXdr.php#608aa9d275764c53a2e16c2f0246d917">00407</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00408"></a>00408 {
<a name="l00409"></a>00409   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00410"></a>00410     {
<a name="l00411"></a>00411     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00412"></a>00412     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00413"></a>00413       {
<a name="l00414"></a>00414 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00415"></a>00415 <span class="preprocessor"></span>
<a name="l00416"></a>00416         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00417"></a>00417 
<a name="l00418"></a>00418         xdr_u_int(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="preprocessor">#else</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>        
<a name="l00422"></a>00422         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00423"></a>00423                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00424"></a>00424                   &lt;&lt; std::endl
<a name="l00425"></a>00425                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00426"></a>00426                   &lt;&lt; std::endl;
<a name="l00427"></a>00427 
<a name="l00428"></a>00428         libmesh_error();
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 <span class="preprocessor">#endif</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00432"></a>00432       }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00435"></a>00435       {
<a name="l00436"></a>00436         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00437"></a>00437         
<a name="l00438"></a>00438         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00439"></a>00439 
<a name="l00440"></a>00440         <span class="keywordflow">return</span>;
<a name="l00441"></a>00441       }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00444"></a>00444       {
<a name="l00445"></a>00445         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00446"></a>00446 
<a name="l00447"></a>00447         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00448"></a>00448         
<a name="l00449"></a>00449         <span class="keywordflow">return</span>;
<a name="l00450"></a>00450       }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452     <span class="keywordflow">default</span>:
<a name="l00453"></a>00453       libmesh_error();
<a name="l00454"></a>00454     }
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a><a class="code" href="classXdr.php#a7df14ebb267c47d9fd40da496fe4d26">00459</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00460"></a>00460 {
<a name="l00461"></a>00461   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00462"></a>00462     {
<a name="l00463"></a>00463     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00464"></a>00464     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00465"></a>00465       {
<a name="l00466"></a>00466 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00467"></a>00467 <span class="preprocessor"></span>
<a name="l00468"></a>00468         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00469"></a>00469 
<a name="l00470"></a>00470         xdr_short(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 <span class="preprocessor">#else</span>
<a name="l00473"></a>00473 <span class="preprocessor"></span>        
<a name="l00474"></a>00474         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00475"></a>00475                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00476"></a>00476                   &lt;&lt; std::endl
<a name="l00477"></a>00477                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00478"></a>00478                   &lt;&lt; std::endl;
<a name="l00479"></a>00479 
<a name="l00480"></a>00480         libmesh_error();
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="preprocessor">#endif</span>
<a name="l00483"></a>00483 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00484"></a>00484       }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00487"></a>00487       {
<a name="l00488"></a>00488         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00489"></a>00489         
<a name="l00490"></a>00490         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00491"></a>00491 
<a name="l00492"></a>00492         <span class="keywordflow">return</span>;
<a name="l00493"></a>00493       }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00496"></a>00496       {
<a name="l00497"></a>00497         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00498"></a>00498 
<a name="l00499"></a>00499         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00500"></a>00500         
<a name="l00501"></a>00501         <span class="keywordflow">return</span>;
<a name="l00502"></a>00502       }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504     <span class="keywordflow">default</span>:
<a name="l00505"></a>00505       libmesh_error();
<a name="l00506"></a>00506     }
<a name="l00507"></a>00507 }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a><a class="code" href="classXdr.php#42c24ba2e3b80ed1ac1b75107ec8aa1e">00511</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00512"></a>00512 {
<a name="l00513"></a>00513   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00514"></a>00514     {
<a name="l00515"></a>00515     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00516"></a>00516     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00517"></a>00517       {
<a name="l00518"></a>00518 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00519"></a>00519 <span class="preprocessor"></span>
<a name="l00520"></a>00520         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00521"></a>00521 
<a name="l00522"></a>00522         xdr_u_short(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="preprocessor">#else</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>        
<a name="l00526"></a>00526         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00527"></a>00527                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00528"></a>00528                   &lt;&lt; std::endl
<a name="l00529"></a>00529                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00530"></a>00530                   &lt;&lt; std::endl;
<a name="l00531"></a>00531 
<a name="l00532"></a>00532         libmesh_error();
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 <span class="preprocessor">#endif</span>
<a name="l00535"></a>00535 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00536"></a>00536       }
<a name="l00537"></a>00537 
<a name="l00538"></a>00538     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00539"></a>00539       {
<a name="l00540"></a>00540         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00541"></a>00541         
<a name="l00542"></a>00542         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00543"></a>00543 
<a name="l00544"></a>00544         <span class="keywordflow">return</span>;
<a name="l00545"></a>00545       }
<a name="l00546"></a>00546 
<a name="l00547"></a>00547     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00548"></a>00548       {
<a name="l00549"></a>00549         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00550"></a>00550 
<a name="l00551"></a>00551         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00552"></a>00552         
<a name="l00553"></a>00553         <span class="keywordflow">return</span>;
<a name="l00554"></a>00554       }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556     <span class="keywordflow">default</span>:
<a name="l00557"></a>00557       libmesh_error();
<a name="l00558"></a>00558     }
<a name="l00559"></a>00559 }
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a><a class="code" href="classXdr.php#1a71aba2819becb57f135a1c08d22937">00563</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">float</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00564"></a>00564 {
<a name="l00565"></a>00565   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00568"></a>00568     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00569"></a>00569       {
<a name="l00570"></a>00570 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00571"></a>00571 <span class="preprocessor"></span>
<a name="l00572"></a>00572         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00573"></a>00573 
<a name="l00574"></a>00574         xdr_float(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 <span class="preprocessor">#else</span>
<a name="l00577"></a>00577 <span class="preprocessor"></span>        
<a name="l00578"></a>00578         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00579"></a>00579                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00580"></a>00580                   &lt;&lt; std::endl
<a name="l00581"></a>00581                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00582"></a>00582                   &lt;&lt; std::endl;
<a name="l00583"></a>00583 
<a name="l00584"></a>00584         libmesh_error();
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 <span class="preprocessor">#endif</span>
<a name="l00587"></a>00587 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00588"></a>00588       }
<a name="l00589"></a>00589 
<a name="l00590"></a>00590     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00591"></a>00591       {
<a name="l00592"></a>00592         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00593"></a>00593         
<a name="l00594"></a>00594         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00595"></a>00595 
<a name="l00596"></a>00596         <span class="keywordflow">return</span>;
<a name="l00597"></a>00597       }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00600"></a>00600       {
<a name="l00601"></a>00601         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00602"></a>00602 
<a name="l00603"></a>00603         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00604"></a>00604         
<a name="l00605"></a>00605         <span class="keywordflow">return</span>;
<a name="l00606"></a>00606       }
<a name="l00607"></a>00607 
<a name="l00608"></a>00608     <span class="keywordflow">default</span>:
<a name="l00609"></a>00609       libmesh_error();
<a name="l00610"></a>00610     }
<a name="l00611"></a>00611 }
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a><a class="code" href="classXdr.php#f6f67518c56aa92c8ac0a20d1ad1a6e6">00615</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">double</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00616"></a>00616 {
<a name="l00617"></a>00617   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00618"></a>00618     {
<a name="l00619"></a>00619     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00620"></a>00620     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00621"></a>00621       {
<a name="l00622"></a>00622 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00623"></a>00623 <span class="preprocessor"></span>
<a name="l00624"></a>00624         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00625"></a>00625 
<a name="l00626"></a>00626         xdr_double(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 <span class="preprocessor">#else</span>
<a name="l00629"></a>00629 <span class="preprocessor"></span>        
<a name="l00630"></a>00630         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00631"></a>00631                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00632"></a>00632                   &lt;&lt; std::endl
<a name="l00633"></a>00633                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00634"></a>00634                   &lt;&lt; std::endl;
<a name="l00635"></a>00635 
<a name="l00636"></a>00636         libmesh_error();
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 <span class="preprocessor">#endif</span>
<a name="l00639"></a>00639 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00640"></a>00640       }
<a name="l00641"></a>00641 
<a name="l00642"></a>00642     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00643"></a>00643       {
<a name="l00644"></a>00644         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00645"></a>00645         
<a name="l00646"></a>00646         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00647"></a>00647 
<a name="l00648"></a>00648         <span class="keywordflow">return</span>;
<a name="l00649"></a>00649       }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00652"></a>00652       {
<a name="l00653"></a>00653         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00654"></a>00654 
<a name="l00655"></a>00655         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00656"></a>00656         
<a name="l00657"></a>00657         <span class="keywordflow">return</span>;
<a name="l00658"></a>00658       }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660     <span class="keywordflow">default</span>:
<a name="l00661"></a>00661       libmesh_error();
<a name="l00662"></a>00662     }
<a name="l00663"></a>00663 }
<a name="l00664"></a>00664 
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00668"></a>00668 <span class="preprocessor"></span>
<a name="l00669"></a><a class="code" href="classXdr.php#3db4953f7f8c6ae7449f3950656b3f05">00669</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::complex&lt;double&gt;&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00670"></a>00670 {
<a name="l00671"></a>00671   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00672"></a>00672     {
<a name="l00673"></a>00673     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00674"></a>00674     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00675"></a>00675       {
<a name="l00676"></a>00676 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00677"></a>00677 <span class="preprocessor"></span>
<a name="l00678"></a>00678         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00679"></a>00679         <span class="keywordtype">double</span>
<a name="l00680"></a>00680           _r=a.real(),
<a name="l00681"></a>00681           _i=a.imag();
<a name="l00682"></a>00682         xdr_double(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;_r);
<a name="l00683"></a>00683         xdr_double(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;_i);
<a name="l00684"></a>00684         a = std::complex&lt;double&gt;(_r,_i);
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 <span class="preprocessor">#else</span>
<a name="l00687"></a>00687 <span class="preprocessor"></span>        
<a name="l00688"></a>00688         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00689"></a>00689                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00690"></a>00690                   &lt;&lt; std::endl
<a name="l00691"></a>00691                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00692"></a>00692                   &lt;&lt; std::endl;
<a name="l00693"></a>00693 
<a name="l00694"></a>00694         libmesh_error();
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 <span class="preprocessor">#endif</span>
<a name="l00697"></a>00697 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00698"></a>00698       }
<a name="l00699"></a>00699 
<a name="l00700"></a>00700     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00701"></a>00701       {
<a name="l00702"></a>00702         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00703"></a>00703         
<a name="l00704"></a>00704         <span class="keywordtype">double</span> _r, _i;
<a name="l00705"></a>00705         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _r;
<a name="l00706"></a>00706         *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _i;
<a name="l00707"></a>00707         a = std::complex&lt;double&gt;(_r,_i);
<a name="l00708"></a>00708         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00709"></a>00709 
<a name="l00710"></a>00710         <span class="keywordflow">return</span>;
<a name="l00711"></a>00711       }
<a name="l00712"></a>00712 
<a name="l00713"></a>00713     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00714"></a>00714       {
<a name="l00715"></a>00715         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00716"></a>00716 
<a name="l00717"></a>00717         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a.real() &lt;&lt; <span class="stringliteral">"\t "</span> 
<a name="l00718"></a>00718             &lt;&lt; a.imag() &lt;&lt; <span class="stringliteral">"\t "</span>
<a name="l00719"></a>00719             &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00720"></a>00720         
<a name="l00721"></a>00721         <span class="keywordflow">return</span>;
<a name="l00722"></a>00722       }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724     <span class="keywordflow">default</span>:
<a name="l00725"></a>00725       libmesh_error();
<a name="l00726"></a>00726     }
<a name="l00727"></a>00727 }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 <span class="preprocessor">#endif // LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00730"></a>00730 <span class="preprocessor"></span>
<a name="l00731"></a>00731 
<a name="l00732"></a>00732 
<a name="l00733"></a><a class="code" href="classXdr.php#411577b0d5e8d933915bafad884f3706">00733</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00734"></a>00734 {
<a name="l00735"></a>00735   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00736"></a>00736     {
<a name="l00737"></a>00737     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00738"></a>00738       {
<a name="l00739"></a>00739 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00740"></a>00740 <span class="preprocessor"></span>
<a name="l00741"></a>00741         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00742"></a>00742 
<a name="l00743"></a>00743         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l00744"></a>00744 
<a name="l00745"></a>00745         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00746"></a>00746 
<a name="l00747"></a>00747         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00748"></a>00748                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00749"></a>00749                    length,
<a name="l00750"></a>00750                    <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),
<a name="l00751"></a>00751                    (xdrproc_t) xdr_int);
<a name="l00752"></a>00752         
<a name="l00753"></a>00753 <span class="preprocessor">#else</span>
<a name="l00754"></a>00754 <span class="preprocessor"></span>        
<a name="l00755"></a>00755         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00756"></a>00756                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00757"></a>00757                   &lt;&lt; std::endl
<a name="l00758"></a>00758                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00759"></a>00759                   &lt;&lt; std::endl;
<a name="l00760"></a>00760 
<a name="l00761"></a>00761         libmesh_error();
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 <span class="preprocessor">#endif</span>
<a name="l00764"></a>00764 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00765"></a>00765       }
<a name="l00766"></a>00766 
<a name="l00767"></a>00767     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00768"></a>00768       {
<a name="l00769"></a>00769 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00770"></a>00770 <span class="preprocessor"></span>
<a name="l00771"></a>00771         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00772"></a>00772 
<a name="l00773"></a>00773         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00774"></a>00774 
<a name="l00775"></a>00775         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00776"></a>00776 
<a name="l00777"></a>00777         v.resize(length);
<a name="l00778"></a>00778 
<a name="l00779"></a>00779         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00780"></a>00780                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00781"></a>00781                    length,
<a name="l00782"></a>00782                    <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),
<a name="l00783"></a>00783                    (xdrproc_t) xdr_int);
<a name="l00784"></a>00784         
<a name="l00785"></a>00785 <span class="preprocessor">#else</span>
<a name="l00786"></a>00786 <span class="preprocessor"></span>        
<a name="l00787"></a>00787         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00788"></a>00788                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00789"></a>00789                   &lt;&lt; std::endl
<a name="l00790"></a>00790                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00791"></a>00791                   &lt;&lt; std::endl;
<a name="l00792"></a>00792 
<a name="l00793"></a>00793         libmesh_error();
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 <span class="preprocessor">#endif</span>
<a name="l00796"></a>00796 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00797"></a>00797       }
<a name="l00798"></a>00798 
<a name="l00799"></a>00799     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00800"></a>00800       {
<a name="l00801"></a>00801         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00802"></a>00802 
<a name="l00803"></a>00803         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00804"></a>00804 
<a name="l00805"></a>00805         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00806"></a>00806 
<a name="l00807"></a>00807         v.resize(length);
<a name="l00808"></a>00808 
<a name="l00809"></a>00809         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00810"></a>00810           {
<a name="l00811"></a>00811             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00812"></a>00812             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l00813"></a>00813           }
<a name="l00814"></a>00814 
<a name="l00815"></a>00815         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00816"></a>00816 
<a name="l00817"></a>00817         <span class="keywordflow">return</span>; 
<a name="l00818"></a>00818       }
<a name="l00819"></a>00819 
<a name="l00820"></a>00820     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00821"></a>00821       {
<a name="l00822"></a>00822         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00823"></a>00823 
<a name="l00824"></a>00824         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l00825"></a>00825 
<a name="l00826"></a>00826         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00827"></a>00827 
<a name="l00828"></a>00828         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00829"></a>00829           {
<a name="l00830"></a>00830             libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00831"></a>00831             *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l00832"></a>00832           }
<a name="l00833"></a>00833 
<a name="l00834"></a>00834         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00835"></a>00835 
<a name="l00836"></a>00836         <span class="keywordflow">return</span>; 
<a name="l00837"></a>00837       }
<a name="l00838"></a>00838 
<a name="l00839"></a>00839     <span class="keywordflow">default</span>:
<a name="l00840"></a>00840       libmesh_error();
<a name="l00841"></a>00841     }
<a name="l00842"></a>00842 }
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a><a class="code" href="classXdr.php#44a44a7a7b4fa4fafbed8562159402a4">00846</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;unsigned int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00847"></a>00847 {
<a name="l00848"></a>00848   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00849"></a>00849     {
<a name="l00850"></a>00850     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00851"></a>00851       {
<a name="l00852"></a>00852 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00853"></a>00853 <span class="preprocessor"></span>
<a name="l00854"></a>00854         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00855"></a>00855 
<a name="l00856"></a>00856         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l00857"></a>00857 
<a name="l00858"></a>00858         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00859"></a>00859 
<a name="l00860"></a>00860         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00861"></a>00861                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00862"></a>00862                    length,
<a name="l00863"></a>00863                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l00864"></a>00864                    (xdrproc_t) xdr_u_int);
<a name="l00865"></a>00865         
<a name="l00866"></a>00866 <span class="preprocessor">#else</span>
<a name="l00867"></a>00867 <span class="preprocessor"></span>        
<a name="l00868"></a>00868         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00869"></a>00869                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00870"></a>00870                   &lt;&lt; std::endl
<a name="l00871"></a>00871                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00872"></a>00872                   &lt;&lt; std::endl;
<a name="l00873"></a>00873 
<a name="l00874"></a>00874         libmesh_error();
<a name="l00875"></a>00875 
<a name="l00876"></a>00876 <span class="preprocessor">#endif</span>
<a name="l00877"></a>00877 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00878"></a>00878       }
<a name="l00879"></a>00879 
<a name="l00880"></a>00880     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00881"></a>00881       {
<a name="l00882"></a>00882 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00883"></a>00883 <span class="preprocessor"></span>
<a name="l00884"></a>00884         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00885"></a>00885 
<a name="l00886"></a>00886         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00887"></a>00887 
<a name="l00888"></a>00888         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00889"></a>00889 
<a name="l00890"></a>00890         v.resize(length);
<a name="l00891"></a>00891 
<a name="l00892"></a>00892         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00893"></a>00893                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00894"></a>00894                    length,
<a name="l00895"></a>00895                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l00896"></a>00896                    (xdrproc_t) xdr_u_int);
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 <span class="preprocessor">#else</span>
<a name="l00899"></a>00899 <span class="preprocessor"></span>        
<a name="l00900"></a>00900         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00901"></a>00901                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00902"></a>00902                   &lt;&lt; std::endl
<a name="l00903"></a>00903                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00904"></a>00904                   &lt;&lt; std::endl;
<a name="l00905"></a>00905 
<a name="l00906"></a>00906         libmesh_error();
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 <span class="preprocessor">#endif  </span>
<a name="l00909"></a>00909 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00910"></a>00910       }
<a name="l00911"></a>00911 
<a name="l00912"></a>00912     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00913"></a>00913       {
<a name="l00914"></a>00914         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00915"></a>00915 
<a name="l00916"></a>00916         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00917"></a>00917 
<a name="l00918"></a>00918         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00919"></a>00919 
<a name="l00920"></a>00920         v.resize(length);
<a name="l00921"></a>00921 
<a name="l00922"></a>00922         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00923"></a>00923           {
<a name="l00924"></a>00924             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00925"></a>00925             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l00926"></a>00926           }
<a name="l00927"></a>00927 
<a name="l00928"></a>00928         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00929"></a>00929 
<a name="l00930"></a>00930         <span class="keywordflow">return</span>; 
<a name="l00931"></a>00931       }
<a name="l00932"></a>00932 
<a name="l00933"></a>00933     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00934"></a>00934       {
<a name="l00935"></a>00935         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00936"></a>00936 
<a name="l00937"></a>00937         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l00938"></a>00938 
<a name="l00939"></a>00939         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00940"></a>00940 
<a name="l00941"></a>00941         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00942"></a>00942           {
<a name="l00943"></a>00943             libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00944"></a>00944             *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l00945"></a>00945           }
<a name="l00946"></a>00946 
<a name="l00947"></a>00947         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l00948"></a>00948 
<a name="l00949"></a>00949         <span class="keywordflow">return</span>; 
<a name="l00950"></a>00950       }
<a name="l00951"></a>00951 
<a name="l00952"></a>00952     <span class="keywordflow">default</span>:
<a name="l00953"></a>00953       libmesh_error();
<a name="l00954"></a>00954     }
<a name="l00955"></a>00955 }
<a name="l00956"></a>00956 
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 
<a name="l00959"></a><a class="code" href="classXdr.php#df4a82ad9f6466191100998f6b167c07">00959</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;short int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00960"></a>00960 {
<a name="l00961"></a>00961   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00962"></a>00962     {
<a name="l00963"></a>00963     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00964"></a>00964       {
<a name="l00965"></a>00965 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00966"></a>00966 <span class="preprocessor"></span>
<a name="l00967"></a>00967         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00968"></a>00968 
<a name="l00969"></a>00969         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l00970"></a>00970 
<a name="l00971"></a>00971         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l00972"></a>00972 
<a name="l00973"></a>00973         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00974"></a>00974                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00975"></a>00975                    length,
<a name="l00976"></a>00976                    <span class="keyword">sizeof</span>(<span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l00977"></a>00977                    (xdrproc_t) xdr_short);
<a name="l00978"></a>00978         
<a name="l00979"></a>00979 <span class="preprocessor">#else</span>
<a name="l00980"></a>00980 <span class="preprocessor"></span>        
<a name="l00981"></a>00981         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l00982"></a>00982                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l00983"></a>00983                   &lt;&lt; std::endl
<a name="l00984"></a>00984                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l00985"></a>00985                   &lt;&lt; std::endl;
<a name="l00986"></a>00986 
<a name="l00987"></a>00987         libmesh_error();
<a name="l00988"></a>00988 
<a name="l00989"></a>00989 <span class="preprocessor">#endif</span>
<a name="l00990"></a>00990 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00991"></a>00991       }
<a name="l00992"></a>00992 
<a name="l00993"></a>00993     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00994"></a>00994       {
<a name="l00995"></a>00995 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00996"></a>00996 <span class="preprocessor"></span>
<a name="l00997"></a>00997         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00998"></a>00998 
<a name="l00999"></a>00999         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01000"></a>01000 
<a name="l01001"></a>01001         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01002"></a>01002 
<a name="l01003"></a>01003         v.resize(length);
<a name="l01004"></a>01004 
<a name="l01005"></a>01005         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01006"></a>01006                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01007"></a>01007                    length,
<a name="l01008"></a>01008                    <span class="keyword">sizeof</span>(<span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l01009"></a>01009                    (xdrproc_t) xdr_short);
<a name="l01010"></a>01010         
<a name="l01011"></a>01011 <span class="preprocessor">#else</span>
<a name="l01012"></a>01012 <span class="preprocessor"></span>        
<a name="l01013"></a>01013         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01014"></a>01014                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01015"></a>01015                   &lt;&lt; std::endl
<a name="l01016"></a>01016                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01017"></a>01017                   &lt;&lt; std::endl;
<a name="l01018"></a>01018 
<a name="l01019"></a>01019         libmesh_error();
<a name="l01020"></a>01020 
<a name="l01021"></a>01021 <span class="preprocessor">#endif</span>
<a name="l01022"></a>01022 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01023"></a>01023       }
<a name="l01024"></a>01024 
<a name="l01025"></a>01025     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01026"></a>01026       {
<a name="l01027"></a>01027         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01028"></a>01028 
<a name="l01029"></a>01029         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01030"></a>01030 
<a name="l01031"></a>01031         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01032"></a>01032 
<a name="l01033"></a>01033         v.resize(length);
<a name="l01034"></a>01034 
<a name="l01035"></a>01035         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01036"></a>01036           {
<a name="l01037"></a>01037             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01038"></a>01038             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01039"></a>01039           }
<a name="l01040"></a>01040 
<a name="l01041"></a>01041         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01042"></a>01042 
<a name="l01043"></a>01043         <span class="keywordflow">return</span>; 
<a name="l01044"></a>01044       }
<a name="l01045"></a>01045 
<a name="l01046"></a>01046     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01047"></a>01047       {
<a name="l01048"></a>01048         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01049"></a>01049 
<a name="l01050"></a>01050         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01051"></a>01051 
<a name="l01052"></a>01052         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01053"></a>01053 
<a name="l01054"></a>01054         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01055"></a>01055           {
<a name="l01056"></a>01056             libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01057"></a>01057             *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01058"></a>01058           }
<a name="l01059"></a>01059 
<a name="l01060"></a>01060         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01061"></a>01061 
<a name="l01062"></a>01062         <span class="keywordflow">return</span>; 
<a name="l01063"></a>01063       }
<a name="l01064"></a>01064 
<a name="l01065"></a>01065     <span class="keywordflow">default</span>:
<a name="l01066"></a>01066       libmesh_error();
<a name="l01067"></a>01067     }
<a name="l01068"></a>01068 }
<a name="l01069"></a>01069 
<a name="l01070"></a>01070 
<a name="l01071"></a>01071 
<a name="l01072"></a><a class="code" href="classXdr.php#0d8d605affccd26241ed6c205c394eb2">01072</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;unsigned short int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01073"></a>01073 {
<a name="l01074"></a>01074   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01075"></a>01075     {
<a name="l01076"></a>01076     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01077"></a>01077       {
<a name="l01078"></a>01078 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01079"></a>01079 <span class="preprocessor"></span>
<a name="l01080"></a>01080         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01081"></a>01081 
<a name="l01082"></a>01082         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01083"></a>01083 
<a name="l01084"></a>01084         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01085"></a>01085 
<a name="l01086"></a>01086         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01087"></a>01087                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01088"></a>01088                    length,
<a name="l01089"></a>01089                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l01090"></a>01090                    (xdrproc_t) xdr_u_short);
<a name="l01091"></a>01091 
<a name="l01092"></a>01092 <span class="preprocessor">#else</span>
<a name="l01093"></a>01093 <span class="preprocessor"></span>        
<a name="l01094"></a>01094         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01095"></a>01095                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01096"></a>01096                   &lt;&lt; std::endl
<a name="l01097"></a>01097                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01098"></a>01098                   &lt;&lt; std::endl;
<a name="l01099"></a>01099 
<a name="l01100"></a>01100         libmesh_error();
<a name="l01101"></a>01101 
<a name="l01102"></a>01102 <span class="preprocessor">#endif  </span>
<a name="l01103"></a>01103 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01104"></a>01104       }
<a name="l01105"></a>01105 
<a name="l01106"></a>01106     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01107"></a>01107       {
<a name="l01108"></a>01108 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01109"></a>01109 <span class="preprocessor"></span>
<a name="l01110"></a>01110         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01111"></a>01111 
<a name="l01112"></a>01112         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01113"></a>01113 
<a name="l01114"></a>01114         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01115"></a>01115 
<a name="l01116"></a>01116         v.resize(length);
<a name="l01117"></a>01117 
<a name="l01118"></a>01118         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01119"></a>01119                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01120"></a>01120                    length,
<a name="l01121"></a>01121                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l01122"></a>01122                    (xdrproc_t) xdr_u_short);
<a name="l01123"></a>01123         
<a name="l01124"></a>01124 <span class="preprocessor">#else</span>
<a name="l01125"></a>01125 <span class="preprocessor"></span>        
<a name="l01126"></a>01126         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01127"></a>01127                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01128"></a>01128                   &lt;&lt; std::endl
<a name="l01129"></a>01129                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01130"></a>01130                   &lt;&lt; std::endl;
<a name="l01131"></a>01131 
<a name="l01132"></a>01132         libmesh_error();
<a name="l01133"></a>01133 
<a name="l01134"></a>01134 <span class="preprocessor">#endif</span>
<a name="l01135"></a>01135 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01136"></a>01136       }
<a name="l01137"></a>01137 
<a name="l01138"></a>01138     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01139"></a>01139       {
<a name="l01140"></a>01140         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01141"></a>01141 
<a name="l01142"></a>01142         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01143"></a>01143 
<a name="l01144"></a>01144         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01145"></a>01145 
<a name="l01146"></a>01146         v.resize(length);
<a name="l01147"></a>01147 
<a name="l01148"></a>01148         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01149"></a>01149           {
<a name="l01150"></a>01150             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01151"></a>01151             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01152"></a>01152           }
<a name="l01153"></a>01153 
<a name="l01154"></a>01154         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01155"></a>01155 
<a name="l01156"></a>01156         <span class="keywordflow">return</span>; 
<a name="l01157"></a>01157       }
<a name="l01158"></a>01158 
<a name="l01159"></a>01159     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01160"></a>01160       {
<a name="l01161"></a>01161         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01162"></a>01162 
<a name="l01163"></a>01163         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01164"></a>01164 
<a name="l01165"></a>01165         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01166"></a>01166 
<a name="l01167"></a>01167         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01168"></a>01168           {
<a name="l01169"></a>01169             libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01170"></a>01170             *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01171"></a>01171           }
<a name="l01172"></a>01172 
<a name="l01173"></a>01173         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01174"></a>01174 
<a name="l01175"></a>01175         <span class="keywordflow">return</span>; 
<a name="l01176"></a>01176       }
<a name="l01177"></a>01177 
<a name="l01178"></a>01178     <span class="keywordflow">default</span>:
<a name="l01179"></a>01179       libmesh_error();
<a name="l01180"></a>01180     }
<a name="l01181"></a>01181 }
<a name="l01182"></a>01182 
<a name="l01183"></a>01183 
<a name="l01184"></a>01184 
<a name="l01185"></a><a class="code" href="classXdr.php#6cb845dacc1a50fbf143a680d3793059">01185</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;float&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01186"></a>01186 {
<a name="l01187"></a>01187   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01188"></a>01188     {
<a name="l01189"></a>01189     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01190"></a>01190       {
<a name="l01191"></a>01191 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01192"></a>01192 <span class="preprocessor"></span>
<a name="l01193"></a>01193         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01194"></a>01194 
<a name="l01195"></a>01195         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01196"></a>01196 
<a name="l01197"></a>01197         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01198"></a>01198 
<a name="l01199"></a>01199         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01200"></a>01200                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01201"></a>01201                    length,
<a name="l01202"></a>01202                    <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>),
<a name="l01203"></a>01203                    (xdrproc_t) xdr_float);
<a name="l01204"></a>01204 
<a name="l01205"></a>01205 <span class="preprocessor">#else</span>
<a name="l01206"></a>01206 <span class="preprocessor"></span>        
<a name="l01207"></a>01207         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01208"></a>01208                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01209"></a>01209                   &lt;&lt; std::endl
<a name="l01210"></a>01210                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01211"></a>01211                   &lt;&lt; std::endl;
<a name="l01212"></a>01212 
<a name="l01213"></a>01213         libmesh_error();
<a name="l01214"></a>01214 
<a name="l01215"></a>01215 <span class="preprocessor">#endif  </span>
<a name="l01216"></a>01216 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01217"></a>01217       }
<a name="l01218"></a>01218 
<a name="l01219"></a>01219     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01220"></a>01220       {
<a name="l01221"></a>01221 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01222"></a>01222 <span class="preprocessor"></span>
<a name="l01223"></a>01223         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01224"></a>01224 
<a name="l01225"></a>01225         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01226"></a>01226 
<a name="l01227"></a>01227         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01228"></a>01228 
<a name="l01229"></a>01229         v.resize(length);
<a name="l01230"></a>01230 
<a name="l01231"></a>01231         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01232"></a>01232                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01233"></a>01233                    length,
<a name="l01234"></a>01234                    <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>),
<a name="l01235"></a>01235                    (xdrproc_t) xdr_float);
<a name="l01236"></a>01236         
<a name="l01237"></a>01237 <span class="preprocessor">#else</span>
<a name="l01238"></a>01238 <span class="preprocessor"></span>        
<a name="l01239"></a>01239         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01240"></a>01240                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01241"></a>01241                   &lt;&lt; std::endl
<a name="l01242"></a>01242                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01243"></a>01243                   &lt;&lt; std::endl;
<a name="l01244"></a>01244 
<a name="l01245"></a>01245         libmesh_error();
<a name="l01246"></a>01246 
<a name="l01247"></a>01247 <span class="preprocessor">#endif</span>
<a name="l01248"></a>01248 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01249"></a>01249       }
<a name="l01250"></a>01250 
<a name="l01251"></a>01251     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01252"></a>01252       {
<a name="l01253"></a>01253         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01254"></a>01254 
<a name="l01255"></a>01255         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01256"></a>01256 
<a name="l01257"></a>01257         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01258"></a>01258 
<a name="l01259"></a>01259         v.resize(length);
<a name="l01260"></a>01260 
<a name="l01261"></a>01261         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01262"></a>01262           {
<a name="l01263"></a>01263             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01264"></a>01264             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01265"></a>01265           }
<a name="l01266"></a>01266 
<a name="l01267"></a>01267         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01268"></a>01268 
<a name="l01269"></a>01269         <span class="keywordflow">return</span>; 
<a name="l01270"></a>01270       }
<a name="l01271"></a>01271 
<a name="l01272"></a>01272     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01273"></a>01273       {
<a name="l01274"></a>01274         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01275"></a>01275 
<a name="l01276"></a>01276         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01277"></a>01277 
<a name="l01278"></a>01278         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01279"></a>01279 
<a name="l01280"></a>01280         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01281"></a>01281           {
<a name="l01282"></a>01282             libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01283"></a>01283             OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,v[i]) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01284"></a>01284           }
<a name="l01285"></a>01285 
<a name="l01286"></a>01286         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01287"></a>01287 
<a name="l01288"></a>01288         <span class="keywordflow">return</span>; 
<a name="l01289"></a>01289       }
<a name="l01290"></a>01290 
<a name="l01291"></a>01291     <span class="keywordflow">default</span>:
<a name="l01292"></a>01292       libmesh_error();
<a name="l01293"></a>01293     }
<a name="l01294"></a>01294 }
<a name="l01295"></a>01295 
<a name="l01296"></a>01296 
<a name="l01297"></a>01297 
<a name="l01298"></a><a class="code" href="classXdr.php#42a903194a8ebc00b6f98bd93674bf83">01298</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;double&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01299"></a>01299 {
<a name="l01300"></a>01300   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01301"></a>01301     {
<a name="l01302"></a>01302     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01303"></a>01303       {
<a name="l01304"></a>01304 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01305"></a>01305 <span class="preprocessor"></span>
<a name="l01306"></a>01306         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01307"></a>01307 
<a name="l01308"></a>01308         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01309"></a>01309 
<a name="l01310"></a>01310         this-&gt;<a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01311"></a>01311 
<a name="l01312"></a>01312         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01313"></a>01313                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01314"></a>01314                    length,
<a name="l01315"></a>01315                    <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01316"></a>01316                    (xdrproc_t) xdr_double);
<a name="l01317"></a>01317 
<a name="l01318"></a>01318 <span class="preprocessor">#else</span>
<a name="l01319"></a>01319 <span class="preprocessor"></span>        
<a name="l01320"></a>01320         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01321"></a>01321                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01322"></a>01322                   &lt;&lt; std::endl
<a name="l01323"></a>01323                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01324"></a>01324                   &lt;&lt; std::endl;
<a name="l01325"></a>01325 
<a name="l01326"></a>01326         libmesh_error();
<a name="l01327"></a>01327 
<a name="l01328"></a>01328 <span class="preprocessor">#endif  </span>
<a name="l01329"></a>01329 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01330"></a>01330       }
<a name="l01331"></a>01331 
<a name="l01332"></a>01332     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01333"></a>01333       {
<a name="l01334"></a>01334 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01335"></a>01335 <span class="preprocessor"></span>
<a name="l01336"></a>01336         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01337"></a>01337 
<a name="l01338"></a>01338         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01339"></a>01339 
<a name="l01340"></a>01340         this-&gt;<a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01341"></a>01341 
<a name="l01342"></a>01342         v.resize(length);
<a name="l01343"></a>01343 
<a name="l01344"></a>01344         <span class="comment">// Note: GCC 3.4.1 will crash in debug mode here if length</span>
<a name="l01345"></a>01345         <span class="comment">// is zero and you attempt to access the zeroth index of v.</span>
<a name="l01346"></a>01346         <span class="keywordflow">if</span> (length &gt; 0)
<a name="l01347"></a>01347           xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01348"></a>01348                      (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01349"></a>01349                      length,
<a name="l01350"></a>01350                      <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01351"></a>01351                      (xdrproc_t) xdr_double);
<a name="l01352"></a>01352         
<a name="l01353"></a>01353 <span class="preprocessor">#else</span>
<a name="l01354"></a>01354 <span class="preprocessor"></span>        
<a name="l01355"></a>01355         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01356"></a>01356                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01357"></a>01357                   &lt;&lt; std::endl
<a name="l01358"></a>01358                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01359"></a>01359                   &lt;&lt; std::endl;
<a name="l01360"></a>01360 
<a name="l01361"></a>01361         libmesh_error();
<a name="l01362"></a>01362 
<a name="l01363"></a>01363 <span class="preprocessor">#endif</span>
<a name="l01364"></a>01364 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01365"></a>01365       }
<a name="l01366"></a>01366 
<a name="l01367"></a>01367     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01368"></a>01368       {
<a name="l01369"></a>01369         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01370"></a>01370 
<a name="l01371"></a>01371         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01372"></a>01372 
<a name="l01373"></a>01373         this-&gt;<a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01374"></a>01374         
<a name="l01375"></a>01375         <span class="comment">// If you were expecting to read in a vector at this</span>
<a name="l01376"></a>01376         <span class="comment">// point, it's not going to happen if length == 0!</span>
<a name="l01377"></a>01377         <span class="comment">// libmesh_assert (length != 0);</span>
<a name="l01378"></a>01378         
<a name="l01379"></a>01379         v.resize(length);
<a name="l01380"></a>01380 
<a name="l01381"></a>01381         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01382"></a>01382           {
<a name="l01383"></a>01383             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01384"></a>01384             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01385"></a>01385           }
<a name="l01386"></a>01386 
<a name="l01387"></a>01387         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01388"></a>01388 
<a name="l01389"></a>01389         <span class="keywordflow">return</span>; 
<a name="l01390"></a>01390       }
<a name="l01391"></a>01391 
<a name="l01392"></a>01392     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01393"></a>01393       {
<a name="l01394"></a>01394         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01395"></a>01395 
<a name="l01396"></a>01396         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01397"></a>01397 
<a name="l01398"></a>01398         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length"</span>);
<a name="l01399"></a>01399 
<a name="l01400"></a>01400         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01401"></a>01401           {
<a name="l01402"></a>01402             libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01403"></a>01403             OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,v[i]) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01404"></a>01404           }
<a name="l01405"></a>01405 
<a name="l01406"></a>01406 
<a name="l01407"></a>01407 
<a name="l01408"></a>01408         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01409"></a>01409 
<a name="l01410"></a>01410         <span class="keywordflow">return</span>; 
<a name="l01411"></a>01411       }
<a name="l01412"></a>01412 
<a name="l01413"></a>01413     <span class="keywordflow">default</span>:
<a name="l01414"></a>01414       libmesh_error();
<a name="l01415"></a>01415     }
<a name="l01416"></a>01416 }
<a name="l01417"></a>01417 
<a name="l01418"></a>01418 
<a name="l01419"></a>01419 
<a name="l01420"></a>01420 
<a name="l01421"></a>01421 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01422"></a>01422 <span class="preprocessor"></span>
<a name="l01423"></a><a class="code" href="classXdr.php#50c7427e5e7a0d2602a1c3a516b51571">01423</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt; std::complex&lt;double&gt; &gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01424"></a>01424 {
<a name="l01425"></a>01425   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01426"></a>01426     {
<a name="l01427"></a>01427     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01428"></a>01428       {
<a name="l01429"></a>01429 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01430"></a>01430 <span class="preprocessor"></span>
<a name="l01431"></a>01431         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01432"></a>01432 
<a name="l01433"></a>01433         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01434"></a>01434 
<a name="l01435"></a>01435         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length x 2 (complex)"</span>);
<a name="l01436"></a>01436 
<a name="l01437"></a>01437         std::vector&lt; std::complex&lt;double&gt; &gt;::iterator iter = v.begin();
<a name="l01438"></a>01438         
<a name="l01439"></a>01439         <span class="keywordflow">for</span> (; iter != v.end(); ++iter)
<a name="l01440"></a>01440             <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(*iter, <span class="stringliteral">""</span>);
<a name="l01441"></a>01441 
<a name="l01442"></a>01442 <span class="preprocessor">#else</span>
<a name="l01443"></a>01443 <span class="preprocessor"></span>        
<a name="l01444"></a>01444         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01445"></a>01445                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01446"></a>01446                   &lt;&lt; std::endl
<a name="l01447"></a>01447                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01448"></a>01448                   &lt;&lt; std::endl;
<a name="l01449"></a>01449 
<a name="l01450"></a>01450         libmesh_error();
<a name="l01451"></a>01451 
<a name="l01452"></a>01452 <span class="preprocessor">#endif  </span>
<a name="l01453"></a>01453 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01454"></a>01454       }
<a name="l01455"></a>01455 
<a name="l01456"></a>01456     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01457"></a>01457       {
<a name="l01458"></a>01458 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01459"></a>01459 <span class="preprocessor"></span>
<a name="l01460"></a>01460         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01461"></a>01461 
<a name="l01462"></a>01462         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01463"></a>01463 
<a name="l01464"></a>01464         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length x 2 (complex)"</span>);
<a name="l01465"></a>01465 
<a name="l01466"></a>01466         v.resize(length);
<a name="l01467"></a>01467 
<a name="l01468"></a>01468         std::vector&lt; std::complex&lt;double&gt; &gt;::iterator iter = v.begin();
<a name="l01469"></a>01469         
<a name="l01470"></a>01470         <span class="keywordflow">for</span> (; iter != v.end(); ++iter)
<a name="l01471"></a>01471             <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(*iter, <span class="stringliteral">""</span>);
<a name="l01472"></a>01472         
<a name="l01473"></a>01473 <span class="preprocessor">#else</span>
<a name="l01474"></a>01474 <span class="preprocessor"></span>        
<a name="l01475"></a>01475         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01476"></a>01476                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01477"></a>01477                   &lt;&lt; std::endl
<a name="l01478"></a>01478                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01479"></a>01479                   &lt;&lt; std::endl;
<a name="l01480"></a>01480 
<a name="l01481"></a>01481         libmesh_error();
<a name="l01482"></a>01482 
<a name="l01483"></a>01483 <span class="preprocessor">#endif</span>
<a name="l01484"></a>01484 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01485"></a>01485       }
<a name="l01486"></a>01486 
<a name="l01487"></a>01487     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01488"></a>01488       {
<a name="l01489"></a>01489         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01490"></a>01490 
<a name="l01491"></a>01491         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01492"></a>01492 
<a name="l01493"></a>01493         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length x 2 (complex)"</span>);
<a name="l01494"></a>01494 
<a name="l01495"></a>01495         v.resize(length);
<a name="l01496"></a>01496 
<a name="l01497"></a>01497         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01498"></a>01498           {
<a name="l01499"></a>01499             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01500"></a>01500         
<a name="l01501"></a>01501             <span class="keywordtype">double</span> _r, _i;
<a name="l01502"></a>01502             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _r;
<a name="l01503"></a>01503             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _i;
<a name="l01504"></a>01504             v[i] = std::complex&lt;double&gt;(_r,_i);
<a name="l01505"></a>01505           }
<a name="l01506"></a>01506 
<a name="l01507"></a>01507         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01508"></a>01508 
<a name="l01509"></a>01509         <span class="keywordflow">return</span>; 
<a name="l01510"></a>01510       }
<a name="l01511"></a>01511 
<a name="l01512"></a>01512     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01513"></a>01513       {
<a name="l01514"></a>01514         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01515"></a>01515 
<a name="l01516"></a>01516         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01517"></a>01517 
<a name="l01518"></a>01518         <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">"# vector length x 2 (complex)"</span>);
<a name="l01519"></a>01519 
<a name="l01520"></a>01520         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01521"></a>01521           {
<a name="l01522"></a>01522             libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01523"></a>01523             OFSNumberscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,v[i]) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01524"></a>01524           }
<a name="l01525"></a>01525 
<a name="l01526"></a>01526         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01527"></a>01527 
<a name="l01528"></a>01528         <span class="keywordflow">return</span>; 
<a name="l01529"></a>01529       }
<a name="l01530"></a>01530 
<a name="l01531"></a>01531     <span class="keywordflow">default</span>:
<a name="l01532"></a>01532       libmesh_error();
<a name="l01533"></a>01533     }
<a name="l01534"></a>01534 }
<a name="l01535"></a>01535 
<a name="l01536"></a>01536 <span class="preprocessor">#endif // ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01537"></a>01537 <span class="preprocessor"></span>
<a name="l01538"></a>01538 
<a name="l01539"></a>01539 
<a name="l01540"></a>01540 
<a name="l01541"></a><a class="code" href="classXdr.php#9a6a8d9c8cd4bee0fe801f3a7ef048a6">01541</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::string&amp; s, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01542"></a>01542 {
<a name="l01543"></a>01543   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01544"></a>01544     {
<a name="l01545"></a>01545     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01546"></a>01546       {
<a name="l01547"></a>01547 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01548"></a>01548 <span class="preprocessor"></span>
<a name="l01549"></a>01549         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01550"></a>01550 
<a name="l01551"></a>01551         {
<a name="l01552"></a>01552           <span class="keywordtype">char</span>* sptr = <span class="keyword">new</span> <span class="keywordtype">char</span>[s.size()+1];
<a name="l01553"></a>01553 
<a name="l01554"></a>01554           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;s.size(); c++)
<a name="l01555"></a>01555             sptr[c] = s[c];
<a name="l01556"></a>01556         
<a name="l01557"></a>01557           sptr[s.size()] = <span class="charliteral">'\0'</span>;
<a name="l01558"></a>01558           
<a name="l01559"></a>01559           xdr_string(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>,
<a name="l01560"></a>01560                      &amp;sptr,
<a name="l01561"></a>01561                      std::strlen(sptr));
<a name="l01562"></a>01562 
<a name="l01563"></a>01563           <span class="keyword">delete</span> [] sptr;
<a name="l01564"></a>01564         }
<a name="l01565"></a>01565 
<a name="l01566"></a>01566 <span class="preprocessor">#else</span>
<a name="l01567"></a>01567 <span class="preprocessor"></span>        
<a name="l01568"></a>01568         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01569"></a>01569                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01570"></a>01570                   &lt;&lt; std::endl
<a name="l01571"></a>01571                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01572"></a>01572                   &lt;&lt; std::endl;
<a name="l01573"></a>01573 
<a name="l01574"></a>01574         libmesh_error();
<a name="l01575"></a>01575 
<a name="l01576"></a>01576 <span class="preprocessor">#endif</span>
<a name="l01577"></a>01577 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01578"></a>01578       }
<a name="l01579"></a>01579 
<a name="l01580"></a>01580     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01581"></a>01581       {
<a name="l01582"></a>01582 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01583"></a>01583 <span class="preprocessor"></span>
<a name="l01584"></a>01584         libmesh_assert (<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01585"></a>01585 
<a name="l01586"></a>01586         {
<a name="l01587"></a>01587           <span class="keywordtype">char</span>* sptr = <span class="keyword">new</span> <span class="keywordtype">char</span>[xdr_MAX_STRING_LENGTH];
<a name="l01588"></a>01588           
<a name="l01589"></a>01589           xdr_string(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>,
<a name="l01590"></a>01590                      &amp;sptr,
<a name="l01591"></a>01591                      xdr_MAX_STRING_LENGTH);
<a name="l01592"></a>01592 
<a name="l01593"></a>01593           s.resize(std::strlen(sptr));
<a name="l01594"></a>01594 
<a name="l01595"></a>01595           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;s.size(); c++)
<a name="l01596"></a>01596             s[c] = sptr[c];
<a name="l01597"></a>01597           
<a name="l01598"></a>01598           <span class="keyword">delete</span> [] sptr;  
<a name="l01599"></a>01599         }
<a name="l01600"></a>01600 
<a name="l01601"></a>01601 <span class="preprocessor">#else</span>
<a name="l01602"></a>01602 <span class="preprocessor"></span>        
<a name="l01603"></a>01603         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01604"></a>01604                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01605"></a>01605                   &lt;&lt; std::endl
<a name="l01606"></a>01606                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01607"></a>01607                   &lt;&lt; std::endl;
<a name="l01608"></a>01608 
<a name="l01609"></a>01609         libmesh_error();
<a name="l01610"></a>01610 
<a name="l01611"></a>01611 <span class="preprocessor">#endif</span>
<a name="l01612"></a>01612 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01613"></a>01613       }
<a name="l01614"></a>01614 
<a name="l01615"></a>01615     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01616"></a>01616       {
<a name="l01617"></a>01617         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01618"></a>01618 
<a name="l01619"></a>01619         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01620"></a>01620 
<a name="l01621"></a>01621 <span class="comment">//#ifndef LIBMESH_BROKEN_IOSTREAM</span>
<a name="l01622"></a>01622 <span class="comment">//      s.clear();</span>
<a name="l01623"></a>01623 <span class="comment">//#else</span>
<a name="l01624"></a>01624         s = <span class="stringliteral">""</span>;
<a name="l01625"></a>01625 <span class="comment">//#endif</span>
<a name="l01626"></a>01626 
<a name="l01627"></a>01627         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;std::strlen(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>); c++)
<a name="l01628"></a>01628           {
<a name="l01629"></a>01629             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>[c] == <span class="charliteral">'\t'</span>) 
<a name="l01630"></a>01630               <span class="keywordflow">break</span>;
<a name="l01631"></a>01631             
<a name="l01632"></a>01632             s.push_back(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>[c]);
<a name="l01633"></a>01633           }
<a name="l01634"></a>01634 
<a name="l01635"></a>01635         <span class="keywordflow">return</span>; 
<a name="l01636"></a>01636       }
<a name="l01637"></a>01637 
<a name="l01638"></a>01638     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01639"></a>01639       {
<a name="l01640"></a>01640         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01641"></a>01641 
<a name="l01642"></a>01642         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; s &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01643"></a>01643 
<a name="l01644"></a>01644         <span class="keywordflow">return</span>; 
<a name="l01645"></a>01645       }
<a name="l01646"></a>01646 
<a name="l01647"></a>01647     <span class="keywordflow">default</span>:
<a name="l01648"></a>01648       libmesh_error();
<a name="l01649"></a>01649     }
<a name="l01650"></a>01650 }
<a name="l01651"></a>01651 
<a name="l01652"></a>01652 
<a name="l01653"></a>01653 
<a name="l01654"></a>01654 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01655"></a><a class="code" href="classXdr.php#4078d136e6c78973c278ff3e073a8e7a">01655</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (T *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01656"></a>01656 {
<a name="l01657"></a>01657   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01658"></a>01658     {
<a name="l01659"></a>01659     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01660"></a>01660       {
<a name="l01661"></a>01661 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01662"></a>01662 <span class="preprocessor"></span>
<a name="l01663"></a>01663         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01664"></a>01664 
<a name="l01665"></a>01665 
<a name="l01666"></a>01666         xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01667"></a>01667                    (<span class="keywordtype">char</span>*) val,
<a name="l01668"></a>01668                    len,
<a name="l01669"></a>01669                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l01670"></a>01670                    (xdrproc_t) xdr_u_int);
<a name="l01671"></a>01671 
<a name="l01672"></a>01672 <span class="preprocessor">#else</span>
<a name="l01673"></a>01673 <span class="preprocessor"></span>        
<a name="l01674"></a>01674         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01675"></a>01675                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01676"></a>01676                   &lt;&lt; std::endl
<a name="l01677"></a>01677                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01678"></a>01678                   &lt;&lt; std::endl;
<a name="l01679"></a>01679 
<a name="l01680"></a>01680         libmesh_error();
<a name="l01681"></a>01681 
<a name="l01682"></a>01682 <span class="preprocessor">#endif  </span>
<a name="l01683"></a>01683 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01684"></a>01684       }
<a name="l01685"></a>01685 
<a name="l01686"></a>01686     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01687"></a>01687       {
<a name="l01688"></a>01688 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01689"></a>01689 <span class="preprocessor"></span>
<a name="l01690"></a>01690         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01691"></a>01691 
<a name="l01692"></a>01692         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l01693"></a>01693           xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01694"></a>01694                      (<span class="keywordtype">char</span>*) val,
<a name="l01695"></a>01695                      len,
<a name="l01696"></a>01696                      <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l01697"></a>01697                      (xdrproc_t) xdr_u_int);
<a name="l01698"></a>01698         
<a name="l01699"></a>01699 <span class="preprocessor">#else</span>
<a name="l01700"></a>01700 <span class="preprocessor"></span>        
<a name="l01701"></a>01701         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01702"></a>01702                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01703"></a>01703                   &lt;&lt; std::endl
<a name="l01704"></a>01704                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01705"></a>01705                   &lt;&lt; std::endl;
<a name="l01706"></a>01706 
<a name="l01707"></a>01707         libmesh_error();
<a name="l01708"></a>01708 
<a name="l01709"></a>01709 <span class="preprocessor">#endif</span>
<a name="l01710"></a>01710 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01711"></a>01711       }
<a name="l01712"></a>01712 
<a name="l01713"></a>01713     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01714"></a>01714       {
<a name="l01715"></a>01715         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01716"></a>01716 
<a name="l01717"></a>01717         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01718"></a>01718           {
<a name="l01719"></a>01719             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01720"></a>01720             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i];
<a name="l01721"></a>01721           }
<a name="l01722"></a>01722 
<a name="l01723"></a>01723         <span class="keywordflow">return</span>; 
<a name="l01724"></a>01724       }
<a name="l01725"></a>01725 
<a name="l01726"></a>01726     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01727"></a>01727       {
<a name="l01728"></a>01728         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01729"></a>01729 
<a name="l01730"></a>01730         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01731"></a>01731           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01732"></a>01732             {
<a name="l01733"></a>01733               libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01734"></a>01734               *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; val[i] &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01735"></a>01735             }
<a name="l01736"></a>01736         <span class="keywordflow">else</span>
<a name="l01737"></a>01737           {
<a name="l01738"></a>01738             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01739"></a>01739             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l01740"></a>01740               {
<a name="l01741"></a>01741                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l01742"></a>01742                   {
<a name="l01743"></a>01743                     libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01744"></a>01744                     *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; val[cnt++] &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01745"></a>01745                   }
<a name="l01746"></a>01746                 libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01747"></a>01747                 *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01748"></a>01748               }
<a name="l01749"></a>01749           }
<a name="l01750"></a>01750 
<a name="l01751"></a>01751         <span class="keywordflow">return</span>; 
<a name="l01752"></a>01752       }
<a name="l01753"></a>01753 
<a name="l01754"></a>01754     <span class="keywordflow">default</span>:
<a name="l01755"></a>01755       libmesh_error();
<a name="l01756"></a>01756     }
<a name="l01757"></a>01757 }
<a name="l01758"></a>01758 
<a name="l01759"></a>01759 
<a name="l01760"></a>01760 
<a name="l01761"></a>01761 <span class="keyword">template</span> &lt;&gt;
<a name="l01762"></a><a class="code" href="classXdr.php#1386a6bba8f20650d34bd3d1172e9fad">01762</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (<span class="keywordtype">double</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01763"></a>01763 {
<a name="l01764"></a>01764   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01765"></a>01765     {
<a name="l01766"></a>01766     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01767"></a>01767     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01768"></a>01768       {
<a name="l01769"></a>01769 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01770"></a>01770 <span class="preprocessor"></span>
<a name="l01771"></a>01771         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01772"></a>01772 
<a name="l01773"></a>01773         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l01774"></a>01774           xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01775"></a>01775                      (<span class="keywordtype">char</span>*) val,
<a name="l01776"></a>01776                      len,
<a name="l01777"></a>01777                      <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01778"></a>01778                      (xdrproc_t) xdr_double);
<a name="l01779"></a>01779         
<a name="l01780"></a>01780 <span class="preprocessor">#else</span>
<a name="l01781"></a>01781 <span class="preprocessor"></span>        
<a name="l01782"></a>01782         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01783"></a>01783                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01784"></a>01784                   &lt;&lt; std::endl
<a name="l01785"></a>01785                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01786"></a>01786                   &lt;&lt; std::endl;
<a name="l01787"></a>01787 
<a name="l01788"></a>01788         libmesh_error();
<a name="l01789"></a>01789 
<a name="l01790"></a>01790 <span class="preprocessor">#endif</span>
<a name="l01791"></a>01791 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01792"></a>01792       }
<a name="l01793"></a>01793 
<a name="l01794"></a>01794     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01795"></a>01795       {
<a name="l01796"></a>01796         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01797"></a>01797 
<a name="l01798"></a>01798         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01799"></a>01799           {
<a name="l01800"></a>01800             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01801"></a>01801             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i];
<a name="l01802"></a>01802           }
<a name="l01803"></a>01803 
<a name="l01804"></a>01804         <span class="keywordflow">return</span>; 
<a name="l01805"></a>01805       }
<a name="l01806"></a>01806 
<a name="l01807"></a>01807     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01808"></a>01808       {
<a name="l01809"></a>01809         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01810"></a>01810 
<a name="l01811"></a>01811         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01812"></a>01812           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01813"></a>01813             {
<a name="l01814"></a>01814               libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01815"></a>01815               OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i]) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01816"></a>01816             }
<a name="l01817"></a>01817         <span class="keywordflow">else</span>
<a name="l01818"></a>01818           {
<a name="l01819"></a>01819             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01820"></a>01820             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l01821"></a>01821               {
<a name="l01822"></a>01822                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l01823"></a>01823                   {
<a name="l01824"></a>01824                     libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01825"></a>01825                     OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt++]) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01826"></a>01826                   }
<a name="l01827"></a>01827                 libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01828"></a>01828                 *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01829"></a>01829               }
<a name="l01830"></a>01830           }
<a name="l01831"></a>01831 
<a name="l01832"></a>01832         <span class="keywordflow">return</span>; 
<a name="l01833"></a>01833       }
<a name="l01834"></a>01834 
<a name="l01835"></a>01835     <span class="keywordflow">default</span>:
<a name="l01836"></a>01836       libmesh_error();
<a name="l01837"></a>01837     }
<a name="l01838"></a>01838 }
<a name="l01839"></a>01839 
<a name="l01840"></a>01840 
<a name="l01841"></a>01841 <span class="keyword">template</span> &lt;&gt;
<a name="l01842"></a><a class="code" href="classXdr.php#b3cd01ff5491a68202a851c926727c81">01842</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (<span class="keywordtype">long</span> <span class="keywordtype">double</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01843"></a>01843 {
<a name="l01844"></a>01844   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01845"></a>01845     {
<a name="l01846"></a>01846     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01847"></a>01847     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01848"></a>01848       {
<a name="l01849"></a>01849 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01850"></a>01850 <span class="preprocessor"></span>
<a name="l01851"></a>01851         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01852"></a>01852 
<a name="l01853"></a>01853         <span class="comment">// FIXME[JWP]: How to implement this for long double?  Mac OS</span>
<a name="l01854"></a>01854         <span class="comment">// X defines 'xdr_quadruple' but AFAICT, it does not exist for</span>
<a name="l01855"></a>01855         <span class="comment">// Linux... for now, reading/writing XDR files with long</span>
<a name="l01856"></a>01856         <span class="comment">// doubles is disabled, but you can still write long double</span>
<a name="l01857"></a>01857         <span class="comment">// ASCII files of course.</span>
<a name="l01858"></a>01858         <span class="comment">// if (len &gt; 0)</span>
<a name="l01859"></a>01859         <span class="comment">//   xdr_vector(xdrs, </span>
<a name="l01860"></a>01860         <span class="comment">//           (char*) val,</span>
<a name="l01861"></a>01861         <span class="comment">//           len,</span>
<a name="l01862"></a>01862         <span class="comment">//           sizeof(double),</span>
<a name="l01863"></a>01863         <span class="comment">//           (xdrproc_t) xdr_quadruple);</span>
<a name="l01864"></a>01864 
<a name="l01865"></a>01865         std::cerr &lt;&lt; <span class="stringliteral">"Writing binary XDR files with long double's is not\n"</span>
<a name="l01866"></a>01866                   &lt;&lt; <span class="stringliteral">"currently supported on all platforms."</span> &lt;&lt; std::endl;
<a name="l01867"></a>01867 
<a name="l01868"></a>01868         libmesh_error();
<a name="l01869"></a>01869         
<a name="l01870"></a>01870 <span class="preprocessor">#else</span>
<a name="l01871"></a>01871 <span class="preprocessor"></span>        
<a name="l01872"></a>01872         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01873"></a>01873                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01874"></a>01874                   &lt;&lt; std::endl
<a name="l01875"></a>01875                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01876"></a>01876                   &lt;&lt; std::endl;
<a name="l01877"></a>01877 
<a name="l01878"></a>01878         libmesh_error();
<a name="l01879"></a>01879 
<a name="l01880"></a>01880 <span class="preprocessor">#endif</span>
<a name="l01881"></a>01881 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01882"></a>01882       }
<a name="l01883"></a>01883 
<a name="l01884"></a>01884     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01885"></a>01885       {
<a name="l01886"></a>01886         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01887"></a>01887 
<a name="l01888"></a>01888         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01889"></a>01889           {
<a name="l01890"></a>01890             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01891"></a>01891             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i];
<a name="l01892"></a>01892           }
<a name="l01893"></a>01893 
<a name="l01894"></a>01894         <span class="keywordflow">return</span>; 
<a name="l01895"></a>01895       }
<a name="l01896"></a>01896 
<a name="l01897"></a>01897     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01898"></a>01898       {
<a name="l01899"></a>01899         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01900"></a>01900 
<a name="l01901"></a>01901         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01902"></a>01902           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01903"></a>01903             {
<a name="l01904"></a>01904               libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01905"></a>01905               OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i]) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01906"></a>01906             }
<a name="l01907"></a>01907         <span class="keywordflow">else</span>
<a name="l01908"></a>01908           {
<a name="l01909"></a>01909             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01910"></a>01910             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l01911"></a>01911               {
<a name="l01912"></a>01912                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l01913"></a>01913                   {
<a name="l01914"></a>01914                     libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01915"></a>01915                     OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt++]) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l01916"></a>01916                   }
<a name="l01917"></a>01917                 libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01918"></a>01918                 *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l01919"></a>01919               }
<a name="l01920"></a>01920           }
<a name="l01921"></a>01921 
<a name="l01922"></a>01922         <span class="keywordflow">return</span>; 
<a name="l01923"></a>01923       }
<a name="l01924"></a>01924 
<a name="l01925"></a>01925     <span class="keywordflow">default</span>:
<a name="l01926"></a>01926       libmesh_error();
<a name="l01927"></a>01927     }
<a name="l01928"></a>01928 }
<a name="l01929"></a>01929 
<a name="l01930"></a>01930 
<a name="l01931"></a>01931 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01932"></a>01932 <span class="preprocessor"></span><span class="keyword">template</span> &lt;&gt;
<a name="l01933"></a><a class="code" href="classXdr.php#0b690f56adeb8a7f1a4f6944891e8354">01933</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (std::complex&lt;double&gt; *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01934"></a>01934 {
<a name="l01935"></a>01935   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01936"></a>01936     {
<a name="l01937"></a>01937     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01938"></a>01938     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01939"></a>01939       {
<a name="l01940"></a>01940 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01941"></a>01941 <span class="preprocessor"></span>
<a name="l01942"></a>01942         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#e11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01943"></a>01943 
<a name="l01944"></a>01944 
<a name="l01945"></a>01945         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l01946"></a>01946           {
<a name="l01947"></a>01947             std::vector&lt;double&gt; io_buffer (2*len);
<a name="l01948"></a>01948             
<a name="l01949"></a>01949             <span class="comment">// Fill io_buffer if we are writing.</span>
<a name="l01950"></a>01950             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>)
<a name="l01951"></a>01951               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, cnt=0; i&lt;len; i++)
<a name="l01952"></a>01952                 {
<a name="l01953"></a>01953                   io_buffer[cnt++] = val[i].real();
<a name="l01954"></a>01954                   io_buffer[cnt++] = val[i].imag();
<a name="l01955"></a>01955                 } 
<a name="l01956"></a>01956               
<a name="l01957"></a>01957             xdr_vector(<a class="code" href="classXdr.php#21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01958"></a>01958                        (<span class="keywordtype">char</span>*) &amp;io_buffer[0],
<a name="l01959"></a>01959                        2*len,
<a name="l01960"></a>01960                        <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01961"></a>01961                        (xdrproc_t) xdr_double);
<a name="l01962"></a>01962             
<a name="l01963"></a>01963             <span class="comment">// Fill val array if we are reading.</span>
<a name="l01964"></a>01964             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>)
<a name="l01965"></a>01965               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, cnt=0; i&lt;len; i++)
<a name="l01966"></a>01966                 {
<a name="l01967"></a>01967                   val[i].real() = io_buffer[cnt++];
<a name="l01968"></a>01968                   val[i].imag() = io_buffer[cnt++];
<a name="l01969"></a>01969                 } 
<a name="l01970"></a>01970           }
<a name="l01971"></a>01971 <span class="preprocessor">#else</span>
<a name="l01972"></a>01972 <span class="preprocessor"></span>        
<a name="l01973"></a>01973         std::cerr &lt;&lt; <span class="stringliteral">"ERROR: Functionality is not available."</span> &lt;&lt; std::endl
<a name="l01974"></a>01974                   &lt;&lt; <span class="stringliteral">"Make sure LIBMESH_HAVE_XDR is defined at build time"</span> 
<a name="l01975"></a>01975                   &lt;&lt; std::endl
<a name="l01976"></a>01976                   &lt;&lt; <span class="stringliteral">"The XDR interface is not available in this installation"</span>
<a name="l01977"></a>01977                   &lt;&lt; std::endl;
<a name="l01978"></a>01978 
<a name="l01979"></a>01979         libmesh_error();
<a name="l01980"></a>01980 
<a name="l01981"></a>01981 <span class="preprocessor">#endif</span>
<a name="l01982"></a>01982 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01983"></a>01983       }
<a name="l01984"></a>01984 
<a name="l01985"></a>01985     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01986"></a>01986       {
<a name="l01987"></a>01987         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01988"></a>01988 
<a name="l01989"></a>01989         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01990"></a>01990           {
<a name="l01991"></a>01991             libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01992"></a>01992             *<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i].real() &gt;&gt; val[i].imag();
<a name="l01993"></a>01993           }
<a name="l01994"></a>01994 
<a name="l01995"></a>01995         <span class="keywordflow">return</span>; 
<a name="l01996"></a>01996       }
<a name="l01997"></a>01997 
<a name="l01998"></a>01998     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01999"></a>01999       {
<a name="l02000"></a>02000         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02001"></a>02001 
<a name="l02002"></a>02002         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l02003"></a>02003           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l02004"></a>02004             {
<a name="l02005"></a>02005               libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02006"></a>02006               OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i].real()) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l02007"></a>02007               OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i].imag()) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l02008"></a>02008             }
<a name="l02009"></a>02009         <span class="keywordflow">else</span>
<a name="l02010"></a>02010           {
<a name="l02011"></a>02011             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l02012"></a>02012             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l02013"></a>02013               {
<a name="l02014"></a>02014                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l02015"></a>02015                   {
<a name="l02016"></a>02016                     libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02017"></a>02017                     OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt].real()) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l02018"></a>02018                     OFSRealscientific(*<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt].imag()) &lt;&lt; <span class="stringliteral">" "</span>;
<a name="l02019"></a>02019                     cnt++;
<a name="l02020"></a>02020                   }
<a name="l02021"></a>02021                 libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02022"></a>02022                 *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l02023"></a>02023               }
<a name="l02024"></a>02024           }
<a name="l02025"></a>02025 
<a name="l02026"></a>02026         <span class="keywordflow">return</span>; 
<a name="l02027"></a>02027       }
<a name="l02028"></a>02028 
<a name="l02029"></a>02029     <span class="keywordflow">default</span>:
<a name="l02030"></a>02030       libmesh_error();
<a name="l02031"></a>02031     }
<a name="l02032"></a>02032 }
<a name="l02033"></a>02033 <span class="preprocessor">#endif // # LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l02034"></a>02034 <span class="preprocessor"></span>
<a name="l02035"></a><a class="code" href="classXdr.php#e207fb366547ff14903d254281b535d6">02035</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#e207fb366547ff14903d254281b535d6">Xdr::comment</a> (std::string &amp;comment)
<a name="l02036"></a>02036 {
<a name="l02037"></a>02037   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l02038"></a>02038     {
<a name="l02039"></a>02039     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8e5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l02040"></a>02040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b82632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l02041"></a>02041       {
<a name="l02042"></a>02042         <span class="keywordflow">return</span>;
<a name="l02043"></a>02043       }
<a name="l02044"></a>02044 
<a name="l02045"></a>02045     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b8cd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l02046"></a>02046       {
<a name="l02047"></a>02047         libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l02048"></a>02048         <a class="code" href="classXdr.php#29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l02049"></a>02049         <span class="keywordflow">return</span>; 
<a name="l02050"></a>02050       }
<a name="l02051"></a>02051 
<a name="l02052"></a>02052     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#3259cc4a42b40ff4f17d1550782ae2b847f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l02053"></a>02053       {
<a name="l02054"></a>02054         libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02055"></a>02055         *<a class="code" href="classXdr.php#c8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">"\t "</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">'\n'</span>;
<a name="l02056"></a>02056         <span class="keywordflow">return</span>; 
<a name="l02057"></a>02057       }
<a name="l02058"></a>02058 
<a name="l02059"></a>02059     <span class="keywordflow">default</span>:
<a name="l02060"></a>02060       libmesh_error();
<a name="l02061"></a>02061     }
<a name="l02062"></a>02062 }
<a name="l02063"></a>02063 
<a name="l02064"></a>02064 
<a name="l02065"></a>02065 <span class="preprocessor">#undef xdr_REAL</span>
<a name="l02066"></a>02066 <span class="preprocessor"></span>
<a name="l02067"></a>02067 
<a name="l02068"></a>02068 <span class="comment">//</span>
<a name="l02069"></a>02069 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data_stream&lt;int&gt;          (<span class="keywordtype">int</span> *val,          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break);
<a name="l02070"></a>02070 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data_stream&lt;unsigned int&gt; (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break);
</pre></div></div>
</div>


<?php make_footer() ?>

</body>
</html>
 
